/*
*
*/

#ifndef _MGMT_CLE_CISCOCMDPARSER_H
#define _MGMT_CLE_CISCOCMDPARSER_H

extern  cle_paramType_t systemParamTypes[];
extern int32 sysParamTypesNum;


#define CISCOCMD_ACCEPT_SYMBOL	"<cr>"
#define CISCOCMD_ACCEPT_STRING	"Acceptable command. Press <Return> to commit command..."
#define CISCOCMD_HELPMSG_FORMAT	"%-16s %s\n"
/*********************************************************************************
Exported API prototype
**********************************************************************************/
void ciscoCmdParserGetAllCandidates(void);
void ciscoCmdParserGetCandidate(void *lastTokenNode);
int32 ciscoCmdGetNextToken(int8 **nextToken, int32 *size, int8 **savedData);
int32 ciscoCmdParserGetCandidateTokenList(struct enumList *list, int32 totalEntries);

//If ciscoCmdParser() returns -1, pass the savedData returned by ciscoCmdParser() to print help message
int32 ciscoCmdParserShowHelp(struct enumList * list, int32 totalEntries);

//Returns the number of valid tokens, if returns -1, command is invalid.
//If command is invalid, *savedData returns the last valid token data structure.
//If commans is valid, *savedData saves the address of candidateNode structure.
int32 ciscoCmdParser( int32 argc, int8 **argv, cle_exec_t **thisCmd, int8 **savedData, int8 **errorToken);

//Release temp resource after users store all state info in his dirStack upon entering a stateful command group
int32 ciscoCmdParserFlushTmpBuffer(void);

//Remember to release all state infomation before any new call to ciscoCmdParser
int32 ciscoCmdParserFree(void);

//cfliu: (2002.11.25) Before ciscoCmdParser module is integrated into our CLE, ciscoCmdParser can 
//be called independently from Ida's current argc,argv style CLE engine. Ref. the dhcp_client.c module for example.
//Returns -1 if command is not valid, otherwise returns 0.
//Modules's command handler is called inside. 
int32 ciscoCmdChecker(uint32 userId, int32 argc, int8 **argv, cle_exec_t *cmd);

//Print Command format string (without help message)
void ciscoCmdPrintSynopsis(int8 *help, int8 *formatString);

#endif
