/*
* --------------------------------------------------------------------
*
*
* --------------------------------------------------------------------
*/
#ifndef DESSIM_H
#define DESSIM_H

#include <rtl_types.h>

int32 desSim_ecb_encrypt(int8 *input, int8 * output, uint32 len, int8 * ks, int8 encrypt);
int32 desSim_ede_ecb_encrypt(int8 *input, int8 * output, uint32 len, int8 * key, int8 encrypt);
int32 desSim_cbc_encrypt(int8 *input, int8 * output, uint32 len, int8 * key, int8 * iv, int8 encrypt);
int32 desSim_ede_cbc_encrypt(int8 *input, int8 * output, uint32 len, int8 * key, int8 * iv, int8 encrypt);
int32 desSim_cbc_encryptEmbIV(int8 *input, int8 * output, uint32 len, int8 * key, int8 encrypt) ;
int32 desSim_ede_cbc_encryptEmbIV(int8 *input, int8 * output, uint32 len, int8 * key, int8 encrypt);

#define SWDECRYPT_CBC_DES		0x00
#define SWDECRYPT_CBC_3DES	0x01
#define SWDECRYPT_ECB_DES		0x02
#define SWDECRYPT_ECB_3DES	0x03
#define SWENCRYPT_CBC_DES		0x04
#define SWENCRYPT_CBC_3DES	0x05
#define SWENCRYPT_ECB_DES		0x06
#define SWENCRYPT_ECB_3DES	0x07
//data, key and iv does not have 4-byte alignment limitatiuon
int32 desSim_des(uint32 mode, int8 *input, int8 *output, uint32 len, int8 *key, int8 *iv );
int32 desSim_desBatch(uint32 mode, int8 ** input, int8 **output, uint32 *len, int8 **key, int8 **iv, uint32 dataNum);

#endif
