/*
 */

#ifndef _CRYPTO_MD5_H_
#define _CRYPTO_MD5_H_

#include "crypto.h"
#include "types.h"


#define MD5_BUFLEN	64
#define MD5_DIGEST_LENGTH 16

typedef struct {
	union {
		uint32	md5_state32[4];
		uint8	md5_state8[16];
	} md5_st;

#define md5_sta		md5_st.md5_state32[0]
#define md5_stb		md5_st.md5_state32[1]
#define md5_stc		md5_st.md5_state32[2]
#define md5_std		md5_st.md5_state32[3]
#define md5_st8		md5_st.md5_state8

	union {
		uint64	md5_count64;
		uint8	md5_count8[8];
	} md5_count;
#define md5_n	md5_count.md5_count64
#define md5_n8	md5_count.md5_count8

	uint32	md5_i;
	uint8	md5_buf[MD5_BUFLEN];
} md5_ctxt;

extern void md5_init (md5_ctxt *);
extern void md5_loop (md5_ctxt *, uint8 *, uint32);
extern void md5_pad (md5_ctxt *);
extern void md5_result (uint8 *, md5_ctxt *);

/* compatibility */
#define MD5_CTX		md5_ctxt
#define MD5Init(x)	md5_init((x))
#define MD5Update(x, y, z)	md5_loop((x), (y), (z))
#define MD5Final(x, y) \
do {				\
	md5_pad((y));		\
	md5_result((x), (y));	\
} while (0)

void MD5StringHash (uint8* digest, const int8* str);

#endif /* ! _CRYPTO_MD5_H_*/
