/*
*
*
*/

#ifndef _RTL8651_ALG_INIT
#define _RTL8651_ALG_INIT
#include "rtl8651_tblDrv.h"

#define RTL8651_ALG_PPTP_IDX				0
#define RTL8651_ALG_IPSEC_IDX				1
#define RTL8651_ALG_L2TP_IDX				2
#define RTL8651_ALG_FTP_IDX				3
#define RTL8651_ALG_NETMEETING_IDX		4
#define RTL8651_ALG_ICQ_IDX				5
#define RTL8651_ALG_YAHOOMSG_IDX			6
#define RTL8651_ALG_IRC_IDX				7
#define RTL8651_ALG_DX7_IDX				8
#define RTL8651_ALG_SIP_IDX				9
#define RTL8651_ALG_ICUII_IDX				10
#define RTL8651_ALG_VDOLIVE_IDX			11
#define RTL8651_ALG_QUAKE_IDX				12
#define RTL8651_ALG_CS_IDX					13
#define RTL8651_ALG_BATTLENET_IDX			14
#define RTL8651_ALG_REALAUDIO_IDX			15
#define RTL8651_ALG_CUSEEME_IDX			16
#define RTL8651_ALG_TFTP_IDX				17
#define RTL8651_ALG_MAX_IDX				18	/* MAX ALG functions */

#define RTL8651_ALG_PPTP_SERVER_IDX		29	/* for client / server setting divided */
#define RTL8651_ALG_IPSEC_SERVER_IDX		30
#define RTL8651_ALG_PPTP_SOFTWARE_IDX	31	/* special define for PPTP software */


#define RTL8651_ALG_PPTP				0x00000001
#define RTL8651_ALG_IPSEC				0x00000002
#define RTL8651_ALG_L2TP				0x00000004
#define RTL8651_ALG_FTP				0x00000008
#define RTL8651_ALG_NETMEETING		0x00000010
#define RTL8651_ALG_ICQ					0x00000020
#define RTL8651_ALG_YAHOOMSG			0x00000040
#define RTL8651_ALG_IRC					0x00000080
#define RTL8651_ALG_DX7				0x00000100
#define RTL8651_ALG_SIP					0x00000200
#define RTL8651_ALG_ICUII				0x00000400
#define RTL8651_ALG_VDOLIVE			0x00000800
#define RTL8651_ALG_QUAKE				0x00001000
#define RTL8651_ALG_CS					0x00002000	/* Counter-Strike /Half Life */
#define RTL8651_ALG_BATTLENET			0x00004000	/* Blizzard Battlenet: StarCraft , Diablo II */
#define RTL8651_ALG_REALAUDIO			0x00008000
#define RTL8651_ALG_CUSEEME			0x00010000
#define RTL8651_ALG_TFTP				0x00020000

#define RTL8651_ALG_PPTP_SERVER		0x20000000	/* special define for PPTP server-in-LAN */
#define RTL8651_ALG_IPSEC_SERVER		0x40000000	/* special define for IPSec server-in-LAN */
#define RTL8651_ALG_PPTP_SOFTWARE	0x80000000	/* special define for PPTP software */

extern uint32 alg_supports[RTL8651_MAX_DIALSESSION];
extern uint32 alg_serverips[RTL8651_MAX_DIALSESSION][32];
extern uint32 alg_qosqid[RTL8651_MAX_DIALSESSION][32];
extern uint32 alg_qoshl[RTL8651_MAX_DIALSESSION][32];
extern uint32 _rtl8651_DefaultDialSessionId;

struct rtl8651_algMaxSession
{
	uint8 l2tpMaxSession;
	uint8 pptpMaxSession;
	uint8 ipsecMaxSession;
};

extern struct rtl8651_algMaxSession algMaxSession;


void rtl8651_setAlgStatus(uint32 alg_support,ipaddr_t *alg_serverip);
uint32 rtl8651a_setAlgStatus(uint32 SessionID,uint32 alg_support,ipaddr_t *alg_serverip);
void rtl8651_setAlgConfig(uint32 alg_support,ipaddr_t *alg_serverip,struct rtl8651_algMaxSession maxSession);
uint32 rtl8651a_setAlgConfig(uint32 SessionID,uint32 alg_support,ipaddr_t *alg_serverip,struct rtl8651_algMaxSession maxSession);
int32 rtl8651_algOneSecondTimer(void);
uint32 rtl8651_getAlgStatus(void);
uint32 rtl8651a_getAlgStatus(uint32 SessionID);
uint32 rtl8651_flushAlgServerIn(void);
uint32 rtl8651a_flushAlgServerIn(uint32 SessionID);
void rtl8651_algReInit(void);
int32 rtl8651_setAlgQosQueueId(uint32 alg_idx,uint32 queueID,uint32 isHigh, uint32 ratio);
int32 rtl8651a_setAlgQosQueueId(uint32 SessionID,uint32 alg_idx,uint32 queueID,uint32 isHigh, uint32 ratio);
int32 _rtl8651_addAlgQosNaptConnection(int8 fromDrv, int16 assigned, int8 flowType, ipaddr_t insideLocalIpAddr, uint16 insideLocalPort, 
			ipaddr_t *insideGlobalIpAddr, uint16 *insideGlobalPort, ipaddr_t dstIpAddr, uint16 dstPort,uint32 AlgIdx);

#endif /* _RTL8651_ALG_INIT */


