#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <features.h>
#if __GLIBC__ >=2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#endif
#include <errno.h>
#include <stdarg.h>
#include "scanport_packet.h"

#if 0
/* read a packet from socket fd */
int nmb_packet(struct nmb_packet *packet, int fd)
{
	int bytes;
	int i;
	char broken_vendors[][8] = {
		"MSFT 98",
		""
	};
	char *vendor;

	memset(packet, 0, sizeof(struct dhcpMessage));
	bytes = read(fd, packet, sizeof(struct dhcpMessage));
	if (bytes < 0) {
		DEBUG(LOG_INFO, "couldn't read on listening socket -- ignoring");
		return -1;
	}

	if (ntohl(packet->cookie) != DHCP_MAGIC) {
		LOG(LOG_ERR, "received bogus message -- ignoring");
		return -1;
	}
	DEBUG(LOG_INFO, "oooooh!!! got some!");
	
	if (packet->op == BOOTREQUEST && (vendor = get_option(packet, DHCP_VENDOR))) {
		for (i = 0; broken_vendors[i][0]; i++) {
			if (vendor[OPT_LEN - 2] == (signed) strlen(broken_vendors[i]) &&
			    !strncmp(vendor, broken_vendors[i], vendor[OPT_LEN - 2]) &&
			    !(ntohs(packet->flags) & BROADCAST_FLAG)) {
			    	DEBUG(LOG_INFO, "broken client (%s), forcing broadcast",
			    		broken_vendors[i]);
			    	packet->flags |= htons(BROADCAST_FLAG);
			}
		}
	}
			    	

	return bytes;
}
#endif

/* Calculate the length of a packet, and make sure its a multiple of 2 */
#if 0
static int calc_length(struct nmb_packet *payload)
{
	int payload_length;
	
	payload_length = sizeof(struct nmb_packet) - 308;
	//payload_length += end_option(payload->options) + 1;
	if (payload_length % 2) {
		payload_length++;
		*((char *) payload + payload_length - 1) = '\0';
	}

	//DEBUG(LOG_INFO, "payload length is %d bytes", payload_length);
	DPRINTF("payload length is %d bytes", payload_length);

	return payload_length;
}
#endif
static uint16 trn_id=0;
static uint16 _generate_trn_id(void)
{

  trn_id = 0;
  if (!trn_id)
  {
    trn_id = ((unsigned)time(NULL)%(unsigned)0x7FFF) + ((unsigned)getpid()%(unsigned)100);
  }
  trn_id = (trn_id+1) % (unsigned)0x7FFF;
  return trn_id;
}


#ifdef ATTACHED_DEVICES
int netbios_packet(u_int32_t *source_ip, int source_port, u_int32_t *dest_ip, int dest_port, unsigned char *name)
#else
int netbios_packet(u_int32_t *source_ip, int source_port, u_int32_t *dest_ip, int dest_port, int cnt)
#endif
{
	int fd;
	int result=0, payload_length = sizeof(struct nmb_packet);
	struct sockaddr_in my_addr;
	struct sockaddr_in dest_addr;
	struct nmb_packet nmb;
	struct nmb_name *nmbname;
	unsigned char nmb_trn_id[2];
	int i, bytes, timeout = 1;
	fd_set in;
	int ret;
	struct timeval tm; 
	time_t		prevTime;
	
	trn_id = _generate_trn_id();
	nmb_trn_id[0] = (trn_id & 0xff00)>>8;
	nmb_trn_id[1] = trn_id & 0x00ff;
	//printf("trn_id = %02x\n", trn_id);
	/* create NetBios query message */
	char buf[] = {nmb_trn_id[0], nmb_trn_id[1], 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
		      0x20, 0x43, 0x4b, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, \
		      0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, \
		      0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x00, 0x00, 0x21, \
		      0x00, 0x01};

	//printf("dest_ip = %d.%d.%d.%d\n", dest_ip[0], dest_ip[1], dest_ip[2], dest_ip[3]);
	//printf("%s = dest_ip = %s\n", __FUNCTION__, dest_ip);
	if ((fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		printf("socket call failed: %s", __FUNCTION__);
		return -1;
	}
	
	
	memset(&my_addr, '\0', sizeof(my_addr));
	my_addr.sin_family = AF_INET;
	my_addr.sin_port   = htons(source_port);
	my_addr.sin_addr.s_addr = INADDR_ANY;
	memset(&(my_addr.sin_zero), '\0', 8);
	if (bind(fd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) < 0) {
		printf("bind call failed: %s", __FUNCTION__);
		close(fd);
		return -1;
	}
	
	memset(&dest_addr, '\0', sizeof(dest_addr));
	dest_addr.sin_family = AF_INET;
	dest_addr.sin_port   = htons(dest_port);
	inet_aton(dest_ip, &(dest_addr.sin_addr));
	memset(&(dest_addr.sin_zero), '\0', 8);

#if 0	
	//memcpy(&(packet.data), payload, payload_length);
	//printf("packet.data.header.opcode = %d\n", packet.data.header.opcode);
	//printf("payload->header.opcode = %d\n", payload->header.opcode);
  	/*packet.data.header.name_trn_id = generate_name_trn_id();
  	packet.data.header.opcode = NMB_NAME_QUERY_OPCODE;
  	packet.data.header.arcount = 0;
  	packet.data.header.nm_flags.recursion_desired = False;*/
	memset(&nmb,'\0',sizeof(nmb));
  	nmb.header.name_trn_id = _generate_name_trn_id();
  	nmb.header.opcode = NMB_NAME_QUERY_OPCODE;
  	nmb.header.response = False;
  	nmb.header.nm_flags.recursion_desired = rec_des;
  	nmb.header.nm_flags.recursion_available = False;
  	nmb.header.nm_flags.trunc = False;
  	nmb.header.nm_flags.authoritative = False;
  	nmb.header.nm_flags.bcast = bcast;
  
  	nmb.header.rcode = 0;
  	nmb.header.qdcount = 1;
  	nmb.header.ancount = 0;
  	nmb.header.nscount = 0;

  	nmb.question.question_name = *nmbname;
  	nmb.question.question_type = QUESTION_TYPE_NB_QUERY;
  	nmb.question.question_class = QUESTION_CLASS_IN;
	//printf("packet.data.header.opcode = %d\n", packet.data.header.opcode);
	//printf("payload->header.opcode = %d\n", payload->header.opcode);
	
	
	//build_nmb(buf,nmb);
	
	packet.ip.tot_len = htons(sizeof(packet.ip) + sizeof(packet.udp) + payload_length);
	packet.ip.ihl = sizeof(packet.ip) >> 2;
	packet.ip.version = IPVERSION;
	packet.ip.ttl = IPDEFTTL;
	packet.ip.check = checksum(&(packet.ip), sizeof(packet.ip));
	packet.udp.source = htons(source_port);
	packet.udp.dest = htons(dest_port);
	packet.udp.len = htons(sizeof(packet.udp) + payload_length);
	packet.udp.check = checksum(&packet, sizeof(packet.ip) + sizeof(packet.udp) + payload_length);
#endif
	result = sendto(fd, &buf/*&nmb*/, sizeof(buf), 0, (struct sockaddr *) &dest_addr, sizeof(struct sockaddr));
	
	if (result <= 0) {
		close(fd);
		printf("write on socket failed: %s", __FUNCTION__);
		return -1;
	}
	
	
	/* write and send */
	/*for (i = 0; i < sizeof(buf); i++) {
	  	unsigned char *ptr;

		ptr = (unsigned char *)&buf;
		printf("%02x ", ptr[i]);
	}*/
	DPRINTF("\n");
	DPRINTF("%d The NetBIOS NAME QUERRY packet is sent. The matrix is around you!\n", sizeof(buf));

	tm.tv_usec = 0;
	time(&prevTime);

	while (timeout > 0) {  
		FD_ZERO(&in);
		FD_SET(fd, &in);
		tm.tv_sec = timeout;		/* wait 2 sec */
		tm.tv_usec = 0;
		
		ret = select(fd+1, &in, NULL, NULL, &tm);
		if (ret == -1) {
			printf("%s: error in select\n", __FUNCTION__);
			goto check_timeout;
		} else if ( ret == 0 ) {
			printf("%s: timeout in select\n", __FUNCTION__);
			goto check_timeout;
		} else if (FD_ISSET(fd, &in)){
			DPRINTF("NetBios response is received.... \n");
			memset(&nmb, 0, sizeof(nmb));
			bytes = read(fd, &nmb, sizeof(nmb));
			//printf("bytes = %d\n", bytes);
			if (bytes <= 0) {
				printf("%s: recv error !\n", __FUNCTION__);
				goto check_timeout;
			}
			
			if (ntohs(nmb.header.opcode) != 0x8400) {
				printf("not correct name query response\n");
				goto check_timeout;
			}						
			
#ifdef ATTACHED_DEVICES
			//unsigned char hostname[20];
			//memset(hostname, 0, 20);
			nmb.answers.rdata[15] = '\0';	
			DPRINTF("nmb.answers->rdata = %s\n", nmb.answers.rdata);
			
			for (i = 0; i < 15; i++) {
				if(nmb.answers.rdata[i] == NULL || nmb.answers.rdata[i] == 0x20)
					break;
				else
					//strcpy(name/*hostname*/, nmb.answers.rdata);
					name[i] = nmb.answers.rdata[i];
			}
			name[i] = 0;	
			close(fd);
			DPRINTF("name = %s\n", name);
#else
			memcpy(device_scand[cnt].hostname, nmb.answers.rdata, 16);
#endif

			if (name[0] != NULL)
				return 1;
			else
				return 2;
			
#if 0
			printf("sizeof(unsigned short) = %d\n", sizeof(unsigned short) );
			printf("nmb.name_trn_id 	 = %04x\n", nmb.header.name_trn_id);
			printf("nmb.header.opcode = %04x\n", nmb.header.opcode);
			//printf("nmb.header.nmflags.response = %x\n", nmb.header.nmflags.response);
			//printf("nmb.header.nmflags.opcode = %x\n", nmb.header.nmflags.opcode);
			//printf("nmb.header.nmflags.authoritative = %x\n", nmb.header.nmflags.authoritative);
			//printf("nmb.header.nmflags.trunc = %x\n", nmb.header.nmflags.trunc);
			//printf("nmb.header.nmflags.recursion_desired = %x\n", nmb.header.nmflags.recursion_desired);
			//printf("nmb.header.nmflags.recursion_available = %x\n", nmb.header.nmflags.recursion_available);
			//printf("nmb.header.nmflags.reserved = %x\n", nmb.header.nmflags.reserved);
			//printf("nmb.header.nmflags.broadcast = %x\n", nmb.header.nmflags.broadcast);
			//printf("nmb.header.nmflags.rcode = %x\n", nmb.header.nmflags.rcode);
			printf("nmb.qdcount = %04x\n", nmb.header.qdcount);
			printf("nmb.ancount = %04x\n", nmb.header.ancount);
			printf("nmb.qdcount = %04x\n", nmb.header.nscount);
			printf("nmb.ancount = %04x\n", nmb.header.arcount);
			printf("sizeof(unsigned long) = %d\n", sizeof(unsigned long));
			printf("nmb.answers.rr_name = %s\n", &nmb.answers.rr_name);
			printf("nmb.answers.rr_type = %04x\n", nmb.answers.rr_type);
			printf("nmb.answers.rr_class = %04x\n", nmb.answers.rr_class);
			printf("nmb.answers.ttl = %x\n", nmb.answers.ttl);
			printf("nmb.answers.ttl_2 = %x\n", nmb.answers.ttl_2);
			printf("nmb.answers.rdlength = %04x\n", nmb.answers.rdlength);
			printf("nmb.answers.num_name = %02x\n", nmb.answers.num_name);
			printf("nmb.answers->rdata[0] = %s\n", nmb.answers.rdata);
			//sprintf("device_scand[cnt].hostname, "%s", nmb.answers.rdata);
			//printf("-----cnt = %d\n", cnt);
			//memcpy(device_scand[cnt].hostname, nmb.answers.rdata, 34);
			//printf("device_scand[cnt].hostname = %s\n", device_scand[cnt].hostname);
			//printf("query wins server response from %d.%d.%d.%d\n",device_scand[cnt].scan_dst_ip[0],device_scand[cnt].scan_dst_ip[1], device_scand[cnt].scan_dst_ip[2], device_scand[cnt].scan_dst_ip[3]);
	                //printf("destMac = ");
	                //printf("%02x %02x %02x %02x %02x %02x\n", device_scand[cnt].scan_dst_hw[0], device_scand[cnt].scan_dst_hw[1], device_scand[cnt].scan_dst_hw[2], device_scand[cnt].scan_dst_hw[3], device_scand[cnt].scan_dst_hw[4], device_scand[cnt].scan_dst_hw[5]);
#endif
		}
	
check_timeout:
		timeout -= time(NULL) - prevTime;
		time(&prevTime);
	}
	close(fd);
	
	return -1;
	
}

#if 0
/*******************************************************************
  build a nmb packet ready for sending

  XXXX this currently relies on not being passed something that expands
  to a packet too big for the buffer. Eventually this should be
  changed to set the trunc bit so the receiver can request the rest
  via tcp (when that becomes supported)
  ******************************************************************/
static int build_nmb(char *buf,struct nmb_packet *nmb)
{
  //struct nmb_packet *nmb = &p->packet.nmb;
  unsigned char *ubuf = (unsigned char *)buf;
  int offset=0;

  printf("%d = %s\n", __LINE__, __FUNCTION__);
  /* put in the header */
  RSSVAL(ubuf,offset,nmb->header.name_trn_id);
  printf("%d = %s\n", __LINE__, __FUNCTION__);
  
 #if 0
  ubuf[offset+2] = (nmb->header.opcode & 0xF) << 3;
  if (nmb->header.response) ubuf[offset+2] |= (1<<7);
  if (nmb->header.nm_flags.authoritative && 
      nmb->header.response) ubuf[offset+2] |= 0x4;
  if (nmb->header.nm_flags.trunc) ubuf[offset+2] |= 0x2;
  if (nmb->header.nm_flags.recursion_desired) ubuf[offset+2] |= 0x1;
  if (nmb->header.nm_flags.recursion_available &&
      nmb->header.response) ubuf[offset+3] |= 0x80;
  if (nmb->header.nm_flags.bcast) ubuf[offset+3] |= 0x10;
  ubuf[offset+3] |= (nmb->header.rcode & 0xF);

  RSSVAL(ubuf,offset+4,nmb->header.qdcount);
  RSSVAL(ubuf,offset+6,nmb->header.ancount);
  RSSVAL(ubuf,offset+8,nmb->header.nscount);
  RSSVAL(ubuf,offset+10,nmb->header.arcount);
  printf("%d = %s\n", __LINE__, __FUNCTION__);
  offset += 12;
  if (nmb->header.qdcount) {
    /* XXXX this doesn't handle a qdcount of > 1 */
    offset += put_nmb_name((char *)ubuf,offset,&nmb->question.question_name);
    RSSVAL(ubuf,offset,nmb->question.question_type);
    RSSVAL(ubuf,offset+2,nmb->question.question_class);
    offset += 4;
  }

  if (nmb->header.ancount)
    offset += put_res_rec((char *)ubuf,offset,nmb->answers,
			  nmb->header.ancount);

  if (nmb->header.nscount)
    offset += put_res_rec((char *)ubuf,offset,nmb->nsrecs,
			  nmb->header.nscount);

  /*
   * The spec says we must put compressed name pointers
   * in the following outgoing packets :
   * NAME_REGISTRATION_REQUEST, NAME_REFRESH_REQUEST,
   * NAME_RELEASE_REQUEST.
   */

  if((nmb->header.response == False) &&
     ((nmb->header.opcode == NMB_NAME_REG_OPCODE) ||
      (nmb->header.opcode == NMB_NAME_RELEASE_OPCODE) ||
      (nmb->header.opcode == NMB_NAME_REFRESH_OPCODE_8) ||
      (nmb->header.opcode == NMB_NAME_REFRESH_OPCODE_9) ||
      (nmb->header.opcode == NMB_NAME_MULTIHOMED_REG_OPCODE)) &&
     (nmb->header.arcount == 1)) {

    offset += put_compressed_name_ptr(ubuf,offset,nmb->additional,12);

  } else if (nmb->header.arcount) {
    offset += put_res_rec((char *)ubuf,offset,nmb->additional,
			  nmb->header.arcount);  
  }

#endif
  return(offset);
}

/*******************************************************************
  put a compressed nmb name into a buffer. return the length of the
  compressed name

  compressed names are really weird. The "compression" doubles the
  size. The idea is that it also means that compressed names conform
  to the doman name system. See RFC1002.
  ******************************************************************/
static int put_nmb_name(char *buf,int offset,struct nmb_name *name)
{
  int ret,m;
  fstring buf1;
  char *p;

  printf("%d = %s\n", __LINE__, __FUNCTION__);
  if (strcmp(name->name,"*") == 0) {
    /* special case for wildcard name */
    memset(buf1,'\0',20);
    buf1[0] = '*';
    buf1[15] = name->name_type;
  } else {
    slprintf(buf1, sizeof(buf1) - 1,"%-15.15s%c",name->name,name->name_type);
  }

  buf[offset] = 0x20;

  ret = 34;

  for (m=0;m<16;m++) {
    buf[offset+1+2*m] = 'A' + ((buf1[m]>>4)&0xF);
    buf[offset+2+2*m] = 'A' + (buf1[m]&0xF);
  }
  offset += 33;

  buf[offset] = 0;

  if (name->scope[0]) {
    /* XXXX this scope handling needs testing */
    ret += strlen(name->scope) + 1;
    pstrcpy(&buf[offset+1],name->scope);  
  
    p = &buf[offset+1];
    while ((p = strchr(p,'.'))) {
      buf[offset] = PTR_DIFF(p,&buf[offset+1]);
      offset += (buf[offset] + 1);
      p = &buf[offset+1];
    }
    buf[offset] = strlen(&buf[offset+1]);
  }

  return(ret);
}

#define HAVE_STDARG_H

#ifdef HAVE_STDARG_H
 int slprintf(char *str, int n, char *format, ...)
{
#else
 int slprintf(va_alist)
va_dcl
{
	char *str, *format;
	int n;
#endif
	va_list ap;  
	int ret;

#ifdef HAVE_STDARG_H
	va_start(ap, format);
#else
	va_start(ap);
	str = va_arg(ap,char *);
	n = va_arg(ap,int);
	format = va_arg(ap,char *);
#endif

	ret = vslprintf(str,n,format,ap);
	va_end(ap);
	return ret;
}

/*******************************************************************
  put a resource record into a packet
  ******************************************************************/
static int put_res_rec(char *buf,int offset,struct res_rec *recs,int count)
{
  int ret=0;
  int i;

  for (i=0;i<count;i++) {
    int l = put_nmb_name(buf,offset,&recs[i].rr_name);
    offset += l;
    ret += l;
    RSSVAL(buf,offset,recs[i].rr_type);
    RSSVAL(buf,offset+2,recs[i].rr_class);
    RSIVAL(buf,offset+4,recs[i].ttl);
    RSSVAL(buf,offset+8,recs[i].rdlength);
    memcpy(buf+offset+10,recs[i].rdata,recs[i].rdlength);
    offset += 10+recs[i].rdlength;
    ret += 10+recs[i].rdlength;
  }

  return(ret);
}

/*******************************************************************
  put a compressed name pointer record into a packet
  ******************************************************************/
static int put_compressed_name_ptr(unsigned char *buf,int offset,struct res_rec *rec,int ptr_offset)
{  
  int ret=0;
  buf[offset] = (0xC0 | ((ptr_offset >> 8) & 0xFF));
  buf[offset+1] = (ptr_offset & 0xFF);
  offset += 2;
  ret += 2;
  RSSVAL(buf,offset,rec->rr_type);
  RSSVAL(buf,offset+2,rec->rr_class);
  RSIVAL(buf,offset+4,rec->ttl);
  RSSVAL(buf,offset+8,rec->rdlength);
  memcpy(buf+offset+10,rec->rdata,rec->rdlength);
  offset += 10+rec->rdlength;
  ret += 10+rec->rdlength;
    
  return(ret);
}

/*******************************************************************
safe string copy into a known length string. maxlength does not
include the terminating zero.
********************************************************************/

char *safe_strcpy(char *dest,const char *src, size_t maxlength)
{
    size_t len;

    if (!dest) {
        DEBUG(0,("ERROR: NULL dest in safe_strcpy\n"));
        return NULL;
    }

    if (!src) {
        *dest = 0;
        return dest;
    }  

    len = strlen(src);

    if (len > maxlength) {
	    DEBUG(0,("ERROR: string overflow by %d in safe_strcpy [%.50s]\n",
		     (int)(len-maxlength), src));
	    len = maxlength;
    }
      
    memcpy(dest, src, len);
    dest[len] = 0;
    return dest;
}  

/* this is like vsnprintf but the 'n' limit does not include
   the terminating null. So if you have a 1024 byte buffer then
   pass 1023 for n */
int vslprintf(char *str, int n, char *format, va_list ap)
{
	int ret = vsnprintf(str, n, format, ap);
	if (ret > n || ret < 0) {
		str[n] = 0;
		return -1;
	}
	str[ret] = 0;
	return ret;
}

#if 0
/* Let the kernel do all the work for packet generation */
int kernel_packet(struct nmb_packet *payload, u_int32_t source_ip, int source_port,
		   u_int32_t dest_ip, int dest_port)
{
	int n = 1;
	int fd, result, payload_length = calc_length(payload);
	struct sockaddr_in client;
	
	if ((fd = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
		return -1;
	
	if (setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, (char *) &n, sizeof(n)) == -1)
		return -1;

	memset(&client, 0, sizeof(client));
	client.sin_family = AF_INET;
	client.sin_port = htons(source_port);
	client.sin_addr.s_addr = source_ip;

	if (bind(fd, (struct sockaddr *)&client, sizeof(struct sockaddr)) == -1)
		return -1;

	memset(&client, 0, sizeof(client));
	client.sin_family = AF_INET;
	client.sin_port = htons(dest_port);
	client.sin_addr.s_addr = dest_ip; 

	if (connect(fd, (struct sockaddr *)&client, sizeof(struct sockaddr)) == -1)
		return -1;

	result = write(fd, payload, payload_length);
	close(fd);
	return result;
}	
#endif
#endif
