/*
* --------------------------------------------------------------------------
*
*/

#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <re865x.h>
#include <board.h>
//#include <string.h>
#include <stdlib.h>
#include "rtl_board.h"
#include <linux/config.h>

/* global cfg structure pointer */
extern romeCfgParam_t *pRomeCfgParam;

#if defined(DNI)
unsigned long ppp_ipup_time = 0;
extern int ppp_mtu;
#endif


void ipupdown(int argc, char*argv[])
{
	uint32   i;
	char     tempStr[30];
	uint32   pppObjId;
	ipaddr_t myIp;
	ipaddr_t myGw;
	ipaddr_t myPrimaryDns;
	ipaddr_t mySecondaryDns;
	ipaddr_t myPrimaryWins;
	ipaddr_t mySecondaryWins;
	uint16   mySessionId;
	uint8    myMac[6];
	uint8    pppx;
#ifdef	CONFIG_WAN_LAN_MATCH_DETECTION

#define SIGSUBNETMATCH 90

	char *RetVal;
	uint32 wanip, lanip, lanmask;
#endif

	rtl8651_sem_wait(SEMAPHORE_IPUPDOWN);
	
	printf("entering ipupdown ...\n");

	/* init CFGMGR before doing IP up / down */
	board_cfgmgr_init(TRUE);

	if (strstr(argv[0],"ip-up"))
	{

		FILE *f;
		int i;

#if defined(DNI)
       pRomeCfgParam->pppoeCfgParam[0].uptime = GetSysUpTime();
       pRomeCfgParam->pptpCfgParam.uptime = GetSysUpTime();
       pRomeCfgParam->l2tpCfgParam.uptime = GetSysUpTime();
              
       log_message("WAN Connected");	       
#endif       

		f=fopen("/var/ip-up.txt","w");
		for(i=0;i<13;i++)				
			fprintf(f,"%02d [%s]\n",i,argv[i]);
		fclose(f);
	
		
		memset(tempStr,0,sizeof(tempStr));

		for (i=0;i<6;i++)
		{
			memcpy(tempStr,(char*)&argv[7][i*3],3);


			
			myMac[i]=(unsigned char)strtoul(tempStr,NULL,16);
		}
		
		myIp = (ipaddr_t)inet_addr(argv[5]);
		myGw = (ipaddr_t)inet_addr(argv[6]);
		myPrimaryDns = (ipaddr_t)inet_addr(argv[8]);
		mySecondaryDns = (ipaddr_t)inet_addr(argv[9]);
		mySessionId = (uint16)strtoul(argv[4],NULL,10);
		myPrimaryWins = (ipaddr_t)inet_addr(argv[11]);
		mySecondaryWins = (ipaddr_t)inet_addr(argv[12]);
		ppp_mtu = atoi(argv[13]);

		pppx = (uint8)(argv[1][3] - '0');
	
		//pppObjId = 0; /* default harmless value */
		//for(i=0;i<MAX_PPPOE_SESSION;i++)
		//	if (pRomeCfgParam->pppoeCfgParam[i].dialState == PPPOECFGPARAM_DIALSTATE_DIALED_TRYING)
		//	{
		//		pRomeCfgParam->pppoeCfgParam[i].pppx = pppx;
		//		pppObjId = i;
		//	}
		
		
		if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE)
		{						
			pppObjId = (uint32)strtoul(argv[10],NULL,10);
			pRomeCfgParam->pppoeCfgParam[pppObjId].pppx = pppx;
			
			memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&myIp,4);
			i=0xffffffff;memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
			memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&myGw,4);
			if (pRomeCfgParam->dnsCfgParam.enable == 0) {
			  memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&myPrimaryDns,4);
			  memcpy(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,&mySecondaryDns,4);
			}  
			if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
			{
				pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = myPrimaryWins;
				pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = mySecondaryWins;
			}
			memcpy(pRomeCfgParam->pppoeCfgParam[0].svrMac,myMac,6);
			pRomeCfgParam->pppoeCfgParam[0].sessionId=mySessionId;
		}
		else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPTP)
		{
			memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&myIp,4);
			i=0xffffffff;memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
			memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&myGw,4);
			if (pRomeCfgParam->dnsCfgParam.enable == 0) {
			  memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&myPrimaryDns,4);
			  memcpy(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,&mySecondaryDns,4);
			}  
			if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
			{
				pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = myPrimaryWins;
				pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = mySecondaryWins;
			}
			//system("/bin/iptables -t nat -A POSTROUTING -o ppp0 -j MASQUERADE");			
		}
		else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_L2TP)
		{
			memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&myIp,4);
			i=0xffffffff;memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
			memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&myGw,4);
			if (pRomeCfgParam->dnsCfgParam.enable == 0) {			
				memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&myPrimaryDns,4);
				memcpy(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,&mySecondaryDns,4);
			}	
			if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
			{
				pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = myPrimaryWins;
				pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = mySecondaryWins;
			}
			//system("/bin/iptables -t nat -A POSTROUTING -o ppp0 -j MASQUERADE");			
		}		
		else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP)
		{
			memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&myIp,4);
			i=0xffffffff;memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
			memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&myGw,4);
			memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&myPrimaryDns,4);	
			memcpy(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,&mySecondaryDns,4);
			if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
			{
				pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = myPrimaryWins;
				pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = mySecondaryWins;
			}
		}		
		else {
			return ;
		}
#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
	memcpy((void*)&lanip,pRomeCfgParam->ifCfgParam[1].ipAddr,sizeof(lanip));
	memcpy((void*)&lanmask,pRomeCfgParam->ifCfgParam[1].ipMask,sizeof(lanmask));
	RetVal = nvram_get("wan0_ipaddr");
	wanip=(uint32)inet_addr(RetVal);
	lanip &= lanmask;
	wanip &= lanmask;
	if(lanip == wanip) { 
		kill(1,SIGSUBNETMATCH);
	}
#endif

		//dhcps_start();
		
		/* configure the asic thru table driver APIs */
		
		board_ipUpEventTableDriverAccess();
		
	} /* end "ip-up" */

	
	/********************************************************************/
	/********************************************************************/
	/********************************************************************/
	
	if (strstr(argv[0],"ip-down"))
	{


		FILE *f;
		int i;

#if defined(DNI)
              pRomeCfgParam->pppoeCfgParam[0].uptime = 0;
       	      pRomeCfgParam->pptpCfgParam.uptime = 0;
 
	      log_message("WAN DisConnected");
#endif

		f=fopen("/var/ip-down.txt","w");
		for(i=0;i<10;i++)				
			fprintf(f,"%02d [%s]\n",i,argv[i]);
		fclose(f);

	
		myIp = (ipaddr_t)inet_addr(argv[5]);
		myGw = (ipaddr_t)inet_addr(argv[6]);
		myPrimaryDns = (ipaddr_t)inet_addr(argv[8]);
		mySecondaryDns = (ipaddr_t)inet_addr(argv[9]);


		/* fetch pRomeCfgParam from argument list */

		pppx=0;
		pppObjId=0;
		
		if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC)
		{
			/* dhcp renew */
		}				
		else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE)
		{
			/* single pppoe hangup case */			
			pRomeCfgParam->pppoeCfgParam[0].dialState = PPPOECFGPARAM_DIALSTATE_OFF;
		}
		else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPTP)
		{
			/* single pptp hangup case */			
			pRomeCfgParam->pptpCfgParam.dialState = PPTPCFGPARAM_DIALSTATE_DISCONNECTING;
			//system("/bin/iptables -t nat -F");			
		}
		else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_L2TP)
		{
			/* single l2tp hangup case */			
			pRomeCfgParam->l2tpCfgParam.dialState = L2TPCFGPARAM_DIALSTATE_OFF;
			//system("/bin/iptables -t nat -F");			
		}		
		else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP)
		{			
			pRomeCfgParam->l2tpCfgParam.dialState = L2TPCFGPARAM_DIALSTATE_OFF;
		}		
		else {
			return ;
		}

		/* configure the asic thru table driver APIs */
		board_ipDownEventTableDriverAccess();

	} /* end "ip-down" */

	rtl8651_sem_post(SEMAPHORE_IPUPDOWN);

} /* end ipupdown() */

/* end ipupdown.c */


