/*
 *
 */

#ifndef _rtl_board_h_
#define _rtl_board_h_

#define CONFIG_CHANGE_FW_VER	1
#define CONFIG_CHANGE_LD_VER	(1<<1)
#define CONFIG_CHANGE_NAT		(1<<2)
#define CONFIG_CHANGE_HW_ACCEL	(1<<3)
#define CONFIG_CHANGE_LAN_IP	(1<<4)
#define CONFIG_CHANGE_LAN_MASK	(1<<5)
#define CONFIG_CHANGE_LAN_MAC	(1<<6)
#define CONFIG_CHANGE_DHCPS		(1<<7)
#define CONFIG_CHANGE_CONN_TYPE	(1<<8)
#define CONFIG_CHANGE_WAN_IP	(1<<9)
#define CONFIG_CHANGE_WAN_MASK	(1<<10)
#define CONFIG_CHANGE_WAN_GW	(1<<11)
#define CONFIG_CHANGE_WAN_DNS	(1<<12)
#define CONFIG_CHANGE_WAN_MAC	(1<<13)
#define CONFIG_CHANGE_RTL8185		(1<<14)

#include "rtl_types.h"
#include "board.h"
#include <linux/config.h>

/*
	For CFGMGR system control.
*/
typedef struct _board_cfgmgr_ctrl_s {
	uint16 tableId;
	void *dafaultPtr;
	uint32 defaultSize;
} _board_cfgmgr_ctrl_t;

enum _board_cfgmgr_tabId_e {
	CFGMGR_TABID_NULL					= 0, /* do not remove this line */
	/* ============================================================= */
	/* inter your module's ID below */
	CFGMGR_TABID_VLAN,
	CFGMGR_TABID_IF,
	CFGMGR_TABID_ROUTE,
	CFGMGR_TABID_ARP,
	CFGMGR_TABID_NAT,
	CFGMGR_TABID_MGMT,
	CFGMGR_TABID_PPPOE,
	CFGMGR_TABID_DHCPS,
	CFGMGR_TABID_DHCPC,
	CFGMGR_TABID_DNS,
	CFGMGR_TABID_DMZ,
	CFGMGR_TABID_LOG,
	CFGMGR_TABID_UPNP,
	CFGMGR_TABID_DDNS,
	CFGMGR_TABID_ACL,
	CFGMGR_TABID_ACL_GLOBAL,
	CFGMGR_TABID_SERVERP,
	CFGMGR_TABID_SPECIALAP,
	CFGMGR_TABID_TBLDRV,
	CFGMGR_TABID_URLFILTER,
	CFGMGR_TABID_DOS,
	CFGMGR_TABID_ALG,
	CFGMGR_TABID_TIME,
	CFGMGR_TABID_UDPBLOCK,
	CFGMGR_TABID_ROUTING,
	CFGMGR_TABID_PPTP,
	CFGMGR_TABID_QOS,
	CFGMGR_TABID_PBNAT,
	CFGMGR_TABID_RATELIMIT,
	CFGMGR_TABID_RATIOQOS,
	CFGMGR_TABID_NAPT,
	CFGMGR_TABID_MODE,
	CFGMGR_TABID_RIP,
	CFGMGR_TABID_PSEUDOVLAN,
	CFGMGR_TABID_PASSTHRU,
	CFGMGR_TABID_IPMULTICAST,
	CFGMGR_TABID_GAMING,	
	CFGMGR_TABID_DOMAINBLOCK,
	CFGMGR_TABID_URLFILTERTRUSTEDUSER,
	/* insert your module's ID above */
#if defined(DNI)	
	CFGMGR_TABID_SCHEDULE, //Add by Timo
	CFGMGR_TABID_EMAIL,	
	CFGMGR_TABID_TEL,
	CFGMGR_TABID_BLANK_STATE, //Append by Kevin
	CFGMGR_TABID_MNU,
//Yili 2006/1/10
	CFGMGR_TABID_HTTPC_INFO,	
#endif
	CFGMGR_TABID_WLAN,
	CFGMGR_TABID_L2TP,
//Added end
#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
	CFGMGR_TABID_WAN_LAN_MATCH_DETECTION,
#endif
	/* ============================================================= */
	CFGMGR_TABID_MAX				/* do not remove this line */
};


/* semaphore */
uint32 rtl8651_sem_init(uint8 val);
void rtl8651_sem_wait(uint32 sem_type);
void rtl8651_sem_post(uint32 sem_type);

uint32 vlan_init(void);
uint32 if_init(void);
uint32 staticroute_init(void);
uint32 arp_init(void);
uint32 nat_init(void);
uint32 dhcpc_init(void);
uint32 dns_init(void);
uint32 dmz_init(void);
uint32 log_init(void);
uint32 upnp_init(void);
uint32 snmp_init(void);
uint32 time_init(void);
uint32 urlfilter_init(void);
uint32 urlfilterTrsutedUser_init(void);
uint32 ddns_init(void);
uint32 dhcps_init(void);
uint32 pppoecfg_init(void);
uint32 acl_init(void);
uint32 acl_tableDriverAccess(void);
uint32 serverp_init(void);
uint32 serverp_tableDriverAccess(uint32 dsid);
uint32 specialap_init(void);
uint32 gaming_init(void);
uint32 pptpserver_init(void);
uint32 domainBlock_init(void);
uint32 wlan_init(void);
uint32 udpblock_init(void);
uint32 routing_init(void);
uint32 board_ipUpEventTableDriverAccess(void);
uint32 board_ipDownEventTableDriverAccess(void);
uint32 pptp_init(void);

#if defined(DNI)
uint32 email_init(void);
uint32 tel_init(void);
uint32 mnu_init(void); //Yili 2006/1/10
#endif

uint32 pbnat_init(void);
uint32 passthru_init(void);
uint32 ipMulticast_init(void);


extern ifCfgParam_t			ramWanCfgParam;
extern ifCfgParam_t			ramLanCfgParam;
extern dhcpsCfgParam_t		ramDhcpsCfgParam;
extern dhcpcCfgParam_t		ramDhcpcCfgParam;
extern pptpCfgParam_t		ramPptpCfgParam;
#if defined(DNI)
extern telCfgParam_t		ramTelCfgParam;
extern mnuCfgParam_t		ramMnuCfgParam;
//Yili 2006/1/10
#endif
extern serverpCfgParam_t	ramServerpCfgParam[][];
extern pppoeCfgParam_t		ramPppoeCfgParam[];
extern uint32 				configChanged;
#endif /* _rtl_board_h_ */
