#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>
#include <signal.h>
#include <string.h>
#include	<net/if.h>

#include <sys/sysinfo.h>
#include <unistd.h>
#include "dni_shutils.h"

// For calling rome driver API
/* uClinux-dist/include ln -s */
#include <rtl8651_tblDrv.h>
#include <re865x.h>


//#define DPRINTF		printf
#define DPRINTF	


extern int g_hearbeat_is_listening;
static int g_sys_is_restarting=0;

static int bLastWanState, bCurWanState;
static int bLastLinkState, bCurLinkState;
void on_signal(int i)
{
    printf("%s::recvd sig:%d\n", __FUNCTION__, i);
    if( i == SIGUSR1 )
		g_hearbeat_is_listening=1;		/* lan listen for demand */
    else if( i == SIGUSR2)
		g_hearbeat_is_listening=0;
    else if( i== SIGHUP )
		g_sys_is_restarting = 1;
		
    signal(i, on_signal);
}

static void log_pid()
{
	FILE *f;
	pid_t pid;
	char *pidfile = "/var/run/checkwan.pid";

	pid = getpid();
	if((f = fopen(pidfile, "w")) == NULL)
		return;
	fprintf(f, "%d\n", pid);
	fclose(f);
}

#define SLEEP_SHORT		5
#define SLEEP_LONG		60

void run_boa(void)
{
	char *argv[] = {
		"/bin/boa",
		"-c",
		"/etc",
		NULL
	};
	int pid;

	//_eval(argv, NULL, 0, &pid);
	eval("killall", "-9", "boa");
	system("/bin/boa -c /etc &");
	printf("run_boa\n");	
}

void run_dnrd(void)
{
	char *argv[] = {
		"/bin/dnrd",
		NULL
	};
	int pid;

	//_eval(argv, NULL, 0, &pid);
	eval("killall", "-9", "dnrd");
	system("/bin/dnrd &");
	printf("run_dnrd\n");	
}



int main( int argc, char **argv)
{
int sleep_interval=SLEEP_SHORT;
unsigned long sleep_short_nums=0;
int s;
struct ifreq ifr;
int test = 0;

	log_pid();
	
	bLastWanState = WAN_INIT;
	bLastLinkState = LINK_INIT;

	signal(SIGCHLD, SIG_IGN);  //to prevent zombies process
	signal(SIGUSR1,on_signal);  //heartbeat is listening lan interface
	signal(SIGUSR2,on_signal);  //heartbeat is NOT listening lan interface
	signal(SIGHUP, on_signal); //if system is restarting
	
	sleep(10);

	while( 1 )
	{
#if 0		
		static int cnt = 0;
		
		if (cnt++ >= 1)
			kill(1, SIGQUIT);
#endif			
		
		if (!task_is_running("boa")) {
			sleep(1);
			if (!task_is_running("boa")) {
				unlink("var/run/boa.pid");
				run_boa();
				sleep(30);
			}	
		}
		if (!task_is_running("dnrd")) {
			sleep(1);
			if (!task_is_running("dnrd")) {
				unlink("var/run/dnrd.pid");
				run_dnrd();
			}	
		}				
		if( (bCurLinkState = getWanLinkState( s, &ifr, NULL )) == LINK_DOWN )  //we don't need to know speed
		{	// current Link down
			if( bLastLinkState == LINK_UP )	{		
				sleep(2);
				bCurLinkState = getWanLinkState( s, &ifr, NULL );
				if (bCurLinkState != LINK_DOWN) 
					goto CheckWan_Loop;					
			}		
			setLedLight(WAN_LED, LED_AMBER);		
			if( bLastLinkState != bCurLinkState ) 
			{ // Last Link state is LINK_INIT or LINK_UP
				if( bLastLinkState == LINK_INIT )
				{
					bLastLinkState = LINK_DOWN;
					sleep_interval=SLEEP_SHORT;
					DPRINTF("[T%d]:LINK_INIT==>LINK_DOWN\n", GetSysUpTime());
				}
				else if( bLastLinkState == LINK_UP )
				{ 
					bLastLinkState = LINK_DOWNING;
					sleep_interval=SLEEP_SHORT;
					DPRINTF("[T%d]:LINK_UP==>LINK_DOWNING\n", GetSysUpTime());
				}
				else if( bLastLinkState == LINK_DOWNING )
				{
					bLastLinkState = LINK_DOWN;
					DPRINTF("[T%d]:LINK_DOWNING==>LINK_DOWN, calling StopWan...\n", 
										GetSysUpTime());
					wan_stop("eth0");
					sleep_interval=SLEEP_SHORT;
				}
			} 
			else
			{
				DPRINTF("[T%d]:LINK_DOWN==>LINK_DOWN\n", GetSysUpTime());
			}
		} 
		else if( bCurLinkState == LINK_UP )// current Link UP
		{
			if( bLastLinkState != LINK_UP )
			{	// Last Link State is LINK_INIT or LINK_DOWN
				if( bLastLinkState == LINK_INIT )
				{
					bLastLinkState = LINK_UP;
					sleep_interval=SLEEP_SHORT;
					DPRINTF("[T%d]:LINK_INIT==>LINK_UP\n", GetSysUpTime());
				} 
				else
				{	//Last Link State is LINK_DOWN
					bLastLinkState = LINK_UP;
					DPRINTF("[T%d]:LINK_DOWN==>LINK_UP\n", GetSysUpTime());
					if (!strcmp(nvram_get("wan_proto"), "static"))
						setLedLight(WAN_LED, LED_GREEN);
					wan_start("eth0");
				}
			}
			else // LINK is always LINK_UP
			{
				DPRINTF("[T%d]:LINK_UP==>LINK_UP\n", GetSysUpTime());
			}	

		}
		else
		{
			DPRINTF("%s::getWanLinkState ret (-1)\n", __FUNCTION__);
		}

		//if (g_sys_is_restarting) {
		//  sleep(3);
		//  re865xIoctl("eth0", RTL8651_IOCTL_REBOOT,0,0,0);
		//}
CheckWan_Loop:		
		sleep(sleep_interval);
	}
}


