/*
 *
 */

//#include <string.h>
//#include "board.h"
//#include <rt_stack/h/sys/porting.h>
//#include "rtl_cfgmgr.h"
#include "../boa/src/rtl865x/rtl_board.h" /* exported function prototypes */
#include <rtl8651_tblDrv.h>
#include <re865x.h>
#include <linux/config.h>
int re865xIoctl(char *name,uint32 arg0, uint32 arg1, uint32 arg2, uint32 arg3);

int32 rtl8651_getChipVersion(int8 * name, uint32 size, int32 * rev)
{
	int32 ret;
	uint32 ptr[3];
	ptr[0] = (uint32)name;
	ptr[1] = (uint32)size;
	ptr[2] = (uint32)rev;

	re865xIoctl("eth0", RTL8651_IOCTL_GETCHIPVERSION, (uint32)ptr, 0, (int32)&ret);
	return ret;
}

int32 rtl8651_reProbe(void)
{
	int32 ret;
	re865xIoctl("eth0", RTL8651_IOCTL_REPROBE, NULL, NULL, (int32) &ret);
	return ret;
}

// Re-init function of ROMEDRV
int32 rtl8651_tblDrvReinit(void)
{
	int32 ret;
	re865xIoctl("eth0", RTL8651_IOCTL_TBLDRVREINIT, NULL, NULL, (int32) &ret);
	return ret;
}

int32 rtl8651_fwdEngineReinit(void)
{
	int32 ret;
	re865xIoctl("eth0", RTL8651_IOCTL_FWDENGREINIT, NULL, NULL, (int32) &ret);
	return ret;
}

// Configure fwdEng drop case
int32 rtl8651_fwdEngineDropPktCase(uint32 fwdengDropCase, int32 *flag) {
	int32 ret;
	uint32 ptr[2];

	ptr[0] = (uint32) fwdengDropCase;
	ptr[1] = (uint32) flag;
	re865xIoctl("eth0", RTL8651_IOCTL_FWDENGDROPPKTCASE, (uint32)ptr, 0, (uint32)&ret);
	return ret;
}

//ip-acl 
int32 rtl8651a_addAclRule(uint32 dsid,int8 * ifName, int8 inputCheck, rtl8651_tblDrvAclRule_t * rule)
{
	uint32 ret;
	uint32 ptr[4];
	//re865xIoctl(ifName,RTL8651_ADDIPACL,(uint32)(ifName),(uint32)inputCheck,(uint32*)rule);
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)ifName;
	ptr[2]=(uint32)inputCheck;
	ptr[3]=(uint32)rule;
	re865xIoctl(ifName,RTL8651_ADDACL,(uint32)(ptr),0,(uint32)&ret);
	return ret;
}

int32 rtl8651a_delAclRule(uint32 dsid,int8 * ifName, int8 inputCheck, rtl8651_tblDrvAclRule_t * rule)
{
	uint32 ret;
	uint32 ptr[4];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)ifName;
	ptr[2]=(uint32)inputCheck;
	ptr[3]=(uint32)rule;
	re865xIoctl(ifName,RTL8651_DELACL,(uint32)(ptr),0,(uint32)&ret);
	return ret;
}



int32 rtl8651a_addAclRuleExt(uint32 dsid,int8 * ifName, int8 inputCheck, rtl8651_tblDrvAclRule_t * rule)
{
	uint32 ret;
	uint32 ptr[4];
	//re865xIoctl(ifName,RTL8651_ADDIPACL,(uint32)(ifName),(uint32)inputCheck,(uint32*)rule);
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)ifName;
	ptr[2]=(uint32)inputCheck;
	ptr[3]=(uint32)rule;
	re865xIoctl(ifName,RTL8651_IOCTL_ADDACLEXT,(uint32)(ptr),0,(uint32)&ret);
	return ret;
}

int32 rtl8651a_delAclRuleExt(uint32 dsid,int8 * ifName, int8 inputCheck, rtl8651_tblDrvAclRule_t * rule)
{
	uint32 ret;
	uint32 ptr[4];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)ifName;
	ptr[2]=(uint32)inputCheck;
	ptr[3]=(uint32)rule;
	re865xIoctl(ifName,RTL8651_IOCTL_DELACLEXT,(uint32)(ptr),0,(uint32)&ret);
	return ret;
}




int32 rtl8651a_flushAclRule(uint32 dsid,int8 * ifName, int8 inputCheck)
{
	uint32 ret;
	uint32 ptr[3];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)ifName;
	ptr[2]=(uint32)inputCheck;
	re865xIoctl(ifName,RTL8651_FLUSHACLRULE,(uint32)ptr,0,(uint32)&ret);	
	return ret;
}


int32 rtl8651a_setDefaultAcl(uint32 dsid,int8 *ifName, int8 isDrop)
{
	uint32 ret;
	uint32 ptr[3];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)ifName;
	ptr[2]=(uint32)isDrop;
	re865xIoctl(ifName,RTL8651_SETDEFAULTACL ,(uint32)ptr,0,(uint32)&ret);
	//re865xIoctl(ifName,RTL8651_SETDEFAULTACL ,(uint32)(ifName),isDrop,(uint32)&ret);
	return ret;
}

//int32 rtl8651_delIpAcl(int8 * ifName, int8 inputCheck, rtl8651_tblDrvIpAclRule_t * rule);
//int32 rtl8651_delVlanIpAcl(uint16 vid, int8 inputCheck, rtl8651_tblDrvIpAclRule_t * rule);
//int32 rtl8651_flushVlanIpAcl(uint16 vid, int8 inputCheck);
//int32 rtl8651_addVlanIpAcl(uint16 vid, int8 inputCheck, rtl8651_tblDrvIpAclRule_t * rule);

int32 rtl8651a_addNaptServerPortMapping(uint32 dsid,int8 isTcp, ipaddr_t extIpAddr, uint16 extPort, ipaddr_t intIpAddr, uint16 intPort)
{
	uint32 ret;
	uint32 ptr[6];	
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)&isTcp;
	ptr[2]=(uint32)&extIpAddr;
	ptr[3]=(uint32)&extPort;
	ptr[4]=(uint32)&intIpAddr;
	ptr[5]=(uint32)&intPort;
	re865xIoctl("eth0",RTL8651_ADDNAPTSERVERPORTMAPPING,(uint32)(ptr),0,(uint32)&ret);
	return ret;	
}

int32 rtl8651a_delNaptServerPortMapping(uint32 dsid,int8 isTcp, ipaddr_t extIpAddr, uint16 extPort, ipaddr_t intIpAddr, uint16 intPort)
{
	uint32 ret;
	uint32 ptr[6];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)&isTcp;
	ptr[2]=(uint32)&extIpAddr;
	ptr[3]=(uint32)&extPort;
	ptr[4]=(uint32)&intIpAddr;
	ptr[5]=(uint32)&intPort;
	re865xIoctl("eth0",RTL8651_DELNAPTSERVERPORTMAPPING,(uint32)(ptr),0,(uint32)&ret);
	return ret;		
}


int32 rtl8651a_addNaptServerPortRange(uint32 dsid,int8 isTcp, ipaddr_t extIpAddr, uint16 extPort, ipaddr_t intIpAddr, uint16 intPort, uint16 nCount)
{
	uint32 ret;
	uint32 ptr[6];	
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)&isTcp;
	ptr[2]=(uint32)&extIpAddr;
	ptr[3]=(uint32)&extPort;
	ptr[4]=(uint32)&intIpAddr;
	ptr[5]=(uint32)&intPort;
	ptr[6]=(uint32)&nCount;	
	re865xIoctl("eth0",RTL8651_IOCTL_ADDNAPTSERVERPORTRANGE,(uint32)(ptr),0,(uint32)&ret);
	return ret;	
}

int32 rtl8651a_delNaptServerPortRange(uint32 dsid,int8 isTcp, ipaddr_t extIpAddr, uint16 extPort, ipaddr_t intIpAddr, uint16 intPort, uint16 nCount)
{
	uint32 ret;
	uint32 ptr[6];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)&isTcp;
	ptr[2]=(uint32)&extIpAddr;
	ptr[3]=(uint32)&extPort;
	ptr[4]=(uint32)&intIpAddr;
	ptr[5]=(uint32)&intPort;
	ptr[6]=(uint32)&nCount;	
	re865xIoctl("eth0",RTL8651_IOCTL_DELNAPTSERVERPORTRANGE,(uint32)(ptr),0,(uint32)&ret);
	return ret;		
}

int32 rtl8651_setAsicNaptAutoAddDelete(int8 autoAdd, int8 autoDelete)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)autoAdd;
	args[1]=(uint32)autoDelete;
	re865xIoctl("eth0",RTL8651_IOCTL_SETASICNAPTAUTOADDDELETE,(uint32)(args),(uint32)&ret,0);
	return ret;
} /* end rtl8651_setAsicNaptAutoAddDelete */

int32 rtl8651_enableNaptAutoAdd(int8 autoAdd)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)autoAdd;
	re865xIoctl("eth0",RTL8651_IOCTL_ENABLENAPTAUTOADD,(uint32)(args),(uint32)&ret,0);
	return ret;
} /* end rtl8651_enableNaptAutoAdd */

int32 rtl8651_addNetworkIntf(int8 *ifName)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)ifName;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDNETWORKINTF,(uint32)(args),(uint32)&ret,0);
	return ret;
} /* end rtl8651_addNetworkIntf */

//If a routing entry/DMZ host/NAT host refers to the network interface to be deleted, delete operation is forbidden. 
int32 rtl8651_delNetworkIntf(int8 *ifName)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)ifName;
	re865xIoctl("eth0",RTL8651_IOCTL_DELNETWORKINTF,(uint32)(args),(uint32)&ret,0);
	return ret;
} /* end rtl8651_delNetworkIntf */

int32 rtl8651_removeNetworkIntfLinkLayerType(int8 * ifName)
{
	int32  ret;
	uint32 args[3];
	args[0]=(uint32)ifName;
	re865xIoctl("eth0",RTL8651_IOCTL_REMOVENETWORKINTFLINKLAYERTYPE,(uint32)(args),(uint32)&ret,0);
	return ret;	
} /* end rtl8651_removeNetworkIntfLinkLayerType */

int32 rtl8651_specifyNetworkIntfLinkLayerType(int8 * ifName, uint32 llType, uint16 vid)
{
	int32  ret;
	uint32 args[3];
	args[0]=(uint32)ifName;
	args[1]=(uint32)llType;
	args[2]=(uint32)vid;
	re865xIoctl("eth0",RTL8651_IOCTL_SPECIFYNETWORKINTFLINKLAYERTYPE,(uint32)(args),(uint32)&ret,0);
	return ret;	
} /* end rtl8651_specifyNetworkIntfLinkLayerType */


int32 rtl8651_setPppoeSessionProperty(uint32 pppoeId, uint16 sid, ether_addr_t * macAddr, uint32 port)
{
	int32  ret;
	uint32 args[4];
	args[0]=(uint32)pppoeId;
	args[1]=(uint32)sid;
	args[2]=(uint32)macAddr;
	args[3]=(uint32)port;
	re865xIoctl("eth0",RTL8651_IOCTL_SETPPPOESESSIONPROPERTY,(uint32)(args),(uint32)&ret,0);
	return ret;
} /* end rtl8651_setPppoeSessionProperty */

int32 rtl8651_resetPppoeSessionProperty(uint32 pppoeId)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)pppoeId;
	re865xIoctl("eth0",RTL8651_IOCTL_RESETPPPOESESSIONPROPERTY,(uint32)(args),(uint32)&ret,0);
	return ret;
} /* end rtl8651_resetPppoeSessionProperty */


int32 rtl8651_addPppoeSession(uint32 pppoeId, uint16 vid)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)pppoeId;
	args[1]=(uint32)vid;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDPPPOESESSION,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_delPppoeSession(uint32 pppoeId)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)pppoeId;
	re865xIoctl("eth0",RTL8651_IOCTL_DELPPPOESESSION,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_bindPppoeSession(ipaddr_t ipaddr, uint32 pppoeId)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)ipaddr;
	args[1]=(uint32)pppoeId;
	re865xIoctl("eth0",RTL8651_IOCTL_BINDPPPOESESSION,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_setPppoeDefaultDialSessionId(uint32 dsid)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)dsid;
	//args[1]=(uint32)pppoeId;
	re865xIoctl("eth0",RTL8651_IOCTL_SETPPPOEDEFAULTDIALSESSIONID,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_addIpIntf(int8 * ifName, ipaddr_t ipAddr, ipaddr_t ipMask)
{
	int32  ret;
	uint32 args[3];
	args[0]=(uint32)ifName;
	args[1]=(uint32)ipAddr;
	args[2]=(uint32)ipMask;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDIPINTF,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_delIpIntf(int8 * ifName, ipaddr_t ipAddr, ipaddr_t ipMask)
{
	int32  ret;
	uint32 args[3];
	args[0]=(uint32)ifName;
	args[1]=(uint32)ipAddr;
	args[2]=(uint32)ipMask;
	re865xIoctl("eth0",RTL8651_IOCTL_DELIPINTF,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_addSession(uint32 type, uint32 sessionId, int8 *ifName, uint16 vid)
{
	int32  ret;
	uint32 args[4];
	args[0]=(uint32)&type;
	args[1]=(uint32)&sessionId;
	args[2]=(uint32)ifName;
	args[3]=(uint32)&vid;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDSESSION,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_delSession(uint32 sessionId)
{
	int32 ret;
	re865xIoctl("eth0",RTL8651_IOCTL_DELSESSION,(uint32)(sessionId),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_bindSession(ipaddr_t ipAddr, uint32 sessionId)
{
	int32  ret;		
	re865xIoctl("eth0",RTL8651_IOCTL_BINDSESSION,(uint32)(ipAddr),(uint32)sessionId,(uint32)&ret);
	return ret;
}

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
int32 rtl8651_setPptpProperty(uint32 sessionId, uint16 callId, uint16 peerCallId, ipaddr_t s_ipaddr, ipaddr_t gw_ipaddr)
{
	int32  ret;
	uint32 args[5];
	args[0]=(uint32)&sessionId;
	args[1]=(uint32)&callId;
	args[2]=(uint32)&peerCallId;
	args[3]=(uint32)&s_ipaddr;
	args[4]=(uint32)&gw_ipaddr;
	re865xIoctl("eth0",RTL8651_IOCTL_SETPPTPPROPERTY,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_setL2tpProperty(uint32 sessionId, uint16 tunnelId, uint16 sid, ipaddr_t s_ipaddr, ipaddr_t gw_ipaddr)
{
	int32  ret;
	uint32 args[5];
	args[0]=(uint32)&sessionId;
	args[1]=(uint32)&tunnelId;
	args[2]=(uint32)&sid;
	args[3]=(uint32)&s_ipaddr;
	args[4]=(uint32)&gw_ipaddr;
	re865xIoctl("eth0",RTL8651_IOCTL_SETL2TPPROPERTY,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_resetPptpProperty(uint32 sessionId)
{
	int32  ret;	
	re865xIoctl("eth0",RTL8651_IOCTL_RESETPPTPPROPERTY,(uint32)(sessionId),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_resetL2tpProperty(uint32 sessionId)
{
	int32  ret;	
	re865xIoctl("eth0",RTL8651_IOCTL_RESETL2TPPROPERTY,(uint32)(sessionId),(uint32)&ret,0);
	return ret;
}
#endif
int32 rtl8651_setLoopbackPortPHY(uint32 phy, int32 flag)
{
	int32  ret;
	re865xIoctl("eth0",RTL8651_IOCTL_SETLOOPBACKPORTPHY,(uint32)(phy),(int32)flag,(uint32)&ret);
	return ret;
}

int32 rtl8651_addNaptMapping(ipaddr_t extIpAddr)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)extIpAddr;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDNAPTMAPPING,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_delNaptMapping(ipaddr_t extIpAddr)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)extIpAddr;
	re865xIoctl("eth0",RTL8651_IOCTL_DELNAPTMAPPING,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_addExtNetworkInterface(int8 * ifName)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)ifName;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDEXTNETWORKINTERFACE,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_delExtNetworkInterface(int8 * ifName)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)ifName;
	re865xIoctl("eth0",RTL8651_IOCTL_DELEXTNETWORKINTERFACE,(uint32)(args),(uint32)&ret,0);
	return ret;
}


int32 rtl8651_addRoute(ipaddr_t ipAddr, ipaddr_t ipMask, int8 * ifName, ipaddr_t nextHop)
{
	int32  ret;
	uint32 args[4];
	args[0]=(uint32)ipAddr;
	args[1]=(uint32)ipMask;
	args[2]=(uint32)ifName;
	args[3]=(uint32)nextHop;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDROUTE,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)ipAddr;
	args[1]=(uint32)ipMask;
	re865xIoctl("eth0",RTL8651_IOCTL_DELROUTE,(uint32)(args),(uint32)&ret,0);
	return ret;
}
int32 rtl8651_addPolicyRoute(rtl8651_tblDrvPolicyRoute_t *rt)
{
	int32  ret;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDPOLICYROUTE,(uint32)(rt),(uint32)&ret,0);
	return ret;
}
int32 rtl8651_addDemandRoute(rtl8651_tblDrvDemandRoute_t *rt,int identity,int32(*p_callBack)(uint32) )
{
	int32  ret;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDDEMANDROUTE,(uint32)(rt),identity,(uint32)&ret);
	return ret;
}


int32 rtl8651_flushDemandRoute(int identity)
{
	int32  ret;
	re865xIoctl("eth0",RTL8651_IOCTL_FLUSHDEMANDROUTE,identity,(uint32)&ret,0);
	return ret;
}

int32 rtl8651_addUrlFilterTrustedUser(uint32 ipaddr)
{
	int32  ret;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDURLFILTERTRUSTEDUSER,ipaddr,0,(uint32)&ret);
	return ret;
}

void rtl8651_flushUrlFilterTrustedUser(void)
{
	int32  ret;
	re865xIoctl("eth0",RTL8651_IOCTL_FLUSHURLFILTERTRUSTEDUSER,0,0,0);
	return ret;
}

int32 rtl8651_flushPolicyRoute(uint32 ip)
{
	int32  ret;
	re865xIoctl("eth0",RTL8651_IOCTL_FLUSHPOLICYROUTE,ip,(uint32)&ret,0);
	return ret;
}


int32 rtl8651_addNatMapping(ipaddr_t extIpAddr, ipaddr_t intIpAddr)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)extIpAddr;
	args[1]=(uint32)intIpAddr;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDNATMAPPING,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_delNatMapping(ipaddr_t extIpAddr, ipaddr_t intIpAddr)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)extIpAddr;
	args[1]=(uint32)intIpAddr;
	re865xIoctl("eth0",RTL8651_IOCTL_DELNATMAPPING,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_addIpUnnumbered(int8 *wanIfName, int8 *lanIfName, ipaddr_t netMask)
{
	int32  ret;
	uint32 args[3];
	args[0]=(uint32)wanIfName;
	args[1]=(uint32)lanIfName;
	args[2]=(uint32)netMask;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDIPUNNUMBERED,(uint32)(args),(uint32)&ret,0);
	return ret;
} /* end rtl8651_addIpUnnumbered */

int32 rtl8651_delIpUnnumbered(int8 *wanIfName, int8 *lanIfName)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)wanIfName;
	args[1]=(uint32)lanIfName;
	re865xIoctl("eth0",RTL8651_IOCTL_DELIPUNNUMBERED,(uint32)(args),(uint32)&ret,0);
	return ret;
} /* end rtl8651_delIpUnnumbered */

int32 rtl8651_setLanSideExternalIpInterface(int8 * ifName, ipaddr_t ipAddr, ipaddr_t ipMask, int8 isExternal)
{
	int32  ret;
	uint32 args[4];
	args[0]=(uint32)ifName;
	args[1]=(uint32)ipAddr;
	args[2]=(uint32)ipMask;
	args[3]=(uint32)isExternal;
	re865xIoctl("eth0",RTL8651_IOCTL_SETLANSIDEEXTERNALIPINTERFACE,(uint32)(args),(uint32)&ret,0);
	return ret;	
} /* end rtl8651_setLanSideExternalIpInterface */

// dmz
int32 rtl8651a_addDmzHost(uint32 dsid,ipaddr_t naptIp, ipaddr_t dmzHostIp)
{
	uint32 ret;
	uint32 ptr[3];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)&naptIp;
	ptr[2]=(uint32)&dmzHostIp;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDDMZHOST,(uint32)(ptr),0,(uint32)&ret);
	return ret;			
}

int32 rtl8651a_delDmzHost(uint32 dsid,ipaddr_t naptIp)
{
	uint32 ret;
	uint32 ptr[2];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)&naptIp;	
	re865xIoctl("eth0",RTL8651_IOCTL_DELDMZHOST,(uint32)(ptr),0,(uint32)&ret);
	return ret;			
}

int32 rtl8651_setDmzL4Fwd(uint32 enable)
{
	uint32 ret;
	uint32 ptr;
	ptr = enable;
	re865xIoctl("eth0", RTL8651_IOCTL_SETDMZHOSTL4FWD, (uint32)&ptr, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_setDmzIcmpFwd(uint32 enable)
{
	uint32 ret;
	uint32 ptr;
	ptr = enable;
	re865xIoctl("eth0", RTL8651_IOCTL_SETDMZHOSTICMPFWD, (uint32)&ptr, 0, (uint32)&ret);
	return ret;
}

// url filter
int32 rtl8651_delURLFilterRule(uint32 dsid, int8 *string, int32 strlen, uint32 ip_start, uint32 ip_end)
{
	uint32 ret;
	uint32 ptr[5];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)string;
	ptr[2]=(uint32)&strlen;
	ptr[3]=(uint32)&ip_start;
	ptr[4]=(uint32)&ip_end;
	re865xIoctl("eth0",RTL8651_IOCTL_DELURLFILTER,(uint32)(ptr),0,(uint32)&ret);
	return ret;
}

int32 rtl8651_addGenericURLFilterRule(rtl8651_tblDrv_urlFilter_t *urlFilter, rtl8651_tblDrv_urlPktFilter_t *pktFilter)
{
	int32 ret;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDGENERICURLFILTERRULE, (uint32)urlFilter, (uint32)pktFilter, (uint32)&ret);
	return ret;
}

int32 rtl8651_delGenericURLFilterRule(rtl8651_tblDrv_urlFilter_t *urlFilter, rtl8651_tblDrv_urlPktFilter_t *pktFilter)
{
	int32 ret;
	re865xIoctl("eth0", RTL8651_IOCTL_DELGENERICURLFILTERRULE, (uint32)urlFilter, (uint32)pktFilter, (uint32)&ret);
	return ret;
}

int32 rtl8651_urlUnknownTypeCaseSensitive(int8 enable)
{
	uint32 ret;
	uint32 ptr;
	ptr = enable;
	re865xIoctl("eth0", RTL8651_IOCTL_URLUNKNOWNTYPECASESENSITIVE, (uint32)&ptr, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_addURLFilterRule(uint32 dsid, int8 *string, int32 strlen, uint32 ip_start, uint32 ip_end)
{
	uint32 ret;
	uint32 ptr[5];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)string;
	ptr[2]=(uint32)&strlen;
	ptr[3]=(uint32)&ip_start;
	ptr[4]=(uint32)&ip_end;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDURLFILTER,(uint32)(ptr),0,(uint32)&ret);
	return ret;
}
int32 rtl8651a_delURLfilterString(uint32 dsid,int8 *string, int32 strlen)
{
	uint32 ret;
	uint32 ptr[3];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)string;
	ptr[2]=(uint32)&strlen;
	re865xIoctl("eth0",RTL8651_IOCTL_DELURLFILTERSTRING,(uint32)(ptr),0,(uint32)&ret);
	return ret;
}

int32 rtl8651a_addURLfilterString(uint32 dsid,int8 *string, int32 strlen)
{
	uint32 ret;
	uint32 ptr[3];
	ptr[0]=(uint32)dsid;
	ptr[1]=(uint32)string;
	ptr[2]=(uint32)&strlen;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDURLFILTERSTRING,(uint32)(ptr),0,(uint32)&ret);
	return ret;	
}

int32 rtl8651_setPppoeSessionHangUp(uint32 PPPoEID, int32 enable, uint32 sec, int32 (*p_callBack)(uint32))
{
	int32  ret;
	uint32 args[4];
	args[0]=(uint32)PPPoEID;
	args[1]=(uint32)enable;
	args[2]=(uint32)sec;
	args[3]=(uint32)p_callBack;
	re865xIoctl("eth0",RTL8651_IOCTL_SETPPPOESESSIONHANGUP,(uint32)(args),(uint32)&ret,0);
	return ret;
}


void rtl8651a_setUdpSizeThreshValue(uint32 dsid, uint32 value)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETUDPSIZETHRESH,dsid,value,0);  
}


void rtl8651a_setWanStatus(uint32 dsid, uint32 Status)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETWANSTATUS,dsid,Status,0);  
}

void rtl8651a_setDosStatus(uint32 dsid,uint32 enableItem)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETDOSSTATUS,dsid,enableItem,0);
}

void rtl8651a_setDosThreshold(uint32 dsid,uint32 type,uint32 threshold)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETDOSTHRESHOLD,dsid,type,threshold);
}

void rtl8651a_setPerSrcDosThreshold(uint32 dsid, uint32 type, uint32 threshold)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETPERSRCDOSTHRESHOLD, dsid, type, threshold);
}

int32 rtl8651_dosScanTrackingSetPara(uint32 dsid, uint32 windowSize, uint32 threshold)
{
	uint32 args[3];
	int32 ret;
	args[0] = (uint32)&dsid;
	args[1] = (uint32)&windowSize;
	args[2] = (uint32)&threshold;
	re865xIoctl("eth0", RTL8651_IOCTL_SETDOSSCANTRACKINGPARA, (uint32)args, &ret, 0);
	return ret;
}

int32 rtl8651_addDosIgnoreType(uint32 ignoreType)
{
	uint32 args[2];
	uint32 ret;
	args[0] = (uint32)&ignoreType;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDDOSIGNORETYPE, (uint32)args, &ret, 0);
	return ret;
}

int32 rtl8651_delDosIgnoreType(uint32 ignoreType)
{
	uint32 args[2];
	uint32 ret;
	args[0] = (uint32)&ignoreType;
	re865xIoctl("eth0", RTL8651_IOCTL_DELDOSIGNORETYPE, (uint32)args, &ret, 0);
	return ret;
}

uint32 rtl8651a_setAlgStatus(uint32 dsid,uint32 Status,ipaddr_t *serverip)
{
	uint32 args[3];
	uint32 ret;
	args[0]=(uint32)&dsid;
	args[1]=(uint32)&Status;
	args[2]=(uint32)serverip;
	re865xIoctl("eth0", RTL8651_IOCTL_SETALGSTATUS,(uint32)(args),&ret,0);
	return ret;
}


void rtl8651_setPppoeMtu(uint32 pppObjId,uint16 mtu)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETPPPOEMTU,pppObjId,(uint32)mtu,0);  
}

void rtl8651_setMtu(uint16 mtu)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETMTU,(uint32)mtu,0,0);  
}

int32 rtl8651_setNetMtu(char *iface,uint16 mtu)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETNETMTU,(uint32)iface,(uint32)mtu,0);
}


void rtl8651_setTimeZone(int32 timezone_diff)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETTIMEZONE,(int32)timezone_diff,0,0);  
}


// special application
void rtl8651_flushTriggerPortRules(void)
{
	re865xIoctl("eth0",RTL8651_IOCTL_FLUSHTRIGGERPORTRULES,NULL,NULL,0);
}

int rtl8651a_addTriggerPortRule(uint32 dsid,uint8 inType,uint16 inPortStart,uint16 inPortFinish,uint8 outType,uint16 outPortStart,uint16 outPortFinish,uint32 address)
{
	int32  ret;
	uint32 args[8];
	args[0]=(uint32)&dsid;
	args[1]=(uint32)&inType;
	args[2]=(uint32)&inPortStart;
	args[3]=(uint32)&inPortFinish;
	args[4]=(uint32)&outType;
	args[5]=(uint32)&outPortStart;
	args[6]=(uint32)&outPortFinish;	
	args[7]=(uint32)&address;		
	re865xIoctl("eth0",RTL8651_IOCTL_ADDTRIGGERPORTRULE,(uint32)args,0,(uint32)&ret);
	return ret;
}

int rtl8651_addTriggerPortMappingRule(uint32 dsid,uint8 inType,uint16 inPortStart,uint16 inPortFinish,uint32 *mappingInfo)
{
	int32  ret;
	uint32 args[5];
	args[0]=(uint32)&dsid;
	args[1]=(uint32)&inType;
	args[2]=(uint32)&inPortStart;
	args[3]=(uint32)&inPortFinish;
	args[4]=(uint32)mappingInfo;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDTRIGGERPORTMAPPINGRULE,(uint32)args,0,(uint32)&ret);
	return ret;
}

void rtl865x_setGpioB0(int value)
{
	re865xIoctl("eth0",RTL8651_IOCTL_SETGPIOB0,(uint32)value,0,0);
}

void rtl865x_setGpioB1(int value)
{
	re865xIoctl("eth0",RTL8651_IOCTL_SETGPIOB1,(uint32)value,0,0);
}

#if 0

void rtl8651_flushProtoStackUsedUdpPorts(void)
{
	re865xIoctl("eth0",RTL8651_IOCTL_FLUSHPROTOSTACKUSEDUDPPORTS,0,0,0);
}

int32 rtl8651_addProtoStackUsedUdpPort(uint16  s_port)
{
	int32  ret;
	uint32 args[1];
	args[0]=(uint32)&s_port;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDPROTOSTACKUSEDUDPPORT,(uint32)args,0,(uint32)&ret);
	return ret;
}

void rtl8651_flushProtoStackServerUsedTcpPorts(void)
{
	re865xIoctl("eth0",RTL8651_IOCTL_FLUSHPROTOSTACKSERVERUSEDTCPPORTS,0,0,0);
}

int32 rtl8651_addProtoStackServerUsedTcpPort(uint16  s_port)
{
	int32  ret;
	uint32 args[1];
	args[0]=(uint32)&s_port;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDPROTOSTACKSERVERUSEDTCPPORT,(uint32)args,0,(uint32)&ret);
	return ret;
}

#endif

int32 rtl8651_installLoggingFunction(void * pMyLoggingFunc)
{
	int32  ret;
	uint32 args[2];
	args[0]=(uint32)pMyLoggingFunc;
	//args[1]=(uint32)0;
	re865xIoctl("eth0",RTL8651_IOCTL_INSTALLLOGGINGFUNCTION,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651a_enableLogging(uint32 dsid,uint32 moduleId,int8 enable)
{
	int32  ret;
	uint32 args[3];
	args[0]=(uint32)dsid;
	args[1]=(uint32)moduleId;
	args[2]=(uint32)enable;
	re865xIoctl("eth0",RTL8651_IOCTL_ENABLELOGGING,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_addNaptConnection
(
int16 assigned,
int8 flowType,
ipaddr_t insideLocalIpAddr,
uint16 insideLocalPort, 
ipaddr_t *insideGlobalIpAddr,
uint16 *insideGlobalPort,
ipaddr_t dstIpAddr,
uint16 dstPort
)
{
	int32  ret;
	uint32 args[8];
	args[0]=(uint32)assigned;
	args[1]=(uint32)flowType;
	args[2]=(uint32)insideLocalIpAddr;
	args[3]=(uint32)insideLocalPort;
	args[4]=(uint32)insideGlobalIpAddr;
	args[5]=(uint32)insideGlobalPort;
	args[6]=(uint32)dstIpAddr;
	args[7]=(uint32)dstPort;
	//args[1]=(uint32)0;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDNAPTCONNECTION,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_flushNaptServerPortbyExtIp(ipaddr_t extIp)
{
	int32 ret;
	re865xIoctl("eth0",RTL8651_IOCTL_FLUSHNAPTSERVERPORTBYEXTIP,(uint32)(extIp),(uint32)&ret,0);
	return ret;
}
int32 rtl8651_multicastSetUpStream(int8 *netName, uint32 para)
{
	int32 ret;
	int8	netIfName[RTL8651_IPINTF_NAME_LEN];
	uint32 args[2] = {&netIfName[0], para};

	if (strlen(netName) > RTL8651_IPINTF_NAME_LEN)
	{
		return FAILED;
	}

	bzero(netIfName, sizeof(netIfName));
	strncpy(netIfName, netName, strlen(netName));

	re865xIoctl("eth0",RTL8651_IOCTL_SETDEFAULTIGMPUPSTREAM, (uint32)(args), (uint32)&ret, 0);
	return ret;
}
int32 rtl8651_multicastAddFilter(ipaddr_t gip, uint32 action)
{
	int32 ret;
	uint32 args[2] = {(uint32)gip, action};

	re865xIoctl("eth0", RTL8651_IOCTL_ADDMULTICASTFILTER, (uint32)args, (uint32)&ret, 0);
	return ret;
}
int32 rtl8651_multicastDelFilter(ipaddr_t gip, uint32 action)
{
	int32 ret;
	uint32 args[2] = {(uint32)gip, action};

	re865xIoctl("eth0", RTL8651_IOCTL_DELMULITCASTFILTER, (uint32)args, (uint32)&ret, 0);
	return ret;
}
int32 rtl8651_addDriverNaptMapping(ipaddr_t extIp)
{
	int32 ret;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDDRIVERNAPTMAPPING, (uint32)extIp, (uint32)&ret, 0);
	return ret;
}

int32 rtl8651_addNaptMappingExt(ipaddr_t extIp)
{
	int32 ret;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDNAPTMAPPINGEXT, (uint32)extIp, (uint32)&ret, 0);
	return ret;
}

void rtl8651_flushProtoStackActions(void)
{	
	re865xIoctl("eth0", RTL8651_IOCTL_FLUSHPROTOSTACKACTIONS, 0, 0, 0);
}

int32 rtl8651_delGenericProtoStackActions(rtl8651_PS_Action_Entry_t *PSAction)
{
	int32 ret;
//	uint32 args[2];
//	args[0] = (uint32) PSAction;
	re865xIoctl("eth0", RTL8651_IOCTL_DELGENERICPROTOSTACKACTIONS, (uint32)PSAction, (uint32)&ret, 0);
	return ret;
}

int32 rtl8651_addGenericProtoStackActions(rtl8651_PS_Action_Entry_t *PSAction)
{
	int32 ret;
//	uint32 args[2];
//	args[0] = (uint32) PSAction;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDGENERICPROTOSTACKACTIONS, (uint32)PSAction, (uint32)&ret, 0);
	return ret;
}

int32 rtl8651_delProtoStackActions(ipaddr_t lowerIp,ipaddr_t upperIp,uint8 action,uint8 role,uint8 protocol,uint16 orgPort,uint16 fwdPort)
{
	int32  ret;
	uint32 args[7];
	args[0]=(uint32)&lowerIp;
	args[1]=(uint32)&upperIp;
	args[2]=(uint32)&action;
	args[3]=(uint32)&role;
	args[4]=(uint32)&protocol;
	args[5]=(uint32)&orgPort;
	args[6]=(uint32)&fwdPort;
	re865xIoctl("eth0",RTL8651_IOCTL_DELPROTOSTACKACTIONS,(uint32)(args),(uint32)&ret,0);
	return ret;
}


int32 rtl8651_addProtoStackActions(ipaddr_t lowerIp,ipaddr_t upperIp,uint8 action,uint8 role,uint8 protocol,uint16 orgPort,uint16 fwdPort)
{
	int32  ret;
	uint32 args[7];
	args[0]=(uint32)&lowerIp;
	args[1]=(uint32)&upperIp;
	args[2]=(uint32)&action;
	args[3]=(uint32)&role;
	args[4]=(uint32)&protocol;
	args[5]=(uint32)&orgPort;
	args[6]=(uint32)&fwdPort;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDPROTOSTACKACTIONS,(uint32)(args),(uint32)&ret,0);
	return ret;
}

int32 rtl8651_delProtoStackServerPortRange(ipaddr_t lowerIp,ipaddr_t upperIp,uint8 protocol,uint16 PortStart,uint16 PortEnd, uint16 fwdPortStart)
{
	int32  ret;
	uint32 args[7];
	args[0]=(uint32)&lowerIp;
	args[1]=(uint32)&upperIp;
	args[2]=(uint32)&protocol;
	args[3]=(uint32)&PortStart;
	args[4]=(uint32)&PortEnd;
	args[5]=(uint32)&fwdPortStart;
	re865xIoctl("eth0",RTL8651_IOCTL_DELPROTOSTACKSERVERPORTRANGE,(uint32)(args),(uint32)&ret,0);
	return ret;
}


int32 rtl8651_addProtoStackServerPortRange(ipaddr_t lowerIp,ipaddr_t upperIp,uint8 protocol,uint16 PortStart,uint16 PortEnd, uint16 fwdPortStart)
{
	int32  ret;
	uint32 args[7];
	args[0]=(uint32)&lowerIp;
	args[1]=(uint32)&upperIp;
	args[2]=(uint32)&protocol;
	args[3]=(uint32)&PortStart;
	args[4]=(uint32)&PortEnd;
	args[5]=(uint32)&fwdPortStart;
	re865xIoctl("eth0",RTL8651_IOCTL_ADDPROTOSTACKSERVERPORTRANGE,(uint32)(args),(uint32)&ret,0);
	return ret;
}

/* DOS process */
void rtl8651_dosProc_blockSip_enable(uint32 dsid, uint32 enable)
{
	re865xIoctl("eth0", RTL8651_IOCTL_ENABLESOURCEIPBLOCK, dsid, enable, 0);
}
void rtl8651_dosProc_blockSip_setPrisonTime(uint32 prisonTime)
{
	re865xIoctl("eth0", RTL8651_IOCTL_SETSOUCEIPBLOCKTIMEOUT, prisonTime, 0, 0);
}

void rtl8651_dosProc_blockSip_freeAll(void)
{
	re865xIoctl("eth0", RTL8651_IOCTL_FREEBLOCKEDSOURCEIP, 0, 0, 0);
}

void rtl8651_flushPolicyBasedQoS(void)
{
	re865xIoctl("eth0", RTL8651_IOCTL_FLUSHABQOS, 0, 0, 0);
}

int32 rtl8651_addPolicyBasedQoS(int8 *ifName, rtl8651_tblDrvPolicy_t *policy_t, int8 highPriority)
{
	uint32 args[3];
	int32 ret;

	args[0] = (uint32)ifName;
	args[1] = (uint32)policy_t;
	args[2] = (uint32)(highPriority&0xff);
	re865xIoctl("eth0", RTL8651_IOCTL_ADDPOLICYBASEDQOS, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_setFlowControl(uint32 port, int8 enable)
{
	uint32 args[2];
	int32 ret;

	args[0] = (uint32)port;
	args[1] = (uint32)(enable&0xff);
	re865xIoctl("eth0", RTL8651_IOCTL_SETFLOWCTRL, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_setPortPriorityQueue(uint32 port, int8 highPriority)
{
	uint32 args[2];
	int32 ret;

	args[0] = (uint32)port;
	args[1] = (uint32)(highPriority&0xff);
	re865xIoctl("eth0", RTL8651_IOCTL_SETPRIORITYQUEUE, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_setEthernetPortBandwidthControl(uint32 port, int8 input, uint32 rate)
{
	uint32 args[3];
	int32 ret;

	args[0] = (uint32)port;
	args[1] = (uint32)(input &0xff);
	args[2] = (uint32)rate;
	re865xIoctl("eth0", RTL8651_IOCTL_SETBANDWIDTHCTRL, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_addRateLimitGroup(uint32 GroupId, int8 * ifName, uint32 rate, uint32 burst, int8 isByteCount)
{
	uint32 args[5];
	int32 ret;

	args[0] = GroupId;
	args[1] = (uint32)ifName;
	args[2] = rate;
	args[3] = burst;
	args[4] = (uint32)isByteCount;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDRATELIMITGROUP, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_addRateLimitRule(rtl8651_tblDrvAclRule_t * rule, uint32 GroupId)
{
	uint32 args[2];
	int32 ret;

	args[0] = (uint32)rule;
	args[1] = GroupId;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDRATELIMIT, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_flushRateLimitGroup(int8 * ifName)
{
	uint32 args[1];
	int32 ret;

	args[0] = (uint32)ifName;
	re865xIoctl("eth0", RTL8651_IOCTL_FLUSHRATELIMITGROUP, (uint32)args, 0, (uint32)&ret);
	return ret;
}



int32 rtl8651_addProtocolBasedNAT( uint8 protocol, ipaddr_t ExtIp, ipaddr_t IntIp )
{
	uint32 args[3];
	int32 ret;

	args[0] = (uint32)protocol;
	args[1] = (uint32)ExtIp;
	args[2] = (uint32)IntIp;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDPBNAT, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_delProtocolBasedNAT( uint8 protocol, ipaddr_t ExtIp, ipaddr_t IntIp )
{
	uint32 args[3];
	int32 ret;

	args[0] = (uint32)protocol;
	args[1] = (uint32)ExtIp;
	args[2] = (uint32)IntIp;
	re865xIoctl("eth0", RTL8651_IOCTL_DELPBNAT, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_cfgCounter(int32 counterIdx, uint32 mbrMask)
{
	uint32 args[2];
	int32 ret;

	args[0] = (uint32)counterIdx;
	args[1] = (uint32)mbrMask;
	re865xIoctl("eth0", RTL8651_IOCTL_CFGCONTER, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_checkEthernetPortStatus(uint32 port, int32 *up,int32 *speed, int32 *duplex, int32 *range){
	int32 args[3];
	int32 ret;
	args[0] = (uint32)port;
	re865xIoctl("eth0", RTL8651_IOCTL_GETLINKSTATUS, (uint32)args, 0, (uint32)&ret);
	*up=args[1]&0x4? 1:0;
	*speed=args[1]&0x2? 1:0;
	*duplex=args[1]&0x1?1:0;
	*range=args[2] ;
	return ret;
}

int32 rtl8651_getIntfCounters(uint32 net,uint32 *counters ){
	uint32 args[7];
	int32 ret;
	args[0] = (uint32)net;
	re865xIoctl("eth0", RTL8651_IOCTL_GETCOUNTER, (uint32)args, 0, (uint32)&ret);
	memcpy(counters, &args[1],sizeof(uint32)*6);
	return ret;
}


int32 rtl8651_setUpstreamBandwidth(int8 *ifName, uint32 bps)
{
	uint32 args[2];
	int32 ret;
	args[0] = ifName;
	args[1] = bps;
	re865xIoctl("eth0", RTL8651_IOCTL_SETMNQUEUEUPSTREAMBW, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_addFlowToUnlimitedQueue(int8 *ifName, rtl8651_tblDrvAclRule_t *rule, uint32 ratio, uint32 queueID)
{
	uint32 args[4];
	int32 ret;
	args[0] = ifName;
	args[1] = (uint32)rule;
	args[2] = ratio;
	args[3] = queueID;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDUNLIMITEDQUEUE, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_addFlowToLimitedQueue(int8 *ifName, rtl8651_tblDrvAclRule_t *rule, uint32 ratio, uint32 queueID)
{
	uint32 args[4];
	int32 ret;
	args[0] = ifName;
	args[1] = (uint32)rule;
	args[2] = ratio;
	args[3] = queueID;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDLIMITEDQUEUE, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_setDscpToMNQueue(uint32 queueID, uint32 queueDSCP)
{
	uint32 args[2];
	int32 ret;
	args[0] = queueID;
	args[1] = queueDSCP;
	re865xIoctl("eth0", RTL8651_IOCTL_SETDSCPTOMNQUEUE, (uint32)args, 0, (uint32)&ret);
	return ret;
}


/*
	enable / disable "TCP Weak NAPT" mode
*/
int32 rtl8651_WeakNaptCtrl(int8 enable)
{
	int32  ret;
	uint32 args;
	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_WEAKNAPTCTL, (uint32)args, 0, (uint32)&ret);
	return ret;
} /* end rtl8651_WeakNaptCtrl */

int32 rtl8651_looseUdpCtrl(int8 enable)
{
	int32  ret;
	uint32 args;
	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_LOOSEUDPCTL, (uint32)args, 0, (uint32)&ret);
	return ret;
} /* end rtl8651_WeakNaptCtrl */

/*
	enable / disable TCP "NAPT port Static mapping" mode
*/
int32 rtl8651_TcpNaptStaticPortMappingCtrl(int8 enable)
{
	int32  ret;
	uint32 args;
	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_TCPNAPTSTATICPORTMAPPINGCTL, (uint32)args, 0, (uint32)&ret);
	return ret;
} /* end rtl8651_TcpNaptStaticPortMappingCtrl */

/*
	enable / disable UDP "NAPT port Static mapping" mode
*/
int32 rtl8651_UdpNaptStaticPortMappingCtrl(int8 enable)
{
	int32  ret;
	uint32 args;
	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_UDPNAPTSTATICPORTMAPPINGCTL, (uint32)args, 0, (uint32)&ret);
	return ret;
} /* end rtl8651_UdpNaptStaticPortMappingCtrl */


int32 rtl8651_addSubVlan(uint16 fvid, uint16 vid, uint32 portMask)
{
	int32 ret;
	uint32 args[3];

	args[0] = (uint32)fvid;
	args[1] = (uint32)vid;
	args[2] = (uint32)portMask;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDSUBVLAN, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_delSubVlan(uint16 vid)
{
	int32 ret;
	uint32 args;

	args = (uint32)vid;
	re865xIoctl("eth0", RTL8651_IOCTL_DELSUBVLAN, (uint32)args, 0, (uint32)&ret);
	return ret;
}



/*
	register napt-redirect rule
*/
int32 rtl8651_registerRedirectOutboundNaptFlow(
		uint8	isTcp,			/* TRUE: tcp, FALSE: udp */
		ipaddr_t	sip,				/* val 0 for wildcard */
		uint16	sport,			/* val 0 for wildcard */
		ipaddr_t	originalDip,		/* val 0 for wildcard */
		uint16	originalDport,	/* val 0 for wildcard */
		ipaddr_t	newDip,			/* val 0 for don't care, automatically assigned by gateway's LAN IP */
		uint16	newDport		/* must assign a new Dport to protocol stack */
)
{
	uint32 args[7];
	int32 ret;

	args[0] = (uint32)isTcp;
	args[1] = sip;
	args[2] = (uint32)sport;
	args[3] = originalDip;
	args[4] = (uint32)originalDport;
	args[5] = newDip;
	args[6] = (uint32)newDport;
	
	re865xIoctl("eth0", RTL8651_IOCTL_NAPTREDIRECT_REGISTER_RULE, (uint32)args, 0, (uint32)&ret);

	return ret;
}
/*
	unregister napt-redirect rule
*/
int32 rtl8651_unregisterRedirectOutboundNaptFlow(
		uint8	isTcp,			/* TRUE: tcp, FALSE: udp */
		ipaddr_t	sip,				/* val 0 for wildcard */
		uint16	sport,			/* val 0 for wildcard */
		ipaddr_t	originalDip,		/* val 0 for wildcard */
		uint16	originalDport,	/* val 0 for wildcard */
		ipaddr_t	newDip,			/* val 0 for wildcard */
		uint16	newDport		/* val 0 for wildcard */
)
{
	uint32 args[7];
	int32 ret;

	args[0] = (uint32)isTcp;
	args[1] = sip;
	args[2] = (uint32)sport;
	args[3] = originalDip;
	args[4] = (uint32)originalDport;
	args[5] = newDip;
	args[6] = (uint32)newDport;
	
	re865xIoctl("eth0", RTL8651_IOCTL_NAPTREDIRECT_UNREGISTER_RULE, (uint32)args, 0, (uint32)&ret);

	return ret;
}
/*
	query napt-redirect flow
*/
int32 rtl8651_queryRedirectOutboundNaptFlow(
		uint8	isTcp,
		ipaddr_t	sip,
		uint16	sport,
		ipaddr_t	*pOriginalDip,
		uint16	*pOriginalDport,
		ipaddr_t	newDip,
		uint16	newDport
)
{
	uint32 args[7];
	int32 ret;

	args[0] = (uint32)isTcp;
	args[1] = sip;
	args[2] = (uint32)sport;
	args[3] = pOriginalDip;
	args[4] = pOriginalDport;
	args[5] = newDip;
	args[6] = (uint32)newDport;
	
	re865xIoctl("eth0", RTL8651_IOCTL_NAPTREDIRECT_QUERY_FLOW, (uint32)args, 0, (uint32)&ret);

	return ret;
}

/*
	add multicast external port
*/
int32 rtl8651_addExternalMulticastPort(uint32 extMPort)
{
	int32 ret;
	uint32 args;

	args = (uint32)extMPort;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDEXTMCASTPORT, (uint32)args, 0, (uint32)&ret);
	return ret;
}

/*
	delete multicast external port
*/
int32 rtl8651_delExternalMulticastPort(uint32 extMPort)
{
	int32 ret;
	uint32 args;

	args = (uint32)extMPort;
	re865xIoctl("eth0", RTL8651_IOCTL_DELEXTMCASTPORT, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int8 rtl8651_EnablePppoePassthru(int8 enable)
{
	int8 ret;
	uint32 args;

	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_ENABLE_PPPOE_PASSTHRU, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int8 rtl8651_enableDropUnknownPppoePADT(int8 enable)
{
	int8 ret;
	uint32 args;

	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_ENABLE_DROP_UNKNOWN_PPPOE_DROP, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int8 rtl8651_EnableIpv6Passthru(int8 enable)
{
	int8 ret;
	uint32 args;

	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_ENABLE_IPV6_PASSTHRU, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int8 rtl8651_EnableIpxPassthru(int8 enable)
{
	int8 ret;
	uint32 args;

	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_ENABLE_IPX_PASSTHRU, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int8 rtl8651_EnableNetbiosPassthru(int8 enable)
{
	int8 ret;
	uint32 args;

	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_ENABLE_NETBIOS_PASSTHRU, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int8 rtl8651_EnablIpMulticast(int8 enable)
{
	int8 ret;
	uint32 args;

	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_ENABLE_IPMULTICAST, (uint32)args, 0, (uint32)&ret);
	return ret;
}

uint32 rtl8651_setAlgQosQueueId(uint32 alg_idx,uint32 queueID,uint32 isHigh, uint32 ratio)
{
	int32 ret;
	uint32 args[4];

	args[0] = (uint32)&alg_idx;
	args[1] = (uint32)&queueID;
	args[2] = (uint32)&isHigh;
	args[3] = (uint32)&ratio;
	
	re865xIoctl("eth0", RTL8651_IOCTL_RTL8651_SETALGQOSQUEUEID, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_delRateLimitGroup(uint32 GroupId)
{
	int8 ret;
	uint32 args;
	args = (uint32)GroupId;
	re865xIoctl("eth0", RTL8651_IOCTL_DELRATELIMITGROUP, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_getMNQueueEntry(rtl8651_tblDrvAclRule_t *rule,uint32 GroupId,uint32 index)
{
	int32 ret;
	uint32 args[3];

	args[0] = (uint32)rule;
	args[1] = (uint32)&GroupId;
	args[2] = (uint32)&index;

	re865xIoctl("eth0", RTL8651_IOCTL_GETMNQUEUEENTRY, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_delRateLimitRule(rtl8651_tblDrvAclRule_t *rule, uint32 GroupId)
{
	int32 ret;
	uint32 args[2];

	args[0] = (uint32)rule;
	args[1] = (uint32)&GroupId;

	re865xIoctl("eth0", RTL8651_IOCTL_DELRATELIMITRULE, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_delFlowFromMNQueue(rtl8651_tblDrvAclRule_t *rule, uint32 GroupId)
{
	int32 ret;
	uint32 args[2];

	args[0] = (uint32)rule;
	args[1] = (uint32)&GroupId;

	re865xIoctl("eth0", RTL8651_IOCTL_DELFLOWFROMMNQUEUE, (uint32)args, 0, (uint32)&ret);
	return ret;
}
int32 rtl8651_enableMacAccessControl(int8 enable)
{
	int8 ret;
	uint32 args;

	args = (uint32)enable;
	re865xIoctl("eth0", RTL8651_IOCTL_ENABLEMACACCESSCONTROL, (uint32)args, 0, (uint32)&ret);
	return ret;

}

int32 rtl8651_addMacAccessControl(ether_addr_t * sMac, ether_addr_t * macMask, int8 isPermit)
{
	int32 ret;
	uint32 args[3];
	args[0] = (uint32) sMac;
	args[1] = (uint32) macMask;
	args[2] = (uint32) &isPermit;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDMACACCESSCONTROL, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_addArp(ipaddr_t ipAddr, ether_addr_t * macAddr, int8 * ifName, uint32 port) 
{
	int32 ret;
	uint32 args[4];
	args[0] = (uint32)&ipAddr;
	args[1] = (uint32)macAddr;
	args[2] = (uint32)ifName;
	args[3] = (uint32)&port;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDARP, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_addDomainBlockingEntry(char *domain, ipaddr_t sip, ipaddr_t smask)
{
	int32 ret;
	uint32 args[3];
	args[0] = (uint32)domain;
	args[1] = (uint32)&sip;
	args[2] = (uint32)&smask;
	re865xIoctl("eth0", RTL8651_IOCTL_ADDDOMAINBLOCKINGENTRY, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_flushDomainBlockingEntry(void)
{
	int32 ret;
	re865xIoctl("eth0", RTL8651_IOCTL_FLUSHDOMAINBLOCKINGENTRY, 0, 0, (uint32)&ret);
	return ret;
}

/* ===================================================================================
		APIs for system verification
    =================================================================================== */
#ifdef CONFIG_SYSTEM_VERIFICATION

int32 rtl8651_pureSoftwareFwd(int8 isSoftFwd)
{
	int32 ret = 0;

	re865xIoctl("eth0", RTL8651_IOCTL_L34PURESOFTWAREPROCESS, (uint32)isSoftFwd, 0, (uint32)&ret);

	return ret;
}

#endif /* CONFIG_SYSTEM_VERIFICATION */

/* ===================================================================================
		APIs for Kernel Level Mutex Lock / Unlock
    =================================================================================== */

/* flags currently is not implemented. Thus, all flags will be lock together. */
int32 rtl8651_kernelMutexLock(uint32 flags)
{
	int32 ret = 0;

	re865xIoctl(	"eth0",
				RTL8651_IOCTL_KERNELMUTEXLOCK,
				0,
				0,
				(uint32)&ret);

	return ret;
}

/* flags currently is not implemented. Thus, all flags will be lock together. */
int32 rtl8651_kernelMutexUnlock(uint32 flags)
{
	int32 ret = 0;

	re865xIoctl(	"eth0",
				RTL8651_IOCTL_KERNELMUTEXUNLOCK,
				0,
				0,
				(uint32)&ret);
	return ret;
}

/* ===================================================================================
		APIs to copy log buffer from kernel space
    =================================================================================== */

int32 rtl8651_getLogFromKernel(void *circBuffer, uint32 moduleId, uint32 sizeToCopy)
{
	int32 ret;
	uint32 args[3];
	args[0] = (uint32)circBuffer;
	args[1] = (uint32)moduleId;
	args[2] = (uint32)sizeToCopy;
	re865xIoctl("eth0", RTL8651_IOCTL_KERNELGETLOG, (uint32)args, 0, (uint32)&ret);
	return ret;
}

int32 rtl8651_clearLogFromKernel(uint32 moduleId)
{
	int32 ret;
	uint32 args[1];
	args[0] = moduleId;
	re865xIoctl("eth0", RTL8651_IOCTL_KERNELCLRLOG, (uint32)args, 0, (uint32)&ret);
	return ret;
}


int32 rtl8651_setEthernetPortPowerDown(uint32 port, uint32 enable)
{
	int32 ret = 0;
	uint32 args[2];
	args[0] = port;
	args[1] = enable;
	re865xIoctl("eth0", RTL8651_IOCTL_SETPORTPOWERDOWN, (uint32)args, 0, (uint32)&ret);
	return ret;
}

/* end tblDrv_mapping.c */
