/*
* ----------------------------------------------------------------
*
* ---------------------------------------------------------------
*/
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <assert.h>

#define SIGHUP		 1	/* Hangup (POSIX).  */
#define SIGQUIT		 3	/* Quit (POSIX).  */
#define SIGKILL		 9	/* Kill, unblockable (POSIX).  */
#define SIGTERM		15	/* Termination (ANSI).  */
#define SIGUSR1		16	/* User-defined signal 1 (POSIX).  */
#define SIGUSR2		17	/* User-defined signal 2 (POSIX).  */

#define SIGSTOPWLAN	91
#define WLAN_REINIT	92

typedef void (*__sighandler_t)(int);
struct sigaction {
	unsigned int	sa_flags;
	__sighandler_t	sa_handler;
	sigset_t	sa_mask;
};

#include <unistd.h> /* for sleep */

#include <linux/sockios.h>
#include <netinet/in.h>
#include <linux/route.h>
#include <time.h>
#include <linux/types.h>
#include <netdb.h>
#include <stdlib.h>

/***Add by Timo for fstat**/
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
/****end****/

#include <re865x.h>
/*#include <rt_stack/h/sys/porting.h> */
#include "../rtl865x/board.h"
#include "../rtl865x/flashdrv.h"

#include <rtl8651_dos.h> /* for DoS define */

#define  MCAST_FILTER_ACT_MIRROR                 0x01            /* mirror this packet to protocol stack */

#include <linux/config.h>

#include "../rtl865x/rtl_cfgmgr.h"	/* For CFGMGR system access */
#include "../rtl865x/rtl_board.h" /* exported function prototypes */
#include <rtl8651_tblDrv.h>
#include <rtl8651_alg_init.h>
#include <rtl8651_tblDrvFwd.h>
#include <rtl8651_dos.h>
#include <dni_shutils.h>

#ifndef __uClinux__
/*  mmap header */
#include <fcntl.h>
#include <stdio.h>
#include <sys/mman.h>
#define DNS_HIJACK
#endif

romeCfgParam_t *pRomeCfgParam = NULL;

/* ==============================================================
	Gateway Setting Related data:

		1. Rome driver setting declarations
		2. Default Values
     ============================================================== */

//romeCfgParam_t romeCfgParam;
//romeCfgParam_t * pRomeCfgParam = &romeCfgParam;
//extern romeCfgParam_t *pRomeCfgParam;
ifCfgParam_t			ramLanCfgParam;
ifCfgParam_t			ramWanCfgParam;
pptpCfgParam_t			ramPptpCfgParam;
#if defined(DNI)
telCfgParam_t			ramTelCfgParam;
mnuCfgParam_t			ramMnuCfgParam; //Yili 2006/1/10
#endif
pppoeCfgParam_t			ramPppoeCfgParam[MAX_PPPOE_SESSION];
dhcpsCfgParam_t			ramDhcpsCfgParam;
dhcpcCfgParam_t			ramDhcpcCfgParam;
serverpCfgParam_t		ramServerpCfgParam[MAX_PPPOE_SESSION][MAX_SERVER_PORT];
urlfilterCfgParam_t		ramUrlfilterCfgParam[MAX_PPPOE_SESSION][MAX_URL_FILTER];

#if defined(DNI)
urlfilterCfgParam_t 		urlfilterCfgParamTemp[MAX_URL_FILTER]= {0};
wlanCfgParam_t		ramWlanCfgParam;		
#endif

int totalWlanCards;
#ifdef CONFIG_RTL8185
	int8 cfgFilePath[]="/var/8185wpa.conf";
#endif

/* ============================================
	internal function declarations
     ============================================ */
extern int re865xIoctl(char *name,uint32 arg0, uint32 arg1, uint32 arg2, uint32 arg3);

// local function declare
int INET_setroute(int action, int options, char **args);
int setInterfaceIp(char *name,int ip, int netmask);
int do_exec(char *name, char *identity);
int do_kill(char *filename);
int upInterface(char *name);
void pppd_start(uint32 identity);
void pptp_start(uint32 identity);
void runDNSProxy();

uint32 configChanged = 0;
uint32 mgmt_udp_500=0;
static rtl8651_tblDrvAclRule_t tempAclRule;
static rtl8651_PS_Action_Entry_t tempPSAction;


/* local function prototype declaration */
int32 pppd_stop(uint32 pppObjId);

int set_dynamic_l2tp_sv(int action);


void LogDebugInfo(FILE *fp)
{

	if (fp == NULL)
		return;
		
		printf("WAN Setting....\n");		
		printf("ifCfgParam[0].ipAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].ipAddr[0]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[1]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[2]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[3]);

		fprintf(fp,"ifCfgParam[0].ipAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].ipAddr[0]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[1]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[2]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[3]);

		printf("ifCfgParam[0].ipMask: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].ipMask[0]
			,pRomeCfgParam->ifCfgParam[0].ipMask[1]
			,pRomeCfgParam->ifCfgParam[0].ipMask[2]
			,pRomeCfgParam->ifCfgParam[0].ipMask[3]);

		fprintf(fp,"ifCfgParam[0].ipMask: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].ipMask[0]
			,pRomeCfgParam->ifCfgParam[0].ipMask[1]
			,pRomeCfgParam->ifCfgParam[0].ipMask[2]
			,pRomeCfgParam->ifCfgParam[0].ipMask[3]);

		printf("ifCfgParam[0].gwAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].gwAddr[0]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[1]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[2]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[3]);

		fprintf(fp,"ifCfgParam[0].gwAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].gwAddr[0]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[1]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[2]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[3]);

		printf("ifCfgParam[0].dnsPrimaryAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

		fprintf(fp,"ifCfgParam[0].dnsPrimaryAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

		printf("ifCfgParam[0].dnsSecondaryAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);

		fprintf(fp,"ifCfgParam[0].dnsSecondaryAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);
#if !defined(DNI)
		{
			uint8 winsAddr[20];

			snprintf(winsAddr, sizeof(winsAddr), "%u.%u.%u.%u",
				(pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr) >> 24,
				((pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x00ff0000) >> 16,
				((pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x0000ff00) >> 8,
				(pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x000000ff);
			
			printf("ifCfgParam[0].winsPrimaryAddr: %s\n", winsAddr);
			fprintf(fp, "ifCfgParam[0].winsPrimaryAddr: %s\n", winsAddr);

			snprintf(winsAddr, sizeof(winsAddr), "%u.%u.%u.%u",
				(pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr) >> 24,
				((pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x00ff0000) >> 16,
				((pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x0000ff00) >> 8,
				(pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x000000ff);

			printf("ifCfgParam[0].winsSecondaryAddr: %s\n", winsAddr);
			fprintf(fp, "ifCfgParam[0].winsSecondaryAddr: %s\n", winsAddr);
		}
#endif	 /* #if !defined(DNI) */	
}


/* ==============================================================
	CFGMGR control code:

		1. All CFGMGR procedures.
		2. Callback functions.
     ============================================================== */


/* ==============================================================
		Default value
     ============================================================== */
vlanCfgParam_t vlanCfgParamDefault[VLAN_LOAD_COUNT] = 
{
	/* WAN */{8,(PHY0),		  (PHY0),		1480,	1,{{0x00, 0x00, 0xda, 0x11, 0x22, 0x58}},{0,0}}, 
	/* LAN */{9,(PHY1|PHY2|PHY3|PHY4),(PHY1|PHY2|PHY3|PHY4),1480,	1,{{0x00, 0x00, 0xda, 0x11, 0x22, 0x68}},{0,0}}, 
		 {0,0x00,		  0x00,			0,	0,{{0,0,0,0,0,0}},			 {0,0}}
};

ifCfgParam_t ifCfgParamDefault[MAX_IP_INTERFACE] =
{
	{0, {0,0,0,0},	{0,0,0,0}, {0,0,0,0}, {255,255,255,0},	{255,255,255,0},	{0,0,0,0},	{0,0,0,0},	{0,0,0,0},	{0,0,0,0},	0, 0, 0, 0, 1,	IFCFGPARAM_CONNTYPE_DHCPC, {0,0,0,0,0,0}, 1500},
	{1, {192,168,1,1},	{0,0,0,0}, {0,0,0,0}, {255,255,255,0},	{255,255,255,0},	{255,255,255,0},	{0,0,0,0},	{0,0,0,0},	{0,0,0,0},	0, 0, 0, 0, 1,	0, {0,0,0,0,0,0}, 1500},	
	/* 2 for wan fixed ip mode */
	{2, {0,0,0,0},	{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0},	{0,0,0,0},	{0,0,0,0},	{0,0,0,0},	0, 0, 0, 0, 1,	IFCFGPARAM_CONNTYPE_STATIC, {0,0,0,0,0,0}, 1500},	
	{0, {0,0,0,0},			{0,0,0,0}, {0,0,0,0}, {0,0,0,0},			{0,0,0,0},		{0,0,0,0},		{0,0,0,0},		{0,0,0,0},	{0,0,0,0},	0, 0, 0, 0, 0,	0, {0,0,0,0,0,0}, 0}
};

routeCfgParam_t routeCfgParamDefault[MAX_IP_INTERFACE] =
{
	{0, {0,0,0,0},     {0,0,0,0},       {0,0,0,0},       0}
};

arpCfgParam_t arpCfgParamDefault[MAX_STATIC_ARP] =
{
	/* Add static arp entrie for the hosts on the LAN interface, e.g. your PC */
	{0, {0,0,0,0},      0,         0,{{0,0,0,0,0,0}},                  {0,0}}
};


natCfgParam_t natCfgParamDefault[1] =
{
	{
		1, /* enable */
		1, /* hw accel */
		0, /* no ipsec passthru */
		0, /* no pptp passthru */
		0  /* no l2tp passthru */
	}
};

pppoeCfgParam_t pppoeCfgParamDefault[MAX_PPPOE_SESSION] =
{
	{
	1, /* disabled/enabled */
	1, /* default session or not */
	0, /* is pppoe unnumbered ? */
	0, /* auto reconnect */	
	1, /* dial on demand */	
	0, /* dial state */
	0, /* session id */
	300, /* silent time out */		/* 5 minute */
	{172,21,1,254} ,{255,255,255,0},{172,21,1,250} ,{168,95,1,1},
	{0,0,0,0}, /* local host ip */
	"guest",
	"\0", /* password */
	"\0", /* ac name */
	"\0", /* service name */
	{"\0","\0","\0","\0"}, /* destination network */
	{PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE},
	{0,0,0,0},  /* unnumbered ip */
	{255,255,255,254},   /* unnumbered network mask */
	{0,0,0,0,0,0}, /* server mac */
	0xff, /* pppx */
	1, /* Unnumbered PPPoE NAPT */
	0, /* whichPppObjId */
	0,  /* manualHangup */
	1492,
	PPPOECFGPARAM_LANTYPE_NAPT,
	PPPPARAM_AUTHTYPE_CHAP,
	{0,0,0,0}, //Internet IP address.	
	1, //Internet IP address assign.
	1, /* auto_connect */
	0, /* uptime */
	0, /* manualStart */
	},

#if (MAX_PPPOE_SESSION == 2)
	{
	1, /* disabled/enabled */
	0, /* default session or not */
	0, /* is pppoe unnumbered ? */
	0, /* auto reconnect */
	1, /* dial on demand */	
	0, /* dial state */
	0, /* session id */
	0, /* silent time out */
	
	{172,22,1,254} ,{255,255,255,0},{172,22,1,250} ,{168,95,1,1},
	{0,0,0,0}, /* local host ip */
	"guest", /* user name */
	"\0", /* password */
	"\0", /* AC name */
	"\0", /* service name */
	{"\0","\0","\0","\0"}, /* destination network */
	{PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE},
	{0,0,0,0},  /* unnumbered ip */
	{255,255,255,254},  /* unnumbered network mask */
	{0,0,0,0,0,0}, /* server mac */
	0xff, /* pppx */
	0, /* rsv1 */
	0, /* whichPppObjId */
	0,  /* manualHangup */
	1492,
	PPPOECFGPARAM_LANTYPE_NAPT,
	PPPPARAM_AUTHTYPE_CHAP,
	{0,0,0,0}, //Internet IP address.	
	1, //Internet IP address assign.
	1, /* auto_connect */	
	0, /* uptime */
	0, /* manualStart */	
	},
#endif

};

dhcpsCfgParam_t dhcpsCfgParamDefault[1] =
{
	{
		1, 	/* DHCP Server Status, 0:disable 1:enable */
		2, 	/* DHCP Server IP Pool Start IP */
		254, 	/* DHCP Server IP Pool End IP */
		0,
		0,	/* don't provide real DNS server to DHCP client */
		//test by dvd.chen
		//0,	/* forward domain got from upper-DHCP server */		
		1, 	/* forward domain got from upper-DHCP server */	
		
		{0},	/* domain */
//Yili 2006/1/6
#if defined(DNI)		
		{0},	/* LAN domain */
#endif		
		{0},	/* manu fixed desc */
		
		{0},		/* manu fixed ip */
		
		{0}, 		/* hardware addr */
		
#if 0		
		{ { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
		  { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00} }	/* hwaddr */
#endif		  
	}
};


dhcpcCfgParam_t dhcpcCfgParamDefault[1] =
{
	{
		0,		        /* cmac valid */	
		{0,0,0,0,0,0},	/* clone mac address */
		//"RP614v4",	/* hostname */
		_PRODUCT_NAME,	/* hostname */
	}
};

dnsCfgParam_t dnsCfgParamDefault[1] =
{
	{
		0, /* DNS Server Status, 0:disable 1:enable */	/* 0->auto dns, 1->manual DNS*/
		{0,0,0,0},	/* primary */
		{0,0,0,0}	/* second */
		
	}
};

mgmtCfgParam_t mgmtCfgParamDefault[MAX_MGMT_USER] =
{
	{
		"admin", 		/* http username */
	 	"password",		/* http password */
	 	0,			/* valid */
	 	0,			/* remote ip */
	 	0xffffffff,		/* mask */
	 	8080,			/* remote port */
	 	0,			/* remote icmp enable */
		1			/* new firm */	 	
	} 	
};

emailCfgParam_t emailCfgParamDefault[1] =
{
	{	 	
	 	0,			/* enable */
		"\0","\0","\0","\0", 	/* mail */
		0,			/* auth */
		0,			/* alert imm */
		4,			/* alert type */	/* None */
		1,			/* alert day */
		1,			/* alert hour */
		1,			/* am/pm */
#ifdef EXTENSION_KO
		47,			/* time_zone */
#elif defined(EXTENSION_GR)
		25,			/* time_zone */
#elif defined(EXTENSION_WW)
		23,			/* time_zone */
#else	//EXTENSION_NA
		5,			/* time_zone */
#endif
		0,			/* daylight saveing */
		"", 			/* auth name */
		"",			/* auth passwd */
	}			
	
};

aclGlobalCfgParam_t aclGlobalCfgParamDefault[1] =
{
	{
		//ACLGLOBALCFGPARAM_ALLOWALLBUTACL,	// equivalent to "drop" rule
		ACLGLOBALCFGPARAM_ALLOWALLBUTACL_LOG,		
		1,
		{0,0},
	}
};

aclCfgParam_t aclCfgParamDefault[MAX_PPPOE_SESSION][MAX_ACL] =
{
    {
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	

    },

#if (MAX_PPPOE_SESSION == 2)
    {
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	{{0,0,0,0},{0,0,0,0},0,0, 0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,1,0,0,23,59, "" },
	
	
   }
#endif   
	
};

serverpCfgParam_t serverpCfgParamDefault[MAX_PPPOE_SESSION][MAX_SERVER_PORT] =
{
   {
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
 	
	
   },

#if (MAX_PPPOE_SESSION == 2)
   {
   	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	{0, {0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP, ""},
	
	
   }
#endif   
	
};

specialapCfgParam_t specialapCfgParamDefault[MAX_PPPOE_SESSION][MAX_SPECIAL_AP] =
{
	
#if !defined(DNI)	
	{{"Quick Time 4",SPECIALACPCFGPARAM_PROTOCOL_UDP,"6970-6999",SPECIALACPCFGPARAM_PROTOCOL_TCP,554,554,0,{0,0,0}},
	{"MSN Gaming Zone",SPECIALACPCFGPARAM_PROTOCOL_TCP,"28800-29000",SPECIALACPCFGPARAM_PROTOCOL_TCP,6667,6667,0,{0,0,0}},
#else
	{{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
#endif	
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},			
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},				
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},			
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},				
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},			
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},				
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}}},
	
	
	

#if (MAX_PPPOE_SESSION == 2)
	{{"Quick Time 4",SPECIALACPCFGPARAM_PROTOCOL_UDP,"6970-6999",SPECIALACPCFGPARAM_PROTOCOL_TCP,554,554,0, 1, 20, {0,0,0,0}},
	{"MSN Gaming Zone",SPECIALACPCFGPARAM_PROTOCOL_TCP,"28800-29000",SPECIALACPCFGPARAM_PROTOCOL_TCP,6667,6667,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},			
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},				
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},			
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},				
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},			
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},				
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0, 1, 20, {0,0,0,0}}},
	
#endif	
	
//    {"ICUII v5.9",SPECIALACPCFGPARAM_PROTOCOL_BOTH,"2000-2003",SPECIALACPCFGPARAM_PROTOCOL_TCP,23562,23566,0,{0,0,0}},	
//    {"AOE II",SPECIALACPCFGPARAM_PROTOCOL_BOTH,"2300-2400",SPECIALACPCFGPARAM_PROTOCOL_BOTH,47624,47624,0,{0,0,0}},
//	{"ICQ 2000b~2003b",SPECIALACPCFGPARAM_PROTOCOL_TCP,"24500-24505",SPECIALACPCFGPARAM_PROTOCOL_TCP,5190,5190,0,{0,0,0}}, // do it with ALG
//	{"Yahoo MSG v5.6",SPECIALACPCFGPARAM_PROTOCOL_BOTH,"5000-5001,5055,5002",SPECIALACPCFGPARAM_PROTOCOL_TCP,5050,5050,0,{0,0,0}}, // do it with ALG
//	{"PPTP Server",SPECIALACPCFGPARAM_PROTOCOL_TCP,"1723",SPECIALACPCFGPARAM_PROTOCOL_TCP,1723,1723,0,{0,0,0}}, //do it with ALG
//	{"IPSEC",SPECIALACPCFGPARAM_PROTOCOL_UDP,"62514",SPECIALACPCFGPARAM_PROTOCOL_UDP,62514,62514,0,{0,0,0}}, // do it with ALG
//	{"mIRC v6.2",SPECIALACPCFGPARAM_PROTOCOL_TCP,"1024-5000",SPECIALACPCFGPARAM_PROTOCOL_TCP,6660,6669,0,{0,0,0}},
//	{"Dialpad",SPECIALACPCFGPARAM_PROTOCOL_UDP,"51200-51201",SPECIALACPCFGPARAM_PROTOCOL_UDP,51200,51201,0,{0,0,0}},
//	{"Paltalk",SPECIALACPCFGPARAM_PROTOCOL_UDP,"2090-2091",SPECIALACPCFGPARAM_PROTOCOL_UDP,2090,2091,0,{0,0,0}},
//	{"Starcraft",SPECIALACPCFGPARAM_PROTOCOL_UDP,"6112",SPECIALACPCFGPARAM_PROTOCOL_TCP,6112,6112,0,{0,0,0}},
};

gamingCfgParam_t gamingCfgParamDefault[MAX_PPPOE_SESSION][MAX_GAMING] =
{
	{{"",0,"","",0},
	{"",0,"","",0},			
	{"",0,"","",0},
	{"",0,"","",0},		
	{"",0,"","",0},
	{"",0,"","",0},		
	{"",0,"","",0},		
	{"",0,"","",0}},

#if (MAX_PPPOE_SESSION == 2)
	{{"",0,"","",0},
	{"",0,"","",0},			
	{"",0,"","",0},
	{"",0,"","",0},		
	{"",0,"","",0},
	{"",0,"","",0},		
	{"",0,"","",0},		
	{"",0,"","",0}}
#endif	
	
};

tbldrvCfgParam_t tbldrvCfgParamDefault[1] =
{
	{
		1,    // auto add on
		1,    // auto delete on
		60,   // icmp timeout
		300,  // udp timeout
		3600, // tcp long timeout
		900,  // tcp med timeout
		20    // tcp fast timeout
	}
};

dmzCfgParam_t dmzCfgParamDefault[MAX_PPPOE_SESSION] =
{
	//enable, ipaddress, don't forward various L4 protocol, don't forward icmp
	{0, 0, 0, 0, 0, 0, 0, 0},
#if (MAX_PPPOE_SESSION == 2)	
	{0, 0, 0, 0, 0, 0, 0, 0}
#endif	
};

logCfgParam_t logCfgParamDefault[MAX_PPPOE_SESSION] =
{
	//RTL8651_LOGMODULE_SYS | RTL8651_LOGMODULE_ACL | RTL8651_LOGMODULE_DOS | RTL8651_LOGMODULE_URL | RTL8651_LOGMODULE_NEWFLOW,
	RTL8651_LOGMODULE_SYS | RTL8651_LOGMODULE_ACL | RTL8651_LOGMODULE_DOS | RTL8651_LOGMODULE_URL,
#if (MAX_PPPOE_SESSION == 2)	
	RTL8651_LOGMODULE_SYS | RTL8651_LOGMODULE_ACL | RTL8651_LOGMODULE_DOS | RTL8651_LOGMODULE_URL | RTL8651_LOGMODULE_NEWFLOW,	
#endif	
};

upnpCfgParam_t upnpCfgParamDefault[1] =
{
	{
		1,	// enable
		4,	/* timetolive */
		30	/* advertime */
	}
};

snmpCfgParam_t snmpCfgParamDefault[1] =
{
	{
		1,	// enable
	}
};


ddnsCfgParam_t ddnsCfgParamDefault[1] =
{
	{
		0,			/* enable */
		"dyndns",		/* service */		
		"\0",			/* username */	
		"\0",			/* passwd */
		"\0",			/* hostname */
		0,			/* wildcard */
		1,			/* ddns_status */ /* 0->ok */
							  /* 1-> fail */
	}						  /* 2_. auth fail */	
};

urlfilterCfgParam_t urlfilterCfgParamDefault[MAX_PPPOE_SESSION][MAX_URL_FILTER] =
{
	
	//{{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 }},
	{ 0 },
#if (MAX_PPPOE_SESSION == 2)	
	//{{0,	"\0", 0, 0 }, {0,	"\0" },{0,	"\0" },{0,	"\0" },{0,	"\0" },{0,	"\0" },{0,	"\0" },{0,	"\0" }}	
	{ 0 },
#endif

};

urlfilterTrustedUserCfgParam_t urlfilterTrustedUserCfgParamDefault[URL_FILTER_MAX_TRUSTED_USERS]=
{
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0}
};


timeCfgParam_t timeCfgParamDefault[1] =
{
	{
		259,
		"-08:00",
		"clock.stdtime.gov.tw",
		"time-b.nist.gov",
		"time.nist.gov"
	}
};

naptCfgParam_t naptCfgParamDefault[1] =
{
	{
		/* disabled, disabled, disabled */
		0,
		0,
		1,
		1
	}
};

dosCfgParam_t dosCfgParamDefault[MAX_PPPOE_SESSION] =
{
	/* Disabled, Disabled, Don't ignore,TCP,UDP,TCPUDP,SRC_TCP,SRC_UDP,SRC_TCPUDP,SYN,FIN,UDP,ICMP,SRC_SYN,SRC_FIN,SRC_UDP,SRC_ICMP, SIPBLOCK_ENABLE, SIPBLOCK_PRISONTIME, portScan Level  */
	//{1,0,0,2048,2048,4096,2048,2048,4096,50,50,50,50,30,30,30,30,0,120, 0},
	{1,	/* dos enable */ 	
		RTL8651_DOS_SYNFLOOD |
		RTL8651_DOS_STEALTHFIN |
		RTL8651_DOS_ICMPFLOOD |
		//RTL8651_DOS_UDPFLOOD |
		RTL8651_DOS_SCAN |
		RTL8651_DOS_PINGOFDEATH |		
		RTL8651_DOS_TEARDROP |		
		RTL8651_DOS_SMURF |		
		RTL8651_DOS_TCPLAND |		
		RTL8651_DOS_UDPLAND |		
		RTL8651_DOS_ICMPLAND |		
		RTL8651_DOS_IPSPOOF |		
		RTL8651_DOS_UDPBOMB |		
		RTL8651_DOS_SYNWITHDATA |		
		RTL8651_DOS_SRC_SYNFLOOD |	
		RTL8651_DOS_SRC_STEALTHFIN |	
		RTL8651_DOS_SRC_ICMPFLOOD |	
		//RTL8651_DOS_SRC_UDPFLOOD |	
		//RTL8651_DOS_ECHOCHARGEN |		
		RTL8651_DOS_PORTSCAN |		
		RTL8651_DOS_SRC_TCPCONNOVERFLOW |	
		RTL8651_DOS_SRC_UDPCONNOVERFLOW |		
		RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW |	

		RTL8651_DOS_TCPCONNOVERFLOW |		
		RTL8651_DOS_UDPCONNOVERFLOW |		
		RTL8651_DOS_TCPUDPCONNOVERFLOW,
	  
	 0,	/* ignor lan check */
	 2048,2048,4096,2048,2048,4096,50,50,50,50,30,30,30,30,0,120, 0},	
#if (MAX_PPPOE_SESSION == 2)	
	{1,0,0,2048,2048,4096,2048,2048,4096,50,50,50,50,30,30,30,30,0,120, 0}
#endif	
};

algCfgParam_t algCfgParamDefault[MAX_PPPOE_SESSION] =
{
	{	0x7fffffff,	/* enable all ALG, disable PPTP software */
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},	/* ALG Server IP List */
		0,0,0,0
	},

#if (MAX_PPPOE_SESSION == 2)
	{	0x7fffffff,	/* enable all ALG, disable PPTP software */
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},	/* ALG Server IP List */
		0,0,0,0
	},
#endif	

};

wlanCfgParam_t wlanCfgParamDefault[MAX_WLAN_CARDS] =
{{
	aliasName:		"WLAN1",
	ssid:				"NETGEAR", 
	enable:			1, 
	channel:			6,
	regDomain:		0,
	mode:			3,
    	dataRateMode:	WLAN_DATA_RATE_BG,
	dataRate:		WLAN_DATA_RATE_54M,
	frag:			2346,
	rts:				2346,
	beacon:			100,
	chipVer:			3,	/* default 8185 D cut */
	rxChargePump:	3,	/* 350mA */
	txChargePump:	6,	/* 500mA */
	protection:		1,
	preambleType:	WLAN_PREAMBLE_TYPE_LONG,
	broadcastSSID:	1,
	range:			0, 	//0:MaxRange
	dualAntenna:		1,

	cryptType:		CRYPT_NONE,
	cryptSubType:	{CRYPT_SUB_NONE},
	authType:		AUTH_AUTO,

	authRadiusPort:	1812,
	authRadiusIp:		0,
	authRadiusPasswd:	"\0",

	acMacList:		{0},
	acComment:		{0},

	wdsMacList:		{0},

	acEnable:		0,
	wdsEnable:		0,
	wdsCount:		0,
	key:			"\0",
	adhoc: 			0,

#ifdef EXTENSION_NA
	tmpDomain:		11,
#else
	tmpDomain:		0,
#endif
	passphrase:	"\0",
	keyNo:			1,
	key1	:		"\0",
	key2	:		"\0",
	key3	:		"\0",
	key4	:		"\0",
},
{
	aliasName:		"WLAN2",
	ssid:				"Realtek AP2", 
	enable:			0,
	channel:			40,
	regDomain:		0,
	mode:			3,
    	dataRateMode:	WLAN_DATA_RATE_A,
	dataRate:		WLAN_DATA_RATE_54M,
	frag:			2346,
	rts:				2347,
	beacon:			100,
	chipVer:			3,	/* default 8185 D cut	 */
	rxChargePump:	3,	/*350mA */
	txChargePump:	6,	/* 500mA */
	protection:		1,
	preambleType:	WLAN_PREAMBLE_TYPE_LONG,
	broadcastSSID:	1,
	range:			3,
	dualAntenna:		1,

	cryptType:		CRYPT_NONE,
	cryptSubType:	{CRYPT_SUB_NONE},
	authType:		AUTH_NONE,

	authRadiusPort:	1812,
	authRadiusIp:		0,
	authRadiusPasswd:	"\0",

	acMacList:		{0},
	acComment:		{0},

	wdsMacList:		{0},

	acEnable:		0,
	wdsEnable:		0,
	wdsCount:		0,
	key:			"\0",
	adhoc:			0,
	
	tmpDomain:		0,
	passphrase:	"\0",
	keyNo:			1,
	key1	:		"\0",
	key2	:		"\0",
	key3	:		"\0",
	key4	:		"\0",

}};

pptpCfgParam_t pptpCfgParamDefault[1] =
{
	{
		{0,0,0,0},		//ip address
		{255,255,255,0},		//ipmask
		{0,0,0,0},		//pptp server ip address
		{0,0,0,0},		//pptp default gw ip address
		"\0",			/* pptpid */
		"guest",		/* user name */
		"\0",			//password
		1460,			//mtu
		0,			// manualHangup
		0,			// autoReconnect
		0,			// demand
		PPTPCFGPARAM_DIALSTATE_OFF,				// dialState
		300,				// silentTimeout	/* 5 minute */
		PPPPARAM_AUTHTYPE_CHAP,
		1, /* auto_connect */		
		0,	/* uptime */
		0, /* manualStart */		
	}
};

l2tpCfgParam_t l2tpCfgParamDefault[1] =
{
	{
		{0,0,0,0},		//ip address
		{255,255,255,0},		//ipmask
		{0,0,0,0},		//pptp server ip address
		{0,0,0,0},		//pptp default gw ip address
		"\0",			/* pptpid */
		"guest",		/* user name */
		"\0",			//password
		1460,			//mtu
		0,			// manualHangup
		0,			// autoReconnect
		0,			// demand
		L2TPCFGPARAM_DIALSTATE_OFF,				// dialState
		300,				// silentTimeout	/* 5 minute */
		PPPPARAM_AUTHTYPE_CHAP,
		1, /* auto_connect */		
		0,	/* uptime */
		0, /* manualStart */		
		//"cable.netvision.net.il",	/* servername */
		"",	/* servername */		
	}
};

//Added by Yili 2005/12/27
#if defined(DNI)
telCfgParam_t telCfgParamDefault[1] =
{
	{
		"guest",		/* user name */
		"\0",			//password
		"\0", 			/* service name */
		300,			// silentTimeout	/* 5 minute */
		1,			// auto_connect
		1,			// demand
		0,			// manualHangup
		0, 			/* manualStart */		
	}
};
//Yili 2006/1/10
mnuCfgParam_t mnuCfgParamDefault[1] =
{
	{
		1,			// enable 0:close 1:open
		1,			// check enable 0:close 1:open
		0			// run test enable 0:no 1:yes
	}
};

http_client_ifno_t httpcCfgParamDefault[1] =
{
	{
		{0},			
		0,			
		0,
		0,	/* g_gLogin */			
	}
};

#endif
//Added end

 
udpblockCfgParam_t udpblockCfgParamDefault[MAX_PPPOE_SESSION] =
{
	//enable, size
		{0,30},
#if (MAX_PPPOE_SESSION == 2)		
		{0,30}
#endif		
};


routingCfgParam_t routingCfgParamDefault[MAX_ROUTING] =
{
		/* route, mask, gateway, interface, metric, valid, desc */
		{0,0xffffffff,0, 0, 0, 0, ""},
		{0,0xffffffff,0, 0, 0, 0, ""},
		{0,0xffffffff,0, 0, 0, 0, ""},
		{0,0xffffffff,0, 0, 0, 0, ""},
		{0,0xffffffff,0, 0, 0, 0, ""},		
			
};


#if 0
qosCfgParam_t qosCfgParamDefault[MAX_QOS] = 
{
	//Policy-Based QoS
	{ POLICY_BASED_QOS, 	{  23, FALSE } },
	{ POLICY_BASED_QOS, 	{  80, FALSE } },
	{ POLICY_BASED_QOS,	{  110, FALSE } },
	{ POLICY_BASED_QOS,	{  25, FALSE } },
	{ POLICY_BASED_QOS,	{    0,  FALSE } },
	{ POLICY_BASED_QOS,	{    0,  FALSE } },
	{ POLICY_BASED_QOS,	{    0,  FALSE } },

	//Port-Based QoS
	{ PORT_BASED_QOS,	{    0,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
	{ PORT_BASED_QOS,	{    1,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
	{ PORT_BASED_QOS,	{    2,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
	{ PORT_BASED_QOS,	{    3,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
	{ PORT_BASED_QOS,	{    4,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
};
#endif

qosCfgParam_t qosCfgParamDefault[MAX_QOS] = 
{
	//Policy-Based QoS
	{ POLICY_BASED_QOS, 	{  0 } },
	{ POLICY_BASED_QOS, 	{  0 } },
	{ POLICY_BASED_QOS,	{  0 } },
	{ POLICY_BASED_QOS,	{  0 } },
	{ POLICY_BASED_QOS,	{  0 } },
	{ POLICY_BASED_QOS,	{  0 } },
	{ POLICY_BASED_QOS,	{  0 } },

};



rateLimitCfgParam_t rateLimitCfgParamDefault[1] = 
{
	{
		0,
		{
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
		}
	}
};

ratioQosCfgParam_t ratioQosCfgParamDefault[1] =
{
	{
		0,
		{	/* max Rate, Rate Unit, remaining Ratio */
			100, 0, 100, 100,0	/* total 100 Mbps, remaining 100%, 100% */
			,{{1000,0,5,0,0}  /* alg ftp queueId, ishigh, ratio , enable ,rsv */
			,{1001,1,30,0,0} /* sip ftp queueId, ishigh, ratio , enable ,rsv */
			,{1002,1,30,0,0}} /* h323 ftp queueId, ishigh, ratio , enable ,rsv */

		},
		{
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0}
			/* MAX_RATIO_QOS is 10 */
			/* enable, queueID, isSrc, ip, ipMask, protoType, s_port, e_port, queue, ratio */
			/* { 0, 0, 0, 0, 0xffffffff, 0, 0, 0, 0, 0xffff, 0} */
		}
	}
};



pbnatCfgParam_t pbnatCfgParamDefault[MAX_PPPOE_SESSION][MAX_PBNAT] =
{
	/* Session 0 */
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },

#if (MAX_PPPOE_SESSION == 2)
	/* Session 1 */
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
#endif	
};

modeCfgParam_t modeCfgParamDefault[1] =
{
	{
		4	/* Gateway mode */
	}
};

ripCfgParam_t ripCfgParamDefault[1] =
{
	{
		2, 2, 0, "realtek", "realtek", 2, 2, 0, 30, 180, 120, 0, 0 //pamela20051227
	}
};


pseudoVlanCfgParam_t pseudoVlanCfgParamDefault[1] = 
{
	{
		FALSE,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	}
};

passthruCfgParam_t passthruCfgParamDefault[1] =
{
	{
		FALSE, /* PPPoE Passthru */
		FALSE, /* IPv6 Passthru */
	}
};

ipMulticastCfgParam_t ipMulticastCfgParamDefault[1] =
{
	{
		FALSE,	/* IP Multicast enable */
	}
};

domainBlockCfgParam_t domainBlockCfgParamDefault[MAX_DOMAIN_BLOCKING] =
{
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
};

#if defined(DNI)
//Add by Timo Wu
scheduleCfgParam_t scheduleCfgParamDefault[1] =
{
	{
	 	0x7f, //Days
		1, //allday
	 	0,0,  //start hour, start min
	 	23,59, //end hour , end min
		0, //aclstatus
		0, //is acl
		0, //filterstatus
		0, //is filter
	}	
};

BlankStateCfgParam_t BlankStateCfgParamDefault[1] =
{
	{
	 	0, //SmtWzdDone
		1, //SmtWzdState
	 	0, //NormalSmtWzdState
	 	0, //Unused
	 	//0,0,0,0,
	}	
};
#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
wanlan_match_det_t wanlan_ip_mat_det_ParamDefault[1] =
{
	{
		0,  //LAN_WAN_FLAG
	}
};
#endif //CONFIG_WAN_LAN_MATCH_DETECTION
#endif
/***********************************************************************/



static _board_cfgmgr_ctrl_t _board_cfgmgr_ctrlTbl[CFGMGR_TABID_MAX+1] =
{
	{CFGMGR_TABID_NULL,			NULL,						0},
	{CFGMGR_TABID_VLAN,			vlanCfgParamDefault,		(sizeof(vlanCfgParamDefault))},
	{CFGMGR_TABID_IF,				ifCfgParamDefault,			(sizeof(ifCfgParamDefault))},
	{CFGMGR_TABID_ROUTE,			routeCfgParamDefault,		(sizeof(routeCfgParamDefault))},
	{CFGMGR_TABID_ARP,				arpCfgParamDefault,			(sizeof(arpCfgParamDefault))},
	{CFGMGR_TABID_NAT,				natCfgParamDefault,			(sizeof(natCfgParamDefault))},
	{CFGMGR_TABID_MGMT,			mgmtCfgParamDefault,		(sizeof(mgmtCfgParamDefault))},
	{CFGMGR_TABID_PPPOE,			pppoeCfgParamDefault,		(sizeof(pppoeCfgParamDefault))},
	{CFGMGR_TABID_DHCPS,			dhcpsCfgParamDefault,		(sizeof(dhcpsCfgParamDefault))},
	{CFGMGR_TABID_DHCPC,			dhcpcCfgParamDefault,		(sizeof(dhcpcCfgParamDefault))},
	{CFGMGR_TABID_DNS,				dnsCfgParamDefault,			(sizeof(dnsCfgParamDefault))},
	{CFGMGR_TABID_DMZ,				dmzCfgParamDefault,		(sizeof(dmzCfgParamDefault))},
	{CFGMGR_TABID_LOG,				logCfgParamDefault,			(sizeof(logCfgParamDefault))},
	{CFGMGR_TABID_UPNP,			upnpCfgParamDefault,		(sizeof(upnpCfgParamDefault))},
	{CFGMGR_TABID_DDNS,			ddnsCfgParamDefault,		(sizeof(ddnsCfgParamDefault))},
	{CFGMGR_TABID_ACL,				aclCfgParamDefault,			(sizeof(aclCfgParamDefault))},
	{CFGMGR_TABID_ACL_GLOBAL,		aclGlobalCfgParamDefault,	(sizeof(aclGlobalCfgParamDefault))},
	{CFGMGR_TABID_SERVERP,			serverpCfgParamDefault,		(sizeof(serverpCfgParamDefault))},
	{CFGMGR_TABID_SPECIALAP,		specialapCfgParamDefault,	(sizeof(specialapCfgParamDefault))},
	{CFGMGR_TABID_TBLDRV,			tbldrvCfgParamDefault,		(sizeof(tbldrvCfgParamDefault))},
	{CFGMGR_TABID_URLFILTER,		urlfilterCfgParamDefault,		(sizeof(urlfilterCfgParamDefault))},
	{CFGMGR_TABID_DOS,				dosCfgParamDefault,			(sizeof(dosCfgParamDefault))},
	{CFGMGR_TABID_ALG,				algCfgParamDefault,			(sizeof(algCfgParamDefault))},
	{CFGMGR_TABID_TIME,			timeCfgParamDefault,		(sizeof(timeCfgParamDefault))},
	{CFGMGR_TABID_UDPBLOCK,		udpblockCfgParamDefault,	(sizeof(udpblockCfgParamDefault))},
	{CFGMGR_TABID_ROUTING,			routingCfgParamDefault,		(sizeof(routingCfgParamDefault))},
	{CFGMGR_TABID_PPTP,			pptpCfgParamDefault,		(sizeof(pptpCfgParamDefault))},
	{CFGMGR_TABID_QOS,				qosCfgParamDefault,			(sizeof(qosCfgParamDefault))},
	{CFGMGR_TABID_PBNAT,			pbnatCfgParamDefault,		(sizeof(pbnatCfgParamDefault))},
	{CFGMGR_TABID_RATELIMIT,		rateLimitCfgParamDefault,	(sizeof(rateLimitCfgParamDefault))},
	{CFGMGR_TABID_RATIOQOS,		ratioQosCfgParamDefault,	(sizeof(ratioQosCfgParamDefault))},
	{CFGMGR_TABID_NAPT,			naptCfgParamDefault,		(sizeof(naptCfgParamDefault))},
	{CFGMGR_TABID_MODE,			modeCfgParamDefault,		(sizeof(modeCfgParamDefault))},
	{CFGMGR_TABID_RIP,				ripCfgParamDefault,			(sizeof(ripCfgParamDefault))},
	{CFGMGR_TABID_PSEUDOVLAN,		pseudoVlanCfgParamDefault,	(sizeof(pseudoVlanCfgParamDefault))},
	{CFGMGR_TABID_PASSTHRU,		passthruCfgParamDefault,	(sizeof(passthruCfgParamDefault))},
	{CFGMGR_TABID_IPMULTICAST,		ipMulticastCfgParamDefault,	(sizeof(ipMulticastCfgParamDefault))}, 
	{CFGMGR_TABID_GAMING,			gamingCfgParamDefault,		(sizeof(gamingCfgParamDefault))},	
	{CFGMGR_TABID_DOMAINBLOCK,	domainBlockCfgParamDefault,	(sizeof(domainBlockCfgParamDefault))},	
	{CFGMGR_TABID_URLFILTERTRUSTEDUSER,		urlfilterTrustedUserCfgParamDefault,	sizeof(urlfilterTrustedUserCfgParamDefault)},
#if defined(DNI)
	{CFGMGR_TABID_SCHEDULE,		scheduleCfgParamDefault, 	(sizeof(scheduleCfgParamDefault))},//Add by Timo Wu	
	{CFGMGR_TABID_EMAIL,			emailCfgParamDefault,		(sizeof(emailCfgParamDefault))},
	{CFGMGR_TABID_TEL,			telCfgParamDefault,		(sizeof(telCfgParamDefault))},
	{CFGMGR_TABID_BLANK_STATE,		BlankStateCfgParamDefault, 	(sizeof(BlankStateCfgParamDefault))},//Add by Kevin	
	{CFGMGR_TABID_MNU,			mnuCfgParamDefault,		(sizeof(mnuCfgParamDefault))},//Yili 2006/1/10
	{CFGMGR_TABID_HTTPC_INFO,		httpcCfgParamDefault,		(sizeof(httpcCfgParamDefault))},
	
#endif
	{CFGMGR_TABID_WLAN,			wlanCfgParamDefault,		(sizeof(wlanCfgParamDefault))},
	{CFGMGR_TABID_L2TP,			l2tpCfgParamDefault,		(sizeof(l2tpCfgParamDefault))},
	
#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
	{CFGMGR_TABID_WAN_LAN_MATCH_DETECTION, wanlan_ip_mat_det_ParamDefault, (sizeof(wanlan_ip_mat_det_ParamDefault))},
#endif

	{CFGMGR_TABID_MAX,				NULL,						0}
};


int32 board_cfgmgr_callBack(uint8 flag, uint8 argc, uint32 argv[]);
int32 _board_cfgmgr_callBack_integrityCheck(uint16 tableId, uint32 buffSize, uint8 *buff);
int32 _board_cfgmgr_callBack_factoryDefault(uint16 tableId, uint8 *origBuff, uint32 origBuffSize, uint8 *newBuff, uint32 *len_p);
int32 board_cfgmgr_init(uint8 syncAll);

int32 board_cfgmgr_callBack(uint8 flag, uint8 argc, uint32 *argv)
{
	uint16 tableId = 0;

	if (argc < 1)
	{
		printf("%s-%d-Error: argument count : %d\n", __FUNCTION__, __LINE__, argc);
		goto err;
	}

	tableId = (uint16)(*argv);

	if (tableId <= CFGMGR_TABID_NULL || tableId >= CFGMGR_TABID_MAX)
	{
		printf("%s-%d-Error: tableID : %d\n", __FUNCTION__, __LINE__, tableId);
		goto err;
	}


	switch (flag)
	{
		case CFGMGR_CALLBACK_CHECKINTEGRITY:
		{
			if (argc != 3)
			{
				printf("%s-%d-Error: argument count : %d for flag %d\n", __FUNCTION__, __LINE__, argc, flag);
				goto err;
			}
			/*
				Check integrity
			*/
			if (	_board_cfgmgr_callBack_integrityCheck(	tableId,
														(uint32)(argv[1]),	/* buffer size */
														(uint8*)(argv[2])	/* buffer pointer*/)	!= SUCCESS			)
			{
				goto err;
			}
			break;
		}
		case CFGMGR_CALLBACK_FACTORYDEFAULT:
		{
			if (argc != 5)
			{
				printf("%s-%d-Error: argument count : %d for flag %d\n", __FUNCTION__, __LINE__, argc, flag);
				goto err;
			}
			/*
				Set factory default for entry
			*/
			if (	_board_cfgmgr_callBack_factoryDefault(	tableId,
														(uint8*)(argv[1]),	/* original data */
														(uint32)(argv[2]),	/* original data size */
														(uint8*)(argv[3]),	/* buffer to write new data */
														(uint32*)(argv[4])	/* pointer for length */)	!= SUCCESS		)
			{
				goto err;
			}
			break;
		}
		default:
			printf("Unknown flag : %d\n", flag);
			goto err;
	}

	return SUCCESS;

err:
	printf("%s-%d-Call Back [%d] failed.\n", __FUNCTION__, __LINE__, flag);
	
	return FAILED;
}

static int32 _board_cfgmgr_callBack_integrityCheck(uint16 tableId, uint32 buffSize, uint8 *buff)
{
	if ((tableId <= CFGMGR_TABID_NULL) || (tableId >= CFGMGR_TABID_MAX))
	{
		return FAILED;
	}

	if (buffSize == _board_cfgmgr_ctrlTbl[tableId].defaultSize)
	{
		return SUCCESS;
	}

	return FAILED;		
}
static int32 _board_cfgmgr_callBack_factoryDefault(uint16 tableId, uint8 *origBuff, uint32 origBuffSize, uint8 *newBuff, uint32 *len_p)
{
	if ((tableId <= CFGMGR_TABID_NULL) || (tableId >= CFGMGR_TABID_MAX))
	{
		return FAILED;
	}
	if (newBuff == NULL || len_p == NULL)
	{
		return FAILED;
	}

	if (*len_p < _board_cfgmgr_ctrlTbl[tableId].defaultSize)
	{
		printf("MAX length of tmp buffer (%d) is smaller than ID (%d)'s configuration (%d)\n",
				*len_p,
				tableId,
				_board_cfgmgr_ctrlTbl[tableId].defaultSize);
		return FAILED;
	}
	
	memcpy(newBuff, _board_cfgmgr_ctrlTbl[tableId].dafaultPtr, _board_cfgmgr_ctrlTbl[tableId].defaultSize);
	*len_p = _board_cfgmgr_ctrlTbl[tableId].defaultSize;

	return SUCCESS;
}

/* procedures */
int32 board_cfgmgr_init(uint8 syncAll)
{
	cfgmgr_initParam_t param;
	cfgmgr_callBackFunction_t callBack;
	int32 idx;

	/* Init  phase */
#ifdef CONFIG_RTL865X_CUSTOM_CCFG_SIZE
	#define CFGMGR_SIZE CONFIG_RTL865X_CUSTOM_CCFG_SIZE /* menuconfig */
#else
	#define CFGMGR_SIZE (0x2000UL)   /* 8k */
#endif

	param.maxCfgSize = CFGMGR_SIZE;
	param.maxEntryCount = CFGMGR_TABID_MAX;
	callBack.pCallBackFunction = board_cfgmgr_callBack;
	if (cfgmgr_init(&param) != SUCCESS)
	{
		goto err;
	}

	/* register phase */

	for (idx = CFGMGR_TABID_NULL+1 ; idx < CFGMGR_TABID_MAX ; idx ++)
	{
		if (cfgmgr_registerEntry(	_board_cfgmgr_ctrlTbl[idx].tableId,
								callBack) != SUCCESS)
		{
			goto err;
		}
	}

	if (cfgmgr_registerOk() != SUCCESS)
	{
		goto err;
	}

	/* Sync CFGMGR */

	if (syncAll == TRUE)
	{
		if (cfgmgr_syncAll() != SUCCESS)
		{
			goto err;
		}
	}

	return SUCCESS;

err:
	return FAILED;
}



/***************************************************************************/
/***************************************************************************/
/***************************************************************************/


#ifdef CONFIG_RTL865X

int ReadPhysicalMemory32(unsigned int addr, unsigned int *value){
	char str[32];
	int ret=-1;
    sprintf(str,"0x%08x",addr);
	FILE *f=fopen("/proc/rtl865x/reg32","w+");
	if(f){
	    fputs(str,f);
		fgets(str,sizeof(str),f);
		*value=(unsigned) strtoul(str,NULL,0);
		fclose(f);
		ret=0;
	}
	return ret;
}

int WritePhysicalMemory32(unsigned int addr, unsigned int value){
	char str[32];
	int ret=-1;
    sprintf(str,"0x%08x",addr);
	FILE *f=fopen("/proc/rtl865x/reg32","w+");
	if(f){
	    fputs(str,f);
	    sprintf(str,"0x%08x",value);
	    fputs(str,f);
		fclose(f);
		ret=0;
	}
	return ret;
}

int _chip_is_shared_pci_mode(){

#ifdef CONFIG_RTL865X_UART_UART0
	return 0;
#elif defined(CONFIG_RTL865X_UART_UART1)
	return 1;
#else/*CONFIG_RTL865X_UART_AUTO*/
	unsigned int value;
	
	if(ReadPhysicalMemory32(0xbc805030,&value))
		printf("Can't read kernel memory via /proc filesystem. \n");
	if((value&0x80000000)==0){
		#ifdef CONFIG_PCI
			goto maybe8650B_208;
		#else
			return 0;
		#endif
	}
maybe8650B_208:	
	if(ReadPhysicalMemory32(0xbc805104,&value))
		printf("Can't read kernel memory via /proc filesystem. \n");
	value&=0x07f0ffff;
	if(0x05005788==value){
		//chip is 8650B 208 package with PCI bonding and PCI kernel option is enabled.
		return 1;
	}
	return 0;
#endif

}
#endif

/*
	memory dump utility
*/
void memDump (void *start, uint32 size, int8 * strHeader){
  int32 row, column, index, index2, max;
  uint8 *buf, ascii[17];
  int8 empty = ' ';

  if(!start ||(size==0))
  	return;
  buf = (uint8 *) start;

  /*
     16 bytes per line
   */
  if (strHeader)
    printf ("%s", strHeader);
  column = size % 16;
  row = (size / 16) + 1;
  for (index = 0; index < row; index++, buf += 16) {
      memset (ascii, 0, 17);
      printf ("\n%08x ", (memaddr) buf);

      max = (index == row - 1) ? column : 16;

      //Hex
      for (index2 = 0; index2 < max; index2++){
	  if (index2 == 8)
	    printf ("  ");
	  printf ("%02x ", (uint8) buf[index2]);
	  ascii[index2] = ((uint8) buf[index2] < 32) ? empty : buf[index2];
	}

      if (max != 16){
	  if (max < 8)
	    printf ("  ");
	  for (index2 = 16 - max; index2 > 0; index2--)
	    printf ("   ");
	}

      //ASCII
      printf ("  %s", ascii);
    }
  printf ("\n");
  return;
}

/* ============================================
	Semaphore Control in board.c
     ============================================ */
uint32 rtl8651_sem_init(uint8 val)
{
	uint32 i;

	if (pRomeCfgParam == NULL) {
		printf("FAILED : pRomeCfgParam is NULL\n");
		return 1;
	}

	/* set default value to ALL semaphores */
	for ( i = 0 ; i < MAX_USER_SEMAPHORE ; i ++ ) {
		pRomeCfgParam->semaphore[i] = val;
	}

	return 0;
}

void rtl8651_sem_wait(uint32 sem_type)
{
	/* why sem not works? */
	return;
	
	if (sem_type >= MAX_USER_SEMAPHORE)
		return;	/* type does not exist */

	while (pRomeCfgParam->semaphore[sem_type] == 0) 
		usleep(200);
	pRomeCfgParam->semaphore[sem_type] --;
}

void rtl8651_sem_post(uint32 sem_type)
{
	/* why sem not works ? */
	return;	
	
	if (sem_type >= MAX_USER_SEMAPHORE)
		return;	/* type does not exist */

	pRomeCfgParam->semaphore[sem_type] ++;
}

/*
 * Routine Name: vlan_init
 * Description: configure vlan and create interface
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 vlan_init()
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_VLAN,(void*)pRomeCfgParam->vlanCfgParam, sizeof(pRomeCfgParam->vlanCfgParam))!=0)
	{
		printf("vlan_init: call cfgmgr_read fail\n");		
		/* take proper actions */
		return 1;
	}
	return 0;
}


/* start lan */
void start_lan(void)
{
	unsigned char  macStr[17];
	uint32	lanMemberPorts=pRomeCfgParam->vlanCfgParam[1].memberPort;
	char eabuf[32];		
	
	/* init lan */
	sleep(1);
	bdinfo_getMac((macaddr_t*)macStr);
	
	lanMemberPorts|= 0x40; //add first extension port(used by WLAN) to LAN. Kevin:06Mar14:

	re865xIoctl("eth1",ADD_VLAN,pRomeCfgParam->vlanCfgParam[1].vid,lanMemberPorts,(uint32)&macStr);
	nvram_set("lan_hwaddr", ether_etoa(macStr, eabuf));
	
	rtl8651_cfgCounter(0x2, lanMemberPorts);//Configure VLAN 9 member port using counter 2 to monitor
	
	setInterfaceIp("lo",0x7f000001,0xff000000);	
	re865xIoctl("eth1",SET_VLAN_TYPE,LL_VLAN,0,0);
	re865xIoctl("eth1",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr)),*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask)),0);
	re865xIoctl("eth1",SET_NET_PARA,0,0,0);
	
	
	setInterfaceIp("eth1",*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr)),*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask)));

	/* turn off auto learn due to url filtering 'forward' logging needs */
	rtl8651_enableNaptAutoAdd(0);

	DEBUG_P("mac address %02X:%02X:%02X:%02X:%02X:%02X\n",macStr[0],macStr[1],macStr[2],macStr[3],macStr[4],macStr[5]);
	DEBUG_P("wan address %x netmask %x\n",*(uint32*)&(pRomeCfgParam->ifCfgParam[0].ipAddr),*(uint32*)&(pRomeCfgParam->ifCfgParam[0].ipMask));
	DEBUG_P("lan address %x netmask %x\n",*(uint32*)&(pRomeCfgParam->ifCfgParam[1].ipAddr),*(uint32*)&(pRomeCfgParam->ifCfgParam[1].ipMask));

	
}

/* start wan */
void start_wan(void)
{
	char           *argv[8];	
	unsigned char  macStr[17];
	uint32 	wanMemberPorts = pRomeCfgParam->vlanCfgParam[0].memberPort;
	char eabuf[32];	
	int32          ret=FAILED;		
	
	/* init wan part I */
	re865xIoctl("eth0",ADD_IF,0,0,0);

	if (pRomeCfgParam->dhcpcCfgParam.cmacValid != 0)
		memcpy((char*)&macStr,(char*)&(pRomeCfgParam->dhcpcCfgParam.cloneMac),6);
	else {
		bdinfo_getMac((macaddr_t*)macStr);
		macStr[5] = macStr[5]+1;
		if (macStr[5] == 0) {
			macStr[4] = macStr[4]+1;		
			if (macStr[4] == 0)
				macStr[3] = macStr[3]+1;	
		}		
	}	
	
	re865xIoctl("eth0",ADD_VLAN,pRomeCfgParam->vlanCfgParam[0].vid,wanMemberPorts,(uint32)&macStr);
	nvram_set("wan_hwaddr", ether_etoa(macStr, eabuf));
//	re865xIoctl("eth0",SET_MAC,pRomeCfgParam->vlanCfgParam[0].vid,(uint32)&macStr,0);
	rtl8651_cfgCounter(0x1, wanMemberPorts);//Configure VLAN 8 member port using counter 1 to monitor
	
/* wan_start */	
	/* init wan part II */
	if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC) 
	{	
		uint32 netmask=0;

		printf("cfg wan to static ...\n");
		//rtl8651_setMtu(1500);	
		memcpy((char *)&(pRomeCfgParam->ifCfgParam[0]), (char *)&(pRomeCfgParam->ifCfgParam[2]), sizeof(ifCfgParam_t)); 
		//memcpy((char *)pRomeCfgParam->ifCfgParam[0].ipAddr, (char *)pRomeCfgParam->ifCfgParam[2].ipAddr, sizeof(pRomeCfgParam->ifCfgParam[0].ipAddr));		
		//memcpy((char *)pRomeCfgParam->ifCfgParam[0].ipMask, (char *)pRomeCfgParam->ifCfgParam[2].ipMask, sizeof(pRomeCfgParam->ifCfgParam[0].ipMask));		
		//memcpy((char *)pRomeCfgParam->ifCfgParam[0].gwAddr, (char *)pRomeCfgParam->ifCfgParam[2].gwAddr, sizeof(pRomeCfgParam->ifCfgParam[0].gwAddr));		
		//pRomeCfgParam->ifCfgParam[0].mtu = pRomeCfgParam->ifCfgParam[2].mtu;
		
		
		//rtl8651_setMtu(pRomeCfgParam->ifCfgParam[2].mtu);
		netmask|=(pRomeCfgParam->ifCfgParam[0].ipMask[0])<<24;
		netmask|=(pRomeCfgParam->ifCfgParam[0].ipMask[1])<<16;
		netmask|=(pRomeCfgParam->ifCfgParam[0].ipMask[2])<<8;
		netmask|=pRomeCfgParam->ifCfgParam[0].ipMask[3];
		
		re865xIoctl("eth0",SET_VLAN_TYPE,LL_VLAN,0,0);
		rtl8651_setNetMtu("eth0", pRomeCfgParam->ifCfgParam[2].mtu);
		rtl8651_setMtu(pRomeCfgParam->ifCfgParam[2].mtu);
		
		re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),netmask,0);
		re865xIoctl("eth0",ADD_GW,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].gwAddr)),netmask,0);
		re865xIoctl("eth0",SET_EXT_INTERFACE,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),0,0);

		setInterfaceIp("eth0",*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),netmask);

		argv[0]="default";
	
		sprintf(macStr,"%u.%u.%u.%u",
			pRomeCfgParam->ifCfgParam[0].gwAddr[0],
			pRomeCfgParam->ifCfgParam[0].gwAddr[1],
			pRomeCfgParam->ifCfgParam[0].gwAddr[2],
			pRomeCfgParam->ifCfgParam[0].gwAddr[3]);
		argv[1]="gw";
		argv[2]=(char*)&macStr;
		argv[3]=NULL;
		INET_setroute(RTACTION_ADD, 0, argv);
		
		//runDNSProxy();
		setLedLight(1/*WAN_LED*/, 0/*LED_GREEN*/);
		log_message("WAN Connected");		
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC */	
#if defined(DNI)
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_DHCPC
		|| pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_TELSTRA)
#else
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_DHCPC)
#endif
	{
		printf("cfg wan to dhcp client ...\n");
		//rtl8651_setMtu(1500);		
		//rtl8651_setMtu(pRomeCfgParam->ifCfgParam[0].mtu);
		/* clear ifCfgParam[0].ipAddr[] etc, dhcp client will fill these values later */
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipMask,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].gwAddr,0,4);
				
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,0,4);
		setInterfaceIp("eth0",0,0);		
		re865xIoctl("eth0",SET_VLAN_TYPE,LL_VLAN,0,0);
		rtl8651_setNetMtu("eth0", pRomeCfgParam->ifCfgParam[0].mtu);
		rtl8651_setMtu(pRomeCfgParam->ifCfgParam[0].mtu);
			
		rtl8651_addExtNetworkInterface((int8*)"eth0");

		udhcpc_start();
	}
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE)
	{
		printf("cfg wan to single PPPoE ...\n");

		/* linux if up */
		upInterface("eth0");
				
		rtl8651_addNetworkIntf("eth0");
    		//rtl8651_setAsicNaptAutoAddDelete(FALSE, 1);
    		rtl8651_enableNaptAutoAdd(0);
    		/* note: for ip unnumbered case, reference  pppObjId=0 only
    	 	*       ppp obj id equal to session number (0,1,2,3,...)
    	 	*/
	    	
		ret=rtl8651_specifyNetworkIntfLinkLayerType("eth0",RTL8651_LL_PPPOE,pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);

		rtl8651_addPppoeSession(0,pRomeCfgParam->vlanCfgParam[0].vid);	/* wan_vid = 8 */

		/* make this network interface for napt */
		//rtl8651_addExtNetworkInterface(int8 * ifName);
		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);

				    /* ipaddr, ipmask, ifname, nexthop */	
		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
			printf("rtl8651_addRoute: ret %d\n",ret);

		memset(pRomeCfgParam->ifCfgParam[0].ipAddr,0,4);
		memset(pRomeCfgParam->ifCfgParam[0].ipMask,0,4);
		memset(pRomeCfgParam->ifCfgParam[0].gwAddr,0,4);
		memset(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,0,4);
		memset(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,0,4);		

		if (pRomeCfgParam->pppoeCfgParam[0].auto_connect)
		pppd_start(0); // start pppd on pppObjId 0
		
	} /* ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE */
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPTP) 
	{
		uint32 netmask=0, def_gw_ipAddr = 0;		
		uint8 strBuffer[128];
		
		printf("cfg wan to pptp ...\n");		
		netmask|=(pRomeCfgParam->pptpCfgParam.ipMask[0])<<24;
		netmask|=(pRomeCfgParam->pptpCfgParam.ipMask[1])<<16;
		netmask|=(pRomeCfgParam->pptpCfgParam.ipMask[2])<<8;
		netmask|=pRomeCfgParam->pptpCfgParam.ipMask[3];
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[0]) << 24;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[1]) << 16;
		def_gw_ipAddr
		 |= (pRomeCfgParam->pptpCfgParam.gwAddr[2]) << 8;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[3]);

		/* linux if up */
		upInterface("eth0");		
		//specifyNetworkIntfLinkLayerType
		//re865xIoctl("eth0",SET_VLAN_TYPE,LL_PPTP,0,0); //for PPPoE only
		rtl8651_addNetworkIntf("eth0");	
		//rtl8651_setNetMtu("eth0",pRomeCfgParam->pptpCfgParam.mtu);	//must call after addNetworkIntf ,2004/6/17
		rtl8651_specifyNetworkIntfLinkLayerType("eth0",LL_PPTP, pRomeCfgParam->vlanCfgParam[0].vid);

    		//rtl8651_setAsicNaptAutoAddDelete(FALSE, 1);
    		rtl8651_enableNaptAutoAdd(0);

		//add ip interface
		re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->pptpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->pptpCfgParam.ipMask)),0);		
		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);

		sprintf(strBuffer,"/sbin/ifconfig eth0 %d.%d.%d.%d netmask %d.%d.%d.%d",
			pRomeCfgParam->pptpCfgParam.ipAddr[0],
			pRomeCfgParam->pptpCfgParam.ipAddr[1],
			pRomeCfgParam->pptpCfgParam.ipAddr[2],
			pRomeCfgParam->pptpCfgParam.ipAddr[3],
			pRomeCfgParam->pptpCfgParam.ipMask[0],
			pRomeCfgParam->pptpCfgParam.ipMask[1],
			pRomeCfgParam->pptpCfgParam.ipMask[2],
			pRomeCfgParam->pptpCfgParam.ipMask[3]);

		system(strBuffer);

		/* ===================================== */
		if (def_gw_ipAddr != 0) {
			argv[0]="default";
			
			sprintf(macStr, "%u.%u.%u.%u",
				pRomeCfgParam->pptpCfgParam.gwAddr[0],
				pRomeCfgParam->pptpCfgParam.gwAddr[1],
				pRomeCfgParam->pptpCfgParam.gwAddr[2],
				pRomeCfgParam->pptpCfgParam.gwAddr[3]);
			argv[1]="gw";
			argv[2]=(char*)&macStr;
			argv[3]=NULL;
			INET_setroute(RTACTION_ADD, 0, argv);
		}
		/* ====================================== */

		ret=rtl8651_addSession(RTL8651_PPTP, 1, "eth0", pRomeCfgParam->vlanCfgParam[0].vid); 
		if (ret)
		{
			printf("rtl8651_addSession: ret %d\n",ret);
		}
		
		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
		}

		memset(pRomeCfgParam->ifCfgParam[0].ipAddr,0,4);
		memset(pRomeCfgParam->ifCfgParam[0].ipMask,0,4);
		memset(pRomeCfgParam->ifCfgParam[0].gwAddr,0,4);
		memset(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,0,4);
		memset(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,0,4);		

		if (pRomeCfgParam->pptpCfgParam.auto_connect)
		pptp_start(0);				
		
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPTP */	
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_L2TP)
	{
		uint32 netmask = 0;
		uint8 strBuffer[128];

		printf("cfg wan to l2tp ...\n");
		// protocol stack setting
		upInterface("eth0");

		netmask |= (pRomeCfgParam->l2tpCfgParam.ipMask[0]) << 24;
		netmask |= (pRomeCfgParam->l2tpCfgParam.ipMask[1]) << 16;
		netmask |= (pRomeCfgParam->l2tpCfgParam.ipMask[2]) << 8;
		netmask |= pRomeCfgParam->l2tpCfgParam.ipMask[3];

		//l2tp by MII lookback path
		ret = rtl8651_addNetworkIntf("eth0");
		if (ret)
			printf("rtl8651_addNetworkIntf: ret %d\n", ret);
		
		ret = rtl8651_specifyNetworkIntfLinkLayerType("eth0", LL_L2TP, pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n", ret);

		re865xIoctl("eth0", SET_VLAN_IP, *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)), *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)), 0);
		
		upInterface("eth0");		
    		rtl8651_enableNaptAutoAdd(0);

		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);    		
		
		sprintf(strBuffer,"/sbin/ifconfig eth0 %d.%d.%d.%d netmask %d.%d.%d.%d",
			pRomeCfgParam->l2tpCfgParam.ipAddr[0],
			pRomeCfgParam->l2tpCfgParam.ipAddr[1],
			pRomeCfgParam->l2tpCfgParam.ipAddr[2],
			pRomeCfgParam->l2tpCfgParam.ipAddr[3],			
			pRomeCfgParam->l2tpCfgParam.ipMask[0],
			pRomeCfgParam->l2tpCfgParam.ipMask[1],
			pRomeCfgParam->l2tpCfgParam.ipMask[2],
			pRomeCfgParam->l2tpCfgParam.ipMask[3]);
		
		system(strBuffer);

		ret = rtl8651_addSession(RTL8651_L2TP, 1, "eth0", pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_addSession: ret %d\n", ret);

		ret = rtl8651_addRoute((ipaddr_t)0, (ipaddr_t)0, (int8*)"eth0", 0);
		if (ret)
			printf("rtl8651_addRoute: ret %d\n", ret);
		l2tp_start(0);
		
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_L2TP */
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_DHCPL2TP) {

		printf("cfg: DHCP+L2TP Wan Type ...\n");
		pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;
				
		/* clear ifCfgParam[0].ipAddr[] etc, dhcp client will fill these values later */
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipMask,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].gwAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,0,4);

		setInterfaceIp("eth0",0,0);		
//		re865xIoctl("eth0",SET_VLAN_TYPE,LL_VLAN,0,0);	
//		rtl8651_specifyNetworkIntfLinkLayerType("eth0",LL_L2TP, pRomeCfgParam->vlanCfgParam[0].vid);
			
   		rtl8651_enableNaptAutoAdd(0);    		
		
		udhcpc_start();
	}	
	
	// set default Upstream of IGMP system
	rtl8651_multicastSetUpStream("eth0", 0);	
	
}


void stop_wan(void)
{
	int32 ret;
	char	*av[3], *av1[4], argv[2];
	char	pname[] = "/bin/ifconfig";
	char	zero_string[] = "0.0.0.0";

	// linux kernel setting
	av1[0] = pname;
	av1[1] = "eth0";
	av1[2] = zero_string;
	av1[3] = NULL;
	runProgram(pname, av1);

	/* == Remove linux default route == */
	{
		int32 ret;
		int sockfd = 0;
		struct sockaddr_in *dst, *gw, *mask;
		struct rtentry route;

		sockfd = socket(AF_INET, SOCK_DGRAM, 0);
		memset(&route, 0, sizeof(struct rtentry));

		dst = (struct sockaddr_in *)(&(route.rt_dst));
		gw = (struct sockaddr_in *)(&(route.rt_gateway));
		mask = (struct sockaddr_in *)(&(route.rt_genmask));

		/* Make sure we're talking about IP here */
		dst->sin_family = AF_INET;
		gw->sin_family = AF_INET;
		mask->sin_family = AF_INET;

		/* Set up the data for removing the default route */
		dst->sin_addr.s_addr = 0;
		gw->sin_addr.s_addr = 0;
		mask->sin_addr.s_addr = 0;
		route.rt_flags = RTF_UP | RTF_GATEWAY;
		    
		/* Remove the default route */
		ret = ioctl(sockfd, SIOCDELRT, &route);
		if (ret < 0)
			printf("ioctl(route) not successful ret: %d\n", ret);
	}
	
/* wan_stop */
	switch(pRomeCfgParam->ifCfgParam[0].connType) {
		case IFCFGPARAM_CONNTYPE_STATIC:
			break;
		case IFCFGPARAM_CONNTYPE_DHCPC:					
			send_signal("/var/run/udhcpc.pid", SIGUSR2); //send signal to release IP first
			sleep(1);
			//do_kill("/var/run/udhcpc.pid");
			break;
//added by dvd.chen for Bpalogin, copy from stop_heartbeat()
#if defined(DNI)	
		case IFCFGPARAM_CONNTYPE_TELSTRA:
			//send_signal("/var/run/udhcpc.pid", SIGUSR2); //send signal to release IP first
			//sleep(1);
			//eval("killall", "bpalogin");  //send signal:TERM to bpalogin task, it will trigger the logout process
			send_signal("/var/run/bpalogin.pid", SIGTERM);  //send signal:TERM to bpalogin task, it will trigger the logout process
			sleep( 3 );
			//eval("killall", "-9", "bpalogin");
			do_kill("/var/run/bpalogin.pid");
			
			//unlink(PPP_LINK_PATH"ppp0");
			unlink("/var/run/link.ppp0");
			unlink("/var/run/bpalogin.pid");

			send_signal("/var/run/udhcpc.pid", SIGUSR2); //send signal to release IP first
			sleep(1);

			
			break;
#endif
//end of dvd.chen
		case IFCFGPARAM_CONNTYPE_PPPOE:
			pppd_stop(0);					

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			
			break;
		case IFCFGPARAM_CONNTYPE_PPTP:
			send_signal("/var/run/pppd0.pid",1);
			send_signal("/var/run/ppp0.pid",1);
			sleep(1);
			send_signal("/var/run/pptp.pid",9);	
			pRomeCfgParam->pptpCfgParam.dialState=PPTPCFGPARAM_DIALSTATE_OFF;		
			//pRomeCfgParam->pptpCfgParam.manualHangup = 1;	

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;
		case IFCFGPARAM_CONNTYPE_L2TP:
			send_signal("/var/run/pppd0.pid",1);
			send_signal("/var/run/ppp0.pid",1);
			sleep(1);
			send_signal("/var/run/l2tpd.pid",9);	
			pRomeCfgParam->l2tpCfgParam.dialState=PPTPCFGPARAM_DIALSTATE_OFF;		
		
			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;			
		default:
			break;
	}

	//do_kill("/var/run/udhcpc.pid");
	//do_kill("/var/run/pppd0.pid");
	//do_kill("/var/run/pptp.pid");
	//do_exec("killall","ripd.pid");
	//unlink("/var/run/ripd.pid");
	//remove("/var/run/pppd0");	
	//remove("/var/run/pptp_redial");
	//remove("/var/ppp/chap0");
	//remove("/var/ppp/pap0");
	//remove("/var/ppp/options0");	
	

}

void wizard_wan_restart(uint32 past_wanType)
{
	uint32 current_type = pRomeCfgParam->ifCfgParam[0].connType;
	
	pRomeCfgParam->ifCfgParam[0].connType = past_wanType;		
	stop_service();
	stop_wan();
	do_kill("/var/run/udhcpc.pid");
	do_kill("/var/run/pppd0.pid");
	do_kill("/var/run/pptp.pid");
	unlink("/var/run/ripd.pid");
	remove("/var/run/pppd0");	
	remove("/var/run/pptp_redial");
	remove("/var/ppp/chap0");
	remove("/var/ppp/pap0");
	remove("/var/ppp/options0");		
	pRomeCfgParam->ifCfgParam[0].connType = current_type;
	start_wan();
}	



/*
 * Routine Name: wanlan_int
 * Description: configure wan/lan interface
 * Input:
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 wanlan_init(void)
{
	char           *argv[8];
	unsigned char  macStr[17];
	//char           *cp;
	uint32         i=0;
	uint32	lanMemberPorts=pRomeCfgParam->vlanCfgParam[1].memberPort;
	uint32 	wanMemberPorts = pRomeCfgParam->vlanCfgParam[0].memberPort;
	int32          ret=FAILED;
	FILE *f;
	char eabuf[32];	
	

#if 0	
	/* init wan part I */
	re865xIoctl("eth0",ADD_IF,0,0,0);

	if (pRomeCfgParam->dhcpcCfgParam.cmacValid != 0)
		memcpy((char*)&macStr,(char*)&(pRomeCfgParam->dhcpcCfgParam.cloneMac),6);
	else {
		bdinfo_getMac((macaddr_t*)macStr);
		macStr[5] = macStr[5]+1;
		if (macStr[5] == 0) {
			macStr[4] = macStr[4]+1;		
			if (macStr[4] == 0)
				macStr[3] = macStr[3]+1;	
		}		
	}	
	
	re865xIoctl("eth0",ADD_VLAN,pRomeCfgParam->vlanCfgParam[0].vid,wanMemberPorts,(uint32)&macStr);
	nvram_set("wan_hwaddr", ether_etoa(macStr, eabuf));
//	re865xIoctl("eth0",SET_MAC,pRomeCfgParam->vlanCfgParam[0].vid,(uint32)&macStr,0);
	rtl8651_cfgCounter(0x1, wanMemberPorts);//Configure VLAN 8 member port using counter 1 to monitor
	
	
	/* init lan */
	sleep(1);
	bdinfo_getMac((macaddr_t*)macStr);
	
	re865xIoctl("eth1",ADD_VLAN,pRomeCfgParam->vlanCfgParam[1].vid,lanMemberPorts,(uint32)&macStr);
	nvram_set("lan_hwaddr", ether_etoa(macStr, eabuf));
	
	rtl8651_cfgCounter(0x2, lanMemberPorts);//Configure VLAN 9 member port using counter 2 to monitor
	
	setInterfaceIp("lo",0x7f000001,0xff000000);	
	re865xIoctl("eth1",SET_VLAN_TYPE,LL_VLAN,0,0);
	re865xIoctl("eth1",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr)),*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask)),0);
	re865xIoctl("eth1",SET_NET_PARA,0,0,0);
	
/* start_lan */	
	setInterfaceIp("eth1",*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr)),*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask)));

	/* turn off auto learn due to url filtering 'forward' logging needs */
	rtl8651_enableNaptAutoAdd(0);

	DEBUG_P("mac address %02X:%02X:%02X:%02X:%02X:%02X\n",macStr[0],macStr[1],macStr[2],macStr[3],macStr[4],macStr[5]);
	DEBUG_P("wan address %x netmask %x\n",*(uint32*)&(pRomeCfgParam->ifCfgParam[0].ipAddr),*(uint32*)&(pRomeCfgParam->ifCfgParam[0].ipMask));
	DEBUG_P("lan address %x netmask %x\n",*(uint32*)&(pRomeCfgParam->ifCfgParam[1].ipAddr),*(uint32*)&(pRomeCfgParam->ifCfgParam[1].ipMask));


	/* set protocol stack used udp ports in DMZ (software path) */
/*
	rtl8651_flushProtoStackUsedUdpPorts();	
	rtl8651_addProtoStackUsedUdpPort(53);
	rtl8651_flushProtoStackServerUsedTcpPorts();		
	rtl8651_addProtoStackServerUsedTcpPort(80);
*/
	//start telnetd
/*
	system("/bin/telnetd &");
	rtl8651_addProtoStackServerUsedTcpPort(23);	
*/


/* wan_start */	
	/* init wan part II */
	if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC) 
	{	
		uint32 netmask=0;

		printf("cfg wan to static ...\n");
		//rtl8651_setMtu(1500);	
		rtl8651_setMtu(pRomeCfgParam->ifCfgParam[0].mtu);
		netmask|=(pRomeCfgParam->ifCfgParam[0].ipMask[0])<<24;
		netmask|=(pRomeCfgParam->ifCfgParam[0].ipMask[1])<<16;
		netmask|=(pRomeCfgParam->ifCfgParam[0].ipMask[2])<<8;
		netmask|=pRomeCfgParam->ifCfgParam[0].ipMask[3];
		
		re865xIoctl("eth0",SET_VLAN_TYPE,LL_VLAN,0,0);
		re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),netmask,0);
		re865xIoctl("eth0",ADD_GW,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].gwAddr)),netmask,0);
		re865xIoctl("eth0",SET_EXT_INTERFACE,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),0,0);

		setInterfaceIp("eth0",*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),netmask);

		argv[0]="default";
	
		sprintf(macStr,"%u.%u.%u.%u",
			pRomeCfgParam->ifCfgParam[0].gwAddr[0],
			pRomeCfgParam->ifCfgParam[0].gwAddr[1],
			pRomeCfgParam->ifCfgParam[0].gwAddr[2],
			pRomeCfgParam->ifCfgParam[0].gwAddr[3]);
		argv[1]="gw";
		argv[2]=(char*)&macStr;
		argv[3]=NULL;
		INET_setroute(RTACTION_ADD, 0, argv);
		
		//runDNSProxy();
		setLedLight(1/*WAN_LED*/, 0/*LED_GREEN*/);
		log_message("WAN Connected");	
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC */	
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_DHCPC || 
	         pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_TELSTRA)
	{
		printf("cfg wan to dhcp client ...\n");
		//rtl8651_setMtu(1500);		
		rtl8651_setMtu(pRomeCfgParam->ifCfgParam[0].mtu);
		/* clear ifCfgParam[0].ipAddr[] etc, dhcp client will fill these values later */
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipMask,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].gwAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,0,4);
		setInterfaceIp("eth0",0,0);		
		re865xIoctl("eth0",SET_VLAN_TYPE,LL_VLAN,0,0);	
		rtl8651_addExtNetworkInterface((int8*)"eth0");

		udhcpc_start();
	}
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE)
	{
		printf("cfg wan to single PPPoE ...\n");

		/* linux if up */
		upInterface("eth0");
				
		rtl8651_addNetworkIntf("eth0");
    		//rtl8651_setAsicNaptAutoAddDelete(FALSE, 1);
    		rtl8651_enableNaptAutoAdd(0);
    		/* note: for ip unnumbered case, reference  pppObjId=0 only
    	 	*       ppp obj id equal to session number (0,1,2,3,...)
    	 	*/
	    	
		ret=rtl8651_specifyNetworkIntfLinkLayerType("eth0",RTL8651_LL_PPPOE,pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);

		rtl8651_addPppoeSession(0,pRomeCfgParam->vlanCfgParam[0].vid);	/* wan_vid = 8 */

		/* make this network interface for napt */
		//rtl8651_addExtNetworkInterface(int8 * ifName);
		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);

				    /* ipaddr, ipmask, ifname, nexthop */	
		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
			printf("rtl8651_addRoute: ret %d\n",ret);

		pppd_start(0); // start pppd on pppObjId 0
		
	} /* ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE */
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPTP) 
	{
		uint32 netmask=0, def_gw_ipAddr = 0;		
		uint8 strBuffer[128];
		
		printf("cfg wan to pptp ...\n");		
		netmask|=(pRomeCfgParam->pptpCfgParam.ipMask[0])<<24;
		netmask|=(pRomeCfgParam->pptpCfgParam.ipMask[1])<<16;
		netmask|=(pRomeCfgParam->pptpCfgParam.ipMask[2])<<8;
		netmask|=pRomeCfgParam->pptpCfgParam.ipMask[3];
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[0]) << 24;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[1]) << 16;
		def_gw_ipAddr
		 |= (pRomeCfgParam->pptpCfgParam.gwAddr[2]) << 8;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[3]);

		/* linux if up */
		upInterface("eth0");		
		//specifyNetworkIntfLinkLayerType
		//re865xIoctl("eth0",SET_VLAN_TYPE,LL_PPTP,0,0); //for PPPoE only
		rtl8651_addNetworkIntf("eth0");	
		//rtl8651_setNetMtu("eth0",pRomeCfgParam->pptpCfgParam.mtu);	//must call after addNetworkIntf ,2004/6/17
		rtl8651_specifyNetworkIntfLinkLayerType("eth0",LL_PPTP, pRomeCfgParam->vlanCfgParam[0].vid);

    		//rtl8651_setAsicNaptAutoAddDelete(FALSE, 1);
    		rtl8651_enableNaptAutoAdd(0);

		//add ip interface
		re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->pptpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->pptpCfgParam.ipMask)),0);		
		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);
	
		sprintf(strBuffer,"/sbin/ifconfig eth0 %d.%d.%d.%d netmask %d.%d.%d.%d",
			pRomeCfgParam->pptpCfgParam.ipAddr[0],
			pRomeCfgParam->pptpCfgParam.ipAddr[1],
			pRomeCfgParam->pptpCfgParam.ipAddr[2],
			pRomeCfgParam->pptpCfgParam.ipAddr[3],
			pRomeCfgParam->pptpCfgParam.ipMask[0],
			pRomeCfgParam->pptpCfgParam.ipMask[1],
			pRomeCfgParam->pptpCfgParam.ipMask[2],
			pRomeCfgParam->pptpCfgParam.ipMask[3]);

		system(strBuffer);

		/* ===================================== */
		if (def_gw_ipAddr != 0) {
			argv[0]="default";
			
			sprintf(macStr, "%u.%u.%u.%u",
				pRomeCfgParam->pptpCfgParam.gwAddr[0],
				pRomeCfgParam->pptpCfgParam.gwAddr[1],
				pRomeCfgParam->pptpCfgParam.gwAddr[2],
				pRomeCfgParam->pptpCfgParam.gwAddr[3]);
			argv[1]="gw";
			argv[2]=(char*)&macStr;
			argv[3]=NULL;
			INET_setroute(RTACTION_ADD, 0, argv);
		}
		/* ====================================== */

		ret=rtl8651_addSession(RTL8651_PPTP, 1, "eth0", pRomeCfgParam->vlanCfgParam[0].vid); 
		if (ret)
		{
			printf("rtl8651_addSession: ret %d\n",ret);
		}
		
		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
		}

		pptp_start(0);				
		
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPTP */	
#else

	start_lan();
	start_wan();
	
#endif		
	
	// set default Upstream of IGMP system
	rtl8651_multicastSetUpStream("eth0", 0);

	return 0;
} /* end wanlan_init */




/*
 * Routine Name: nat_init
 * Description: configure nat cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 nat_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_NAT,(void*)&(pRomeCfgParam->natCfgParam), sizeof(pRomeCfgParam->natCfgParam))!=0)
	{
		printf("nat_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	return 0;	
} /* end nat_init */
/* userDb_init()
*/

uint32 userDb_init(void)
{
	if (cfgmgr_read(CFGMGR_TABID_MGMT,(void*)&(pRomeCfgParam->mgmtCfgParam), sizeof(struct mgmtCfgParam_s)*MAX_MGMT_USER)!=0)
	{
		printf("userDb_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	return 0;	


}

/*
 * Routine Name: pppoe_init
 * Description: configure pppoe cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
#if 0
/* obsolete by wan flat init in sysInit 2003/09/24 */
uint32 pppoe_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_PPPOE,(void*)pRomeCfgParam->pppoeCfgParam, sizeof(pppoeCfgParam_t)*MAX_PPPOE_SESSION)!=0)
	{
		printf("pppoe_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	memcpy((void*)ramPppoeCfgParam,(void*)pRomeCfgParam->pppoeCfgParam,sizeof(pppoeCfgParam_t)*MAX_PPPOE_SESSION));
	
	
	return 0;	
} /* end pppoe_init */
#endif

void dhcps_start(void)
{
	FILE *f1,*f2;
	unsigned char tmp[240];
	int32 i;

	if (pRomeCfgParam->dhcpsCfgParam.enable == 0)
	{
		do_kill("/var/run/udhcpd.pid");
		return;
	}

	/* Don't need sleep because running dns proxy/cache */
	f1 = fopen("/etc/udhcpd.conf","r");
	if (!f1)
	{
		printf("fopen /etc/udhcpd.conf failed\n");
		while(1);
	}

	f2 = fopen("/var/udhcpd.conf","w+");
	if (!f2)
	{
		printf("fopen /var/udhcpd.conf failed\n");
		//while (1);
		return;
	}
	
	while (!feof(f1))
	{
		fgets(tmp,240,f1);
		if (!memcmp(tmp,"startip",7))
			sprintf(tmp,"start	%u.%u.%u.%u\n",
				pRomeCfgParam->ifCfgParam[1].ipAddr[0],
				pRomeCfgParam->ifCfgParam[1].ipAddr[1],
				pRomeCfgParam->ifCfgParam[1].ipAddr[2],
				pRomeCfgParam->dhcpsCfgParam.startIp);
					
		if (!memcmp(tmp,"endip",5))
			sprintf(tmp,"end	%u.%u.%u.%u\n",
				pRomeCfgParam->ifCfgParam[1].ipAddr[0],
				pRomeCfgParam->ifCfgParam[1].ipAddr[1],
				pRomeCfgParam->ifCfgParam[1].ipAddr[2],
				pRomeCfgParam->dhcpsCfgParam.endIp);
					
		if (!memcmp(tmp,"dnsip",5))
		{
			if (pRomeCfgParam->dhcpsCfgParam.realDNSenable)
			{	/* provide real DNS server */
				ipaddr_t dnsServer[2] = {0};
				dnsServer[0] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]) << 24) +
								((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]) << 16) +
								((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]) << 8) +
								(uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

				dnsServer[1] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]) << 24) +
								((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]) << 16) +
								((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]) << 8) +
								(uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);

				if ((dnsServer[0] == 0) && (dnsServer[1] == 0))
				{	/* no DNS server assigned, use gateway as the default DNS server */
					goto GWIsDNS;
				}
				if (dnsServer[0] && dnsServer[1])
				{	/* both primary and secondary DNS servers are OK */
					sprintf(tmp, "opt dns %u.%u.%u.%u\nopt dns %u.%u.%u.%u\n",
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);
				} else if (dnsServer[0])
				{	/* only primary DNS server is OK */
					sprintf(tmp, "opt dns %u.%u.%u.%u\n",
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);
				} else
				{	/* only secondary DNS server is OK */
					sprintf(tmp, "opt dns %u.%u.%u.%u\n",
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);
				}

			}else
			{	/* provide gateway as the default DNS server */
	GWIsDNS:
				sprintf(tmp,"opt dns  %u.%u.%u.%u\n",
					pRomeCfgParam->ifCfgParam[1].ipAddr[0],
					pRomeCfgParam->ifCfgParam[1].ipAddr[1],
					pRomeCfgParam->ifCfgParam[1].ipAddr[2],
					pRomeCfgParam->ifCfgParam[1].ipAddr[3]);
			}
		}

		if (!memcmp(tmp,"routerip",8))
			sprintf(tmp,"opt router  %u.%u.%u.%u\n",
				pRomeCfgParam->ifCfgParam[1].ipAddr[0],
				pRomeCfgParam->ifCfgParam[1].ipAddr[1],
				pRomeCfgParam->ifCfgParam[1].ipAddr[2],
				pRomeCfgParam->ifCfgParam[1].ipAddr[3]);

		if (!memcmp(tmp, "domain", 6))
		{
			tmp[0] = '\0';
			if (pRomeCfgParam->dhcpsCfgParam.lan_domain[0] != '\0') {
				snprintf(tmp, sizeof(tmp), "opt domain %s\n", pRomeCfgParam->dhcpsCfgParam.lan_domain);
			}				
			else if (pRomeCfgParam->dhcpsCfgParam.domain[0] != '\0')
			{
				snprintf(tmp, sizeof(tmp), "opt domain %s\n", pRomeCfgParam->dhcpsCfgParam.domain);
			}
			else
				snprintf(tmp, sizeof(tmp), "opt domain %s\n", _PRODUCT_NAME/*"RP614v4"*/);
				
		}

		if (!memcmp(tmp, "winsip", 6))
		{
			uint8 winsAddr[20];
			uint8 winsAddr2[20];

			snprintf(winsAddr, sizeof(winsAddr), "%u.%u.%u.%u",
				(pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr) >> 24,
				((pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x00ff0000) >> 16,
				((pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x0000ff00) >> 8,
				(pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x000000ff);

			snprintf(winsAddr2, sizeof(winsAddr2), "%u.%u.%u.%u",
				(pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr) >> 24,
				((pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x00ff0000) >> 16,
				((pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x0000ff00) >> 8,
				(pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x000000ff);
	
			tmp[0] = '\0';
			if (pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr && pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)
			{
				sprintf(tmp, "opt wins %s\nopt wins %s\n", winsAddr, winsAddr2);
			}else if (pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)
			{
				sprintf(tmp, "opt wins %s\n", winsAddr);
			}else if (pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)
			{
				sprintf(tmp, "opt wins %s\n", winsAddr2);
			}
		}
		if (!memcmp(tmp, "lease", 5)) 
		{		
				sprintf(tmp, "opt lease %d\n", 86400/* ONE DAY */);			
		}			
		fputs(tmp,f2);
	}

	for(i=0; i<MAX_RESERVED_FIXED; i++) {
		if (pRomeCfgParam->dhcpsCfgParam.manualIp[i] == 0)
			break;
		sprintf(tmp, "\nmanual %02X:%02X:%02X:%02X:%02X:%02X  %u.%u.%u.%u\n", 
				pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][0], pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][1],
				pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][2], pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][3],
				pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][4], pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][5],
				pRomeCfgParam->dhcpsCfgParam.manualIp[i]>>24, (pRomeCfgParam->dhcpsCfgParam.manualIp[i]&0x00ff0000)>>16,
				(pRomeCfgParam->dhcpsCfgParam.manualIp[i]&0x0000ff00)>>8, pRomeCfgParam->dhcpsCfgParam.manualIp[i]&0xff);
		fputs(tmp,f2);
	}
#if 0
	f1 = fopen("/var/resolv.conf","r");
	if (f1)
	{
		while ((!feof(f1))) 
		{
			memset(tmp,0,160);
			fgets(tmp,160,f1);
			/*for (i=0;i<160;i++)
			{
				if (memcmp(*tmp," ",1))
					tmp++;
				if (*tmp==0)break;
			}*/
			cp = strchr(tmp,' ');
			if (cp)
			fprintf(f2,"opt dns %s\n",cp);
		}
	}
#endif
	fclose(f2);

	/* kill old udhcpd if it exists */
	/* backup lease info */
	send_signal("/var/run/udhcpd.pid", SIGUSR1);
	sleep(1);
	
	do_kill("/var/run/udhcpd.pid");
	eval("killall", "-9", "udhcpd");	
	do_exec("/bin/udhcpd", NULL);
}

/*
 * Routine Name: dhcps_init
 * Description: configure dhcps cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dhcps_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DHCPS,(void*)&(pRomeCfgParam->dhcpsCfgParam), sizeof(dhcpsCfgParam_t))!=0)
	{
		printf("dhcps_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	memcpy((void*)&ramDhcpsCfgParam,&(pRomeCfgParam->dhcpsCfgParam),sizeof(dhcpsCfgParam_t));
#if 0	
#if defined(DNI)
	if (!((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC) ||
		(pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP) ||
		(pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_TELSTRA)))
#else
	if (!((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC) ||
		(pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP)))
#endif
	{	/* other wan type except DHCP: don't forward domain */
		pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd = 0;
	}
#endif	

	return 0;	
} /* end dhcps_init */

/*
 * Routine Name: dhcpc_init
 * Description: configure dhcpc cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
#if 0
/* obsoleted by flat wan init in sysInit 2003/09/24 orlando */
uint32 dhcpc_init(void)
{	
	/* read cfg from cfgmgr
	 */
	if (cfgmgr_read(CFGMGR_TABID_DHCPC,(void*)&(pRomeCfgParam->dhcpcCfgParam), sizeof(dhcpcCfgParam_t))!=0)
	{
		printf("dhcpc_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	
	memcpy((void*)&(ramDhcpcCfgParam),(void*)&(pRomeCfgParam->dhcpcCfgParam),sizeof(dhcpcCfgParam_t));
	
	return 0;	
} /* end dhcpc_init */
#endif

/*
 * Routine Name: dns_init
 * Description: create /var/resolv.conf based on xxxCfgParam[].dnsPrimaryAddr
 *              this file is to be referenced by nameserver
 *              note that dhcpc and pppd will overwrite this file upon ip-up.
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dns_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DNS,(void*)&(pRomeCfgParam->dnsCfgParam), sizeof(pRomeCfgParam->dnsCfgParam))!=0)
	{
		printf("dns_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	
#if !defined(DNI)	
	/* PPPoE has to have a callback mechanism when ppp state reaches "NETWORK"
	   reflect the new dns given by pppoe service provider
	   current implementation try to init it during bootup to wan's static dns.
	   it's easier for demonstraton purpose. but need to change it when
	   the callback mechanism is ready!! orlando 2003/06/26
	 */
	if ( (pRomeCfgParam->dnsCfgParam.enable == 1)	
	     && 
	     (   pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_STATIC
	      || pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE
	      || pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC
	     )
	   )
	{
		char primary[16]={0};
		FILE *f;
		sprintf(primary,"%d.%d.%d.%d",pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0],
									  pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1],
									  pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2],
									  pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3] );
		//printf("dns_init: starting dns proxy at %s ...\n",primary);
		
		// set resolv.conf
		f=fopen("/var/resolv.conf","w+");
		fprintf(f,"nameserver %s\n",primary);
		fclose(f);
	}
#else
#if 0
	/* manual dns */
	if ( (pRomeCfgParam->dnsCfgParam.enable == 1)) {	/* auto_dns = 0 */
		char primary[16]={0};
		FILE *f;		
		
		f=fopen("/var/resolv.conf","w+");		
		memcpy((uint32 *)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr), 
			(uint32 *)(pRomeCfgParam->dnsCfgParam.primary), 4);
		memcpy((uint32 *)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr), 
			(uint32 *)(pRomeCfgParam->dnsCfgParam.secondary), 4);	

		sprintf(primary,"%d.%d.%d.%d",pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0],
									  pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1],
									  pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2],
									  pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3] );
		fprintf(f,"nameserver %s\n",primary);
		sprintf(primary,"%d.%d.%d.%d",pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0],
									  pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1],
									  pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2],
									  pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3] );
		fprintf(f,"nameserver %s\n",primary);									  
		
		fclose(f);			
		//runDNSProxy();					
	}
#endif
#endif	

	return 0;	
} /* end dns_init */

/*********** Add by Timo Wu************/
#if defined(DNI)
void urlfilter_tableDriverSingleHandle(int action ,int j, int i)	
{

	int ret,k;
	
	if (pRomeCfgParam->natCfgParam.hwaccel==1)
	{

		if(action==URLFILTER_SINGLE_HANDLE_ADD)
		{
			/*
			ret = rtl8651a_addAclRule(j, ifStr,
								  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
								||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC ),
								(rtl8651_tblDrvAclRule_t *)&tempAclRule);
			*/
			
			//ret = rtl8651_addURLFilterRule(0,pRomeCfgParam->urlfilterCfgParam[0][i].string, strlen(pRomeCfgParam->urlfilterCfgParam[0][i].string), pRomeCfgParam->urlfilterCfgParam[0][i].ip_start, pRomeCfgParam->urlfilterCfgParam[0][i].ip_end);
			{
				printf("enter rtl8651_addGenericURLFilterRule\n");				
				//rtl8651_urlUnknownTypeCaseSensitive(TRUE);
    				rtl8651_tblDrv_urlFilter_t urlFilter_tmp;
    				rtl8651_tblDrv_urlPktFilter_t urlPktFilter_tmp;
    				bzero(&urlFilter_tmp, sizeof(rtl8651_tblDrv_urlFilter_t));
    				bzero(&urlPktFilter_tmp, sizeof(rtl8651_tblDrv_urlPktFilter_t));
    				urlFilter_tmp.sessionId = 0;
    				urlFilter_tmp.ruleType = RTL8651_URLSTRING_UNKNOWNTYPE;
    				urlFilter_tmp.urlFilterString  = (int8 *)malloc(32);
    				urlFilter_tmp.urlFilterStrLen=sprintf(urlFilter_tmp.urlFilterString,"%s",pRomeCfgParam->urlfilterCfgParam[0][i].string);    
    				urlPktFilter_tmp.rule_type=RTL8651_URLPKTFILTER_TYPE_SIP;
    				urlPktFilter_tmp.sip_start=pRomeCfgParam->urlfilterCfgParam[0][i].ip_start;
    				urlPktFilter_tmp.sip_end=pRomeCfgParam->urlfilterCfgParam[0][i].ip_end;     
    				ret = rtl8651_addGenericURLFilterRule(&urlFilter_tmp, &urlPktFilter_tmp);
    				printf("add url filter ret=%d string=%s len=%d\n",ret,urlFilter_tmp.urlFilterString,urlFilter_tmp.urlFilterStrLen);   
    				free(urlFilter_tmp.urlFilterString); 
			}
					
			if (ret!=SUCCESS)
			{
				printf("urlfilter_tableDriverAccess: Failed rtl8651_addURLFilterRule() ret:%d\n",ret);
				//pRomeCfgParam->urlfilterCfgParam[0][i].enable=0;
				return NOT_OK;
			}
			else
				printf("urlfilter_tableDriverAccess: Success rtl8651_addURLFilterRule() ret:%d\n",ret);
		}
		else if(action==URLFILTER_SINGLE_HANDLE_DEL)
		{
			/*	
			ret = rtl8651a_delAclRule(j, ifStr,
								  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
								||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC ),
								(rtl8651_tblDrvAclRule_t *)&tempAclRule);
			*/
			{
				printf("enter rtl8651_delGenericURLFilterRule\n");
				//rtl8651_urlUnknownTypeCaseSensitive(TRUE);
    				rtl8651_tblDrv_urlFilter_t urlFilter_tmp;
    				rtl8651_tblDrv_urlPktFilter_t urlPktFilter_tmp;
    				bzero(&urlFilter_tmp, sizeof(rtl8651_tblDrv_urlFilter_t));
    				bzero(&urlPktFilter_tmp, sizeof(rtl8651_tblDrv_urlPktFilter_t));
    				urlFilter_tmp.sessionId = 0;
    				urlFilter_tmp.ruleType = RTL8651_URLSTRING_UNKNOWNTYPE;
    				urlFilter_tmp.urlFilterString  = (int8 *)malloc(32);
    				urlFilter_tmp.urlFilterStrLen=sprintf(urlFilter_tmp.urlFilterString,"%s",pRomeCfgParam->urlfilterCfgParam[0][i].string);    
    				urlPktFilter_tmp.rule_type=RTL8651_URLPKTFILTER_TYPE_SIP;
    				urlPktFilter_tmp.sip_start=pRomeCfgParam->urlfilterCfgParam[0][i].ip_start;
    				urlPktFilter_tmp.sip_end=pRomeCfgParam->urlfilterCfgParam[0][i].ip_end;     
    				ret = rtl8651_delGenericURLFilterRule(&urlFilter_tmp, &urlPktFilter_tmp);
    				printf("del url filter ret=%d string=%s len=%d\n",ret,urlFilter_tmp.urlFilterString,urlFilter_tmp.urlFilterStrLen);   
    				free(urlFilter_tmp.urlFilterString); 
			}
			
			if (ret!=SUCCESS)
			{
				printf("urlfilter_tableDriverAcess: Failed rtl8651_delURLFilterRule ret:%d\n",ret);
				//pRomeCfgParam->urlfilterCfgParam[0][i].enable=0;
				return NOT_OK;
			}
			else
				printf("urlfilter_tableDriverAcess: Success rtl8651_delURLFilterRule() ret:%d\n",ret);
		
#if 0		
			//check if delete action is within legal time
			if(pRomeCfgParam->scheduleCfgParam.allday ==1)
			{
				//printf("pRomeCfgParam->scheduleCfgParam.allday  == 1\n");
				for (k=0; k<MAX_URL_FILTER; k++){	
					clock_t t;
					struct tm *gm;
					time(&t);
				
					if(((pRomeCfgParam->scheduleCfgParam.day)&(1<<(gm->tm_wday)))==0) continue; // not today
					//check time
						
					if(
					((gm->tm_hour*60+gm->tm_min)<
					((uint32)(pRomeCfgParam->scheduleCfgParam.start_hour)*60+pRomeCfgParam->scheduleCfgParam.start_minute)) ||
					((gm->tm_hour*60+gm->tm_min)>
					((uint32)(pRomeCfgParam->scheduleCfgParam.end_hour)*60+pRomeCfgParam->scheduleCfgParam.end_minute))
		  				) continue;  // time not in the schedule
		  			printf("time is in schedulem add urlfilter again\n");
		  				
		  			urlfilter_tableDriverSingleHandle(URLFILTER_SINGLE_HANDLE_ADD,j,i);			
				}
			}
#endif			
		}
	}

}
#endif
/****************End*************/

void acl_tableDriverSingleHandle(int action,int j,int i)	
{
	// j: dial session , i: index of acl rule
	int8 ifStr[20];
	int8 ifWanStr[20];
	int8 ifLanStr[20];
	int ret;

	memset(ifStr,0,20);	
	sprintf(ifStr,"eth0");
	memset(ifWanStr,0,20);	
	sprintf(ifWanStr,"eth0");
	memset(ifLanStr,0,20);	
	sprintf(ifLanStr,"eth1");		
	
	memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));

	/* prepare acl rule data structure */
	if (   (pRomeCfgParam->aclCfgParam[j][i].direction == ACLCFGPARAM_DIRECTION_INGRESS_DEST)
	    || (pRomeCfgParam->aclCfgParam[j][i].direction == ACLCFGPARAM_DIRECTION_EGRESS_DEST )
	   )
	{			
		memcpy(&(tempAclRule.dstIpAddr_),pRomeCfgParam->aclCfgParam[j][i].ip,4);
		if (   pRomeCfgParam->aclCfgParam[j][i].ip[0]==0
	    	&& pRomeCfgParam->aclCfgParam[j][i].ip[1]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[2]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[3]==0)
			tempAclRule.dstIpAddrMask_=0;
		else
			tempAclRule.dstIpAddrMask_=0xffffffff;
	}
	else
	{	//Add by Timo Wu
		memcpy(&(tempAclRule.srcIpAddr_),pRomeCfgParam->aclCfgParam[j][i].ip,4);
		if (   pRomeCfgParam->aclCfgParam[j][i].ip[0]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[1]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[2]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[3]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip_end[0]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip_end[1]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip_end[2]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip_end[3]==0)  
			tempAclRule.srcIpAddrMask_=0;
		else
			memcpy(&(tempAclRule.srcIpAddrMask_),pRomeCfgParam->aclCfgParam[j][i].ip_end,4);

	}
	
	tempAclRule.tos_=0;
	tempAclRule.tosMask_=0;

	tempAclRule.ipFlag_=0;
	tempAclRule.ipMF_=0;
	tempAclRule.ipDF_=0;
	//tempAclRule.ipRSV_=0;
		
	if (pRomeCfgParam->aclCfgParam[j][i].type == ACLCFGPARAM_PROTOCOL_TCP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_TCP;
		tempAclRule.tcpFlagMask_=0;
		if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		    ||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_EGRESS_DEST )
		   )
		{
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.tcpDstPortLB_=0;
				tempAclRule.tcpDstPortUB_=0xffff;
			}else{
				tempAclRule.tcpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.tcpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}

			tempAclRule.tcpSrcPortLB_=0;
			tempAclRule.tcpSrcPortUB_=0xffff;
		}
		else
		{
		//Add by Timo
		#if defined(DNI) //DNI's type is to check Destination Port
			//if (pRomeCfgParam->aclCfgParam[j][i].port==0){
			//	tempAclRule.tcpDstPortLB_=0;
			//	tempAclRule.tcpDstPortUB_=0xffff;	
			//}else{
				/* port range */
				tempAclRule.tcpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;	/* start dst-port */
				tempAclRule.tcpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port_e;	/* end dst-port */

			//}
			tempAclRule.tcpSrcPortLB_=0;
			tempAclRule.tcpSrcPortUB_=0xffff;
		#else
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.tcpSrcPortLB_=0;
				tempAclRule.tcpSrcPortUB_=0xffff;
			}else{
				tempAclRule.tcpSrcPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.tcpSrcPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.tcpDstPortLB_=0;
			tempAclRule.tcpDstPortUB_=0xffff;
		#endif
		}
		tempAclRule.tcpFlag_=0;
		tempAclRule.tcpURG_=0;
		tempAclRule.tcpACK_=0;
		tempAclRule.tcpPSH_=0;
		tempAclRule.tcpRST_=0;
		tempAclRule.tcpSYN_=0;
		tempAclRule.tcpFIN_=0;
	}
	else if (pRomeCfgParam->aclCfgParam[j][i].type == ACLCFGPARAM_PROTOCOL_UDP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_UDP;
		if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		    ||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_EGRESS_DEST )
		   )
		{
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.udpDstPortLB_=0;
				tempAclRule.udpDstPortUB_=0xffff;
			}else{
				tempAclRule.udpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.udpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.udpSrcPortLB_=0;
			tempAclRule.udpSrcPortUB_=0xffff;
		}
		else
		{
		#if defined(DNI) //Add by Timo Wu
			//if (pRomeCfgParam->aclCfgParam[j][i].port==0){
			//	tempAclRule.udpDstPortLB_=0;
			//	tempAclRule.udpDstPortUB_=0xffff;
			//}else{
				/* port range */
				tempAclRule.udpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.udpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port_e;
			//}
			tempAclRule.udpSrcPortLB_=0;
			tempAclRule.udpSrcPortUB_=0xffff;		
		#else
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.udpSrcPortLB_=0;
				tempAclRule.udpSrcPortUB_=0xffff;
			}else{
				tempAclRule.udpSrcPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.udpSrcPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.udpDstPortLB_=0;
			tempAclRule.udpDstPortUB_=0xffff;
		#endif
		}
	}
#if 0	
	else if (pRomeCfgParam->aclCfgParam[j][i].type == ACLCFGPARAM_PROTOCOL_IP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_IP;
		tempAclRule.tcpFlagMask_=0;
				
		if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		    ||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_EGRESS_DEST )
		   )
		{
		
			tempAclRule.tcpDstPortLB_=0;
			tempAclRule.tcpDstPortUB_=0xffff;				
			tempAclRule.tcpSrcPortLB_=0;
			tempAclRule.tcpSrcPortUB_=0xffff;

		}
		else
		{				
			tempAclRule.tcpSrcPortLB_=0;
			tempAclRule.tcpSrcPortUB_=0xffff;				
			tempAclRule.tcpDstPortLB_=0;
			tempAclRule.tcpDstPortUB_=0xffff;
		}

		tempAclRule.ipFlag_=0;
		tempAclRule.ipFlagMask_=0;
	}
#endif	
	/* Netgear ACLCFGPARAM_PROTOCOL_IP -> TCP/UDP */
	else if (pRomeCfgParam->aclCfgParam[j][i].type == ACLCFGPARAM_PROTOCOL_IP)
	{
		/* first add TCP */
		tempAclRule.ruleType_=RTL8651_ACL_TCP;
		tempAclRule.tcpFlagMask_=0;
		if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		    ||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_EGRESS_DEST )
		   )
		{
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.tcpDstPortLB_=0;
				tempAclRule.tcpDstPortUB_=0xffff;
			}else{
				tempAclRule.tcpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.tcpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}

			tempAclRule.tcpSrcPortLB_=0;
			tempAclRule.tcpSrcPortUB_=0xffff;
		}
		else
		{
		//Add by Timo
		#if defined(DNI) //DNI's type is to check Destination Port
			//if (pRomeCfgParam->aclCfgParam[j][i].port==0){
			//	tempAclRule.tcpDstPortLB_=0;
			//	tempAclRule.tcpDstPortUB_=0xffff;	
			//}else{
				/* port range */
				tempAclRule.tcpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;	/* start dst-port */
				tempAclRule.tcpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port_e;	/* end dst-port */

			//}
			tempAclRule.tcpSrcPortLB_=0;
			tempAclRule.tcpSrcPortUB_=0xffff;
		#else
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.tcpSrcPortLB_=0;
				tempAclRule.tcpSrcPortUB_=0xffff;
			}else{
				tempAclRule.tcpSrcPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.tcpSrcPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.tcpDstPortLB_=0;
			tempAclRule.tcpDstPortUB_=0xffff;
		#endif
		}
		tempAclRule.tcpFlag_=0;
		tempAclRule.tcpURG_=0;
		tempAclRule.tcpACK_=0;
		tempAclRule.tcpPSH_=0;
		tempAclRule.tcpRST_=0;
		tempAclRule.tcpSYN_=0;
		tempAclRule.tcpFIN_=0;
	}	
				
			
	if (pRomeCfgParam->aclGlobalCfgParam.policy == ACLGLOBALCFGPARAM_ALLOWALLBUTACL)
		tempAclRule.actionType_=RTL8651_ACL_DROP;
	else if (pRomeCfgParam->aclGlobalCfgParam.policy == ACLGLOBALCFGPARAM_DENYALLBUTACL)
		tempAclRule.actionType_=RTL8651_ACL_PERMIT;
	else if(pRomeCfgParam->aclGlobalCfgParam.policy == ACLGLOBALCFGPARAM_ALLOWALLBUTACL_LOG)
		tempAclRule.actionType_=RTL8651_ACL_DROP_LOG;			

	if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC )
	   )
		sprintf(ifStr,ifLanStr);
	else
		sprintf(ifStr,ifWanStr);

	/* To DNI Testing */
	//trap packets to CPU 
	//tempAclRule.actionType_=RTL8651_ACL_CPU;
	//tempAclRule.actionType_= RTL8651_ACL_DROP_LOG;		
	
	
	if (pRomeCfgParam->natCfgParam.hwaccel==1)
	{

		if(action==ACL_SINGLE_HANDLE_ADD)
		{	//Add by Timo Wu
			ret = rtl8651a_addAclRuleExt(j, ifStr,
								  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
								||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC ),
								(rtl8651_tblDrvAclRule_t *)&tempAclRule);
			if (ret!=SUCCESS)
			{
				printf("acl_tableDriverAcess: rtl8651a_addAclRule() ret:%d\n",ret);
				//pRomeCfgParam->aclCfgParam[j][i].enable=0;
				return NOT_OK;
			}
			else
				printf("acl_tableDriverAcess: rtl8651a_addAclRule(if:%s) ret:%d\n",ifStr,ret);
		}
		else if(action==ACL_SINGLE_HANDLE_DEL)
		{	//Add by Timo Wu
			ret = rtl8651a_delAclRuleExt(j, ifStr,
								  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
								||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC ),
								(rtl8651_tblDrvAclRule_t *)&tempAclRule);
			if (ret!=SUCCESS)
			{
				printf("acl_tableDriverAcess: rtl8651a_delAclRule() ret:%d\n",ret);
				//pRomeCfgParam->aclCfgParam[j][i].enable=0;
				return NOT_OK;
			}
			else
				printf("acl_tableDriverAcess: rtl8651a_delAclRule(if:%s) ret:%d\n",ifStr,ret);
		}
	}	
	
	if (pRomeCfgParam->aclCfgParam[j][i].type == ACLCFGPARAM_PROTOCOL_IP)
	{
		/* secondary add UDP */
		tempAclRule.ruleType_=RTL8651_ACL_UDP;
		if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		    ||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_EGRESS_DEST )
		   )
		{
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.udpDstPortLB_=0;
				tempAclRule.udpDstPortUB_=0xffff;
			}else{
				tempAclRule.udpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.udpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.udpSrcPortLB_=0;
			tempAclRule.udpSrcPortUB_=0xffff;
		}
		else
		{
		#if defined(DNI) //Add by Timo Wu
			//if (pRomeCfgParam->aclCfgParam[j][i].port==0){
			//	tempAclRule.udpDstPortLB_=0;
			//	tempAclRule.udpDstPortUB_=0xffff;
			//}else{
				/* port range */
				tempAclRule.udpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.udpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port_e;
			//}
			tempAclRule.udpSrcPortLB_=0;
			tempAclRule.udpSrcPortUB_=0xffff;		
		#else
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.udpSrcPortLB_=0;
				tempAclRule.udpSrcPortUB_=0xffff;
			}else{
				tempAclRule.udpSrcPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.udpSrcPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.udpDstPortLB_=0;
			tempAclRule.udpDstPortUB_=0xffff;
		#endif
		}
	}			
			
	if (pRomeCfgParam->aclGlobalCfgParam.policy == ACLGLOBALCFGPARAM_ALLOWALLBUTACL)
		tempAclRule.actionType_=RTL8651_ACL_DROP;
	else if (pRomeCfgParam->aclGlobalCfgParam.policy == ACLGLOBALCFGPARAM_DENYALLBUTACL)
		tempAclRule.actionType_=RTL8651_ACL_PERMIT;
	else if(pRomeCfgParam->aclGlobalCfgParam.policy == ACLGLOBALCFGPARAM_ALLOWALLBUTACL_LOG)
		tempAclRule.actionType_=RTL8651_ACL_DROP_LOG;			

	if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC )
	   )
		sprintf(ifStr,ifLanStr);
	else
		sprintf(ifStr,ifWanStr);

	/* To DNI Testing */
	//trap packets to CPU 
	//tempAclRule.actionType_=RTL8651_ACL_CPU;
	//tempAclRule.actionType_= RTL8651_ACL_DROP_LOG;		
	
	
	if (pRomeCfgParam->natCfgParam.hwaccel==1)
	{

		if(action==ACL_SINGLE_HANDLE_ADD)
		{	//Add by Timo Wu
			ret = rtl8651a_addAclRuleExt(j, ifStr,
								  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
								||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC ),
								(rtl8651_tblDrvAclRule_t *)&tempAclRule);
			if (ret!=SUCCESS)
			{
				printf("acl_tableDriverAcess: rtl8651a_addAclRule() ret:%d\n",ret);
				//pRomeCfgParam->aclCfgParam[j][i].enable=0;
				return NOT_OK;
			}
			else
				printf("acl_tableDriverAcess: rtl8651a_addAclRule(if:%s) ret:%d\n",ifStr,ret);
		}
		else if(action==ACL_SINGLE_HANDLE_DEL)
		{	//Add by Timo Wu
			ret = rtl8651a_delAclRuleExt(j, ifStr,
								  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
								||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC ),
								(rtl8651_tblDrvAclRule_t *)&tempAclRule);
			if (ret!=SUCCESS)
			{
				printf("acl_tableDriverAcess: rtl8651a_delAclRule() ret:%d\n",ret);
				//pRomeCfgParam->aclCfgParam[j][i].enable=0;
				return NOT_OK;
			}
			else
				printf("acl_tableDriverAcess: rtl8651a_delAclRule(if:%s) ret:%d\n",ifStr,ret);
		}
	}		
	
}


void parse_and_add_triggerPort(int dsid,int parseLen,char *inRange,uint8 inType,uint8 outType,uint16 outStart,uint16 outFinish,ipaddr_t localIp)
{
	int j;
	char tempStr1[10]={0},tempStr2[10]={0};
	int idx=0,shift=0;

	printf("Range=%s\n",inRange);

	// add trigger port entry to fwdEngine
	for(j=0;j<parseLen;j++)
	{
		if(((inRange[j]>='0')&&(inRange[j]<='9')))
		{
			if(shift>=9) continue;
			if(idx==0)
				tempStr1[shift++]=inRange[j];
			else
				tempStr2[shift++]=inRange[j];
			
		}
		else if((inRange[j]==',')||
				(inRange[j]=='-')||
				(inRange[j]==0))
		{
			if(idx==0)
				tempStr1[shift]=0;
			else
				tempStr2[shift]=0;
		
			shift=0;
			if((inRange[j]==',')||
				(inRange[j]==0))
			{
				uint16 inStart,inFinish;
				inStart=atoi(tempStr1);
				if(idx==0)
					inFinish=inStart;
				else
					inFinish=atoi(tempStr2);
				idx=0;
			
				//make inFinish always bigger than inStart
				if(inStart>inFinish)
				{
					uint16 temp;
					temp=inFinish;
					inFinish=inStart;
					inStart=temp;
				}
				
				if(!((inStart==0)||(inFinish==0)))
				{
#if 0					
					rtl8651a_addTriggerPortRule(
					dsid, //dsid
					inType,inStart,inFinish,
					outType,
					outStart,
					outFinish,localIp);
//					printf("inRange=%d-%d\n inType=%d\n",inStart,inFinish,inType);
#endif

    					_rtl8651_triggerPort_param_t mappingInfo;
     					memset(&mappingInfo,0,sizeof(mappingInfo));
     					mappingInfo.age=pRomeCfgParam->specialapCfgParam[0][0].g_triggertime*60;  // how many second to age out after trigger.
     					mappingInfo.isStaticMapping=0;
     					mappingInfo.tp_outType=outType;
     					mappingInfo.tp_outPortStart=outStart;     
     					mappingInfo.tp_outPortEnd=outFinish;
     					if (localIp == 0) {
     						mappingInfo.tp_triggeringInsideLocalIpAddrStart=0x0;  // Trigger Port be triggered by this IP range
     						mappingInfo.tp_triggeringInsideLocalIpAddrEnd=0xffffffff;   // Trigger Port be triggered by this IP range
					} else {
    						mappingInfo.tp_triggeringInsideLocalIpAddrStart=localIp;  // Trigger Port be triggered by this IP range
     						mappingInfo.tp_triggeringInsideLocalIpAddrEnd=localIp;   // Trigger Port be triggered by this IP range
					}						
					rtl8651_addTriggerPortMappingRule(
     					dsid,  // dial session id: if single session, please fill '0'.
     					inType,
     					inStart,
     					inFinish,
     					&mappingInfo);


				}
			}
			else
			{
				idx++;	
			}
			if(inRange[j]==0)
				break;
		}				
	}
#if 0 //disable trap to cpu , when turn auto-learn off.
	memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));
	//trap all IP address
	tempAclRule.dstIpAddrMask_=0;

	if (pRomeCfgParam->specialapCfgParam[i].outType == ACLCFGPARAM_PROTOCOL_TCP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_TCP;

		tempAclRule.tcpDstPortLB_=pRomeCfgParam->specialapCfgParam[i].outStart;
		tempAclRule.tcpDstPortUB_=pRomeCfgParam->specialapCfgParam[i].outFinish;
		tempAclRule.tcpSrcPortLB_=0;
		tempAclRule.tcpSrcPortUB_=0xffff;
		
		tempAclRule.tcpFlagMask_=0;
		tempAclRule.tcpFlag_=0;
		tempAclRule.tcpURG_=0;
		tempAclRule.tcpACK_=0;
		tempAclRule.tcpPSH_=0;
		tempAclRule.tcpRST_=0;
		tempAclRule.tcpSYN_=1;
		tempAclRule.tcpFIN_=0;
	}
	else if (pRomeCfgParam->specialapCfgParam[i].outType == ACLCFGPARAM_PROTOCOL_UDP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_UDP;
		tempAclRule.udpDstPortLB_=pRomeCfgParam->specialapCfgParam[i].outStart;
		tempAclRule.udpDstPortUB_=pRomeCfgParam->specialapCfgParam[i].outFinish;
		tempAclRule.udpSrcPortLB_=0;
		tempAclRule.udpSrcPortUB_=0xffff;	
	}
			
	//trap packets to CPU 
	tempAclRule.actionType_=RTL8651_ACL_CPU;

	if (pRomeCfgParam->natCfgParam.hwaccel==1)
	{
		//add egress rule
		ret = rtl8651a_addAclRule(i,"eth1",TRUE,(rtl8651_tblDrvAclRule_t *)&tempAclRule);
		if (ret!=SUCCESS)
		{
			printf("acl_tableDriverAcess Trigger_Port: rtl8651_addAclRule() ret:%d\n",ret);
			return NOT_OK;
		}
		else
			printf("acl_tableDriverAcess Trigger_Port: rtl8651_addAclRule(if:eth1) ret:%d\n",ret);
	}			
#endif
}

/*************Add by Timo Wu***********/
//2006/01/12 for schedule email
enum emailtypeCfgParam_e {
	EMAIL_LOGFULL = 0,
	EMAIL_LOGHOURLY,
	EMAIL_LOGDAILY,
	EMAIL_LOGWEEKLY,	
	EMAIL_LOGNONE
};

uint32 email_checkLogFull(void)
{
	
	int fd;
	struct stat stat_buf;
	FILE *f;
	//read system.log file if >16000 then log full
	fd=open("/var/system.log", O_RDONLY);
	if(fd < 0)
	{
		printf("fd open error\n");
		return -1;
	}
				
	fstat(fd ,&stat_buf);
	close(fd);
		
	if(stat_buf.st_size > 16000)
	{
		
		system("/bin/smtpclient subject_log /var/system.log no_trigger");
		
		{
	   		timer_t timep;
	   		struct tm *tm;
	   		char *wday[]={"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};
			char *wmonth[]={"Jan", "Feb","Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
		
	   		time(&timep);
	   		tm=gmtime(&timep);
	   	
			if(!(f = fopen("/var/system.log", "w"))) {
				return -1;
			}
	
			fprintf(f, "[Log Cleared] %s, %02d %s %04d %02d:%02d:%02d\n",wday[tm->tm_wday], tm->tm_mday, wmonth[tm->tm_mon], (1900+tm->tm_year), tm->tm_hour, tm->tm_min, tm->tm_sec);
			fclose(f);
		}
		
	}

}

uint32 email_tableDriverAccess(void)
{
	FILE *f;
	int alerthour=0;
		
	printf("email_tableDriverAccess\n");
	
	f=fopen("/var/urlfilter.cron","a");
	
	if(f==NULL)
	{
		perror("Open urlfilter.cron Failed\n");
		return -1;
	}
	
	if(pRomeCfgParam->emailCfgParam.enable)
	{
				
		//send log and clear log?
		if(pRomeCfgParam->emailCfgParam.alerttype == EMAIL_LOGFULL)
		{
						
			fprintf(f,"*/1 * * * * /bin/boa checklogfull\n"); //Check full every min

		}
		if(pRomeCfgParam->emailCfgParam.alerttype == EMAIL_LOGHOURLY)
		{
			fprintf(f,"0 */1 * * * /bin/smtpclient subject_log /var/system.log no_trigger\n"); //Every hour
		}
		else if(pRomeCfgParam->emailCfgParam.alerttype == EMAIL_LOGDAILY)
		{
			if(pRomeCfgParam->emailCfgParam.alertampm == 1)
				alerthour = pRomeCfgParam->emailCfgParam.alerthour + 12;
			else
				alerthour = pRomeCfgParam->emailCfgParam.alerthour;
					
			fprintf(f,"0 %d * * * /bin/smtpclient subject_log /var/system.log no_trigger\n", alerthour);
		}
		else if(pRomeCfgParam->emailCfgParam.alerttype == EMAIL_LOGWEEKLY)
		{
			if(pRomeCfgParam->emailCfgParam.alertampm == 1)
				alerthour = pRomeCfgParam->emailCfgParam.alerthour + 12;
			else
				alerthour = pRomeCfgParam->emailCfgParam.alerthour;
				
			fprintf(f,"0 %d * * %d /bin/smtpclient subject_log /var/system.log no_trigger\n", alerthour, pRomeCfgParam->emailCfgParam.alertday);
		}

		
	}
	
	fclose(f);
	
	//run the crond after writing done in urlfilter.cron
	{
		start_crond();
		
		#if 0
		char tempStr[32];		
		sprintf(tempStr,"/bin/crontab /var/urlfilter.cron"); //Add by Timo Wu
		system(tempStr);
		f=fopen("/var/run/crond.pid","r");
		if(f==NULL)		
		{
			sprintf(tempStr,"/bin/crond -f &");
			system(tempStr);
			printf("run crond\n");
		}
		else
		{
			fclose(f);
			send_signal("/var/run/crond.pid",SIGHUP);
		}
		#endif
	}
	
	return OK;
}

void start_crond(void)
{
	char tempStr[64];		
	
	//sprintf(tempStr,"/bin/crontab /var/urlfilter.cron"); //Add by Timo Wu
	//system(tempStr);
	//sleep(1);
	eval("killall", "-9", "crond");
	do_kill("/var/run/crond.pid");
	sprintf(tempStr,"/bin/crontab /var/urlfilter.cron"); //Add by Timo Wu
	system(tempStr);
	sleep(1);
	sprintf(tempStr,"/bin/crond -f &");
	system(tempStr);
	printf("run crond\n");
	
}
/**********End******/

/* Add by Timo Wu
 * Routine Name: urlfilter_tableDriverAccess
 * Description: access table driver acl APIs
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 urlfilter_tableDriverAccess(void)
{
#if defined(DNI)	
	int i,j,k,l;
	FILE *f;
	int in_one_day = 1;
	int pre_day = 0;
	int check_today = 0, check_next = 0;
	
	
	urlfilter_tableDriverdel();	
	
	//printf("enter urlfilter_tableaccess\n");
	memcpy(urlfilterCfgParamTemp,&pRomeCfgParam->urlfilterCfgParam[0][0],sizeof(urlfilterCfgParam_t)*MAX_URL_FILTER); 

	f=fopen("/var/urlfilter.cron","w");	

	j = 0;	
	for (i=0; i<MAX_URL_FILTER; i++){	
		clock_t t;
		struct tm *gm;
		time(&t);	

		if (pRomeCfgParam->scheduleCfgParam.filterstatus == BLOCK_NEVER)
			break;			
			
		//if ((pRomeCfgParam->urlfilterCfgParam[j][i].enable != 1) && (pRomeCfgParam->scheduleCfgParam.filterstatus == BLOCK_PERSCHEDULE))
		if ((pRomeCfgParam->urlfilterCfgParam[j][i].enable != 1) || 
		    (pRomeCfgParam->urlfilterCfgParam[j][i].string[0] == '\0') )
			continue;
			//break;
									
		printf("pRomeCfgParam->urlfilterCfgParam[0][%d].enable is %d\n", i, pRomeCfgParam->urlfilterCfgParam[j][i].enable);
		
		if (pRomeCfgParam->scheduleCfgParam.filterstatus==BLOCK_ALWAYS)		
			goto Add_urlfilter;			
		
		// For allday and days of block =0-6
		if( (pRomeCfgParam->scheduleCfgParam.day == 0x7f) && (pRomeCfgParam->scheduleCfgParam.allday == 1))
			goto Add_urlfilter;			
		
		gm=localtime(&t);
		//printf("gm->tm_wday=%d hour=%d min=%d\n",gm->tm_wday,gm->tm_hour,gm->tm_min);

		//create urlfilter crontab file
		if(pRomeCfgParam->scheduleCfgParam.day!=0)			
		{
			int first=1, day_continue=0;
			
			first=1;
			day_continue = 0;
			fprintf(f,"%d %d * * ",pRomeCfgParam->scheduleCfgParam.start_minute,pRomeCfgParam->scheduleCfgParam.start_hour);
			for(l=0,k=1;l<7;l++,k<<=1)
			{
				if(pRomeCfgParam->scheduleCfgParam.day&k) 
				{
					if(pRomeCfgParam->scheduleCfgParam.allday == 1)	{				
						if (!day_continue) {
					  		if(first!=1) fprintf(f,",");					
					 	 	fprintf(f,"%d",l);
					 	 	first = 0;
						}					
					} else {
					  if(first!=1) fprintf(f,",");					
					  fprintf(f,"%d",l);
					  first = 0;
					}  
					day_continue = 1;
				}
				else
					day_continue = 0;
			}
				
			fprintf(f," /bin/boa addurlfilter %d %d\n",j,i);
			
			first=1;
			/* keep previos day_continue; */
			//day_continue = 0;
			if(pRomeCfgParam->scheduleCfgParam.allday == 1)
				fprintf(f,"0 0 * * ");
			else
				fprintf(f,"%d %d * * ",pRomeCfgParam->scheduleCfgParam.end_minute,pRomeCfgParam->scheduleCfgParam.end_hour);
				
			if (pRomeCfgParam->scheduleCfgParam.start_hour > pRomeCfgParam->scheduleCfgParam.end_hour)   
				in_one_day = 0;
			else if ((pRomeCfgParam->scheduleCfgParam.start_hour == pRomeCfgParam->scheduleCfgParam.end_hour) &&    		
				 (pRomeCfgParam->scheduleCfgParam.start_minute > pRomeCfgParam->scheduleCfgParam.end_minute))   	
				in_one_day = 0;
			else in_one_day = 1;	
			
			if ((in_one_day == 0) && (pRomeCfgParam->scheduleCfgParam.day && 0x40))
				pre_day = 1;			
			for(l=0,k=1;l<7;l++,k<<=1)
			{					
				if(pRomeCfgParam->scheduleCfgParam.day&k) 
				{
		
					if(pRomeCfgParam->scheduleCfgParam.allday == 1)	{
						day_continue = 1;				

					} else {
						if(first!=1) fprintf(f,",");						
						fprintf(f,"%d",l);
						first=0;
					}
					pre_day = 1;	
				}
				else {
					if(pRomeCfgParam->scheduleCfgParam.allday == 1)	{
						if (day_continue) {
							if(first!=1) fprintf(f,",");
							fprintf(f,"%d",l);
							first = 0;
						}	
					}
					else if ((pre_day) && (in_one_day == 0)) {
						if(first!=1) fprintf(f,",");
						fprintf(f,"%d",l);
						first = 0;
					}			
					pre_day = 0;					
					day_continue = 0;	
				}		
					
			}
			fprintf(f," /bin/boa delurlfilter %d %d\n",j,i);
		
		}

		//check day
		if (in_one_day == 0) {
			check_today = check_next = 0;
			if(((pRomeCfgParam->scheduleCfgParam.day)&(1<<(gm->tm_wday)))) check_today = 1; // today				
			if(((pRomeCfgParam->scheduleCfgParam.day)&(1<<((gm->tm_wday == 0 ? 6 : (gm->tm_wday-1)))))) check_next=1; // next day				
			if ((check_today == 0) && (check_next == 0))
				continue;
		}		
		else if(((pRomeCfgParam->scheduleCfgParam.day)&(1<<(gm->tm_wday)))==0) continue; // not today
			//check time
		if (pRomeCfgParam->scheduleCfgParam.allday == 1)
			goto Add_urlfilter;
		if (in_one_day == 1) {					
		  if(
			((gm->tm_hour*60+gm->tm_min)<
			((uint32)(pRomeCfgParam->scheduleCfgParam.start_hour)*60+pRomeCfgParam->scheduleCfgParam.start_minute)) ||
			//((gm->tm_hour*60+gm->tm_min)>
			((gm->tm_hour*60+gm->tm_min)>=
			((uint32)(pRomeCfgParam->scheduleCfgParam.end_hour)*60+pRomeCfgParam->scheduleCfgParam.end_minute))
		  ) continue;  // time not in the schedule
		}
		else {		
		  if ((check_next) && 
			((gm->tm_hour*60+gm->tm_min) <
			((uint32)(pRomeCfgParam->scheduleCfgParam.end_hour)*60+pRomeCfgParam->scheduleCfgParam.end_minute))			
		  ) goto Add_urlfilter;			  
		  if ((check_today) && 
			((gm->tm_hour*60+gm->tm_min) >=
			((uint32)(pRomeCfgParam->scheduleCfgParam.start_hour)*60+pRomeCfgParam->scheduleCfgParam.start_minute))			
		  ) goto Add_urlfilter;
		  continue;
		}
			
Add_urlfilter:			
		urlfilter_tableDriverSingleHandle(URLFILTER_SINGLE_HANDLE_ADD,j,i);
		
	} /* end for i */
	fclose(f);
#endif
	return OK;
}

/* Add by Timo Wu
 * Routine Name: urlfilter_tableDriverAccess
 * Description: access table driver acl APIs
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 urlfilter_tableDriverdel(void)
{
#if defined(DNI)	
	
		int i, ret;
		int ms=0;
	
	printf("urlfilter_tableDriverdel\n");
	
	
	for(i=0;i<MAX_URL_FILTER;i++)
	{
		//delete old url filter string
		//2006/01/05/Timo
		//if( strcmp(urlfilterCfgParamTemp[i].string,"")!=0 )
		if((urlfilterCfgParamTemp[i].enable ==1) && (urlfilterCfgParamTemp[i].string[0] != '\0'))
		{
			{
				int ret;
				rtl8651_tblDrv_urlFilter_t urlFilter_tmp;
    				rtl8651_tblDrv_urlPktFilter_t urlPktFilter_tmp;
    				bzero(&urlFilter_tmp, sizeof(rtl8651_tblDrv_urlFilter_t));
    				bzero(&urlPktFilter_tmp, sizeof(rtl8651_tblDrv_urlPktFilter_t));
    				urlFilter_tmp.sessionId = 0;
    				urlFilter_tmp.ruleType = RTL8651_URLSTRING_UNKNOWNTYPE;
    				urlFilter_tmp.urlFilterString  = (int8 *)malloc(32);
    				urlFilter_tmp.urlFilterStrLen=sprintf(urlFilter_tmp.urlFilterString,"%s",urlfilterCfgParamTemp[i].string);    
    				urlPktFilter_tmp.rule_type=RTL8651_URLPKTFILTER_TYPE_SIP;
    				urlPktFilter_tmp.sip_start=urlfilterCfgParamTemp[i].ip_start;
    				urlPktFilter_tmp.sip_end=urlfilterCfgParamTemp[i].ip_end;     
    				ret = rtl8651_delGenericURLFilterRule(&urlFilter_tmp, &urlPktFilter_tmp);
    				printf("del url filter ret=%d url string=%s len=%d\n",ret,urlFilter_tmp.urlFilterString,urlFilter_tmp.urlFilterStrLen);
    				free(urlFilter_tmp.urlFilterString); 
			
				if (ret!=SUCCESS)
				{
					printf("delete old rules failed: ret:%d\n",ret);

				}			
			}
			

			
			
		}
		else
			break;
	}	
#endif
	return OK;
}

int dnshijack_add(void)
{
	/* add a acl to allow 80 from Lan port */      	
      	{
		int32 ret; 
		uint32 tempip,mask; 		    		
		
      		printf("set UDP 53 acl rule from Lan Port\n");
		memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));
	
		tempAclRule.srcIpAddr_ = 0;
		tempAclRule.srcIpAddrMask_ = 0xffffffff;	

		tempAclRule.udpDstPortLB_=53;
		tempAclRule.udpDstPortUB_=53;	
	
		tempAclRule.udpSrcPortLB_=0;
		tempAclRule.udpSrcPortUB_=0xffff;	

		tempAclRule.ruleType_=RTL8651_ACL_UDP;
		tempAclRule.actionType_=RTL8651_ACL_CPU;
		ret = rtl8651a_addAclRuleExt(0, "eth1", 1,(rtl8651_tblDrvAclRule_t* )&tempAclRule);
		if (ret)
		{
			printf("acl_tableDriverAccess: rtl8651a_addAclRule(if:%s) ret:%d\n","eth0",ret);
			return NOT_OK;		
		}
		return OK;
	}
}	

/*
 * Routine Name: acl_tableDriverAccess
 * Description: access table driver acl APIs
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 acl_tableDriverAccess(void)
{
	int32 ret;
	
	int8 ifWanStr[20];
	int8 ifLanStr[20];
	uint32 i,j,k,l;
	uint32 loopUpperBound=0;
	uint32 defActionSet[2] = {0};
	FILE *f;
	int in_one_day = 1;
	int pre_day = 0;	
	int check_today = 0, check_next = 0;
	
	memset(ifWanStr,0,20);	
	sprintf(ifWanStr,"eth0");
	memset(ifLanStr,0,20);	
	sprintf(ifLanStr,"eth1");

	loopUpperBound = 1;
	
	/* flush all wan interface's egress/ingress rule */
	for(i=0;i<loopUpperBound;i++){
		if (pRomeCfgParam->natCfgParam.hwaccel==1)
		{
			ret = rtl8651a_flushAclRule(i,ifWanStr,0);
			if (ret)
			{
				printf("acl_tableDriverAccess: rtl8651_flushAclRule(if:%s) ret:%d\n",ifWanStr,ret);
				return NOT_OK;		
			}
		
			ret = rtl8651a_flushAclRule(i,ifWanStr,1);		
			if (ret)
			{
				printf("acl_tableDriverAccess: rtl8651_flushAclRule(if:%s) ret:%d\n",ifWanStr,ret);
				return NOT_OK;		
			}

			ret = rtl8651a_flushAclRule(i,ifLanStr,0);
			if (ret)
			{
				printf("acl_tableDriverAccess: rtl8651_flushAclRule(if:%s) ret:%d\n",ifLanStr,ret);
				return NOT_OK;		
			}
		
			ret = rtl8651a_flushAclRule(i,ifLanStr,1);		
			if (ret)
			{
				printf("acl_tableDriverAccess: rtl8651_flushAclRule(if:%s) ret:%d\n",ifLanStr,ret);
				return NOT_OK;		
			}
		}
	}
	
	/* permit to target form lan */
	if(pRomeCfgParam->aclGlobalCfgParam.lanPermit==1)
	{
		memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));	
		{
			uint32 tempip,mask;

			memcpy(&tempip,pRomeCfgParam->ifCfgParam[1].ipAddr,4);		
			memcpy(&mask,pRomeCfgParam->ifCfgParam[1].ipMask,4);
			tempip&=mask;
			memcpy(&(tempAclRule.dstIpAddr_),&tempip,4);
			memcpy(&(tempAclRule.dstIpAddrMask_),pRomeCfgParam->ifCfgParam[1].ipMask,4);
		}
		tempAclRule.ruleType_=RTL8651_ACL_IP;
		tempAclRule.actionType_=RTL8651_ACL_PERMIT;
		ret = rtl8651a_addAclRule(0,ifLanStr,1,(rtl8651_tblDrvAclRule_t* )&tempAclRule);		
	}

#ifdef DNS_HIJACK
        /* add acl rule to permit UDP port 53 for DNS use */
        	/* add a acl to allow 53 from Wan port */      	
      	#if 0
      	{
      		printf("set UDP 53 acl rule\n");
		uint32 tempip,mask;      	
		memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));
		
		tempAclRule.srcIpAddr_ = 0;
		tempAclRule.srcIpAddrMask_ = 0xffffffff;	
		
		tempAclRule.udpDstPortLB_=0;
		tempAclRule.udpDstPortUB_=0xffff;	
	
		tempAclRule.udpSrcPortLB_=53;
		tempAclRule.udpSrcPortUB_=53;	

		tempAclRule.ruleType_=RTL8651_ACL_UDP;
		tempAclRule.actionType_=RTL8651_ACL_CPU;
		ret = rtl8651a_addAclRuleExt(0, "eth0", 0,(rtl8651_tblDrvAclRule_t* )&tempAclRule);		
		if (ret)
		{
			printf("acl_tableDriverAccess: rtl8651a_addAclRule(if:%s) ret:%d\n","eth0",ret);
			return NOT_OK;		
		}
	}
	#endif
	/* add a acl to allow 53 from Lan port */      	
      	{
      		printf("set UDP 53 acl rule from Lan Port\n");
		uint32 tempip,mask;      	
		memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));
	
		tempAclRule.srcIpAddr_ = 0;
		tempAclRule.srcIpAddrMask_ = 0xffffffff;	

		tempAclRule.udpDstPortLB_=53;
		tempAclRule.udpDstPortUB_=53;	
	
		tempAclRule.udpSrcPortLB_=0;
		tempAclRule.udpSrcPortUB_=0xffff;	

		tempAclRule.ruleType_=RTL8651_ACL_UDP;
		tempAclRule.actionType_=RTL8651_ACL_CPU;
		ret = rtl8651a_addAclRuleExt(0, "eth1", 1,(rtl8651_tblDrvAclRule_t* )&tempAclRule);
		if (ret)
		{
			printf("acl_tableDriverAccess: rtl8651a_addAclRule(if:%s) ret:%d\n","eth0",ret);
			return NOT_OK;		
		}
	}
#endif  /* #ifdef DNS_HIJACK */

#if 0
	for(i=0;i<loopUpperBound;i++){
		#if 0
		if (pRomeCfgParam->pppoeCfgParam[i].dialState == PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS &&
		(!pRomeCfgParam->pppoeCfgParam[i].defaultSession) && pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED)
		#else
		/* bug fix for multiple pppoe's unnumbered case 2004/10/04 */
		if (pRomeCfgParam->pppoeCfgParam[i].dialState == PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS &&
		(!pRomeCfgParam->pppoeCfgParam[i].defaultSession)
  		 && (   pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED
		      ||((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
		          &&(pRomeCfgParam->pppoeCfgParam[i].lanType==PPPOECFGPARAM_LANTYPE_UNNUMBERED)))
		)
		#endif
		{
			if(pRomeCfgParam->pppoeCfgParam[i].lanType==PPPOECFGPARAM_LANTYPE_NAPT)
			{
				memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));
				tempAclRule.dstIpAddrMask_=0xffffffff;
				memcpy(&(tempAclRule.dstIpAddr_),pRomeCfgParam->pppoeCfgParam[i].ipAddr,4);
				tempAclRule.ruleType_=RTL8651_ACL_IP;
				tempAclRule.actionType_=RTL8651_ACL_CPU;
			}else{
				ipaddr_t mySubnet;
				memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));
				memcpy(&(tempAclRule.dstIpAddrMask_),pRomeCfgParam->pppoeCfgParam[i].unnumberedIpMask,4);
				memcpy(&(tempAclRule.dstIpAddr_),pRomeCfgParam->pppoeCfgParam[i].unnumberedIpAddr,4);
				mySubnet = (tempAclRule.dstIpAddr_ & tempAclRule.dstIpAddrMask_);
				tempAclRule.dstIpAddr_ = mySubnet;
				tempAclRule.ruleType_=RTL8651_ACL_IP;
				tempAclRule.actionType_=RTL8651_ACL_CPU;
			}
			ret = rtl8651a_addAclRule(i,"eth0",1,(rtl8651_tblDrvAclRule_t* )&tempAclRule);
			if (ret !=SUCCESS)
			{
				printf("rtl8651a_addAclRule() ret:%d\n",ret);				
			}
		}
	}
#endif
	
	// flush all trigger port entry in fwdEngine
	rtl8651_flushTriggerPortRules();

	if (pRomeCfgParam->specialapCfgParam[0][0].g_enable == 0)
		goto exit_trigger_port;			
	// add trigger port	
	for(k=0;k<loopUpperBound;k++)
	{	
		for(i=0;i<MAX_SPECIAL_AP;i++)
		{		
			if((pRomeCfgParam->specialapCfgParam[k][i].outStart!=0)&&(pRomeCfgParam->specialapCfgParam[k][i].enable==1))
			{
				parse_and_add_triggerPort(k,SPECIAL_AP_MAX_IN_RANGE,pRomeCfgParam->specialapCfgParam[k][i].inRange
					,pRomeCfgParam->specialapCfgParam[k][i].inType
					,pRomeCfgParam->specialapCfgParam[k][i].outType
					,pRomeCfgParam->specialapCfgParam[k][i].outStart
					,pRomeCfgParam->specialapCfgParam[k][i].outFinish
					//,0);
					,*((uint32 *)&(pRomeCfgParam->specialapCfgParam[k][i].ip)));	/* DNI, all/specified ip */
			}			
		} //end special_application
exit_trigger_port:		

#if !defined(DNI)		
		// add gaming port 
		for(i=0;i<MAX_GAMING;i++)
		{		
			if((pRomeCfgParam->gamingCfgParam[k][i].ip!=0)&&(pRomeCfgParam->gamingCfgParam[k][i].enable==1))
			{
				if(strlen(pRomeCfgParam->gamingCfgParam[k][i].tcpRange)!=0)
				{
					parse_and_add_triggerPort(k,GAMING_MAX_RANGE,pRomeCfgParam->gamingCfgParam[k][i].tcpRange					
						,0
						,0
						,0
						,0
						,pRomeCfgParam->gamingCfgParam[k][i].ip);
				}

				if(strlen(pRomeCfgParam->gamingCfgParam[k][i].udpRange)!=0)
				{
					parse_and_add_triggerPort(k,GAMING_MAX_RANGE,pRomeCfgParam->gamingCfgParam[k][i].udpRange
						,1
						,0
						,0
						,0
						,pRomeCfgParam->gamingCfgParam[k][i].ip);
				}				
			}			
		} //end special_application
#endif			
		
	}


	/* set default permit rule
	 * the next loop ensures that rtl8651_setDefaultAcl() is called
	 * once and only once.
	 */

	for ( i = 0 ; i < loopUpperBound; i ++ )
	{
		if (pRomeCfgParam->natCfgParam.hwaccel == 1)
		{
			int8 defAction;

			switch (pRomeCfgParam->aclGlobalCfgParam.policy)
			{
				case ACLGLOBALCFGPARAM_DENYALLBUTACL:
					defAction = RTL8651_ACL_DROP;
					break;
				case ACLGLOBALCFGPARAM_L34_DENYALLBUTACL:	/* default-deny all L34 packet, bu L2 is permitted */
					defAction = RTL8651_ACL_L34_DROP;
					break;
				case ACLGLOBALCFGPARAM_ALLOWALLBUTACL:
					defAction = RTL8651_ACL_PERMIT;
					break;
				case ACLGLOBALCFGPARAM_ALLOWALLBUTACL_LOG:
					defAction = RTL8651_ACL_PERMIT;
					break;
				default:
					printf("[%s] Unknown default policy: %d, set default permit\n", __FUNCTION__, pRomeCfgParam->aclGlobalCfgParam.policy);
					defAction = RTL8651_ACL_PERMIT;
			}

			{
				char* intf[2] = {"eth0", "eth1"};
				const int intfCnt = 2;

				for ( j = 0 ; j < intfCnt ; j ++ )
				{
					if (defActionSet[j] == 1)
					{	/* default ACL action of this interface has been set */
						continue;
					}
					ret = rtl8651a_setDefaultAcl(i , intf[j], defAction);
					if ( ret == 0 )	/* 0: SUCCESS */
					{
						defActionSet[j] = 1;
					} else
					{
						printf("%s: set default ACL(%s) to the action [%d] FAILED, return value: %d\n", __FUNCTION__, intf[j], defAction, ret);
					}
				}
			}
		}
	}
	
	/* scan aclCfgParam[] to set rule to asic one by one */
	f=fopen("/var/urlfilter.cron","a"); //Add by Timo Wu	
	if (f == NULL)
		return OK;
	
	for (j=0;j<loopUpperBound;j++){
		for (i=0; i<MAX_ACL; i++){	
			clock_t t;
			struct tm *gm;
			time(&t);	
			
			if (pRomeCfgParam->aclCfgParam[j][i].enable != 1)
				continue;
	
			if (pRomeCfgParam->scheduleCfgParam.aclstatus == BLOCK_ALWAYS)		
				goto Add_acl;
						
			// For allday and days of block =0-6
			if( (pRomeCfgParam->scheduleCfgParam.day == 0x7f) && (pRomeCfgParam->scheduleCfgParam.allday == 1))
				goto Add_acl;	
					
			gm=localtime(&t);
			//printf("gm->tm_wday=%d hour=%d min=%d\n",gm->tm_wday,gm->tm_hour,gm->tm_min);

			//create acl crontab file
			//if(pRomeCfgParam->scheduleCfgParam.day!=0)			
			if(pRomeCfgParam->aclCfgParam[j][i].day!=0)			
			{
				int first=1, day_continue=0;
			
				first=1;
				day_continue = 0;
				fprintf(f,"%d %d * * ",pRomeCfgParam->aclCfgParam[j][i].start_minute,pRomeCfgParam->aclCfgParam[j][i].start_hour);
				for(l=0,k=1;l<7;l++,k<<=1)
				{					
					if(pRomeCfgParam->aclCfgParam[j][i].day&k) 
					{
						if(pRomeCfgParam->scheduleCfgParam.allday == 1)	{				
							if (!day_continue) {
					  			if(first!=1) fprintf(f,",");					
					 	 		fprintf(f,"%d",l);
					 	 		first = 0;
							}					
						} else {
					  		if(first!=1) fprintf(f,",");					
					  		fprintf(f,"%d",l);
					  		first = 0;
						}  
						day_continue = 1;							
					}
					else 
						day_continue = 0;
				}
				fprintf(f," /bin/boa addacl %d %d\n",j,i);

				first=1;
				/* keep previos day_continue; */
				//day_continue = 0;
				if(pRomeCfgParam->scheduleCfgParam.allday == 1)
					fprintf(f,"0 0 * * ");
				else
				fprintf(f,"%d %d * * ",pRomeCfgParam->aclCfgParam[j][i].end_minute,pRomeCfgParam->aclCfgParam[j][i].end_hour);
				
				if (pRomeCfgParam->scheduleCfgParam.start_hour > pRomeCfgParam->scheduleCfgParam.end_hour)   
					in_one_day = 0;
				else if ((pRomeCfgParam->scheduleCfgParam.start_hour == pRomeCfgParam->scheduleCfgParam.end_hour) &&    		
					 (pRomeCfgParam->scheduleCfgParam.start_minute > pRomeCfgParam->scheduleCfgParam.end_minute))   	
					in_one_day = 0;
				else in_one_day = 1;	
			
				if ((in_one_day == 0) && (pRomeCfgParam->scheduleCfgParam.day && 0x40))
					pre_day = 1;				
				for(l=0,k=1;l<7;l++,k<<=1)
				{
					if(pRomeCfgParam->aclCfgParam[j][i].day&k) 
					{
						if(pRomeCfgParam->scheduleCfgParam.allday == 1)	{
							day_continue = 1;				
						} else {
							if(first!=1) fprintf(f,",");						
							fprintf(f,"%d",l);
							first=0;
						}	
						pre_day = 1;
					}
					else {
						if(pRomeCfgParam->scheduleCfgParam.allday == 1)	{
							if (day_continue) {
								if(first!=1) fprintf(f,",");
								fprintf(f,"%d",l);
								first = 0;
							}	
						}
						else if ((pre_day) && (in_one_day == 0)) {
							if(first!=1) fprintf(f,",");
							fprintf(f,"%d",l);
							first = 0;
						}			
						pre_day = 0;						
						day_continue = 0;	
					}		
					
				}						
				fprintf(f," /bin/boa delacl %d %d\n",j,i);
				
			}

			//check day
			if (in_one_day == 0) {
				check_today = check_next = 0;
				if(((pRomeCfgParam->aclCfgParam[j][i].day)&(1<<(gm->tm_wday)))) check_today = 1; // today				
				if(((pRomeCfgParam->aclCfgParam[j][i].day)&(1<<((gm->tm_wday == 0 ? 6 : (gm->tm_wday-1)))))) check_next=1; // next day				
				if ((check_today == 0) && (check_next == 0))
					continue;
			}			
			else if(((pRomeCfgParam->aclCfgParam[j][i].day)&(1<<(gm->tm_wday)))==0) continue; // not today

			if (pRomeCfgParam->scheduleCfgParam.allday == 1)
				goto Add_acl;	
			//check time	
			if (in_one_day == 1) {					
			  if(
				((gm->tm_hour*60+gm->tm_min)<
				((uint32)(pRomeCfgParam->aclCfgParam[j][i].start_hour)*60+pRomeCfgParam->aclCfgParam[j][i].start_minute)) ||
				((gm->tm_hour*60+gm->tm_min)>=
				((uint32)(pRomeCfgParam->aclCfgParam[j][i].end_hour)*60+pRomeCfgParam->aclCfgParam[j][i].end_minute))
			  ) continue;  // time not in the schedule
			}  
			else {
			  if ((check_next) && 
				((gm->tm_hour*60+gm->tm_min) <
				((uint32)(pRomeCfgParam->aclCfgParam[j][i].end_hour)*60+pRomeCfgParam->aclCfgParam[j][i].end_minute))			
			  ) goto Add_acl;			  
			  if ((check_today) && 
				((gm->tm_hour*60+gm->tm_min) >=
				((uint32)(pRomeCfgParam->aclCfgParam[j][i].start_hour)*60+pRomeCfgParam->aclCfgParam[j][i].start_minute))			
			  ) goto Add_acl;
			  continue;
			}			  
Add_acl:		
			acl_tableDriverSingleHandle(ACL_SINGLE_HANDLE_ADD,j,i);
		
		} /* end for i */
	} /* end for j */
	fclose(f);

	#if 0 //comment by Timo Wu 2006/01/13
	//run the crond
	{
		char tempStr[32];		
		sprintf(tempStr,"/bin/crontab /var/urlfilter.cron"); //Add by Timo Wu
		system(tempStr);
		f=fopen("/var/run/crond.pid","r");
		if(f==NULL)		
		{
			sprintf(tempStr,"/bin/crond -f &");
			system(tempStr);
			printf("run crond\n");
		}
		else
		{
			fclose(f);
			send_signal("/var/run/crond.pid",SIGHUP);
		}
	}
	#endif
	qos_tableDriverAccess();
	
	return OK;
} /* end acl_tableDriverAccess */

int route_action(uint32 route, uint32 mask, uint32 gw, uint8 metric, int action)
{
	char addr[20], netmask[20], gwaddr[20], hops[20];
	char *argv[10];
	unsigned char *ptr;
	
	argv[0]="-net";
	argv[1]="0.0.0.0";
	argv[2]="netmask";
	argv[3]="255.255.255.255";
	argv[4]="gw";		
	argv[5]="0.0.0.0";
	argv[6]="metric";
	argv[7]="1";
	argv[8]=NULL;


	ptr = (unsigned char *)&route;
	sprintf(addr, "%u.%u.%u.%u",
			*ptr,
			*(ptr+1),
			*(ptr+2),
			*(ptr+3));
			
	ptr = (unsigned char *)&mask;
	sprintf(netmask, "%u.%u.%u.%u",
			*ptr,
			*(ptr+1),
			*(ptr+2),
			*(ptr+3));			
		
	ptr = (unsigned char *)&gw;
	sprintf(gwaddr, "%u.%u.%u.%u",
			*ptr,
			*(ptr+1),
			*(ptr+2),
			*(ptr+3));
				
	sprintf(hops, "%d", metric);		

	argv[1]=addr;
	argv[3]=netmask;
	argv[5]=gwaddr;
	argv[7]=hops;
	if (action == RTACTION_ADD) {
		INET_setroute(RTACTION_ADD, 0, argv);
	}	
	else {
		INET_setroute(RTACTION_DEL, 0, argv);
	}		
	return 0;
}

uint32 routing_tableDriverdel(void)
{
	int ret;	
	int i;
		
	/* delete all routing */
	for(i=0;i<MAX_ROUTING;i++)
	{
		if ((pRomeCfgParam->routingCfgParam[i].valid) && 	
		    (pRomeCfgParam->routingCfgParam[i].interface!=ROUTING_INTERFACE_NONE))
		{
			ret=rtl8651_delRoute((ipaddr_t)pRomeCfgParam->routingCfgParam[i].route,(ipaddr_t)pRomeCfgParam->routingCfgParam[i].mask);
			if (ret)
			{
				printf("rtl8651_delRoute(default): ret %d\n",ret);
			}
		}
	}
	routing_INET_route(RTACTION_DEL);	
	return OK;
}	

uint32 routing_tableDriveradd(void)
{
	int i, ret;
	for(i=0;i<MAX_ROUTING;i++)
	{
		if ((pRomeCfgParam->routingCfgParam[i].valid) && 	
		    (pRomeCfgParam->routingCfgParam[i].interface!=ROUTING_INTERFACE_NONE))
		{
			char interface[8]={0};
			
			/* check RoutGate is same lan netmask */
			{	
				char *lan_ipaddr, *lan_netmask;
				struct in_addr ipaddr, netmask, gwaddr;
	
				lan_ipaddr = nvram_get("lan_ipaddr");
				(void) inet_aton(lan_ipaddr, &ipaddr);
				lan_netmask = nvram_get("lan_netmask");
				(void) inet_aton(lan_netmask, &netmask);
				//(void) inet_aton(ptr3, &gwaddr);
				gwaddr.s_addr = pRomeCfgParam->routingCfgParam[i].gateway;				
	

				ipaddr.s_addr = ipaddr.s_addr & netmask.s_addr;
				gwaddr.s_addr = gwaddr.s_addr & netmask.s_addr;
		
				if (ipaddr.s_addr == gwaddr.s_addr) {	
					pRomeCfgParam->routingCfgParam[i].interface = ROUTING_INTERFACE_LAN;
				}
				else {
					pRomeCfgParam->routingCfgParam[i].interface = ROUTING_INTERFACE_WAN;				
				}			
			}
			
			
			if(pRomeCfgParam->routingCfgParam[i].interface==ROUTING_INTERFACE_WAN) 
				sprintf(interface,"eth0");
			if(pRomeCfgParam->routingCfgParam[i].interface==ROUTING_INTERFACE_LAN) 
				sprintf(interface,"eth1");
			ret=rtl8651_addRoute((ipaddr_t)pRomeCfgParam->routingCfgParam[i].route,
								  (ipaddr_t)pRomeCfgParam->routingCfgParam[i].mask,
								  (int8*)interface,(ipaddr_t)pRomeCfgParam->routingCfgParam[i].gateway);
			if (ret)
			{
				//pRomeCfgParam->routingCfgParam[i].interface=ROUTING_INTERFACE_NONE;
				//pRomeCfgParam->routingCfgParam[i].valid = 0;
				printf("rtl8651_addRoute %x: ret %d\n",pRomeCfgParam->routingCfgParam[i].route,ret);				
			}
		}		
	}	
	routing_INET_route(RTACTION_ADD);	
	return OK;
}

uint32 routing_INET_route(int action)
{
	int i, ret;
	
	for(i=0;i<MAX_ROUTING;i++)
	{
		if ((pRomeCfgParam->routingCfgParam[i].valid) && 	
		    (pRomeCfgParam->routingCfgParam[i].interface!=ROUTING_INTERFACE_NONE))
		{

			route_action(pRomeCfgParam->routingCfgParam[i].route, pRomeCfgParam->routingCfgParam[i].mask, 
				     pRomeCfgParam->routingCfgParam[i].gateway, pRomeCfgParam->routingCfgParam[i].metric, action);
		}		
	}	
	return OK;
}

/*
 * Routine Name: acl_init
 * Description: configure acl cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 acl_init(void)
{	
	if (cfgmgr_read(CFGMGR_TABID_ACL_GLOBAL,(void*)&(pRomeCfgParam->aclGlobalCfgParam), sizeof(pRomeCfgParam->aclGlobalCfgParam))!=0)
	{
		printf("acl_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_ACL,(void*)pRomeCfgParam->aclCfgParam, sizeof(struct aclCfgParam_s)*MAX_ACL*MAX_PPPOE_SESSION)!=0)
	{
		printf("acl_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
		
	return OK;	
} /* end acl_init */

uint32 pptp_init(void)
{	
	if (cfgmgr_read(CFGMGR_TABID_PPTP,(void*)&(pRomeCfgParam->pptpCfgParam), sizeof(struct pptpCfgParam_s))!=0)
	{
		printf("pptp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	
	return OK;	
} /* end pptp_init */

uint32 l2tp_init(void)
{	
	if (cfgmgr_read(CFGMGR_TABID_L2TP,(void*)&(pRomeCfgParam->l2tpCfgParam), sizeof(struct l2tpCfgParam_s))!=0)
	{
		printf("l2tp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}	
	return OK;	
} /* end l2tp_init */



uint32 tel_init(void)
{	
	if (cfgmgr_read(CFGMGR_TABID_TEL,(void*)&(pRomeCfgParam->telCfgParam), sizeof(struct telCfgParam_s))!=0)
	{
		printf("tel_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	pRomeCfgParam->telCfgParam.manualHangup = 0;
	
	return OK;	
} /* end tel_init */

//Yili 2006/1/10
#if defined(DNI)
uint32 mnu_init(void)
{	
	if (cfgmgr_read(CFGMGR_TABID_MNU,(void*)&(pRomeCfgParam->mnuCfgParam), sizeof(struct mnuCfgParam_s))!=0)
	{
		printf("tel_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	
	return OK;	
} /* end mnu_init */

extern int g_bLogin;
extern int upgrading;

uint32 httpc_init(void)
{	
#if CONFIG_WAN_LAN_MATCH_DETECTION
	int WanLanFlag = atoi(nvram_get("WL_ip_match"));
	if(WanLanFlag) {
			//FILE *fp;
			int i;
			
			printf("WAN_LAN_Subnet_Match_mode, Flush http clinet info.\n");
			memcpy((void*)&(pRomeCfgParam->httpclientCfgParam),
				httpcCfgParamDefault,
				sizeof(http_client_ifno_t));
			httpc_cfg_save();
			copy_httpc_info_to_client(&httpcCfgParamDefault);
			g_bLogin=0;
			for(i=1 ; i<5 ; i++) {
				rtl8651_setEthernetPortPowerDown(i, 0);
			}
			return OK;
	}
#endif
	if (cfgmgr_read(CFGMGR_TABID_HTTPC_INFO,(void*)&(pRomeCfgParam->httpclientCfgParam), sizeof(struct http_client_ifno_s))!=0)
	{
		printf("httpc_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	
	pRomeCfgParam->httpclientCfgParam.lastaccess_time = GetSysUpTime();
	
	copy_httpc_info_to_client(&(pRomeCfgParam->httpclientCfgParam));
	g_bLogin = pRomeCfgParam->httpclientCfgParam.g_bLogin;
	
	
	return OK;	
} /* end httpc_init */


int copy_client_to_httpc_info(char *ptr)
{
	
	memcpy((char *)&(pRomeCfgParam->httpclientCfgParam), ptr, sizeof(pRomeCfgParam->httpclientCfgParam));	
	
	pRomeCfgParam->httpclientCfgParam.g_bLogin = g_bLogin;	
	
}

#endif
//end

uint32 domainBlock_init(void)
{
	int idx;

	if (cfgmgr_read(	CFGMGR_TABID_DOMAINBLOCK,
					(void*)&(pRomeCfgParam->domainBlockCfgParam),
					sizeof(domainBlockCfgParam_t) * MAX_DOMAIN_BLOCKING) != 0 )
	{
		printf("domainBlock_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}

	rtl8651_flushDomainBlockingEntry();

	for ( idx = 0 ; idx < MAX_DOMAIN_BLOCKING ; idx ++ )
	{
		if (pRomeCfgParam->domainBlockCfgParam[idx].enable == TRUE)
		{
			if (rtl8651_addDomainBlockingEntry(	pRomeCfgParam->domainBlockCfgParam[idx].domain,
												pRomeCfgParam->domainBlockCfgParam[idx].sip,
												pRomeCfgParam->domainBlockCfgParam[idx].smask) != SUCCESS)
			{
				printf("Enable Add failed\n");
				pRomeCfgParam->domainBlockCfgParam[idx].enable = FALSE;
			}
		}
	}

	return OK;
}


/* protocol 2 -> both */
/* bit 1 is pure software */
int check_pptp_tcp_udp(int connType, int protocol)
{
	int type = 0;
	
	if ((connType == IFCFGPARAM_CONNTYPE_PPTP) && (protocol == 2)) {
		type = 2;	/* pure software */
	}	
	else if (protocol == SERVERPCFGPARAM_PROTOCOL_TCP)
		type = 1;
				
	return type;				
		
}	
				

/*
 * Routine Name: serverp_tableDriverAccess
 * Description: access table driver server port APIs
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 serverp_tableDriverAccess(uint32 dsid)
{
	int32 ret;
	ipaddr_t wanIp;
	ipaddr_t tempIpAddr;
	int i;

	//if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
	//{
	//	memcpy((void*)&wanIp,pRomeCfgParam->pppoeCfgParam[dsid].ipAddr,4);			
	//}
	//else
	{
		memcpy((void*)&wanIp,(void*)(pRomeCfgParam->ifCfgParam[0].ipAddr),4);		
	}

	if(wanIp==0)
	{
		printf("serverp_tableDriverAccess: no valid wan ip!\n");
		return NOT_OK;
	}

	
#if !defined(DNI)				
		/* for loop to delete all "enabled" entry in serverpCfgParam[] */	
		for (i=0;i<MAX_SERVER_PORT;i++)
		{	
			if (ramServerpCfgParam[dsid][i].enable == 0)
				continue;

			memcpy((void*)&tempIpAddr,(void*)(ramServerpCfgParam[dsid][i].ip),4);

			if(ramServerpCfgParam[dsid][i].wanPortStart==ramServerpCfgParam[dsid][i].wanPortFinish)
			{			
				ret = rtl8651a_delNaptServerPortMapping(
					dsid,
					(ramServerpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t) wanIp,                     /* current wan ip */
					(uint16)   ramServerpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t) tempIpAddr,
					(uint16)   ramServerpCfgParam[dsid][i].portStart);

				if (ret != SUCCESS)
				{					
					printf("serverp_tableDriverAccess: rtl8651_delNaptServerPortMapping() ret:%d\n",ret);
					//return NOT_OK;
				}				
			}
			else
			{
				ret = rtl8651a_delNaptServerPortRange(
					dsid,
					(ramServerpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t)wanIp,                     /* current wan ip */
					(uint16)ramServerpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t)tempIpAddr,
					(uint16)ramServerpCfgParam[dsid][i].portStart,
					(uint16)ramServerpCfgParam[dsid][i].wanPortFinish-ramServerpCfgParam[dsid][i].wanPortStart+1);

				if (ret != SUCCESS)
				{
					printf("serverp_tableDriverAccess: rtl8651_delNaptServerPortRange() ret:%d\n",ret);
					//return NOT_OK;
				}				
				
			}
			
			
		} /* end for */
#else
		rtl8651_flushNaptServerPortbyExtIp(wanIp);	
#endif		
	
	
	/* for loop to add all "enabled" entry in newServerpCfgParam[] */
	for (i=0;i<MAX_SERVER_PORT;i++)
	{	
		
		if (pRomeCfgParam->serverpCfgParam[dsid][i].enable == 0)
			continue;
			
		/* enable/create some serverp entry */
		if ( (    (pRomeCfgParam->serverpCfgParam[dsid][i].ip[0] == 0)
			   && (pRomeCfgParam->serverpCfgParam[dsid][i].ip[1] == 0)
			   && (pRomeCfgParam->serverpCfgParam[dsid][i].ip[2] == 0)
			   && (pRomeCfgParam->serverpCfgParam[dsid][i].ip[3] == 0)
			  )
			 || (pRomeCfgParam->serverpCfgParam[dsid][i].portStart == 0)
			 || (pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart == 0)
			)
		{
			/* clear this invalid rule */
			memset(&(pRomeCfgParam->serverpCfgParam[dsid][i]),0,sizeof(serverpCfgParam_t));
		}
		else
		{
			memcpy((void*)&tempIpAddr,(void*)(pRomeCfgParam->serverpCfgParam[dsid][i].ip),4);

			
			
			if(pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart==pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish)
			/* force PPTP serverP through SW */
			//if((pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart==pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish) &&
			//	(pRomeCfgParam->ifCfgParam[0].connType != IFCFGPARAM_CONNTYPE_PPTP))
			
			{	
				
				ret = rtl8651a_addNaptServerPortMapping(
					dsid,
					/* bit 1 is pure software */
					//check_pptp_tcp_udp(pRomeCfgParam->ifCfgParam[0].connType, pRomeCfgParam->serverpCfgParam[dsid][i].protocol),
					(pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t) wanIp,               /* current wan ip */
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t) tempIpAddr,
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].portStart);
				
#if defined(DNI)			
				/* protocol = 2 is TCP/UDP */	
				if (pRomeCfgParam->serverpCfgParam[dsid][i].protocol == 2) {
				ret += rtl8651a_addNaptServerPortMapping(
					dsid,
					//(pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					//check_pptp_tcp_udp(pRomeCfgParam->ifCfgParam[0].connType, pRomeCfgParam->serverpCfgParam[dsid][i].protocol)+1,	/* add TCP */
					1,		/* previous pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP is false -> UDP */
					(ipaddr_t) wanIp,               /* current wan ip */
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t) tempIpAddr,
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].portStart);
				}

				if((pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart==1720) && strstr(pRomeCfgParam->serverpCfgParam[dsid][i].desc, "Netmeeting")) {
				ret += rtl8651a_addNaptServerPortMapping(
					dsid,
					//check_pptp_tcp_udp(pRomeCfgParam->ifCfgParam[0].connType, pRomeCfgParam->serverpCfgParam[dsid][i].protocol),
					(pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t) wanIp,               /* current wan ip */
					(uint16)   1503,		/* NetMeeting data */
					(ipaddr_t) tempIpAddr,
					(uint16)   1503);

				if (pRomeCfgParam->serverpCfgParam[dsid][i].protocol == 2) {
				ret += rtl8651a_addNaptServerPortMapping(
					dsid,
					//check_pptp_tcp_udp(pRomeCfgParam->ifCfgParam[0].connType, pRomeCfgParam->serverpCfgParam[dsid][i].protocol)+1,
					1,//(pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t) wanIp,               /* current wan ip */
					(uint16)   1503,		/* NetMeeting data */
					(ipaddr_t) tempIpAddr,
					(uint16)   1503);					
				}
				}				
#endif				
								
				if (ret != SUCCESS)
				{
					ramServerpCfgParam[dsid][i].enable = 0;
					pRomeCfgParam->serverpCfgParam[dsid][i].enable=0;				
					printf("serverp_tableDriverAccess: rtl8651_addNaptServerPortMapping(wanip:%0x,wanport:%u,localip:%0x,localport:%u) ret:%d\n",wanIp,pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,tempIpAddr,pRomeCfgParam->serverpCfgParam[dsid][i].portStart,ret);
					//return NOT_OK;
				}				
				
			}
			else
			{
				ret = rtl8651a_addNaptServerPortRange(
					dsid,
					//check_pptp_tcp_udp(pRomeCfgParam->ifCfgParam[0].connType, pRomeCfgParam->serverpCfgParam[dsid][i].protocol),
					(pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t) wanIp,               /* current wan ip */
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t) tempIpAddr,
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].portStart, 
					(uint16)((pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish==pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart) ? 2 :		
						 (pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish-pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart+1)));		
					//(uint16) pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish-pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart+1);		
#if defined(DNI)
				/* both protocol (TCP/UDP) */
				if (pRomeCfgParam->serverpCfgParam[dsid][i].protocol == 2) {
				ret += rtl8651a_addNaptServerPortRange(
					dsid,
					//(pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					//check_pptp_tcp_udp(pRomeCfgParam->ifCfgParam[0].connType, pRomeCfgParam->serverpCfgParam[dsid][i].protocol)+1,
					1,	/* previous pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP is false -> UDP */
					(ipaddr_t) wanIp,               /* current wan ip */
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t) tempIpAddr,
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].portStart, 
					(uint16)((pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish==pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart) ? 2 :		
						 (pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish-pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart+1)));		
					
					//(uint16) pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish-pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart+1);		
				
			}	
#endif			
				if (ret != SUCCESS)
				{
					ramServerpCfgParam[dsid][i].enable = 0;
					pRomeCfgParam->serverpCfgParam[dsid][i].enable=0;				
					printf("serverp_tableDriverAccess: rtl8651_addNaptServerPortRange(wanip:%0x,wanport:%u,localip:%0x,localport:%u) ret:%d\n",wanIp,pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,tempIpAddr,pRomeCfgParam->serverpCfgParam[dsid][i].portStart,ret);
					return NOT_OK;
				}				
				
			}
			
			
		} /* end if */
	} /* end for */

	return OK;
} /* end serverp_tableDriverAccess */

/*
 * Routine Name: serverp_init
 * Description: configure serverp cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 serverp_init(void)
{	


	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_SERVERP,(void*)pRomeCfgParam->serverpCfgParam, sizeof(serverpCfgParam_t)*MAX_SERVER_PORT*MAX_PPPOE_SESSION)!=0)
	{
		printf("serverp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}		

	/* skip all delete when boot from scratch, since asic are all EMPTY */
	memcpy(ramServerpCfgParam,pRomeCfgParam->serverpCfgParam,sizeof(serverpCfgParam_t)*MAX_SERVER_PORT*MAX_PPPOE_SESSION);

	return 0;	
} /* end serverp_init */


/*
 * Routine Name: dmz_tableDriverAccess
 * Description: access table driver dmz APIs
 * Input:  char *ip , pointer to a ip address(char[4]).
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dmz_tableDriverAccess(int pppObjId)
{
	/* config DMZ host*/
	int32    ret;
	ipaddr_t wanIp=0, wanIp2=0, wanIp3=0;
	

	if (pRomeCfgParam->dmzCfgParam[pppObjId].enable==0)
		return OK; // do nothing and return success if not dmz host not enabled

	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
	{
		memcpy((void*)&wanIp,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr,4);		
	}
	else
	{
		memcpy((void*)&wanIp,(void*)(pRomeCfgParam->ifCfgParam[0].ipAddr),4);
		memcpy((void*)&wanIp2,(void*)(pRomeCfgParam->ifCfgParam[0].ipAddr1),4);
		memcpy((void*)&wanIp3,(void*)(pRomeCfgParam->ifCfgParam[0].ipAddr2),4);
	}
	/* access table driver now */
	//ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp);
	if (wanIp)
	{
		ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp);
		if(ret)
		{
			printf("dmz_tableDriverAccess: rtl8651_addDmzHost() ret:%d\n",ret);
		}
	}
	if (wanIp2)
	{
		ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp2, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp2);
		if(ret)
		{
			printf("dmz_tableDriverAccess: rtl8651_addDmzHost() ret:%d\n",ret);
		}
	}
	if (wanIp3)
	{
		ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp3, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp3);
		if(ret)
		{
			printf("dmz_tableDriverAccess: rtl8651_addDmzHost() ret:%d\n",ret);
		}
	}

#if 0	// RTL865xB d-cut testing hash-1.
		ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp3 + 1, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp3 + 1);
		if(ret)
		{
			printf("dmz_tableDriverAccess: rtl8651_addDmzHost() ret:%d\n",ret);
		}
#endif	

	return OK;
} /* dmz_tableDriverAccess */



uint32 udp_tableDriverAccess(int pppObjId)
{
	/* config DMZ host*/
	int32    ret;
	uint32  len;

	if (pRomeCfgParam->udpblockCfgParam[pppObjId].enable)
		len=	pRomeCfgParam->udpblockCfgParam[pppObjId].size*1000;
	else
		len=0xffff;
		
	/* access table driver now */
	rtl8651a_setUdpSizeThreshValue(pppObjId,len);
#if 0
	ret=rtl8651a_setUdpSizeThreshValue(pppObjId,len);
	if(ret)
	{
		printf(" ret:udp_tableDriverAccess() : rtl8651a_setUdpSizeThreshValue %d\n",ret);
		return NOT_OK;
	}
#endif

	return OK;
} /* udp_tableDriverAccess */

void addRMPsaForUnnumberCase(ipaddr_t privateLanIp, ipaddr_t privateLanMask, ipaddr_t publicLanIp, ipaddr_t publicLanMask, ipaddr_t wanIp, uint16 RMport)
{
	int32 ret;
	FILE *fp;
	ipaddr_t ipRange1_LB, ipRange1_UB, ipRange2_LB, ipRange2_UB, temp_ip;
	
	if (privateLanIp < publicLanIp) {
		ipRange1_LB = (privateLanIp & privateLanMask) + 1;
		ipRange1_UB = (privateLanIp & privateLanMask) + (~privateLanMask) - 1;
		ipRange2_LB = (publicLanIp & publicLanMask) + 1;
		ipRange2_UB = (publicLanIp & publicLanMask) + (~publicLanMask) - 1;
	}
	else {
		ipRange1_LB = (publicLanIp & publicLanMask) + 1;
		ipRange1_UB = (publicLanIp & publicLanMask) + (~publicLanMask) - 1;
		ipRange2_LB = (privateLanIp & privateLanMask) + 1;
		ipRange2_UB = (privateLanIp & privateLanMask) + (~privateLanMask) - 1;
	}
	/* add a proto stack action for ip range 1. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = 0;
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = ipRange1_LB - 1;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForUnnumberCase (1) ret: %d\n", ret);

	/* add a proto stack action for ip range 2. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = ipRange1_UB + 1;
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = ipRange2_LB - 1;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForUnnumberCase (2) ret: %d\n", ret);

	/* add a proto stack action for ip range 3. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = ipRange2_UB + 1;
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = 0xffffffff;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForUnnumberCase (3) ret: %d\n", ret);
}

void addRMPsaForNaptCase(ipaddr_t privateLanIp, ipaddr_t privateLanMask, ipaddr_t wanIp, uint16 RMport)
{
	int32 ret;
	ipaddr_t temp_ip;

	/* add a proto stack action for ip range 1. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = 0;
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = privateLanIp & privateLanMask;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForNaptCase (1) ret: %d\n", ret);

	/* add a proto stack action for ip range 2. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = (privateLanIp & privateLanMask) + (~privateLanMask);
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = 0xffffffff;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForNaptCase (2) ret: %d\n", ret);
	
}

#if 0
/* 
	IpUnWAport: unnumbered subnet web access port
	S1WAport: private lan web access port on session 1
	S2WAport: private lan web access port on session 2
	lanType: private lan / unnumbered subnet (public lan)
*/
void addProtoStackActions(ipaddr_t wanIp, ipaddr_t ipAddr, ipaddr_t ipMask, int sessionNo, uint16 IpUnWAport, uint16 S0WAport, uint16 S1WAPort, uint32 lanType)
{
	int32 ret;
	ipaddr_t temp_ip;
	
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&(tempPSAction.dstIp), &wanIp, sizeof(ipaddr_t));
	temp_ip = (ipAddr & ipMask) + 1;
	memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
	temp_ip = (ipAddr & ipMask) + (~ipMask) - 1;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	/* 
		(1) sessionNo is unnumbered session and lanType is unnumbered subnet => use IpUnWAport 
		(2) sessionNo is unnumbered session and lanType is private lan => sessionNo == 0, use S0WAport; sessionNo = 1, use S1WAport
		(3) sessionNo is NAPT session and lanType is unnumbered subnet => the same as (2)
		(4) sessionNo is NAPT session and lanType is private lan => the same as (2)
	*/
	if (pRomeCfgParam->pppoeCfgParam[sessionNo].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED && lanType == RTL865XB_MULTIPLE_PPPOE_UNNUMBER_LAN) {
		tempPSAction.orgPort = IpUnWAport;
		tempPSAction.orgPortEnd = IpUnWAport;
	}
	else {
		tempPSAction.orgPort = (sessionNo == 0)? S0WAport: S1WAPort;
		tempPSAction.orgPortEnd = (sessionNo == 0)? S0WAport: S1WAPort;
	}
#if 0	
	tempPSAction.orgPort = (pRomeCfgParam->pppoeCfgParam[sessionNo].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED) ? IpUnRMport: NaptRMport;
	tempPSAction.orgPortEnd = (pRomeCfgParam->pppoeCfgParam[sessionNo].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED) ? IpUnRMport: NaptRMport;
#endif
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf("addGenericProtoStackActions failed (wanIp: %u.%u.%u.%u): %d\n", NIPQUAD(wanIp), ret);
}
#endif

void addProtoStackActions(ipaddr_t wanIp, ipaddr_t ipAddr1, ipaddr_t ipAddr2, uint16 orgPort1, uint16 orgPort2, uint16 fwdPort, int protocol, int action, int role)
{
	int32 ret;
	ipaddr_t temp_ip;
	
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&(tempPSAction.dstIp), &wanIp, sizeof(ipaddr_t));
	temp_ip = ipAddr1;
	memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
	temp_ip = ipAddr2;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	
	tempPSAction.orgPort = orgPort1;
	tempPSAction.orgPortEnd = orgPort2;
	tempPSAction.fwdPort = fwdPort;
	tempPSAction.protocol = protocol;
	tempPSAction.action = action;
	tempPSAction.role = role;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf("addGenericProtoStackActions failed (wanIp: %u.%u.%u.%u): %d\n", NIPQUAD(wanIp), ret);
}


void addProtoStackActionsForIcmpDisable(ipaddr_t wanIp, ipaddr_t ipAddr, ipaddr_t ipMask)
{
	int32 ret;
	ipaddr_t temp_ip;

	if(!pRomeCfgParam->mgmtCfgParam[0].remoteIcmpEnable)
	{
		memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
		memcpy(&(tempPSAction.dstIp), &wanIp, sizeof(ipaddr_t));
		temp_ip = (ipAddr & ipMask) + 1;
		memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
		temp_ip = (ipAddr & ipMask) + (~ipMask) - 1;
		memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
		tempPSAction.protocol = IPPROTO_ICMP;
		tempPSAction.action = PS_ACTION_TO_PS;
		ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
		if (ret)
			printf("addGenericProtoStackActions failed (wanIp: %u.%u.%u.%u): %d\n", NIPQUAD(wanIp), ret);
	}

}


uint32 remoteMgmt_tableDriverAccess(void)
{
	uint32 ret;
	/* 
	      	-1: no unnumbered pppoe session exists in multiple pppoe
		0: session 0 is unnumbered pppoe session
		1: session 1 is unnumbered pppoe session
	*/
	int8 IpUnSession = -1;

	rtl8651_flushProtoStackActions();

	{	
		ipaddr_t ipAddr, ipMask;
				
		ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
		ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));

		/* Ping from LAN to PS */
		addProtoStackActionsForIcmpDisable( 0, ipAddr, ipMask );
	}
	

      if (pRomeCfgParam->mgmtCfgParam[0].valid) {
#if 0      	
	if (1) {
		ipaddr_t ipAddr, ipMask;
		ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
		ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));
		ret = rtl8651_addProtoStackActions((ipAddr & ipMask) + 1, (ipAddr & ipMask) + (~ipMask) - 1,
										   PS_ACTION_TO_PS, PS_ACTION_SERVER, IPPROTO_TCP,
										   pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort, 80);
		if (ret)
			printf(" addProtoStackActions :LAN pkt to web server failed: %d\n", ret);

	}
#endif	
	/* ============================================================================ */

	/* ========================= Remote Management Setting ================================ */

	/* when remote ip range setting is default, we partition it into several ip ranges */
	if (pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp == 0 && pRomeCfgParam->mgmtCfgParam[0].remoteMgmtMask == 0xffffffff) {

		if (1) {
			ipaddr_t ipAddr, ipMask;
			ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
			ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));

			/* add two range of remote management: {0.0.0.0~255.255.555.255} - {LAN subnet} */		
			ret = rtl8651_addProtoStackActions(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp,
											ipAddr & ipMask,
											PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,
											pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort,80);
			if(ret)
				printf(" ret:remoteMgmt_tableDriverAccess() : rtl8651_addProtoStackActions %d\n",ret);

			ret = rtl8651_addProtoStackActions((ipAddr & ipMask) + (~ipMask), pRomeCfgParam->mgmtCfgParam[0].remoteMgmtMask,
											PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,
											pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort,80);
			if(ret)
				printf(" ret:remoteMgmt_tableDriverAccess() : rtl8651_addProtoStackActions %d\n",ret);
		}
	}
	/* user setting of remote ip range */
	else {
		ret = rtl8651_addProtoStackActions(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp,
										pRomeCfgParam->mgmtCfgParam[0].remoteMgmtMask,
										PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,
										pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort,80);
		if(ret)
			printf(" ret:remoteMgmt_tableDriverAccess() : rtl8651_addProtoStackActions %d\n",ret);
	}
      }
      
	/* ================================================================================== */


	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,23,23);	
	ret = rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,8888,8888); //for Home Monitor
	if (ret)
		printf(" addProtoStackActions for Home Monitor failed: %d\n", ret);

	//rtl8651_addProtoStackServerPortRange(0,0,IPPROTO_TCP,23,23); //for telnetd
	
	/* chenyl : these settings are not be used after napt-flow-cache is applied */
	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_CLIENT,IPPROTO_TCP,53,53);
	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_CLIENT,IPPROTO_UDP,53,53);
	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_CLIENT,IPPROTO_UDP,67,67);
	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_UDP,68,68);
	if (mgmt_udp_500) {
		ret = rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_UDP,500,500);
		if (ret)
			printf(" addProtoStackActions for mgmt_udp_500 failed: %d\n", ret);
	}
	//disable L2TP,PPTP idle timeout
	ret = rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DONT_TIMEOUT,PS_ACTION_CLIENT,IPPROTO_UDP,1701,1701);
	if (ret)
		printf(" addProtoStackActions to disable L2TP idle timeout failed: %d\n", ret);
	
	ret = rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DONT_TIMEOUT,PS_ACTION_CLIENT,IPPROTO_TCP,1723,1723);	
	if (ret)
		printf(" addProtoStackActions to disable PPTP idle timeout failed: %d\n", ret);

	if(pRomeCfgParam->mgmtCfgParam[0].remoteIcmpEnable)
		ret=rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,0,IPPROTO_ICMP,0,0);
	else
		ret=rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DROP,0,IPPROTO_ICMP,0,0);
	if(ret)
		printf(" ret:remoteMgmt_tableDriverAccess() : rtl8651_addProtoStackActions for icmp %d\n",ret);
		
		
      //if ((pRomeCfgParam->mgmtCfgParam[0].valid == 0) || (pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort != 80))
      if (pRomeCfgParam->dmzCfgParam[0].enable == 0)
      {
      	
	ipaddr_t wanIp;
	
	memcpy(&(wanIp), pRomeCfgParam->ifCfgParam[0].ipAddr, sizeof(ipaddr_t));
	addProtoStackActions(wanIp, 0, 0xffffffff, 80, 80, 80, IPPROTO_TCP, PS_ACTION_DROP, PS_ACTION_SERVER);
	//addProtoStackActions(wanIp, 0, 0xffffffff, 0, 0xffff, 0, IPPROTO_TCP, PS_ACTION_DROP, PS_ACTION_SERVER);
	//addProtoStackActions(wanIp, 0, 0xffffffff, 0, 0xffff, 0, IPPROTO_UDP, PS_ACTION_DROP, PS_ACTION_SERVER);
     		      	
     }
		
	return OK;
} /* remoteMgmt_tableDriverAccess */


/*
 * Routine Name: dmz_init
 * Description: configure dmz cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dmz_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DMZ,(void*)(pRomeCfgParam->dmzCfgParam), sizeof(struct dmzCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("dmz_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	/* for each PPPoE session, l4fwd and icmpfwd are the same */
	rtl8651_setDmzL4Fwd(pRomeCfgParam->dmzCfgParam[0].l4fwd);
	rtl8651_setDmzIcmpFwd(pRomeCfgParam->dmzCfgParam[0].icmpfwd);

	return 0;	
} /* end dmz_init */


/*
 * Routine Name: udpblock_init
 * Description: configure udpblock cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 udpblock_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_UDPBLOCK,(void*)(pRomeCfgParam->udpblockCfgParam), sizeof(struct udpblockCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("udpblock_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	return 0;	
} /* end udpblock_init */

/*
 * Routine Name: routing_init
 * Description: configure routing cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 routing_init(void)
{	
	int i,ret;
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_ROUTING,(void*)(pRomeCfgParam->routingCfgParam), sizeof(struct routingCfgParam_s)*MAX_ROUTING)!=0)
	{
		printf("routing_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

#if 0
	for(i=0;i<MAX_ROUTING;i++)
	{
		if(pRomeCfgParam->routingCfgParam[i].interface!=ROUTING_INTERFACE_NONE)
		{
			char interface[8]={0};
			if(pRomeCfgParam->routingCfgParam[i].interface==ROUTING_INTERFACE_WAN) sprintf(interface,"eth0");
			if(pRomeCfgParam->routingCfgParam[i].interface==ROUTING_INTERFACE_LAN) sprintf(interface,"eth1");
			ret=rtl8651_addRoute((ipaddr_t)pRomeCfgParam->routingCfgParam[i].route,
								  (ipaddr_t)pRomeCfgParam->routingCfgParam[i].mask,
								  (int8*)interface,(ipaddr_t)pRomeCfgParam->routingCfgParam[i].gateway);
			if (ret)
			{
				//pRomeCfgParam->routingCfgParam[i].interface=ROUTING_INTERFACE_NONE;			
				printf("rtl8651_addRoute %x: ret %d\n",pRomeCfgParam->routingCfgParam[i].route,ret);				
			}
		}	
	}
#endif	
	return 0;	
} /* end routing_init */

/*
 * Routine Name: log_init
 * Description: configure log cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 log_init(void)
{	
	int i;
	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_LOG,(void*)(pRomeCfgParam->logCfgParam), sizeof(struct logCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("log_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	system("touch /var/syslog");
	
	for(i=0;i<MAX_PPPOE_SESSION;i++)
	{
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_DOS)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_DOS,1);
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_ACL)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_ACL, 1);
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_URL)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_URL, 1);
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_NEWFLOW)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_NEWFLOW, 1);
	}

	return 0;	
} /* end log_init */

void ripd_start()
{
	char dir[2]={0,0},ver[2]={0,0};
	strcpy(dir,(char *)nvram_get("rip_dir"));
	strcpy(ver,(char *)nvram_get("rip_ver"));
	
	if (*dir==0||*ver==0)
		return 0; // get rip direction or rip version error

	if (atoi(dir)>0&&atoi(ver)>0)
	{
		//do_exec("/bin/killall", "ripd");
		do_kill("/var/run/ripd.pid");
		eval("killall", "-9", "ripd");		
		sleep(1);
		eval("killall", "-9", "ripd");			
		do_exec("/bin/ripd", NULL);
	}	

}

/* if wan ip no changed and last ddns_status is ok then no need update */
void check_updateDDNS(void)
{
	char *pstrWanLastIP=NULL;
	char *pstrWanNowIP;
	int ip_changed=0, need_update = 0;

	pstrWanLastIP = file2str("/tmp/WanLastIPAddr");
	pstrWanNowIP = nvram_get( "wan0_ipaddr");

	if (!pstrWanLastIP)
		ip_changed = 1;
	else if( strcmp( pstrWanLastIP, pstrWanNowIP ) )
		ip_changed = 1;
	
	if (ip_changed) {
		str2file( "/tmp/WanLastIPAddr", pstrWanNowIP );
	}	
	else {
		FILE *fp=NULL;
   		char buf[256];		
   		fp = fopen("/tmp/ddns_status.txt", "r");	
   		
   		if (!fp) 
   			need_update = 1;
   		else {	
   			fgets(buf, 255, fp);		
			if (!strstr(buf, "good"))
				need_update = 1;
			fclose(fp);	
		}	
	}		
	if (ip_changed || need_update)
		ddns_start();		   			
		
	if (pstrWanLastIP)
		free( pstrWanLastIP );
}


void ddns_start (void)
{
	//if(pRomeCfgParam->ddnsCfgParam.enable == 1) {
	//	printf("ddns_starting\n");
	//	ddns(nvram_get("wan0_ipaddr"));
	//}
	char str[300]={0};
	int r;

	r=send_signal("/var/run/ez-ipupdate.pid",9);
	if(r==0)
		sleep(1);

	if (pRomeCfgParam->ddnsCfgParam.enable == 0) 
		return;
	
	//sprintf(str,"/bin/ez-ipupdate -d --pid-file /var/run/ez-ipupdate.pid --service-type %s --user %s:%s --host %s %s",
	sprintf(str,"/bin/ez-ipupdate -D --pid-file /var/run/ez-ipupdate.pid --service-type %s --user %s:%s --host %s %s",
		pRomeCfgParam->ddnsCfgParam.service,
		pRomeCfgParam->ddnsCfgParam.username,
		pRomeCfgParam->ddnsCfgParam.password,
		pRomeCfgParam->ddnsCfgParam.hostname,
		(pRomeCfgParam->ddnsCfgParam.wildcard ? "--wildcard" : ""));
	

	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_STATIC:
		case IFCFGPARAM_CONNTYPE_DHCPC:
		case IFCFGPARAM_CONNTYPE_TELSTRA:		
			strcat(str," --interface eth0");
			break;
		case IFCFGPARAM_CONNTYPE_PPTP:
		case IFCFGPARAM_CONNTYPE_PPPOE:
		case IFCFGPARAM_CONNTYPE_L2TP:	
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:			
			strcat(str," --interface ppp0");
			break;					
	}

	strcat(str," &");
	printf("run:[%s]\n",str);
	system(str);
}
		

void upnp_stop(void)
{
		char *argv[6];
		argv[0]="-net";
		argv[1]="239.0.0.0";
		argv[2]="netmask";
		argv[3]="255.0.0.0";
		argv[4]="eth1";
		argv[5]=NULL;
		
		//kill old process	
#if 0
		send_signal("/var/run/linuxigd.pid",SIGTERM);
		unlink("/var/run/linuxigd.pid");
#endif
		//added by dvd.chen 0n 12/30/2005 
		//kill old process	
		//cprintf("killing upnp task !!!\n");
		eval("killall", "-9", "upnp");
		
		// del upnp route
		INET_setroute(RTACTION_DEL, 0, argv);
		sleep(1);
}

uint32 upnp_start(void)
{
	if(pRomeCfgParam->upnpCfgParam.enable==1)
	{
		//close old upnp daemon.
		upnp_stop();
	
		// start upnp service
		char temp[30];
		char *argv[6];
		char interface[10]={0};
		int pid=0;
		FILE *f,*f2;
		
		argv[0]="-net";
		argv[1]="239.0.0.0";
		argv[2]="netmask";
		argv[3]="255.0.0.0";
		argv[4]="eth1";
		argv[5]=NULL;
#if 0  //marked off by dvd.chen, 01/05/2006
		f=fopen("/var/gatedesc.xml","w");
		f2=fopen("/etc/linuxigd/gatedesc.xml.org","r");		
		if(f2!=NULL)
		{
			char tempStr[160]={0};

			while(1)
			{
				fgets(tempStr,160,f2);
				if(feof(f2)) break;
				if(strstr(tempStr,"<URLBase>")!=NULL)
				{
					fprintf(f,"<URLBase>http://%d.%d.%d.%d:49152</URLBase>\n"
					,pRomeCfgParam->ifCfgParam[1].ipAddr[0]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[1]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[2]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[3]);
				}
				else if(strstr(tempStr,"<presentationURL>")!=NULL)
				{
					fprintf(f,"<presentationURL>http://%d.%d.%d.%d</presentationURL>\n"
					,pRomeCfgParam->ifCfgParam[1].ipAddr[0]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[1]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[2]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[3]);
				}
				else
					fputs(tempStr,f);			
				
			}				
			fclose(f2);			
		}
		fclose(f);
#endif		
	
		switch(pRomeCfgParam->ifCfgParam[0].connType)
		{
			case IFCFGPARAM_CONNTYPE_STATIC:
			case IFCFGPARAM_CONNTYPE_DHCPC:
#if defined(DNI)	
			case IFCFGPARAM_CONNTYPE_TELSTRA:
#endif
				sprintf(interface,"eth0");
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE:
			case IFCFGPARAM_CONNTYPE_PPTP:
			case IFCFGPARAM_CONNTYPE_L2TP:			
			case IFCFGPARAM_CONNTYPE_DHCPL2TP:			
				sprintf(interface,"ppp0");
				break;
		}
				
		INET_setroute(RTACTION_ADD, 0, argv);
		rtl8651_multicastAddFilter(ntohl(inet_addr("239.255.255.250")), MCAST_FILTER_ACT_MIRROR);
		//modify by dvd.chen, 01/05/2006
		//sprintf(temp,"/bin/upnpd %s eth1 &",interface);		
		eval("killall", "-9", "upnp");
		sprintf(temp,"/bin/upnp -D -L eth1 -W %s -T %d", interface, 
				atoi(nvram_get("upnp_advertime"))*60);
		system(temp);
	}
	else
	{
		rtl8651_multicastDelFilter(ntohl(inet_addr("239.255.255.250")), MCAST_FILTER_ACT_MIRROR);
		return 1;
	}
	return 0;		
}


void udhcpc_start(void)
{
#if 0	
	//send_signal("/var/run/udhcpc.pid",9);
	do_kill("/var/run/udhcpc.pid");
	do_exec("/bin/udhcpc",NULL);
#endif
	
	int pid;
	char *wan_hostname = nvram_get("wan_hostname");
	char *dhcp_argv[] = { "/bin/udhcpc",
				wan_hostname && *wan_hostname ? "-H" : NULL,
				wan_hostname && *wan_hostname ? wan_hostname : NULL,
				NULL
			};
	
	do_kill("/var/run/udhcpc.pid");
	_eval(dhcp_argv, NULL, 0, &pid);	
	
}

void udhcpc_renew(void)
{
	FILE *f;

	f = fopen("/var/run/udhcpc.pid", "r");
	if (f) {
		send_signal("/var/run/udhcpc.pid", SIGUSR1);
		fclose(f);
	}	
	else
		udhcpc_start();
}

void bpa_start(void)
{
	int pid;
	char *argv[] = {
		"hb_start",
		NULL
	};	
	
	if(nvram_match("wan_proto", "telstra"))
	{
		do_kill("/var/run/bpalogin.pid");
		eval("killall", "-9", "bpalogin");
		_eval( argv, NULL, 0, &pid );
	}
}

#define WLAN_SUPPORT_FUNCs

/*
	ReArrange WLAN interfaces for init / reinit.

	isInit == TRUE	-- init (called when system reboot)
	isInit == FALSE	-- reinit
*/
static void wlan_reArrange(int isInit)
{
	/* ===================================================
				Information collection
	     =================================================== */

	totalWlanCards = 0;			/* total WLAN card count in whole system */
	#ifdef CONFIG_RTL8185
	totalWlanCards += wlan_rtl8185_getInterfaceCount();
	#endif /* CONFIG_RTL8185 */

	/* ===================================================
				System initialize
	     =================================================== */

	if (isInit == TRUE)
	{
		#ifdef CONFIG_RTL8185
		wlan_setup(1);
		#endif /* CONFIG_RTL8185 */
	} else
	{
		#ifdef CONFIG_RTL8185
		wlan_setup(0);
		#endif /* CONFIG_RTL8185 */
	}
}

/*
	Init function of WLAN
*/
uint32 wlan_init (void)
{		
	wlan_reArrange(TRUE);
	return 0;
} /* end wlan_init */

/*
	Reinit function of WLAN
*/
uint32 wlan_reinit(void)
{
	wlan_reArrange(FALSE);
	return 0;
}

uint32 Process_wlan_reinit(void)
{
	wlan_reArrange(FALSE);
	return 0;
}

/*
	Check WEP/WPA key's correctness
*/

int32 wlan_chkKey(int8 *key, int32 cryptType, uint8 *cryptSubType)
{
	int i;
	int keylen = strlen(key);
	int legalLen;

	switch ( cryptType )
	{
		case CRYPT_WPA:
		case CRYPT_WPA2:
		case CRYPT_WPAMIX:
		{
			/* check length */
			if (keylen > 64 || keylen < 8)
			{
				return -1;
			}
			
			if (keylen == 64)
			{	/* No pass-phrase needed, so all of them must be HEX-digit */
				for ( i = 0 ; i < keylen ; i ++ )
				{
					if (isxdigit(key[i]))
					{
						continue;
					} else
					{
						return -1;
					}
				}
			} else
			{
				/* need be pass-phrased, so no any constraint */
			}
			break;
		}
		case CRYPT_WEP:
		{
			/*
				Due to WEP types have no any MIX mode, so we just simply get the first
				subtype of cryptSubType to decide if it's WEP64 or WEP128.
			*/
			switch (*cryptSubType)
			{
				case CRYPT_SUB_WEP_64:
					/*
						For WEP64, legal key is 10 hex digit
					*/
					legalLen = 10;

					break;
				case CRYPT_SUB_WEP_128:
					/*
						For WEP128, legal key is 26 hex digit
					*/
					legalLen = 26;

					break;
				default:
					assert(0);
					return -1;
			}
			/*
				start to check key:

					For WEP key, no passphrase can be used and length must fix.
					Besides, all chars of key must be hex digit.
			*/
			if ( keylen != legalLen )
			{
				return -1;
			}
			for ( i = 0 ; i < legalLen ; i ++ )
			{
				if (isxdigit(key[i]))
				{
					continue;
				} else
				{
					return -1;
				}
			}
			break;
		}
	}

	/* correctness check OK, accept */
	return keylen;
}

#ifdef CONFIG_RTL8185

/* <---- debug message ----> */
#define WLAN_DEBUG
#define WLAN_MSG_MASK			0xffffffff	/* Tune ON all debug messages */
#define WLAN_MSG_INFO			(1<<0)
#define WLAN_MSG_WARN			(1<<1)
#define WLAN_MSG_ERR			(1<<2)

#ifdef WLAN_DEBUG

#define WLAN_INFO(fmt, args...) \
	if (WLAN_MSG_MASK&WLAN_MSG_INFO) \
		do {printf("[%s-%d]-info-: " fmt "\n", __FUNCTION__, __LINE__, ## args); fflush(stdout);} while (0);
#define WLAN_WARN(fmt, args...) \
	if (WLAN_MSG_MASK&WLAN_MSG_WARN) \
		do {printf("[%s-%d]-warning-: " fmt "\n", __FUNCTION__, __LINE__, ## args); fflush(stdout);} while (0);
#define WLAN_ERR(fmt, args...) \
	if (WLAN_MSG_MASK&WLAN_MSG_ERR) \
		do {printf("[%s-%d]-error-: " fmt "\n", __FUNCTION__, __LINE__, ## args); fflush(stdout);} while (0);

#else	/* WLAN_DEBUG */

#define WLAN_INFO(fmt, args...)
#define WLAN_WARN(fmt, args...)
#define WLAN_ERR(fmt, args...)

#endif	/* WLAN_DEBUG */

#define SLEEP(t)	\
		do { \
			int i; \
			for (i=0;i<t;i++) \
			{ \
				sleep(1);\
			} \
		} while (0);

int32 wds_intf_updown(int w, int wds, int up)
{
	char cmdBuf[64];
	printf("Turn %s WDS interface : wlan%d-wds%d\n", up?"ON":"OFF", w, wds);

	sprintf(cmdBuf, "ifconfig wlan%d-wds%d %s", w, wds, up?"up":"down");
	printf("==> %s\n", cmdBuf);
	system(cmdBuf);
	return SUCCESS;
}

/* rearrange WDS interfaces to check redundant link */
void wds_rearrange(void)
{
	int card, wds;
	char zero[6] = {0};
	int wdsCnt[MAX_WLAN_CARDS];		/* per-Card wds count */

	printf("\nRe-Arrange ALL WDS Links:\n");
	printf("=============================================================\n");

	for (card=0;card<MAX_WLAN_CARDS;card++)
	{
		/* init WDS count of the specific interface */
		wdsCnt[card] = 0;

		for(wds=0;wds<MAX_WLAN_WDS;wds++)
		{
			/* Per-interface process															*/
			/********************************************************************************/

		
			/* check for redundancy */
			if(memcmp(pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds], zero, sizeof(ether_addr_t)) != 0)
			{
				int card_cmp, wds_cmp;

				for (card_cmp=0;card_cmp<MAX_WLAN_CARDS;card_cmp++)
				for (wds_cmp=0;wds_cmp<MAX_WLAN_WDS;wds_cmp++)
				{
					if (card_cmp<card)
						continue;
					if (card_cmp==card&&wds_cmp<=wds)
						continue;
					if (memcmp(	pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds],
								pRomeCfgParam->wlanCfgParam[card_cmp].wdsMacList[wds_cmp],
								sizeof(ether_addr_t)) == 0)
					{
						/*
							redundant WDS peer found : remove it.
						*/
						printf("[%s] Duplicate WDS peer: %02X:%02X:%02X:%02X:%02X:%02X at (wlan%d-wds%d) and (wlan%d-wds%d)\n",
							__FUNCTION__,
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][0],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][1],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][2],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][3],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][4],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][5],
							card, wds,
							card_cmp, wds_cmp
							);

						printf("\t==> Remove (wlan%d-wds%d)\n",
							card_cmp, wds_cmp);
						/* remove the redundant interface same as current one */
						memset(pRomeCfgParam->wlanCfgParam[card_cmp].wdsMacList[wds_cmp], 0, sizeof(ether_addr_t));
					}
				}

				printf("[%s] WDS peer: %02X:%02X:%02X:%02X:%02X:%02X at (wlan%d-wds%d)\n",
					__FUNCTION__,
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][0],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][1],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][2],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][3],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][4],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][5],
					card, wds
				);

				/* current entry is counted */
				wdsCnt[card] ++;
			}

			/********************************************************************************/
		}
		printf("[%s] Total WDS count of (wlan%d) : %d\n",
			__FUNCTION__,
			card,
			wdsCnt[card]);
	}

	/* fill WDS count of each CARD */
	for (card=0;card<MAX_WLAN_CARDS;card++)
	{
		pRomeCfgParam->wlanCfgParam[card].wdsCount = wdsCnt[card];
	}

	printf("=============================================================\n\n");
}

int32 wds_down(int w)
{
	int32 i;
	char cmdBuf[64];
	printf("Turn OFF WDS interfaces ....\n");
	/*
		When turning OFF WDS interfaces, we MUST ALWAYS try to turn ALL interfaces OFF.
		It is due to some of these interfaces are turned off by web-setting before.
		The corresponding interfaces would be turned on in wds_up()
	*/
	for ( i = 0 ; i < MAX_WLAN_WDS ; i++ )
	{
		wds_intf_updown(w, i, 0);
	}
}

int32 wds_up(int w)
{
	int32 i;
	char cmdBuf[64];

	if (	(pRomeCfgParam->wlanCfgParam[w].enable) &&
		(pRomeCfgParam->wlanCfgParam[w].mode>1) &&
		(pRomeCfgParam->wlanCfgParam[w].wdsEnable))
	{
		/* Bring up WDS interfaces. */
		WLAN_INFO("total %d WDS links\n",pRomeCfgParam->wlanCfgParam[w].wdsCount);

		for(i=0;i<(pRomeCfgParam->wlanCfgParam[w].wdsCount);i++)
		{
			wds_intf_updown(w, i, 1);
		}
	}
}

static int32 wlandrv_setup(int w, FILE *wpaCfgFile)
{
	uint8 wepkeyid=1;
	char temp[6]={0};	
	char mask[6]={0xff,0xff,0xff,0xff,0xff,0xff};	
	char cmdBuf[64]={0};
	int i=0,value,j;

	int8 KEY[65];
	int32 keylen;

	int16 authType[CRYPT_MAX/*encryption selection*/][AUTH_MAX/*auth selection*/] = {
		/*No encrypt*/	{	AUTH_NONE	,AUTH_8021x	,-1			,-1			},
		/*WEP64*/		{	AUTH_NONE	,AUTH_KEY	,AUTH_AUTO	,AUTH_8021x	},
		/*WEP128*/		{	AUTH_NONE	,AUTH_KEY	,AUTH_AUTO	,AUTH_8021x	},
		/*WPA-TKIP*/	{	AUTH_KEY	,AUTH_8021x	,-1			,-1			},
		/*WPA-AES*/	{	AUTH_KEY	,AUTH_8021x	,-1			,-1			}
	};

	if (cfgmgr_read(	CFGMGR_TABID_WLAN,
					(void*)pRomeCfgParam->wlanCfgParam,
					sizeof(struct wlanCfgParam_s)*MAX_WLAN_CARDS) !=0 )
	{
		printf("wlan_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return -1;
	}
	
	//pRomeCfgParam->wlanCfgParam[w].range = 0;	/* Max rabge */
	if (pRomeCfgParam->wlanCfgParam[w].enable == 0)
	{
		printf("wlan_init: wlan%d not enabled\n",w);
		return -1;
	}

	{
		printf("\n================================================\n");
		printf("\tCrypt:\t\t%d\n",
				pRomeCfgParam->wlanCfgParam[w].cryptType);
		for (j = 0 ; j < MAX_WLAN_CRYPT_MIX_TYPE ; j ++ )
		{
			printf("\tCrypt SubType:\t%d\n",
					pRomeCfgParam->wlanCfgParam[w].cryptSubType[j]);
		}
		printf("\tAuth:\t\t%d\n",
				pRomeCfgParam->wlanCfgParam[w].authType);
		printf("================================================\n");
	}

	/* set the random seed */
	srandom(time(NULL));

	/****************************************************************************
		Set mib to drvier
	*****************************************************************************/
	#define IWPRIV(wlanIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, "busybox iwpriv wlan%d " fmt, wlanIdx, ## args); \
			printf("@ WLAN -%d- [%s]\n", wlanIdx, cmdBuf); \
			system(cmdBuf); \
		} while (0);

	#define SETMIB(wlanIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, "busybox iwpriv wlan%d set_mib " fmt, wlanIdx, ## args); \
			printf("@ WLAN -%d- [%s]\n", wlanIdx, cmdBuf); \
			system(cmdBuf); \
		} while (0);

	#define SETIFCFG(wlanIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, "ifconfig wlan%d " fmt, wlanIdx, ## args); \
			printf("@ WLAN -%d- [%s]\n", wlanIdx, cmdBuf); \
			system(cmdBuf); \
		} while (0);

	#define SETIFCFG_WDS(wlanIdx, wdsIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, "ifconfig wlan%d-wds%d " fmt, wlanIdx, wdsIdx, ## args); \
			printf("@ WLAN -%d- [%s]\n", wlanIdx, cmdBuf); \
			system(cmdBuf); \
		} while (0);

	#define SETCFGFILE(wlanIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, fmt, ## args); \
			printf("@ WLAN -%d- File (%s) [%s]\n", wlanIdx, cfgFilePath, cmdBuf); \
			fprintf(wpaCfgFile, "%s\n", cmdBuf); \
		} while (0);

wlan_start_setting:

	/* =======================================================================
		Set Chip Version

		8:	8185B,	Zebra A
		9:	8185C,	Zebra A
		10:	8185C,	Zebra B
		11:	8185D,	Zebra C
		23:	8185D,	OMC A
	    ======================================================================= */

#ifdef CONFIG_RTL865X_CLE  //Kevin:Update for lost board info.
{
	bdinfo_t bdinfo;
	int RFChipID;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		int RFChipID = bdinfo.wlan[0].RFChipID;		
		
		printf("bdinfo.wlan[0].RFChipID = %d\n", bdinfo.wlan[0].RFChipID);
		if ((RFChipID == 10) || (RFChipID == 9))
			goto out;
	}

 IWPRIV( w, "mp_cfg rfchip=%d",
   (pRomeCfgParam->wlanCfgParam[w].chipVer == 4)?10/* OMC */:9/* Zebra */);
out:   

/* 8185 MP 
   if  bdinfo.wlan[0].cckTxPower[14][4] all equal 0xff then run UDPserver */
{
	uint8 invalid1[BDINFO_24GRF_CHANNELS*4]={0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,		
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff,
						0xff,0xff,0xff,0xff };
						
	uint8 invalid2[BDINFO_24GRF_CHANNELS*4]={0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,		
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a,
						0x0c,0x0c,0x0b,0x0a, };						
						
	int i;					
	
	printf("cckTxPower....\n");
	for (i = 0; i < BDINFO_24GRF_CHANNELS; i++) {
		printf("%02x ", bdinfo.wlan[0].cckTxPower[i][0]);
		printf("%02x ", bdinfo.wlan[0].cckTxPower[i][1]);
		printf("%02x ", bdinfo.wlan[0].cckTxPower[i][2]);
		printf("%02x\n", bdinfo.wlan[0].cckTxPower[i][3]);						
	}	
	
	if ((memcmp((uint8 *)bdinfo.wlan[0].cckTxPower, invalid1, BDINFO_24GRF_CHANNELS*4) == 0) || 
	    (memcmp((uint8 *)bdinfo.wlan[0].cckTxPower, invalid2, BDINFO_24GRF_CHANNELS*4) == 0))   {
	//if (1) {
		start_UDPserver();
	}				
	
}	

}   
#endif

	SETMIB(	w, "chipVersion=%d",
			(pRomeCfgParam->wlanCfgParam[w].chipVer == 4)
				?23	/* OMC */
				:(8+pRomeCfgParam->wlanCfgParam[w].chipVer)	/* Zebra */);

	/* =======================================================================
		RFChip Version

		RFChipID:
			7	- Zebra RTL8225
			8	- OMC RTL8255
	    ======================================================================= */
	if (pRomeCfgParam->wlanCfgParam[w].chipVer != 4)
	{
		SETMIB(w, "RFChipID=7");	/* use Realtek's own 11g RF chip (RTL8225) */
	}else
	{
		SETMIB(w, "RFChipID=8");	/* use Realtek's own 11abg RF chip (RTL8255) */
	}


	/* =======================================================================

		Wifi test specific setting

		For compatible issues (B+G AP mode's accessibility for 11B client),
		we need turn the mib 'wifi_specific' OFF.
		However, turn this off would cause some effects and let WIFI-reverse-test being FAILED.

		In RTL865XB platform, we think the compatibility issue is more important than WIFI test issues now.
		So we ALWAYS turn the mib item OFF here.

													- 2005/05/31
	    ======================================================================= */

	SETMIB(w, "wifi_specific=0");

	/* =======================================================================
		Regulation Domain
	    ======================================================================= */

	SETMIB(w, "regdomain=%d", (pRomeCfgParam->wlanCfgParam[w].regDomain+1));

	/* =======================================================================
		MAC address
	    ======================================================================= */
	{
		macaddr_t macStr;
		uint8 *p = (unsigned char *)&macStr;
#if !defined(DNI)
		if (bdinfo_getWlanMac((macaddr_t*)&macStr, w) != 0)
		{
			WLAN_ERR("Can not get MAC Address.");
			goto err;
		} else
		{
			/* get MAC successfully */
			uint8 invalid[6]={0xff,0xff,0xff,0xff,0xff,0xff};

			/*
				MAC is FF:FF:FF:FF:FF:FF	:
					It's invlalid and might be the default value of storage (ex. NOR Flash),
					so we must call reset function.
			*/
			if (memcmp(&invalid, p, 6) == 0)
			{
				goto flashDefault;
			}

			SETIFCFG(w, "hw ether %02X:%02X:%02X:%02X:%02X:%02X",	p[0],
																	p[1],
																	p[2],
																	p[3],
																	p[4],
																	p[5]);
		}
#else
		ether_atoe(nvram_get("lan_hwaddr",""),&macStr);
		SETIFCFG(w, "hw ether %02X:%02X:%02X:%02X:%02X:%02X",	p[0],
																p[1],
																p[2],
																p[3],
																p[4],
																p[5]); 
#endif

	}

	/* =======================================================================
		Charge pump
	    ======================================================================= */
	{
		int rxChargePump, txChargePump;

		if (bdinfo_get8185ChargePumpSetting(&rxChargePump,&txChargePump, w) != 0)
		{
			WLAN_ERR("Can not get ChargePump.");
			goto err;
		} else
		{
			/*
				Charge Pump is 0xff
					It's invlalid and might be the default value of storage (ex. NOR Flash),
					so we must call reset function.
			*/
			if (rxChargePump==0xff || txChargePump==0xff)
			{
				goto flashDefault;
			}

			/* charge pump is useful only for RTL8225 2.4G RF chip, it is meaningless for RTL8255 2.4/5G RF. */
			if (rxChargePump == 0)
			{
				rxChargePump = 3; /* Default Rx charge pump on Realtek's mini-PCI demo board */
			}
			if (txChargePump == 0)
			{
				txChargePump = 6; /* Default Tx charge pump on Realtek's mini-PCI demo board */
			}

			SETMIB(w, "rxChargePump=%d", rxChargePump);
			SETMIB(w, "txChargePump=%d", txChargePump);
		}
	}

	/* =======================================================================
		Protection mode
	     ======================================================================= */

	SETMIB(w, "disable_protection=%d", pRomeCfgParam->wlanCfgParam[w].protection?0:1);
	SETMIB(w, "cts2self=%d", pRomeCfgParam->wlanCfgParam[w].protection?1:0);	/* use CTS to self for protection mode */

	/* =======================================================================
		CCK Preamble
			0:	long preamble
			1:	short preamble
	     ======================================================================= */
	SETMIB(w, "preamble=%d", pRomeCfgParam->wlanCfgParam[w].preambleType);

	/* =======================================================================
		Operation mode

		opmode:
			16	- AP
			8	- Infrastructure client
			32	- Ad-hoc client
	    ======================================================================= */

	switch (pRomeCfgParam->wlanCfgParam[w].mode)
	{
		case 0:	/* AP */

			SETMIB(w, "opmode=16");		/* AP mode */
			break;

		case 1:	/* Client mode */

			if (pRomeCfgParam->wlanCfgParam[w].adhoc==0)
			{
				/* set as infrastructure client */
				SETMIB(w, "opmode=8");		/* Infrastructure client */
			} else
			{
				/* set as Ad-hoc client */
				SETMIB(w, "opmode=32");		/* Ad-hoc client */
			}
			break;

		case 2:	/* Pure WDS */

			SETMIB(w, "opmode=16");		/* AP mode */
			SETMIB(w, "wds_pure=1");		/* pure wds */
			break;

		case 3:	/* AP+WDS */

			SETMIB(w, "opmode=16");		/* AP mode */
			SETMIB(w, "wds_pure=0");		/* not pure wds */
			break;

		default:
			WLAN_ERR("Unknown mode [%d].", pRomeCfgParam->wlanCfgParam[w].mode);
			goto err;
	}

	/* =======================================================================
		Hidden AP
	     ======================================================================= */

	SETMIB(w,	"hiddenAP=%d",
				(pRomeCfgParam->wlanCfgParam[w].broadcastSSID == 1)	?0/* Broadcast SSID */
																	:1/* Dont broadcast SSID and Hide AP */);

	/* =======================================================================
		Dual Antenna
			- Diversity
			- DIG
			- High Pwoer Check
			- Antenna Diversity
			- Default Antenna
	    ======================================================================= */
	{
		int dualAntenna = 0;

		if (pRomeCfgParam->wlanCfgParam[w].dualAntenna)
		{
			dualAntenna = 1;
		} else
		{
			dualAntenna = 0;
		}

		SETMIB(w, "Diversity=%d",			dualAntenna);
		SETMIB(w, "DIG_enable=%d",		dualAntenna);
		SETMIB(w, "HighPowerChk=%d",	dualAntenna);
		SETMIB(w, "AntDvrsty=%d",		dualAntenna);
		SETMIB(w, "DefaultAnt=0");
	}

	switch (pRomeCfgParam->wlanCfgParam[w].range)
	{
		case 3:
			WLAN_INFO("Wireless coverage: Minimum.");
			break;
		case 2:
			WLAN_INFO("Wireless coverage: Limited.");
			break;
		case 1:
			WLAN_INFO("Wireless coverage: Normal.");
			break;
		case 0:
			WLAN_INFO("Wireless coverage: Max range.");
			break;
		default:
			WLAN_INFO("Wireless coverage: Unknown(%d).", pRomeCfgParam->wlanCfgParam[w].range);
			goto err;
	}

	/* =======================================================================
			Get TxPower and set channels
	    ======================================================================= */
	switch (pRomeCfgParam->wlanCfgParam[w].dataRateMode)
	{
		case WLAN_DATA_RATE_A:		/* 11a mode */
		{
			uint32 ofdmPower = 0;
			uint32 channel;
			uint32 chanlist[BDINFO_5GRF_CHANNELS+1/* 0 */]={0,36,40,44,48,52,56,60,64};

			for ( i=0 ; i < BDINFO_5GRF_CHANNELS ; i++)
			{
				/* RTL8255 supports only 8 11a channels: 36~64 */
				channel=36+i*4;

				/* Get OFDM TxPower */
				if (	bdinfo_get8185OfdmTxPower(	&ofdmPower,
													channel,
													pRomeCfgParam->wlanCfgParam[w].range, w) != 0 )
				{
					WLAN_ERR("Get OFDM TxPower error.");
					goto err;
				}

				/*		Invalid TxPower: '0xff' means the default value of storage (ex. NOR type FLASH),
						so we try to set it to default value and refetch TxPower again.						*/
				if ( ofdmPower == 0xff )
				{
					goto flashDefault;
				}
				/*
					Important Note:
						When we set  TxPower of channels,
						we must set the channel number as (channel - 1) to fix 8185 driver's constraint.
				*/
				SETMIB(w, "TxPowerOFDM=%d,%d", (channel - 1), ofdmPower);
			}

			/* Set Working Channel */
			channel = chanlist[pRomeCfgParam->wlanCfgParam[w].channel];
	 
			/* check the correctness of channel */
			{
				int idx;

				for (idx = 0 ; idx < (BDINFO_5GRF_CHANNELS+1) ; idx ++)
				{
					if (channel == chanlist[idx])
					{
						break;
					}
				}
				if (idx >= (BDINFO_5GRF_CHANNELS+1))
				{
					uint32 defChan = chanlist[0];
					WLAN_INFO("=> Unknown channel : %d, use the default channel [%d].", channel, defChan);
					channel = defChan;
				}
			}

			SETMIB(w, "channel=%d", channel);
		}
			break;
		case WLAN_DATA_RATE_B:
		case WLAN_DATA_RATE_G:
		case WLAN_DATA_RATE_BG:
		{
			int channel;

			for ( i = 0 ; i < 14 ; i++ )
			{
				uint32 ofdmPower = 0, cckPower = 0;
				channel = i+1;

				/* ============================================================
						OFDM
				    ============================================================ */

				if (bdinfo_get8185OfdmTxPower(	&ofdmPower,
												channel,
												pRomeCfgParam->wlanCfgParam[w].range,
												w))
				{
					WLAN_ERR("Get OFDM TxPower error.");
					goto err;
				}

				/*		Invalid TxPower: '0xff' means the default value of storage (ex. NOR type FLASH),
						so we try to set it to default value and refetch TxPower again.						*/
				if ( ofdmPower == 0xff )
				{
					goto flashDefault;
				}
				/*
					Important Note:
						When we set  TxPower of channels,
						we must set the channel number as (channel - 1) to fix 8185 driver's constraint.

						==> i = (channel - 1)
				*/
				SETMIB(w, "TxPowerOFDM=%d,%d", i, ofdmPower);

				/* ============================================================
						CCK
				    ============================================================ */
	 
				bdinfo_get8185CckTxPower(&cckPower,channel, pRomeCfgParam->wlanCfgParam[w].range, w);

				/*
					Important Note:
						When we set  TxPower of channels,
						we must set the channel number as (channel - 1) to fix 8185 driver's constraint.

						==> i = (channel - 1)
				*/
				SETMIB(w, "TxPowerCCK=%d,%d", i, cckPower);

			}

			{
				/* start to set working channel number */
				if (pRomeCfgParam->wlanCfgParam[w].channel == 0)
				{
					channel = 0;
				} else
				{
				  	int first, last;;

					#define WLAN_REGDOMAIN_FCC			0
					#define WLAN_REGDOMAIN_CANADA		1
					#define WLAN_REGDOMAIN_EUROPE		2
					#define WLAN_REGDOMAIN_SPAIN			3
					#define WLAN_REGDOMAIN_FRANCE		4
					#define WLAN_REGDOMAIN_JAPAN			5
					#define WLAN_REGDOMAIN_ISRAEL		6
					

					switch (pRomeCfgParam->wlanCfgParam[w].regDomain)
					{
						case WLAN_REGDOMAIN_FCC:
							first = 1;
							last = 11;
							break;
						case WLAN_REGDOMAIN_CANADA:
							first = 1;
							last = 11;
							break;
						case WLAN_REGDOMAIN_EUROPE:
							first = 1;
							last = 13;
							break;
						case WLAN_REGDOMAIN_SPAIN:
							first = 1;
							last = 11;
							break;
						case WLAN_REGDOMAIN_FRANCE:
							first = 1;
							last = 13;
							break;
						case WLAN_REGDOMAIN_JAPAN:
							first = 1;
							last = 14;
							break;
						case WLAN_REGDOMAIN_ISRAEL:
							first = 1;
							last = 13;
							break;
						default:
							printf("[WARNING] Unknown regulation domain: %d\n");
							first = 0;
							last = 0;
					}

					if (pRomeCfgParam->wlanCfgParam[w].channel > (last-first+1))
					{	/* Unknown channel setting */
						WLAN_WARN("[WARNING] Unknown channel index: %d, reset to AUTO\n", pRomeCfgParam->wlanCfgParam[w].channel);
						pRomeCfgParam->wlanCfgParam[w].channel = 0;
						channel = 0;
					} else
					{
						channel = first + pRomeCfgParam->wlanCfgParam[w].channel - 1;
					}

				}
			}
			/* set channel */
			SETMIB(w, "channel=%d", channel);
		}
			break;
		default:
		{
			WLAN_ERR("Unknown data rate mode (%d).", pRomeCfgParam->wlanCfgParam[w].dataRateMode);
			goto err;
		}
	}

	/* =======================================================================
			SSID
	    ======================================================================= */

	if (strlen(pRomeCfgParam->wlanCfgParam[w].ssid) > 32)
	{
		WLAN_ERR("string length of SSID (%d) is too large.\n", strlen(pRomeCfgParam->wlanCfgParam[w].ssid));
		goto err;
	}

#if 0
	SETMIB(w, "ssid=\"%s\"", pRomeCfgParam->wlanCfgParam[w].ssid);	/* SSID */
	SETMIB(w, "defssid=\"%s\"", pRomeCfgParam->wlanCfgParam[w].ssid);	/* default SSID : for IBSS mode */
	
#endif

	/* fixed system() function eat some special characters */
	set_mib(w, "ssid", pRomeCfgParam->wlanCfgParam[w].ssid);	/* SSID */
	set_mib(w, "defssid", pRomeCfgParam->wlanCfgParam[w].ssid);	/* default SSID : for IBSS mode */


	/* =======================================================================
			Band selection
				1		11b
				2		11g
				3		11b+g
				4		11a
	    ======================================================================= */
	{
		//uint16 band[4] = {1/*b only*/, 2 /*g only*/,3/*b+g*/,4/*a only */}; //Fix id15 @ ST_KWGR614_DVT_0.0.1_02.21.00.pdf
		uint16 band[4] = {1/*b only*/, 3 /*g only*/,3/*b+g*/,4/*a only */};

		if (	(pRomeCfgParam->wlanCfgParam[w].dataRateMode >= 0	/* (b only) = 0 */) &&
			(pRomeCfgParam->wlanCfgParam[w].dataRateMode < 4	/* (a only) = 3 */))
		{
			SETMIB(w, "band=%d", band[pRomeCfgParam->wlanCfgParam[w].dataRateMode]);	/* Band selection */
		}
	}

	/* =======================================================================
			Rate setting

			Basic Rate :
				For the compatible issue with Centrino, basic rate need to be provided in different modes.

	    ======================================================================= */

	{
		uint32 basicRate = 0xfff;

		/* Rate support/BitMask mapping */
		#define R_1M			(1<<0)
		#define R_2M			(1<<1)
		#define R_5_5M		(1<<2)
		#define R_11M		(1<<3)
		#define R_6M			(1<<4)
		#define R_9M			(1<<5)
		#define R_12M		(1<<6)
		#define R_18M		(1<<7)
		#define R_24M		(1<<8)
		#define R_36M		(1<<9)
		#define R_48M		(1<<10)
		#define R_54M		(1<<11)

		/* oprate rate */
		if ( pRomeCfgParam->wlanCfgParam[w].dataRate > 0 )
		{
			uint16 opRateSet[13] = {	0		/* Auto*/				,
									0xfff	/* All rate <= 54M */		,
									0x7ff	/* All rate <= 48M */		,
									0x3ff	/* All rate <= 36M */		,
									0x1ff	/* All rate <= 24M */		,
									0x0ff	/* All rate <= 18M */		,
									0x07f	/* All rate <= 12M */		,
									0x03f	/* All rate <= 9M */		,
									0x01f	/* All rate <= 6M */		,
									0x00f	/* All rate <= 11M */		,
									0x007	/* All rate <= 5.5M */		,
									0x003	/* All rate <= 2M */		,
									0x001	/* All rate <= 1M */			};

			if (pRomeCfgParam->wlanCfgParam[w].dataRate < 13)
			{
				uint16 oprate = opRateSet[pRomeCfgParam->wlanCfgParam[w].dataRate];

				switch (pRomeCfgParam->wlanCfgParam[w].dataRateMode)
				{
					case WLAN_DATA_RATE_B:
						/* b mode only can use 1/2/5.5/11 M */
						oprate &= (R_1M | R_2M | R_5_5M | R_11M);
						break;
					default:
						/* all data rates are ok to use, we don't need to mask anyone. */
						break;
				}
				SETMIB(w, "oprates=%d", opRateSet[pRomeCfgParam->wlanCfgParam[w].dataRate]);
			} else
			{
				WLAN_WARN("Unknown data Rate item [%d], set to auto.", pRomeCfgParam->wlanCfgParam[w].dataRate);
				pRomeCfgParam->wlanCfgParam[w].dataRate = WLAN_DATA_RATE_AUTO;
			}
		}

		/* basic rate */
		switch (pRomeCfgParam->wlanCfgParam[w].dataRateMode)
		{
			case WLAN_DATA_RATE_B:
			case WLAN_DATA_RATE_BG:
			{
				SETMIB(w, "deny_legacy=false"); //Fix id15 @ ST_KWGR614_DVT_0.0.1_02.21.00.pdf
				basicRate = (R_1M | R_2M | R_5_5M | R_11M);
			}
				break;
			case WLAN_DATA_RATE_G:
#if 1 //Fix id15 @ ST_KWGR614_DVT_0.0.1_02.21.00.pdf
				SETMIB(w, "deny_legacy=ture");
				basicRate = (R_1M | R_2M | R_5_5M | R_11M | R_6M | R_12M | R_24M);
				break;
#endif 
			case WLAN_DATA_RATE_A:
			{
				basicRate = (R_6M | R_9M | R_12M | R_18M);
			}
				break;
			default:
			{
				WLAN_ERR("Unknown data rate mode (%d).", pRomeCfgParam->wlanCfgParam[w].dataRateMode);
				goto err;
			}
		}

		SETMIB(w, "basicrates=%d", basicRate);

		/* auto rate */
		SETMIB(w, "autorate=1");									/* we always turn ON auto rate */

		/* fix rate */
		SETMIB(w, "fixrate=%d", R_1M);								/* we never use fix rate */

	}

	/* =======================================================================
			Threshold / time related parameters
				- DTIM period
				- client inactivity time
				- Long/short retry limit
				- fragmentation threshold
				- RTS threshold
				- beacon interval
	    ======================================================================= */
	SETMIB(w, "dtimperiod=1");										/* DTIM period : 1 (because patent issue) */
	SETMIB(w, "expired_time=30000");									/* Client inactivity time in 10 ms */
	SETMIB(w, "longretry=6");											/* Long Retry Limit : 6 (default value in 8185 driver) */
	SETMIB(w, "shortretry=6");											/* Short Retry Limit : 6 (default value in 8185 driver) */
	SETMIB(w, "fragthres=%d", pRomeCfgParam->wlanCfgParam[w].frag);	/* fragmentation threshold */
	SETMIB(w, "rtsthres=%d", pRomeCfgParam->wlanCfgParam[w].rts);		/* RTS threshold */
	SETMIB(w, "bcnint=%d", pRomeCfgParam->wlanCfgParam[w].beacon);	/* beacon interval */

	/* =======================================================================
			MISC setting
				- DONT block associated clients' relay
				- DONT deny 'any'
				- DONT disable TX shortcut
				- DONT disable RX shortcut
				- Always enable NAT2.5
				- Always add broadcast flag into DHCP request
	    ======================================================================= */
	SETMIB(w, "block_relay=0");							/* For packet relaying between associated client: 0 - relay, 1 - block and drop 2 - block and indicate to bridge */
	SETMIB(w, "deny_any=0");								/* don't deny the association SSID of 'any' */
	SETMIB(w, "disable_txsc=0");							/* don't disable TX shortcut */
	SETMIB(w, "disable_rxsc=0");							/* don't disable RX shortcut */
	SETMIB(w, "nat25_disable=0");							/* always enable NAT 2.5 */
	SETMIB(w, "dhcp_bcst_disable=0");						/* always enable bcast for DHCP */

	/* =======================================================================
		Security

			- WEP/WPA/WPA2
			- configuration file setting
			- key setting
	    ======================================================================= */
	{
		/* Set WPA configuration file */
		if (wpaCfgFile)
		{
			SETCFGFILE(w, "ssid = \"%s\"", pRomeCfgParam->wlanCfgParam[w].ssid);
		}

		/* ====================================
				Encryption mode
		     ==================================== */
		{
			int32 encmode = 0;

			switch (pRomeCfgParam->wlanCfgParam[w].cryptType)
			{
				case CRYPT_NONE:
					encmode = 0;			/* disabled */
					break;
				case CRYPT_WEP:
				{
					switch (pRomeCfgParam->wlanCfgParam[w].cryptSubType[0])
					{
						case CRYPT_SUB_WEP_64:
							encmode = 1;		/* WEP64 */
							break;
						case CRYPT_SUB_WEP_128:
							encmode = 5;		/* WEP128 */
							break;
						default:
							WLAN_ERR("Unknown encryption sub-type [%d] (encryption type : %d).",
								pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
								pRomeCfgParam->wlanCfgParam[w].cryptType);
							goto err;
					}
					break;
				}
				case CRYPT_WPA:
				case CRYPT_WPA2:
				{
					switch (pRomeCfgParam->wlanCfgParam[w].cryptSubType[0])
					{
						case CRYPT_SUB_WPA_TKIPAES:	/* BOTH TKIP / AES are supported */
						/*
							8185 driver team:
								After test, if the encription supports both AES/TKIP, the AES/TKIP encryption type for each client
								is decided by 'auth' daemon and tell 8185 driver by iwcontrol. Therefore, the encmode could be
								set to one of TKIP or AES and these two setting are OK.
							
						*/
						case CRYPT_SUB_WPA_TKIP:
							encmode = 2;		/* TKIP */
							break;
						case CRYPT_SUB_WPA_AES:
							encmode = 4;		/* AES(CCMP) */
							break;
						default:
							WLAN_ERR("Unknown encryption sub-type [%d] (encryption type : %d).",
								pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
								pRomeCfgParam->wlanCfgParam[w].cryptType);
							goto err;
					}
					break;
				}
				case CRYPT_WPAMIX:
					/*
						8185 driver team:
							When cryption type set to WPA Mix mode, the AES/TKIP encryption type for each client is decided by 'auth' daemon
							and tell 8185 driver by iwcontrol. Therefore, the encmode could be set to one of TKIP or AES and these two setting are OK.
						
					*/
					encmode = 2;	/* TKIP */
					break;
				default:
					WLAN_ERR("Unknown ecryption type [%d].", pRomeCfgParam->wlanCfgParam[w].cryptType);
					goto err;
			}

			SETMIB(w, "encmode=%d", encmode);
		}

		/* ====================================
				WEP / WPA detail setting
		     ==================================== */
		{
			int32 key_idx;

			switch (pRomeCfgParam->wlanCfgParam[w].cryptType)
			{
				/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
										WEP
				    =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
				case CRYPT_WEP:
					/* -----------------------------------
							WEP encryption related setting
					     ----------------------------------- */

					/*
						Set Key inforamtion to 8185 driver:

							In 8185 driver, there are 4 different keys can set.
							However, in fact, we only allow user to set only 1 key in system now.
							Therefore, we set 4 key-entries with same key set by user,
							and always tell 8185 driver to use the key 1 to process encryption.
					*/
#if !defined(DNI)
					for ( key_idx = 0 ; key_idx < 4 ; key_idx ++ )
					{
						/*
							The key set by user might be fail:

							In order to prevent MIB setting error, we would want to 
						*/
						if (wlan_chkKey(	pRomeCfgParam->wlanCfgParam[w].key,
										pRomeCfgParam->wlanCfgParam[w].cryptType,
										&(pRomeCfgParam->wlanCfgParam[w].cryptSubType))< 0)
						{
							int i;

							if (pRomeCfgParam->wlanCfgParam[w].cryptSubType[0] == CRYPT_SUB_WEP_64)
							{
								uint8 key64[11] = {0};

								for ( i = 0 ; i < 10 ; i ++ )
								{
									uint8 ran, asci;

									ran = (rand() & 0x0f);
									asci = (ran >= 10)?(ran-10+'a'):(ran+'0');
									key64[i] = asci;
								}

								SETMIB(w, "wepkey%d=%s", (key_idx + 1), key64);
							} else
							{
								uint8 key128[27] = {0};

								assert(pRomeCfgParam->wlanCfgParam[w].cryptSubType[0] == CRYPT_SUB_WEP_128);

								for (i = 0 ; i < 26 ; i ++)
								{
									uint8 ran, asci;

									ran = (rand() & 0x0f);
									asci = (ran >= 10)?(ran-10+'a'):(ran+'0');
									key128[i] = asci;
								}

								SETMIB(w, "wepkey%d=%s", (key_idx + 1), key128);
							}
							
						} else
						{
							SETMIB(w, "wepkey%d=%s", (key_idx + 1), pRomeCfgParam->wlanCfgParam[w].key);
						}
					}

					SETMIB(w, "wepdkeyid=0");	/* always use the first key */
#else
					SETMIB(w, "wepkey1=%s", pRomeCfgParam->wlanCfgParam[w].key1);
					SETMIB(w, "wepkey2=%s", pRomeCfgParam->wlanCfgParam[w].key2);
					SETMIB(w, "wepkey3=%s", pRomeCfgParam->wlanCfgParam[w].key3);
					SETMIB(w, "wepkey4=%s",  pRomeCfgParam->wlanCfgParam[w].key4);

					//SETMIB(w, "wepdkeyid=0");	/* always use the first key */
					SETMIB(w, "wepdkeyid=%d", pRomeCfgParam->wlanCfgParam[0].keyNo-1);	/* always use the first key */
					
#endif
					/*
						Set WEP inforamtion to configuration file for AUTH:

							In 8185 driver, there are 4 different keys can set.
							However, in fact, we only allow user to set only 1 key in system now.
							Therefore, we set 4 key-entries with same key set by user,
							and always tell 8185 driver to use the key 1 to process encryption.
					*/

					if (wpaCfgFile)
					{
						/* Encryption setting */
						SETCFGFILE(w, "encryption = 1");

						/* WEP type */
						if (pRomeCfgParam->wlanCfgParam[w].cryptSubType[0] == CRYPT_SUB_WEP_64)
						{	/* WEP 64 */
							SETCFGFILE(w, "wepKey = 1");	/* WEP64 */
						} else
						{	/* WEP 128 */
							SETCFGFILE(w, "wepKey = 2");	/* WEP128 */
						}
					} else
					{
						WLAN_ERR("WPA configuration is not provided.");
					}

				/* continue to set AUTHENTICATION */
				case CRYPT_NONE:	/* Don't do encryption, we check authentication only */
					/* ---------------------------------------------------------------------
						WEP authentication related setting

						Now, for WEP, 865x platform provide 4 kinds of AUTH methods to
						be used:
							1. Open system (none)
							2. Pre-shared key
							3. auto (both Open system and Pre-shared key are ok)
							3. 802.1x radius
					     --------------------------------------------------------------------- */
					switch (pRomeCfgParam->wlanCfgParam[w].authType)
					{
						case AUTH_NONE:		/* Open system */
							SETMIB(w, "802_1x=0");			/* not 802.1x */
							SETMIB(w, "authtype=0");			/* 0: open system */
							break;

						case AUTH_KEY:		/* Pre-shared key */
							SETMIB(w, "802_1x=0");			/* not 802.1x */
							SETMIB(w, "authtype=1");			/* 1: shared key */
							break;

						case AUTH_AUTO:		/* Open system + Pre-shared key */
							SETMIB(w, "802_1x=0");			/* not 802.1x */
							SETMIB(w, "authtype=2");			/* 2: auto */
							break;

						case AUTH_8021x:	/* 802.1x */
							SETMIB(w, "802_1x=1");			/* 802.1x */
							/*
								chenyl (2005/09/14):

									Jimmy said, in (WEP + 802.1x) mode, we can allow user to set its authentication
									type (Open System / Shared Key / Auto).

									Due to our UI don't support independent setting of authentication type & 802.1x radius ON/OFF,
									we just simply set the authType to Auto mode when 802.1x is enabled.
							*/
							SETMIB(w, "authtype=2");			/* 2: auto */

							/* Set configuration file */
							if (wpaCfgFile)
							{
								/* enable 1x */
								SETCFGFILE(w, "enable1x = 1");
								/* authentication == 2: pre-shared key for WEP 802.1x authentication, referenced from 8186's setting (chenyl, 2005/9/16) */
								SETCFGFILE(w, "authentication = 2");
								/* Set the UDP Port number of radius server (normally, 1812 is used) */
								SETCFGFILE(w, "rsPort = %d", pRomeCfgParam->wlanCfgParam[w].authRadiusPort);
								/* IP Address of radius server */
								SETCFGFILE(w, "rsIP = %u.%u.%u.%u", NIPQUAD(pRomeCfgParam->wlanCfgParam[w].authRadiusIp));
								/* password of radius server (31 chars in max) */
								SETCFGFILE(w, "rsPassword = \"%s\"", pRomeCfgParam->wlanCfgParam[w].authRadiusPasswd);
								/* Max retry number of request packet with radius server (3 is the default value) */
								SETCFGFILE(w, "rsMaxReq = 3");
								/* Timeout (in sec.) of waiting RSP packet of radius server (5 is the default value) */
								SETCFGFILE(w, "rsAWhile = 5");
							} else
							{
								WLAN_ERR("WPA configuration is not provided.");
							}
							break;
						default:
							WLAN_ERR("Unknown authentication type [%d].", pRomeCfgParam->wlanCfgParam[w].authType);
							goto err;
					}
					
					break;
				/* ===================================================================== */

				/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
										WPA
				    =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
				case CRYPT_WPA:
				case CRYPT_WPA2:
				case CRYPT_WPAMIX:
				{
					int32 unicastCipher = -1, wpa2UnicastCipher = -1;
					int32 wpaCipher[CRYPT_SUB_MAX] = {
						-1	/* CRYPT_SUB_NONE , non-exist in WPA */,
						-1	/* CRYPT_SUB_WEP_64 , non-exist in WPA */,
						-1	/* CRYPT_SUB_WEP_128 , non-exist in WPA */,
						1	/* CRYPT_SUB_WPA_TKIP , WPA auth configuration is set to 1 */,
						2	/* CRYPT_SUB_WPA_AES , WPA auth configuration is set to 2 */,
						3	/* CRYPT_SUB_WPA_TKIPAES , WPA auth configuration is set to 3 (bit-width OR of TKIP and AES) */
					};
					/*
						For WPA settings, AUTH is always needed.
					*/
					if (wpaCfgFile == NULL)
					{
						WLAN_ERR("WPA configuration is not provided.");
						break;
					}

					/* -----------------------------------
							WPA encryption related setting
					     ----------------------------------- */

					/*
						Set Key inforamtion to 8185 driver.

						chenyl (2005/09/14):
							Jimmy said, in (WPA + 802.1x) mode, no matter its WPA, WPA2 or WPA mixed mode,
							the authentication type MUST be set to Open System !
					*/

					SETMIB(w, "authtype=0");	/* 0: open system */
					/*
						Set WEP inforamtion to configuration file for AUTH:
					*/

					/* disable MAC authentication */
					SETCFGFILE(w, "enableMacAuth = 0");
					/* disable non-WPA client support (not supported now) */
					SETCFGFILE(w, "supportNonWpaClient = 0");
					/* Group key re-key time (No use yet) */
					SETCFGFILE(w, "groupRekeyTime = 86400");

					/* For WPA/WPA2/WPA-Mix mode, the only w differences between them are Cipher function / encryption setting */

					switch (pRomeCfgParam->wlanCfgParam[w].cryptType)
					{
						case CRYPT_WPA:

							SETCFGFILE(w, "encryption = 2");

							unicastCipher = wpaCipher[pRomeCfgParam->wlanCfgParam[w].cryptSubType[0]];
							if (unicastCipher < 0)
							{
								WLAN_ERR("Invalid cryptSubType %d (crypt type: %d)",
									pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
									pRomeCfgParam->wlanCfgParam[w].cryptType);
								goto err;
							}
							break;
						case CRYPT_WPA2:

							SETCFGFILE(w, "encryption = 4");

							wpa2UnicastCipher = wpaCipher[pRomeCfgParam->wlanCfgParam[w].cryptSubType[0]];
							if (wpa2UnicastCipher < 0)
							{
								WLAN_ERR("Invalid cryptSubType %d (crypt type: %d)",
									pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
									pRomeCfgParam->wlanCfgParam[w].cryptType);
								goto err;
							}
							break;
						case CRYPT_WPAMIX:

							SETCFGFILE(w, "encryption = 6");

							unicastCipher = wpaCipher[pRomeCfgParam->wlanCfgParam[w].cryptSubType[0]];
							//DNI:Kevin: We just only used first record. 06Apr27
							//wpa2UnicastCipher = wpaCipher[pRomeCfgParam->wlanCfgParam[w].cryptSubType[1]];  
							wpa2UnicastCipher = wpaCipher[pRomeCfgParam->wlanCfgParam[w].cryptSubType[0]];
							if (	(unicastCipher < 0) ||
								(wpa2UnicastCipher < 0) )
							{
								WLAN_ERR("Invalid cryptSubType %d, %d (crypt type: %d)",
									pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
									pRomeCfgParam->wlanCfgParam[w].cryptSubType[1],
									pRomeCfgParam->wlanCfgParam[w].cryptType);
								goto err;
							}
							break;
					}

					if (unicastCipher >= 0)
					{
						SETCFGFILE(w, "unicastCipher = %d", unicastCipher);
					}

					if (wpa2UnicastCipher >= 0)
					{
						SETCFGFILE(w, "wpa2UnicastCipher = %d", wpa2UnicastCipher);
					}

					/* ---------------------------------------------------------------------
						WPA authentication related setting

						Now, for WPA, 865x platform provide 2 kinds of AUTH methods to
						be used:
							1. Pre-shared key
							2. 802.1x radius
					     --------------------------------------------------------------------- */
					switch(pRomeCfgParam->wlanCfgParam[w].authType)
					{
						case AUTH_8021x:	/* WPA radius */

							/* enable 1x */
							SETMIB(w, "802_1x=1"); 
							SETCFGFILE(w, "enable1x = 1");
							/* authentication == 1: radius */
							SETCFGFILE(w, "authentication = 1");
							/* Set the UDP Port number of radius server (normally, 1812 is used) */
							SETCFGFILE(w, "rsPort = %d", pRomeCfgParam->wlanCfgParam[w].authRadiusPort);
							/* IP Address of radius server */
							SETCFGFILE(w, "rsIP = %u.%u.%u.%u", NIPQUAD(pRomeCfgParam->wlanCfgParam[w].authRadiusIp));
							/* password of radius server (31 chars in max) */
							SETCFGFILE(w, "rsPassword = \"%s\"", pRomeCfgParam->wlanCfgParam[w].authRadiusPasswd);
							/* Max retry number of request packet with radius server (3 is the default value) */
							SETCFGFILE(w, "rsMaxReq = 3");
							/* Timeout (in sec.) of waiting RSP packet of radius server (5 is the default value) */
							SETCFGFILE(w, "rsAWhile = 5");
							break;

						case AUTH_KEY: /* WPA-PSK */

							/* disable 1x */
							SETMIB(w, "802_1x=0"); 
							SETCFGFILE(w, "enable1x = 0");
							/* authentication == 2: pre-shared key */
							SETCFGFILE(w, "authentication = 2");
							/* key process */
							keylen = strlen(pRomeCfgParam->wlanCfgParam[w].key);
							if (keylen != 64)	/* legal pre-shared key's length is 64 */
							{
								/* 1: use passphrase algorithm to convert Pre-shared Key value */
								SETCFGFILE(w, "usePassphrase = 1");
							}else
							{
								/* 0: use key as raw data */
								SETCFGFILE(w, "usePassphrase = 0");
							}

#if !defined(DNI)
							/* pre-shared key: if (usePassphrase == 0), it's is 64 hex digits. if (usePassphrase == 1), this string length is (>=8) && (<=64) */
							SETCFGFILE(w, "psk = \"%s\"", pRomeCfgParam->wlanCfgParam[w].key);
#else
							SETCFGFILE(w, "psk = \"%s\"", pRomeCfgParam->wlanCfgParam[w].passphrase);
#endif

							break;

						default:
							SETMIB(w, "802_1x=0"); 
							WLAN_ERR("Unknown authentication type [%d].", pRomeCfgParam->wlanCfgParam[w].authType);
							goto err;
					}
					break;
				}
				/* ===================================================================== */

				default:
					WLAN_ERR("Unknown encryption type [%d].", pRomeCfgParam->wlanCfgParam[w].cryptType);
					goto err;
			}
		}
	}

	/* =======================================================================
		Access control

			- ACL
	    ======================================================================= */

	if (pRomeCfgParam->wlanCfgParam[w].acEnable)	/* accept or deny */
	{
		int i;

		/* 0: disable 1: accept 2: deny */
		SETMIB(w, "aclmode=%d", pRomeCfgParam->wlanCfgParam[w].acEnable);

		/* init acl rule number */
		SETMIB(w, "aclnum=0");

		for ( i = 0 ; i < MAX_WLAN_AC ; i++ )
		{
			/* If acl rule is set, we set it to driver */
			if ( memcmp(pRomeCfgParam->wlanCfgParam[w].acMacList[i], temp, 6) != 0 )
			{
				SETMIB(w, "acladdr=%02x%02x%02x%02x%02x%02x",
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][0],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][1],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][2],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][3],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][4],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][5]
				);
			}
		}
	}else
	{
		/* 0: disable 1: accept 2: deny */
		SETMIB(w, "aclmode=%d", pRomeCfgParam->wlanCfgParam[w].acEnable);
		/* init acl rule number */
		SETMIB(w, "aclnum=0");
	}

	/* =======================================================================
		WDS
	    ======================================================================= */

	/* we don't give WDS packets higher priority */
	SETMIB(w, "wds_priority=0");
	
	if (	(pRomeCfgParam->wlanCfgParam[w].mode > 1 /* It's 2 (WDS) or 3 (AP+WDS) */) &&
		(pRomeCfgParam->wlanCfgParam[w].wdsEnable))
	{
		char macAddr[16];
		macaddr_t macStr;
		uint8 *p = (unsigned char *)&macStr;
		int count = 0;
		uint8 invalid[6]={0xff,0xff,0xff,0xff,0xff,0xff};

		if (bdinfo_getWlanMac((macaddr_t*)&macStr, w) != 0)
		{
			WLAN_ERR("Can not get MAC Address.");
			goto err;
		}
		/* get MAC successfully */

		/*
			MAC is FF:FF:FF:FF:FF:FF	:
				It's invlalid and might be the default value of storage (ex. NOR Flash),
				so we must call reset function.
		*/
		if (memcmp(&invalid, p, 6) == 0)
		{
			goto flashDefault;
		}

		/* enable WDS */
		SETMIB(w, "wds_enable=1");

		/* init WDS number */
		SETMIB(w, "wds_num=0");

		/* before setting WDS interfaces, we must rearrange it */
		wds_rearrange();

		count = 0;
		for ( i = 0 ; i < MAX_WLAN_WDS ; i++)
		{
			/* Turn ON WDS interfaces */
			if (memcmp(pRomeCfgParam->wlanCfgParam[w].wdsMacList[i], temp, 6) != 0)
			{
				sprintf(macAddr, "%02x%02x%02x%02x%02x%02x",
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][0],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][1],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][2],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][3],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][4],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][5]	
				);

				SETMIB(w, "wds_add=%s", macAddr);

				SETIFCFG_WDS(w, count, "hw ether %02X:%02X:%02X:%02X:%02X:%02X", p[0], p[1], p[2], p[3], p[4], p[5]);
				count++;

				/* ==========================================
					Default don't use any encryption over WDS links.

					If user wants to support encryption on WDS, please
					refers to RTL8185's iwpriv document.
				    ========================================== */
			}
		}
	}else
	{
		/* Disable WDS */
		SETMIB(w, "wds_enable=0");
		/* init WDS number */
		SETMIB(w, "wds_num=0");

	}
	
	/* led_type ->
			LED0			LED1
		0	tx			rx
		1	enable/tx/rx		n/a	
		2	link			tx/rx(d,m)
		3	link/tx/rx(d,m)		n/a
		4	link			tx/rx(d)
		5	link/tx/rx(d)		n/a
		6	enable			tx/rx(d)
		7	enable/tx/rx(d)		n/a
		
		0-1	hw control
		2-7	sw control
		enable -> RF enable
		link   -> AP/Client associate
		d      -> data frame
		m      -> management frame
	*/	
	SETMIB(w, "led_type=7");	

	return 0;	/* SUCCESS */

flashDefault:
	{
		int cnt;
		WLAN_WARN("== Reset MP-CFG parameters for WLAN [%d] ==", w);
		IWPRIV(w, "mp_cfg default");
		WLAN_WARN("== Done, re-start setting ==");
		SLEEP(3);
	}
	goto wlan_start_setting;	/* restart setting */

err:
	return -1;	/* FAILED */
}


void wlan_setup (int32 flag)
{
	int32 w;
	char cmdBuf[128];
	int8 cfgFilePathFmt[]="/var/8185auth%d.conf";
	int8 cfgFilePath[64];
	int32 restart;
	int8 daemonInUsed = FALSE;	/* indicate if IAPP or 802.1x daemon are used or not */

do_again:

	restart = 0;

	/* =========================================================================== 
			Stop Interfaces and services
	    =========================================================================== */
	for ( w = 0 ; w < totalWlanCards ; w++ )
	{
		/* stop wlan interface */
		WLAN_INFO("==> Stop wlan%d", w);
		sprintf(cmdBuf, "ifconfig wlan%d down", w);
		printf("%s\n", cmdBuf);system(cmdBuf);;

		/* stop wds interfaces if any */
		WLAN_INFO("==> Stop WDS for wlan%d", w);
		wds_down(w);

		/* shutdown Daemon: AUTH */
		{
			int pid = 0;
			FILE *f;

			sprintf(cmdBuf, "/var/run/auth-wlan%d.pid", w);
			
			f = fopen(cmdBuf, "r");
			if ( f )
			{
				fscanf(f, "%d", &pid);
				fclose(f);

				if ( pid != 0 )
				{
					WLAN_INFO("@ Try to Kill process %s (%d)", cmdBuf, pid);
					kill(pid, SIGTERM);
					WLAN_INFO("\t=> Done");
				}
				f = fopen (cmdBuf, "r");
				if (f)
				{
					fclose(f);
					remove (cmdBuf);
				}
			}

			/* remove configuration file */
			sprintf(cmdBuf, cfgFilePathFmt, w);
			f = fopen(cmdBuf, "r");
			if ( f )
			{
				fclose(f);
				remove (cmdBuf);
			}
		}
	}

	for ( w=0 ; w < totalWlanCards ; w++ )
	{
		FILE *wpaCfgFile;

		/* setup driver via iwpriv */
		sprintf(cfgFilePath, cfgFilePathFmt, w);
		wpaCfgFile = fopen(cfgFilePath,"w+");		/* erase old file and create new one. */

		if (wlandrv_setup(w, wpaCfgFile))
		{
			WLAN_ERR("wlan%d setup failed!!!\n", w);
			continue;
		}
		if (wpaCfgFile)
		{
			fclose(wpaCfgFile);
		}

		/* now bring up wlan interface */
		WLAN_INFO("==> Turn ON wlan%d", w);
		sprintf(cmdBuf, "ifconfig wlan%d up",w);
		printf("%s\n", cmdBuf);system(cmdBuf);	

		/* now bring up wds interfaces if any */
		WLAN_INFO("==> Turn ON WDS for wlan%d", w);
		wds_up(w);

		/*
			start user level auth daemon if WPA enabled or Radius enable:

				802.1x Daemon Configuration:
					Need start daemon when:
						- WPA/WPA2 is used
						- WEP + 802.1x (authentication with radius server)
						- No encryption + 802.1x (authentication with radius server)
		*/
		if (	(pRomeCfgParam->wlanCfgParam[w].cryptType==CRYPT_WPA)||
			(pRomeCfgParam->wlanCfgParam[w].cryptType==CRYPT_WPA2)||
			(pRomeCfgParam->wlanCfgParam[w].cryptType==CRYPT_WPAMIX) ||
			(pRomeCfgParam->wlanCfgParam[w].authType==AUTH_8021x))
		{
			daemonInUsed = TRUE;

 			if (wpaCfgFile == NULL)
			{
				WLAN_ERR("Must run auth daemon but no cfg file exist\n");
				return;
			}

			SLEEP(3);

			WLAN_INFO("==> auth start");
			if (pRomeCfgParam->wlanCfgParam[w].mode != 1)
			{	/* is AP mode */
				sprintf(cmdBuf, "auth wlan%d eth1 auth %s &", w,cfgFilePath);
			}else
			{
				/* is client mode */
				if (pRomeCfgParam->wlanCfgParam[w].adhoc == 1)
				{
					sprintf(cmdBuf, "auth wlan%d eth1 client-adhoc %s &", w,cfgFilePath);
				}else
				{
					sprintf(cmdBuf, "auth wlan%d eth1 client-infra %s &", w,cfgFilePath);
				}
			}
			printf("%s\n", cmdBuf); system(cmdBuf);
		}
	}

	/* delay before runing iwcontrol is needed */
	SLEEP(3);

	/* start user level iwcontrol daemon to recv driver->auth messages */
	if (daemonInUsed == TRUE)
	{
		/*
			iwcontrol Daemon Configuration
				Need start daemon when:
					- 802.1x daemon is used
					- IAPP daemon is used
					==> Note: iwcontrol daemon should be started AFTER 802.1x or IAPP daemon is running.
		*/
		WLAN_INFO("==> iwcontrol start");
		{
			sprintf(cmdBuf, "iwcontrol ");
			for ( w = 0 ; w < totalWlanCards ; w++ )
			{
				sprintf(cmdBuf, "%s wlan%d", cmdBuf, w);
			}
			printf("%s\n", cmdBuf);system(cmdBuf);
		}
	}

	/* if in client mode, join to AP */
	for ( w=0 ; w<totalWlanCards ; w++ )
	{
		if (pRomeCfgParam->wlanCfgParam[w].mode == 1)
		{
			if ( 1==apClientJoin(w, flag) )
			{
				restart ++;
			}
		}
	}

	if (restart)
	{
		flag = 0;
		goto do_again;
	}
}

/* ====================================
		RTL8185 informations
    ==================================== */
int wlan_rtl8185_getInterfaceCount (void)
{
	int32 idx;
	char intfMib[32];
	FILE *fd;
	int intfCnt = 0;

	for ( idx = 0 ; idx < MAX_WLAN_CARDS ; idx ++ )
	{
		memset(intfMib, 0, sizeof(intfMib));
		sprintf(intfMib,"/proc/wlan%d/mib_all", idx);

		fd = fopen(intfMib, "r");
		if (fd == NULL)
		{
			break;
		}
		fclose(fd);

		intfCnt ++;
	}

	return intfCnt;
}


uint32 wlan_acl_init (void)
{		
	/* read cfg from cfgmgr */	
	if (cfgmgr_read(CFGMGR_TABID_WLAN,(void*)(pRomeCfgParam->wlanCfgParam), sizeof(wlanCfgParam_t)*MAX_WLAN_CARDS)!=0)
	{
		printf("wlan_acl_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	return 0;
} /* end wlan_acl_init */

#endif	/* CONFIG_RTL8185 */


/*
 * Routine Name: upnp_init
 * Description: configure upnp cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 upnp_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_UPNP,(void*)&(pRomeCfgParam->upnpCfgParam), sizeof(struct upnpCfgParam_s))!=0)
	{
		printf("upnp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	return 0;	
} /* end upnp_init */

/*
 * Routine Name: urlfilter_init
 * Description: configure urlfilter cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 urlfilter_init(void)
{		
	int i;
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_URLFILTER,(void*)(pRomeCfgParam->urlfilterCfgParam), sizeof(struct urlfilterCfgParam_s)*MAX_PPPOE_SESSION*MAX_URL_FILTER)!=0)
	{
		printf("urlfilter_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	
	urlfilter_tableDriverAccess();
	return 0;
} /* end urlfilter_init */

/*
 * Routine Name: urlfilterTrustedUser_init
 * Description: configure urlfilter trusted user cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 urlfilterTrustedUser_init(void)
{		
	int i;
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_URLFILTERTRUSTEDUSER,(void*)(pRomeCfgParam->urlfilterTrustedUserCfgParam), sizeof(struct urlfilterTrustedUserCfgParam_s)*URL_FILTER_MAX_TRUSTED_USERS)!=0)
	{
		printf("urlfilterTrustedUser_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}


	rtl8651_flushUrlFilterTrustedUser();

	for(i=0;i<URL_FILTER_MAX_TRUSTED_USERS;i++)
	{
		if((pRomeCfgParam->urlfilterTrustedUserCfgParam[i].trustedIP!=0) && (pRomeCfgParam->urlfilterTrustedUserCfgParam[i].enable==1))
			rtl8651_addUrlFilterTrustedUser(pRomeCfgParam->urlfilterTrustedUserCfgParam[i].trustedIP);
	}

	return 0;	
} /* end urlfilter_init */

uint32 zone_init(void)
{
	char tmp[16];
	FILE *f;
	int32 timezone_diff;

#if !defined(DNI)
	sprintf(tmp,"EST%s",pRomeCfgParam->timeCfgParam.timeZone);
	if(tmp[3]==' ') tmp[3]='+';
	
	setenv("TZ",tmp, 1);
	timezone_diff=(tmp[4]-'0')*36000+(tmp[5]-'0')*3600+(tmp[7]-'0')*600+(tmp[8]-'0')*60;
	if(tmp[3]=='+') timezone_diff*=-1;
	rtl8651_setTimeZone(timezone_diff);
	
	f=fopen("/var/TZ","w");
	fprintf(f,"%s\n",tmp);
	fclose(f);
#endif
	
	f=fopen("/proc/sys/net/ipv4/conf/all/arp_announce","w");
	fprintf(f,"1");
	fclose(f);
	f=fopen("/proc/sys/net/ipv4/conf/default/arp_announce","w");
	fprintf(f,"1");
	fclose(f);

}

uint32 time_start(void)
{
	char tempStr[100];
	char host1,host2;
	int	iTimeZone=atoi(nvram_get("time_zone"));
	FILE *fp;
	
	//sprintf(tempStr, "killall -15 ntpclient");	/* terminate */
	//system(tempStr);
	//sprintf(tempStr, "killall -9 ntpclient");
	//system(tempStr);
	do_kill("/var/run/ntpclient.pid");	
	eval("killall", "-9", "ntpclient");		
	sleep(1);
	iTimeZone= iTimeZone % 8;
	host1= 'a' + iTimeZone;
	iTimeZone= (iTimeZone+1) % 8;
	host2= 'a' + iTimeZone;
	sprintf(tempStr,"/bin/ntpclient -d -z %s -h time-%c.netgear.com,time-%c.netgear.com -i 3 -l -s &", nvram_get("time_zone"),host1,host2);	
	system(tempStr);
	
}

/*
 * Routine Name: time_init
 * Description: configure time cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 time_init(void)
{		
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_TIME,(void*)&pRomeCfgParam->timeCfgParam, sizeof(struct timeCfgParam_s))!=0)
	{
		printf("time_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	return 0;	
} /* end time_init */

/*
 * Routine Name: napt_init
 * Description: configure napt cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 napt_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_NAPT, (void*)(&pRomeCfgParam->naptCfgParam), sizeof(struct naptCfgParam_s)) != 0)
	{
		printf("napt_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	

	pRomeCfgParam->naptCfgParam.weakNaptEnable = 0;	
	//pRomeCfgParam->naptCfgParam.looseUdpEnable = 1;
	pRomeCfgParam->naptCfgParam.looseUdpEnable = 0;		
	//pRomeCfgParam->naptCfgParam.tcpStaticPortMappingEnable = 1;	/* don't masqurate src port */
	//pRomeCfgParam->naptCfgParam.udpStaticPortMappingEnable = 1;		
	pRomeCfgParam->naptCfgParam.tcpStaticPortMappingEnable = 0;	/* masqurate src port */
	pRomeCfgParam->naptCfgParam.udpStaticPortMappingEnable = 0;		
	
	
	/* initial parameters */
	rtl8651_WeakNaptCtrl(pRomeCfgParam->naptCfgParam.weakNaptEnable);
	rtl8651_looseUdpCtrl(pRomeCfgParam->naptCfgParam.looseUdpEnable);
	rtl8651_TcpNaptStaticPortMappingCtrl(pRomeCfgParam->naptCfgParam.tcpStaticPortMappingEnable);
	rtl8651_UdpNaptStaticPortMappingCtrl(pRomeCfgParam->naptCfgParam.udpStaticPortMappingEnable);

	return 0;
}	/* end napt_init */

/*
 * Routine Name: dos_init
 * Description: configure dos cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dos_init(void)
{
	uint32 i;
	uint32 pScanThreshold;
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DOS,(void*)(pRomeCfgParam->dosCfgParam), sizeof(struct dosCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("dos_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	
	pRomeCfgParam->dosCfgParam[0].syn = 50;
	pRomeCfgParam->dosCfgParam[0].fin = 50;
	pRomeCfgParam->dosCfgParam[0].icmp = 100;		
	
	pRomeCfgParam->dosCfgParam[0].perSrc_syn = 30;
	pRomeCfgParam->dosCfgParam[0].perSrc_fin = 30;	
	pRomeCfgParam->dosCfgParam[0].perSrc_icmp = 50;		
	//pRomeCfgParam->dosCfgParam[0].ignoreLanSideCheck = 1;
	
	pRomeCfgParam->dosCfgParam[0].enableItem = 
		RTL8651_DOS_SYNFLOOD |
		RTL8651_DOS_STEALTHFIN |
		RTL8651_DOS_ICMPFLOOD |
		//RTL8651_DOS_UDPFLOOD |
		RTL8651_DOS_SCAN |
		RTL8651_DOS_PINGOFDEATH |		
		RTL8651_DOS_TEARDROP |		
		RTL8651_DOS_SMURF |		
		RTL8651_DOS_TCPLAND |		
		//RTL8651_DOS_UDPLAND |		
		RTL8651_DOS_ICMPLAND |		
		RTL8651_DOS_IPSPOOF |		
		//RTL8651_DOS_UDPBOMB |		
		RTL8651_DOS_SYNWITHDATA |		
			//RTL8651_DOS_SRC_SYNFLOOD |	
			//RTL8651_DOS_SRC_STEALTHFIN |	
			//RTL8651_DOS_SRC_ICMPFLOOD |	
		//RTL8651_DOS_SRC_UDPFLOOD |	
		//RTL8651_DOS_ECHOCHARGEN |		
		RTL8651_DOS_PORTSCAN;	//|		
			//RTL8651_DOS_SRC_TCPCONNOVERFLOW |	
			//RTL8651_DOS_SRC_UDPCONNOVERFLOW |		
			//RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW |	

			//RTL8651_DOS_TCPCONNOVERFLOW |		
			//RTL8651_DOS_UDPCONNOVERFLOW |		
			//RTL8651_DOS_TCPUDPCONNOVERFLOW;
			
	
	for(i=0;i<MAX_PPPOE_SESSION;i++){

		/* flooding */
		rtl8651a_setDosThreshold(i,RTL8651_DOS_SYN_THRESHOLD,pRomeCfgParam->dosCfgParam[i].syn);
		rtl8651a_setDosThreshold(i,RTL8651_DOS_FIN_THRESHOLD,pRomeCfgParam->dosCfgParam[i].fin);
		rtl8651a_setDosThreshold(i,RTL8651_DOS_UDP_THRESHOLD,pRomeCfgParam->dosCfgParam[i].udp);
		rtl8651a_setDosThreshold(i,RTL8651_DOS_ICMP_THRESHOLD,pRomeCfgParam->dosCfgParam[i].icmp);

		rtl8651a_setPerSrcDosThreshold(i, RTL8651_DOS_SYN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_syn);
		rtl8651a_setPerSrcDosThreshold(i, RTL8651_DOS_FIN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_fin);
		rtl8651a_setPerSrcDosThreshold(i, RTL8651_DOS_UDP_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_udp);
		rtl8651a_setPerSrcDosThreshold(i, RTL8651_DOS_ICMP_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_icmp);

		/* connection count control */
		rtl8651a_setDosThreshold(0, RTL8651_DOS_TCPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].tcpc);
		rtl8651a_setDosThreshold(0, RTL8651_DOS_UDPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].udpc);
		rtl8651a_setDosThreshold(0, RTL8651_DOS_TCPUDPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].tcpudpc);

		rtl8651a_setPerSrcDosThreshold(0, RTL8651_DOS_TCPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_tcpc);
		rtl8651a_setPerSrcDosThreshold(0, RTL8651_DOS_UDPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_udpc);
		rtl8651a_setPerSrcDosThreshold(0, RTL8651_DOS_TCPUDPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_tcpudpc);

		/* scan */
		switch (pRomeCfgParam->dosCfgParam[i].portScan_level)
		{
			case 0:	/* Low */
				pScanThreshold = DOS_PORTSCAN_LOW_VAL;
				break;
			case 1:	/* high */
				pScanThreshold = DOS_PORTSCAN_HIGH_VAL;
				break;
			default:
				pScanThreshold = DOS_PORTSCAN_LOW_VAL;
		}
		rtl8651_dosScanTrackingSetPara(i, RTL8651_DOS_SCAN_MOINTOR_WIN_DEFAULT, pScanThreshold);

		if (pRomeCfgParam->dosCfgParam[i].ignoreLanSideCheck)
		{
			rtl8651_addDosIgnoreType(RTL8651_DOS_IGNORETYPE_FROM_LAN);
		}else
		{
			rtl8651_delDosIgnoreType(RTL8651_DOS_IGNORETYPE_FROM_LAN);
		}

		rtl8651_dosProc_blockSip_setPrisonTime(pRomeCfgParam->dosCfgParam[i].sipblock_PrisonTime);
		rtl8651_dosProc_blockSip_enable(i, pRomeCfgParam->dosCfgParam[i].sipblock_enable);
	}

	return 0;	
} /* end dos_init */

/*
 * Routine Name: alg_init
 * Description: configure alg cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 alg_init(void)
{		
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_ALG,(void*)(pRomeCfgParam->algCfgParam), sizeof(struct algCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("alg_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	/* enable software PPTP ALG */
	pRomeCfgParam->algCfgParam[0].algList |= 0x80000000;	
	
	/* check sip */
	//if (pRomeCfgParam->algCfgParam[0].sip)
	if (0)	/* disabled by netgear */
		pRomeCfgParam->algCfgParam[0].algList |= 0x00000200;	/* enable sip alg */
	else	
		pRomeCfgParam->algCfgParam[0].algList &= 0xfffffdff;	/* disable sip alg */	
	return 0;	
} /* end alg_init */

/*
 * Routine Name: passthru_init
 * Description: configure passthru cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 passthru_init(void)
{		
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_PASSTHRU,(void*)(&pRomeCfgParam->passthruCfgParam), sizeof(struct passthruCfgParam_s))!=0)
	{
		printf("passthru_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	rtl8651_EnablePppoePassthru( pRomeCfgParam->passthruCfgParam.enabledPppoe );
	rtl8651_enableDropUnknownPppoePADT( pRomeCfgParam->passthruCfgParam.enabledDropUnknownPppoePADT );
	rtl8651_EnableIpv6Passthru( pRomeCfgParam->passthruCfgParam.enabledIpv6 );
	rtl8651_EnableIpxPassthru( pRomeCfgParam->passthruCfgParam.enabledIpx );
	rtl8651_EnableNetbiosPassthru( pRomeCfgParam->passthruCfgParam.enabledNetbios );

	return 0;	
} /* end passthru_init */

/*
 * Routine Name: ipMulticast_init
 * Description: configure passthru cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 ipMulticast_init(void)
{		
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_IPMULTICAST,(void*)(&pRomeCfgParam->ipMulticastCfgParam), sizeof(struct ipMulticastCfgParam_s))!=0)
	{
		printf("ipMulticast_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	rtl8651_EnablIpMulticast( pRomeCfgParam->ipMulticastCfgParam.enabledIpMulticast );

	return 0;	
} /* end ipMulticast_init */

uint32 opMode_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_MODE, (void*)&(pRomeCfgParam->modeCfgParam), sizeof(struct modeCfgParam_s)) != 0)
	{
		printf("opMode_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	return 0;
}

uint32 CreateStunnelCfgFile(void)
{
	FILE *fp;

	fp = fopen("/var/stunnel.conf", "w");
	if (fp) {
		fprintf(fp, "cert = /etc/stunnel/stunnel.pem\n");
		fprintf(fp, "pid = /var/run/stunnel.pid\n");
//		fprintf(fp, "setuid = 0\n");
//		fprintf(fp, "setgid = 0\n");
		fprintf(fp, "foreground = yes\n");
		fprintf(fp, "output = /var/stunnel.log\n");
		fprintf(fp, "debug = 7\n");
		fprintf(fp, "[boa]\n");
//		fprintf(fp, "accept = %u.%u.%u.%u:443\n", NIPQUAD(*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr))));
//		fprintf(fp, "connect = 127.0.0.1:80\n");
		fprintf(fp, "accept = 443\n");
		fprintf(fp, "connect = 80\n");
		fprintf(fp, "delay = no\n");
		fprintf(fp, "TIMEOUTclose = 0\n");
//		fprintf(fp, "exec = /bin/boa\n");
//		fprintf(fp, "execargs = boa -c /etc\n");
		fclose(fp);
	}
	else {
		printf("create stunnel.conf fail\n");
		return 1;
	}
	return 0;
}

//remove by kane.chen
#if 0
uint32 CreateRipCfgFile(void)
{
	FILE *f1, *f2;
	
	/* Create zebra configuration files: zebra.conf */
	f1 = fopen("/var/zebra.conf", "w");
	f2 = fopen("/var/ripd.conf", "w");

	/* Basic command in zebra.conf */
	if(f1)
	{
		fprintf(f1, "hostname Router\n");

		// No need to transmit RIP messages to eth0(WAN).
		// For Layer4 configuration, LAN routes cannot be distributed to WAN.
		// Therefore, I comment the following two lines.

		fprintf(f1, "interface eth0\n");
		fprintf(f1, "multicast\n");

		
		fprintf(f1, "interface eth1\n");
		fprintf(f1, "multicast\n");
		fclose(f1);
	}
	else
	{
		printf("create zebra.conf fail\n");
		return 1;
	}

	/* Read configurations in FLASH, and map them to the ripd command. */
	if(f2)
	{
		fprintf(f2, "hostname ripd\n");

		// RIP authentication testing
/*		
		fprintf(f2, "key chain test\n");
		fprintf(f2, "key 1\n");
		fprintf(f2, "key-string test\n");
*/
		// Per-interface setting: eth0

		fprintf(f2, "interface eth0\n");
		if(pRomeCfgParam->ripCfgParam.send_eth0 == 0)
			fprintf(f2, "ip rip send version 1 2\n");
		else
			fprintf(f2, "ip rip send version %d\n", pRomeCfgParam->ripCfgParam.send_eth0);
		if(pRomeCfgParam->ripCfgParam.rcv_eth0 == 0)
			fprintf(f2, "ip rip receive version 1 2\n");
		else
			fprintf(f2, "ip rip receive version %d\n", pRomeCfgParam->ripCfgParam.rcv_eth0);

		if(pRomeCfgParam->ripCfgParam.auth_eth0 == 1)
		{
			fprintf(f2, "ip rip authentication mode text\n");
			fprintf(f2, "ip rip authentication string %s\n", pRomeCfgParam->ripCfgParam.pass_eth0);
		}


		// Per-interface setting: eth1
		fprintf(f2, "interface eth1\n");
		if(pRomeCfgParam->ripCfgParam.send_eth1 == 0)
			fprintf(f2, "ip rip send version 1 2\n");
		else
			fprintf(f2, "ip rip send version %d\n", pRomeCfgParam->ripCfgParam.send_eth1);
		if(pRomeCfgParam->ripCfgParam.rcv_eth1 == 0)
			fprintf(f2, "ip rip receive version 1 2\n");
		else
			fprintf(f2, "ip rip receive version %d\n", pRomeCfgParam->ripCfgParam.rcv_eth1);

		if(pRomeCfgParam->ripCfgParam.auth_eth1 == 1)
		{
			fprintf(f2, "ip rip authentication mode text\n");
			fprintf(f2, "ip rip authentication string %s\n", pRomeCfgParam->ripCfgParam.pass_eth1);
		}
/*
		fprintf(f2, "ip rip authentication mode md5\n");
		fprintf(f2, "ip rip authentication key-chain test\n");
*/

		// RIP setting
		fprintf(f2, "router rip\n");
//		fprintf(f2, "route 0.0.0.0/0\n");
		fprintf(f2, "timers basic %d %d %d\n", pRomeCfgParam->ripCfgParam.update_tr, pRomeCfgParam->ripCfgParam.timeout_tr, pRomeCfgParam->ripCfgParam.garbage_tr);

		fprintf(f2, "network eth0\n");
		// If we configure RTL865xB in gateway mode, we don't distribute routing information to WAN.
		if (pRomeCfgParam->modeCfgParam.Mode == RTL865XB_L4GATEWAYMODE)
			fprintf(f2, "passive-interface eth0\n");
		else
			fprintf(f2, "no passive-interface eth0\n");

		fprintf(f2, "network eth1\n");
		fprintf(f2, "no passive-interface eth1\n");
		fclose(f2);
	}
	else
	{
		printf("create ripd.conf fail\n");
		return 1;
	}

	return 0;
}
#endif

uint32 stunnel_init(void)
{
	//Create "/var/stunnel.conf".
	if(CreateStunnelCfgFile())
	{
		printf("stunnel_init: create stunnel cfg file fail\n");
		return 1;
	}

	do_exec("/bin/stunnel", NULL);
	return 0;
}

/*
 * Routine Name: rip_init
 * Description: configure rip cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 rip_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_RIP,(void*)&(pRomeCfgParam->ripCfgParam), sizeof(struct ripCfgParam_s))!=0)
	{
		printf("rip_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

//remove by kane.chen
#if 0
	//Create "/var/zebra.conf" & "/var/ripd.conf".
	if(CreateRipCfgFile())
	{
		printf("rip_init: create rip cfg file fail\n");
		return 1;
	}
#endif

	//When multicast feature of the gateway is turned on, the packet destined to "224.0.0.9" should be mirrored to CPU.
	rtl8651_multicastAddFilter(ntohl(inet_addr("224.0.0.9")), MCAST_FILTER_ACT_MIRROR);
	//Invoke the zebra and ripd.
//	do_exec("/bin/zebra", NULL);
#if 0
	char dir[2]={0,0},ver[2]={0,0};
	strcpy(dir,nvram_get("rip_dir"));
	strcpy(ver,nvram_get("rip_ver"));
	
	if (*dir==0||*ver==0)
		return 0; // get rip direction or rip version error

	if (atoi(dir)>0&&atoi(ver)>0)
	{
		//do_exec("/bin/killall", "ripd");
		do_kill("/var/run/bpalogin.pid");		
		sleep(1);
		do_exec("/bin/ripd", NULL);
	}
#endif	
	return 0;	
}



/*
 * Routine Name: ddns_init
 * Description: configure ddns cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 ddns_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DDNS,(void*)&(pRomeCfgParam->ddnsCfgParam), sizeof(struct ddnsCfgParam_s))!=0)
	{
		printf("ddns_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	return 0;	
} /* end ddns_init */


uint32 rateLimit_init(void)
{
	int32 retval;
	uint32 entry;
	uint8 *ifname[] = { "eth1", "eth0" };
	rtl8651_tblDrvAclRule_t rule;
	
	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_RATELIMIT,(void*)&(pRomeCfgParam->rateLimitCfgParam), sizeof(struct rateLimitCfgParam_s))!=0) 	{
		printf("rateLimit_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	for(entry=0; entry<16; entry++) {
		if (pRomeCfgParam->rateLimitCfgParam.entry[entry].enable == FALSE) {
			bzero(&pRomeCfgParam->rateLimitCfgParam.entry[entry], sizeof(rateLimitEntry_t));
			pRomeCfgParam->rateLimitCfgParam.entry[entry].ipMask = 0xffffffff;
			continue;
		}
		if (pRomeCfgParam->rateLimitCfgParam.enable == FALSE)
			continue;
		asp_addRateLimitRule(&pRomeCfgParam->rateLimitCfgParam.entry[entry], entry);
	}

	return 0;
}

uint32 ratioQos_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_RATIOQOS,(void*)&(pRomeCfgParam->ratioQosCfgParam), sizeof(struct ratioQosCfgParam_s))!=0)
	{
		printf("ratioQos_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	if(pRomeCfgParam->ratioQosCfgParam.enable)
	{
		int i;
		for(i=0;i<ALG_QOS_TYPES;i++)
		{
			uint32 queueId;
			uint32 isHigh,enable,ratio;

			enable=pRomeCfgParam->ratioQosCfgParam.upInfo.algQosEntry[i].enable;
			isHigh=pRomeCfgParam->ratioQosCfgParam.upInfo.algQosEntry[i].isHigh;
			ratio=pRomeCfgParam->ratioQosCfgParam.upInfo.algQosEntry[i].ratio;			

			if(enable==1)
			{
				queueId=pRomeCfgParam->ratioQosCfgParam.upInfo.algQosEntry[i].queueID;
/* Following configuration is invalid due to NULL rule return SUCCESS directly */
				if(isHigh==1)
				{
					rtl8651_addFlowToUnlimitedQueue("eth0",NULL,ratio,queueId);
				}
				else
				{
					rtl8651_addFlowToLimitedQueue("eth0",NULL,ratio,queueId);
				}
			}
			else queueId=0;
			
			switch(i)
			{
				case 0: //ftp
					rtl8651_setAlgQosQueueId(RTL8651_ALG_FTP_IDX,queueId,isHigh, ratio);
					break;
				case 1://sip
					rtl8651_setAlgQosQueueId(RTL8651_ALG_SIP_IDX,queueId,isHigh, ratio);
					break;
				case 2://netmeeting
					rtl8651_setAlgQosQueueId(RTL8651_ALG_NETMEETING_IDX,queueId,isHigh, ratio);
					break;
			}
				
		}
	}

	
	rearrange_Ratio_Qos(FALSE);
	return 0;
}


uint32 pseudoVlan_init(void)
{
	uint32 port, portMask[6] = { 0 }, i;
	uint32 startVid;
	
	
	if (cfgmgr_read(CFGMGR_TABID_PSEUDOVLAN,(void*)&(pRomeCfgParam->pseudoVlanCfgParam), sizeof(struct pseudoVlanCfgParam_s))!=0)
	{
		printf("pseudoVlan_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	if (pRomeCfgParam->vlanCfgParam[0].vid > pRomeCfgParam->vlanCfgParam[1].vid)
		startVid = pRomeCfgParam->vlanCfgParam[0].vid+1;
	else startVid = pRomeCfgParam->vlanCfgParam[1].vid+1;

	if (pRomeCfgParam->pseudoVlanCfgParam.enable == TRUE) {
		for(port=0; port<RTL8651_PORT_NUMBER; port++) {
			if (pRomeCfgParam->pseudoVlanCfgParam.portVid[port] == 0)
				continue;
			portMask[pRomeCfgParam->pseudoVlanCfgParam.portVid[port]-startVid] |= (1<<port);
		}
		for(i=0; i<6; i++) {
			if (portMask[i] > 0)
				rtl8651_addSubVlan(pRomeCfgParam->vlanCfgParam[1].vid, i+startVid, portMask[i]);
		}
	}
	return 0;
}

int udhcpc_need_restart = 0;
int oneSecPass(void)
{
	if (upgrading)
		return 0;	
	if (!task_is_running("checkwan")) {
		sleep(1);
		if (!task_is_running("checkwan")) {
			unlink("var/run/checkwan.pid");
			start_CheckWan();			
			sleep(1);
		}
	}	
	if ((udhcpc_need_restart)
	    && (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP)
	    && (pRomeCfgParam->l2tpCfgParam.dialState != L2TPCFGPARAM_DIALSTATE_DIALED_SUCCESS)) {
	       	udhcpc_need_restart = 0;	    
		pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;
		pRomeCfgParam->l2tpCfgParam.manualHangup = 0;
		pRomeCfgParam->l2tpCfgParam.manualStart = 1;			
		printf("perform udhcpc_renew()...\n");
	    	udhcpc_renew();
	}
	if (pRomeCfgParam->l2tpCfgParam.dialState == L2TPCFGPARAM_DIALSTATE_DIALED_RESTART) {
		pRomeCfgParam->l2tpCfgParam.dialState = L2TPCFGPARAM_DIALSTATE_OFF;		
		sleep(1);
		l2tp_start(0);
	}	
	return 0;
		
}	    		

char* get_wan_ifname(void)
{

	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_STATIC:
		case IFCFGPARAM_CONNTYPE_DHCPC:
		case IFCFGPARAM_CONNTYPE_TELSTRA:		
			return ("eth0");
		case IFCFGPARAM_CONNTYPE_PPTP:
		case IFCFGPARAM_CONNTYPE_PPPOE:
		case IFCFGPARAM_CONNTYPE_L2TP:	
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:			
			return ("ppp0");
		default:
			return ("eth0");				
	}			
}

/*
 *  This function will return the external IP address of the specific session
 *    no matter the WAN type is static or not, and no matter the WAN type is PPPoE or not.
 */
ipaddr_t board_getExternalIp( int32 ms )
{
	ipaddr_t msIp;

	msIp = NULL;

	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_STATIC:/* fall through */
		case IFCFGPARAM_CONNTYPE_DHCPC: /* fall through */
		case IFCFGPARAM_CONNTYPE_TELSTRA: /* fall through */
		case IFCFGPARAM_CONNTYPE_PPTP:  /* fall through */
		case IFCFGPARAM_CONNTYPE_PPPOE: /* fall through */
		case IFCFGPARAM_CONNTYPE_L2TP:	/* fall through */
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:	/* fall through */			
			msIp = pRomeCfgParam->ifCfgParam[0].ipAddr[0] << 24 |
		           pRomeCfgParam->ifCfgParam[0].ipAddr[1] << 16 |
		           pRomeCfgParam->ifCfgParam[0].ipAddr[2] << 8 |
		           pRomeCfgParam->ifCfgParam[0].ipAddr[3];
			break;
		default:
			break;
	}

	return msIp;
}


/*
 *	Protocol-Based NAT
 */

int32 pbnat_ipup( int32 ms, ipaddr_t MyIp )
{
	int j,ret;

	if ( MyIp == NULL ) return SUCCESS; /* This session does NOT holds an IP address */
	
	for( j = 0; j < MAX_PBNAT; j++ )
	{
		if ( pRomeCfgParam->pbnatCfgParam[ms][j].enabled )
		{
			ret = rtl8651_addProtocolBasedNAT( pRomeCfgParam->pbnatCfgParam[ms][j].protocol,
			                                   MyIp,
		                                       pRomeCfgParam->pbnatCfgParam[ms][j].IntIp );
			if ( ret != SUCCESS )
			{
				printf( "rtl8651_addProtocolBasedNAT(protocol:%d,ExtIp:%08x,IntIp:%08x) error: %d, but never mind.\n",
					pRomeCfgParam->pbnatCfgParam[ms][j].protocol,
					MyIp,
		    		pRomeCfgParam->pbnatCfgParam[ms][j].IntIp,
		    		ret );
			}
		}
	}

	return SUCCESS;
}


int32 pbnat_ipdown( int32 ms, ipaddr_t MyIp )
{
	int j,ret;

	if ( MyIp == NULL ) return SUCCESS; /* This session does NOT holds an IP address */
	
	for( j = 0; j < MAX_PBNAT; j++ )
	{
		if ( pRomeCfgParam->pbnatCfgParam[ms][j].enabled ) // no matter enabled or not, delete anyway.
		{
			ret = rtl8651_delProtocolBasedNAT( pRomeCfgParam->pbnatCfgParam[ms][j].protocol,
			                                   MyIp,
		                                       pRomeCfgParam->pbnatCfgParam[ms][j].IntIp );
			if ( ret != SUCCESS )
			{
				printf( "rtl8651_delProtocolBasedNAT(protocol:%d,ExtIp:%08x,IntIp:%08x) error: %d, but never mind.\n",
					pRomeCfgParam->pbnatCfgParam[ms][j].protocol,
					MyIp,
		    		pRomeCfgParam->pbnatCfgParam[ms][j].IntIp,
		    		ret );
			}
		}
	}

	return SUCCESS;
}


uint32 pbnat_init()
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_PBNAT,(void*)&(pRomeCfgParam->pbnatCfgParam), sizeof(struct pbnatCfgParam_s)*MAX_PBNAT*MAX_PPPOE_SESSION)!=0)
	{
		printf("pbnat_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	if ( pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_STATIC )
	{
		pbnat_ipup( 0, pRomeCfgParam->ifCfgParam[0].ipAddr[0] << 24 |
		               pRomeCfgParam->ifCfgParam[0].ipAddr[1] << 16 |
		               pRomeCfgParam->ifCfgParam[0].ipAddr[2] << 8 |
		               pRomeCfgParam->ifCfgParam[0].ipAddr[3] );
	}

	return 0;
}


uint32 qos_init(void)
{	
	rtl8651_tblDrvPolicy_t policy;
	int32 index;
	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_QOS,(void*)&(pRomeCfgParam->qosCfgParam), sizeof(struct qosCfgParam_s)*MAX_QOS)!=0)
	{
		printf("qos_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	
	//if (pRomeCfgParam->qosCfgParam[MAX_QOS].qosType & ENABLE_QOS) {
	if (0) {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			rtl8651_setFlowControl(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.enableFlowCtrl);
			rtl8651_setPortPriorityQueue(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.isHigh);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.inRL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.outRL);
		}
	}
	else {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			//rtl8651_setFlowControl(index, TRUE);	/* cause phy reset */
			rtl8651_setPortPriorityQueue(index, FALSE);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, RTL8651_BC_FULL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, RTL8651_BC_FULL);
		}
	}

#if 0
	if (pRomeCfgParam->qosCfgParam[0].qosType & ENABLE_QOS) {
		for (index=0; index<7; index++) {
			if (pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber != 0) {
				bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
				policy.proto = RTL8651_POLICY_TCP;
				//Server is in the WAN
				policy.dport_start = 0; policy.dport_end = 65535;
				policy.sport_start = policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				//Server is in the LAN
				policy.sport_start = 0; policy.sport_end = 65535;
				policy.dport_start = policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);

				bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
				policy.proto = RTL8651_POLICY_TCP;
				//Server is in the WAN
				policy.sport_start = 0; policy.sport_end = 65535;
				policy.dport_start = policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				//Server is in the LAN
				policy.dport_start = 0; policy.dport_end = 65535;
				policy.sport_start = policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);

				if (index > 3) {
					bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
					policy.proto = RTL8651_POLICY_UDP;
					//Server is in the WAN
					policy.dport_start = 0; policy.dport_end = 65535;
					policy.sport_start = policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
					rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					//Server is in the LAN
					policy.sport_start = 0; policy.sport_end = 65535;
					policy.dport_start = policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
					rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);

					bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
					policy.proto = RTL8651_POLICY_UDP;
					//Server is in the WAN
					policy.sport_start = 0; policy.sport_end = 65535;
					policy.dport_start = policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
					rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					//Server is in the LAN
					policy.dport_start = 0; policy.dport_end = 65535;
					policy.sport_start = policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
					rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}
				
			}

		}
	}

	
	if (pRomeCfgParam->qosCfgParam[7].qosType & ENABLE_QOS) {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			rtl8651_setFlowControl(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.enableFlowCtrl);
			rtl8651_setPortPriorityQueue(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.isHigh);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.inRL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.outRL);
		}
	}
	else {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			//rtl8651_setFlowControl(index, TRUE);	/* cause phy reset */
			rtl8651_setPortPriorityQueue(index, FALSE);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, RTL8651_BC_FULL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, RTL8651_BC_FULL);
		}
	}
#endif	

	//if (pRomeCfgParam->qosCfgParam[MAX_QOS].qosType & ENABLE_QOS) {
	if (0) {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			rtl8651_setFlowControl(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.enableFlowCtrl);
			rtl8651_setPortPriorityQueue(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.isHigh);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.inRL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.outRL);
		}
	}
	else {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			//rtl8651_setFlowControl(index, TRUE);	/* cause phy reset */
			rtl8651_setPortPriorityQueue(index, FALSE);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, RTL8651_BC_FULL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, RTL8651_BC_FULL);
		}
	}
	
	return 0;	
} 

void qos_tableDriverAccess(void)
{
	rtl8651_tblDrvPolicy_t policy;
	int32 index;
	int32 ret;

	rtl8651_flushPolicyBasedQoS();		
	//if (pRomeCfgParam->qosCfgParam[0].qosType & ENABLE_QOS) {
	if (1) {
		for (index=0; index<MAX_QOS; index++) {
			if (	(pRomeCfgParam->qosCfgParam[index].un.policy_based.enable) &&
				(pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber != 0))  {
				bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
				//policy.proto = RTL8651_POLICY_TCP;
				//Server is in the WAN
				policy.dport_start = 0; policy.dport_end = 65535;
				policy.sport_start = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1;
				if (pRomeCfgParam->qosCfgParam[index].un.policy_based.protocol == 2) {
					policy.proto = RTL8651_POLICY_TCP;					
					ret = rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					policy.proto = RTL8651_POLICY_UDP;					
					ret = rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}
				else {
					policy.proto = ((pRomeCfgParam->qosCfgParam[index].un.policy_based.protocol == 0) ? RTL8651_POLICY_TCP : RTL8651_POLICY_UDP);						
					ret = rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}					
				
				//Server is in the LAN
				policy.sport_start = 0; policy.sport_end = 65535;
				policy.dport_start = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1;
				if (pRomeCfgParam->qosCfgParam[index].un.policy_based.protocol == 2) {
					policy.proto = RTL8651_POLICY_TCP;					
					ret = rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					policy.proto = RTL8651_POLICY_UDP;					
					ret = rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}
				else {	
					policy.proto = ((pRomeCfgParam->qosCfgParam[index].un.policy_based.protocol == 0) ? RTL8651_POLICY_TCP : RTL8651_POLICY_UDP);						
					ret = rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}					


				bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
				//policy.proto = RTL8651_POLICY_TCP;
				//Server is in the WAN
				policy.sport_start = 0; policy.sport_end = 65535;
				policy.dport_start = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber; 
				policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1;
				if (pRomeCfgParam->qosCfgParam[index].un.policy_based.protocol == 2) {
					policy.proto = RTL8651_POLICY_TCP;					
				ret = rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					policy.proto = RTL8651_POLICY_UDP;					
					ret = rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}
				else {	
					policy.proto = ((pRomeCfgParam->qosCfgParam[index].un.policy_based.protocol == 0) ? RTL8651_POLICY_TCP : RTL8651_POLICY_UDP);						
					ret = rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}					
				
				//Server is in the LAN
				policy.dport_start = 0; policy.dport_end = 65535;
				policy.sport_start = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1;
				if (pRomeCfgParam->qosCfgParam[index].un.policy_based.protocol == 2) {
					policy.proto = RTL8651_POLICY_TCP;					
				ret = rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					policy.proto = RTL8651_POLICY_UDP;
					ret = rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}
				else {	
					policy.proto = ((pRomeCfgParam->qosCfgParam[index].un.policy_based.protocol == 0) ? RTL8651_POLICY_TCP : RTL8651_POLICY_UDP);						
					ret = rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					if (ret)
						printf("%s ret=%d, %d-%d, proto=%d, high=%d\n", __FUNCTION__, ret, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber, pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber1, policy.proto, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}					
		
			}

		}
	}

	//if (pRomeCfgParam->qosCfgParam[MAX_QOS].qosType & ENABLE_QOS) {
	if (0) {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			rtl8651_setFlowControl(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.enableFlowCtrl);
			rtl8651_setPortPriorityQueue(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.isHigh);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.inRL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.outRL);
		}
	}
	else {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			//rtl8651_setFlowControl(index, TRUE);	/* cause phy reset */
			rtl8651_setPortPriorityQueue(index, FALSE);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, RTL8651_BC_FULL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, RTL8651_BC_FULL);
		}
	}
	
}	

/* ==========================================================================================
						Board-info access
     ========================================================================================== */
#define BDINFO_ACCESS_FUNCs

int32 bdinfo_read(bdinfo_t *bdInfo_p)
{
	if (bdInfo_p == NULL)
	{
		return FAILED;
	}

	flashdrv_read(	(void*)bdInfo_p,
					(void*)FLASH_MAP_BOARD_INFO_ADDR,
					sizeof(bdinfo_t));

	return SUCCESS;
}

int32 bdinfo_write(bdinfo_t *bdInfo_p)
{
	if (bdInfo_p == NULL)
	{
		return FAILED;
	}

	flashdrv_updateBdInfo(bdInfo_p);

	return SUCCESS;
}

int32 bdinfo_getMac(macaddr_t *mac_p)
{
	bdinfo_t bdinfo;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		memcpy(	(void*)mac_p,
					(void*)&(bdinfo.mac),
					sizeof(macaddr_t));
	}

	return 0;
} /* end bdinfo_getMac */

int32 bdinfo_getWlanMac(macaddr_t *mac_p, int index)
{
	bdinfo_t bdinfo;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		memcpy(mac_p, bdinfo.wlan[index].mac, sizeof(macaddr_t));
		return 0;
	}
	return -1;
} 

int32 bdinfo_get8185CckTxPower(int *txPower, unsigned int channel, unsigned int level, unsigned int index)
{
	bdinfo_t bdinfo;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		*txPower = (int)(bdinfo.wlan[index].cckTxPower[channel - 1][level]);
		return 0;
	}
	return -1;
}

int32 bdinfo_get8185OfdmTxPower(int *txPower, unsigned int channel, unsigned int level, unsigned int index)
{
	bdinfo_t bdinfo;

	if (channel > 14)
	{
		channel = 14 + ((channel-36)/4) + 1;
	}

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		*txPower = (int)(bdinfo.wlan[index].txPower[channel-1][level]);
		return 0;
	}
	return -1;
}

int32 bdinfo_get8185ChargePumpSetting(unsigned int *rx,unsigned int *tx, unsigned int index)
{
	bdinfo_t bdinfo;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		*rx = bdinfo.wlan[index].rxChargePump;
		*tx = bdinfo.wlan[index].txChargePump;
		return 0;
	}
	return -1;
}

#ifdef CONFIG_RTL8185

void start_UDPserver(void)
{
	FILE *f1;

	printf("%s\n", __FUNCTION__);	
	stop_UDPserver();
	sleep(1);
	f1 = fopen("/var/run/UDPserver.pid", "w");
	if (f1)
		fclose(f1);
	system("/bin/UDPserver &");
}


void stop_UDPserver(void)
{
	unlink("/var/run/UDPserver.pid");	
	eval("killall", "-9", "UDPserver");	
}	

static int32 bdinfo_set8185TxPower(int cardIdx, int txPower, int isCCK, int chIdx, int level)
{
	bdinfo_t bdinfo;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		/* update bdinfo */
		if (isCCK)
		{
			bdinfo.wlan[cardIdx].cckTxPower[chIdx][level] = txPower;
		} else
		{
			bdinfo.wlan[cardIdx].txPower[chIdx][level] = txPower;
		}
		/* write back */
		bdinfo_write(&bdinfo);

		return 0;
	}

	return -1;
}

static int32 bdinfo_get8185TxPower(int cardIdx, int* txPower, int isCCK, int chIdx, int level)
{
	bdinfo_t bdinfo;

	if (	(txPower) &&
			(bdinfo_read(&bdinfo) == SUCCESS))
	{
		/* read bdinfo */
		if (isCCK)
		{
			*txPower = bdinfo.wlan[cardIdx].cckTxPower[chIdx][level];
		} else
		{
			*txPower = bdinfo.wlan[cardIdx].txPower[chIdx][level];
		}
		return 0;
	}

	return -1;
}


#define STREAM_SAME(s1, s2) \
	((strlen(s1) == strlen(s2)) && (strcmp(s1, s2) == 0))

int32 bdinfo_access(int argc, char **argv)
{
	/* command type : [get/set] [type] [type-specific parameters] [output FD for "get"] */
	int isGet = 0;
	char *type;

	/* for WLAN TX Power setting */
	int accWlanTxPower = FALSE;
	int isCCK = FALSE;
	int chIdx = 0;
	int chCnt;

 	if (argc <= 2)
	{
		goto errout;
	}

 	if (STREAM_SAME(argv[1], "get"))
	{	
		isGet = TRUE;
	} else if (STREAM_SAME(argv[1], "set"))
	{
		isGet = FALSE;
	} else
	{
		goto errout;
	}

	/* set BDInfo According to "Type" */
	type = argv[2];

	if (STREAM_SAME(type, "HW_WLAN_TX_POWER_A"))
	{
		accWlanTxPower = TRUE;
		isCCK = FALSE;
		chIdx = 14;
		chCnt = 8;
	} else if (STREAM_SAME(type, "HW_WLAN_TX_POWER_B"))
	{
		accWlanTxPower = TRUE;
		isCCK = TRUE;
		chIdx = 0;
		chCnt = 14;
	} else if (STREAM_SAME(type, "HW_WLAN_TX_POWER_G"))
	{
		accWlanTxPower = TRUE;
		isCCK = FALSE;
		chIdx = 0;
		chCnt = 14;
	}

	/* =======================================
		Access WLAN TX Power
	   ======================================= */
	if (accWlanTxPower == TRUE)
	{
		int wlanIdx;

		if (argc <= 3)
		{
			goto errout;
		}

		wlanIdx = atoi(argv[3]);

		if (isGet == TRUE)
		{
			/* get Tx Power */
			int idx;
			int txPower = 0;
			FILE *fp = NULL;

			if (argc > 4)
			{
				fp = fopen(argv[4], "w");
			}
			
			if (fp)
			{
				fprintf(fp, "%s=%02x", type, wlanIdx);
			} else
			{
				printf("%s=%02x", type, wlanIdx);
			}

			for ( idx = 0 ; idx < chCnt ; idx ++, chIdx ++)
			{
				if (bdinfo_get8185TxPower(	wlanIdx,
											&txPower,
											isCCK,
											chIdx,
											0) == 0)
				{
					if (fp)
					{
						fprintf(fp, "%02x", txPower);
					} else
					{
						printf("%02x", txPower);
					}
				}
			}

			/* close File pointer */
			if (fp)
			{
				fclose(fp);
			}
		} else
		{
			int pwrIdx;

 			/* set Tx Power */
			if (pwrIdx <= 4)
			{
				goto errout;
			}

 			for (pwrIdx = 4 ; pwrIdx < argc ; pwrIdx ++, chIdx ++)
			{
				int pwr = atoi(argv[pwrIdx]);
				int level=0;

				for ( level = 0 ; level < 4 ; level ++ )
				{
					bdinfo_set8185TxPower(	wlanIdx,
											pwr,
											isCCK,
											chIdx,
											level);
				}
			}
		}
		goto okout;
	}

	/* No Any action : return FAILED */

errout:
	return FAILED;

okout:
	return SUCCESS;
}

#endif

/* ========================================================================================== */


/*
 * Routine Name: specialap_init
 * Description: configure specialap cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 specialap_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_SPECIALAP,(void*)pRomeCfgParam->specialapCfgParam, sizeof(struct specialapCfgParam_s)*MAX_SPECIAL_AP*MAX_PPPOE_SESSION)!=0)
	{
		printf("specialap_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	return OK;
} /* end specialap_init */

/*
 * Routine Name: gaming_init
 * Description: configure gaming cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 gaming_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_GAMING,(void*)pRomeCfgParam->gamingCfgParam, sizeof(struct gamingCfgParam_s)*MAX_GAMING*MAX_PPPOE_SESSION)!=0)
	{
		printf("gaming_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	return OK;
} /* end gaming_init */

/* Add by Timo Wu
 * Routine Name: schedule_init
 * Description: configure schedule cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 schedule_init(void)
{	
#if defined(DNI)
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_SCHEDULE,(void*)&(pRomeCfgParam->scheduleCfgParam), sizeof(struct scheduleCfgParam_s))!=0)
	{
		printf("schedule_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	
	//printf("schedule_init\n");
#endif
	return OK;
} /* end schedule_init */

/*
 * Routine Name: email_init
 * Description: configure schedule cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 email_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_EMAIL,(void*)&(pRomeCfgParam->emailCfgParam), sizeof(struct emailCfgParam_s))!=0)
	{
		printf("email_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	
	//printf("email_init\n");
	return OK;
} /* end email_init */

#if defined(DNI)
//KEVIN:05JAN02:BlankState+++
uint32 SmtWzdCfgParam_init() {
	if (cfgmgr_read(CFGMGR_TABID_BLANK_STATE,(void*)&(pRomeCfgParam->BlankStateCfgParam), sizeof(struct BlankStateCfgParam_s))!=0)
	{
		printf("%s: call cfgmgr_read fail\n", __FUNCTION__);
		return NOT_OK;
	}
	
	return OK;
}

int SmtWzd_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_BLANK_STATE,(void*)&(pRomeCfgParam->BlankStateCfgParam),sizeof(pRomeCfgParam->BlankStateCfgParam));
	cfgmgr_task();

	return 1;
}

int SetSmtWzdDone(int Done) {
	char tmp[20];
	uint32 curConnType = GetCurWanConnType();
	sprintf(tmp, "%d", Done);
	
	if( nvram_set("SmtWzdDone", tmp) == 1) {
		//SmtWzd_cfg_save();
		WanConfigSaveToFlash(curConnType);
	}
}
//KEVIN:BlankState---
#endif 

/*
 * rtl8651 demo system configuration initialization entry point
 * called by main.c of go-ahead web server	
 */
#define SIGNAL(s, handler)	do { \
	sa.sa_handler = handler; \
	sigaction(s, &sa, NULL);  \
    } while (0)



struct circ_buf {
	int size;			
	int head;			
	int tail;			
	char data[1];		
};

/****Add by Timo Wu***/
//When AlertImm is triggered, call this function to send URL LOG queitly

char *source="SOURCE";
char urlhost[128]="URLHOST";
//char allow[]="ALLOW";
//char trusted_user[]="ALLOWTRUSTED";	
uint32 email_log_byschedule(uint32 moduleId, uint32 alert_trigger)
{
	int  ret = 0;
	FILE *fp=NULL;
	//FILE *fp1=NULL;
	char urltemp[300];		
	char content[300];
	int log_len = 0;
    	
	struct circ_buf *buf;		
	unsigned int index=0;
	int i=-1;
	int head, size, tail;
	int show = 0;    	
	char *circBuff=NULL;
	
	int fd=-1;
	struct stat stat_buf;
	//FILE *f;
	char *ptr;
	char host_temp[128]="";
	int ptr_count=0;	
	int smtp_send=0;
	//int urltemp_allow=0;
	//int urltemp_trusted=0;
	char *content_source=NULL;
		
	if ( moduleId == RTL8651_LOGMODULE_URL) {
		fd=open("/var/url.log", O_RDONLY);
		
		if( fd >0 )
		{		
			flock(fd, LOCK_EX);
			fstat(fd ,&stat_buf);
					
			//fp1=fopen("/var/url.log","r");
			//read(fd , urltemp, stat_buf.st_size);    
						
			//not empty then read orl log of last timeonly when word "BLOCK" is shown,else write bellow	
			if( (stat_buf.st_size >0) ) 
			{
					
				//printf("url.log is not empty\n");
				//read(fd , urltemp, stat_buf.st_size); 				
				read(fd , urltemp, sizeof(urltemp)); 				
				
				ptr = strtok(urltemp, ":");
				while( (ptr = strtok(NULL, ":")) )
				{
					ptr_count++;		
															
					if( ptr_count == 3)
					{
						strcpy( host_temp, ptr);
						//printf("host_temp is %s\n", host_temp);						
					}
					else if(ptr_count ==4)
					{

						strsep(&ptr, " ");
						source = strsep(&ptr, " ");
						//printf("source1 is %d, %s\n", strlen(source), source);
						
					}
				}
				
				strcpy( urlhost,strtok(host_temp , "]"));
				ptr_count =0;
				
			}
			
			flock(fd, LOCK_UN);
			close(fd);
			fd = -1;			
		}
		else //url.log delete when press "Never", or when power on the device
		{			
			//source = strdup("SOURCE"); 
			source="SOURCE";
			strcpy(urlhost, "URLHOST");
		}
	}
		
		
	if (checkLogFull() == -1)
		return ret;
		
	if (!(fp = fopen("/var/system.log", "a+"))) {
		perror("write error /var/system.log");
		return -1;
	}
	
	
	//return ret;
    	//ret += websWrite(wp, "\nFirewall Log...\n" );
	//ret += dump_firewall_log(wp);
	{  	   
		//char *circBuff=NULL;
		
		circBuff = malloc(sizeof(struct circ_buf)+16000);
		if ( circBuff )
		{
			memset(circBuff, 0, (sizeof(struct circ_buf)+16000));
		   	
			if (rtl8651_getLogFromKernel(circBuff, moduleId, (sizeof(struct circ_buf)+16000)) == SUCCESS)
			{
				buf = (struct circ_buf *)circBuff;
			} else
			{
				buf = NULL;
				
			}			   		   
		} 
		else
		{
			buf = NULL;
		}
		
		if ((buf == -1) ||
			(buf == NULL) )
		{	
	  		if (circBuff) {
				free(circBuff);			
				circBuff = NULL;
			}	
			goto out;
		
		}
		
	
		head=buf->head;
		size=buf->size;
		tail=buf->tail;
		
		//DPRINTF("head = %d\n", head);
		//DPRINTF("size = %d\n", size);
		//DPRINTF("tail = %d\n", tail);						
			
		if(head>tail) tail+=size;

		/*
			determine show message or not according to the "prefix" of each message:
				show message only when this message is not dsid related ('x') or the dsid is same as the dsid(it's "ms") we select now.
		*/
		//if((buf->data[head]==('0')) || buf->data[head] == 'x')
		if (1)
			show = 1;
		else
			show = 0;

		for( i = head ; i < tail ; i++)
		{
			int idx = i;
			unsigned char c;
			
			while (idx >= size)
				idx -= size;

			c = buf->data[idx];
			content[log_len++] = c;
			if (log_len >= (sizeof(content)-1)) {
				log_len = 0;
				content[log_len] = 0;
				goto out;
				//break;
			}	
						
			if (c == 13)
			{	/* CR: Carriage Return, we ignore it */ 
				continue;
			}

			if(c == 10) 
			{	/* LF: Line Feed, we add new line in html form */
				
				continue;
			}	
			if(c == 0) 
			{	
				log_len = 0;
				/* end of string: check next message */
				//if((buf->data[(idx+1)%size] == ('0')) || (buf->data[(idx+1)%size] == 'x'))
				if (1)
					show = 1;
				else
					show = 0;
				
				{
					switch(moduleId)
					{
						case RTL8651_LOGMODULE_URL:
							//show block site and trusted ip's logs						
							//printf("content %d %s\n", strlen(content), content);
							ptr_count = 0;							
							content_source = NULL;
							if( strstr(content, "BLOCK")  )
							{
							
								strcpy(urltemp, content); //reuse variable urltemp
								//printf("urltemp %d, %s\n", strlen(urltemp), urltemp);
								ptr = strtok(urltemp, ":");
								while( (ptr = strtok(NULL, ":")) )
								{
									ptr_count++;		
															
									if(ptr_count ==4)
									{
				
										strsep(&ptr, " ");
										content_source = strsep(&ptr, " ");
										//printf("content_source is %d, %s\n", strlen(content_source), content_source);
						
									}
								}
								
								//printf("urltemp_allow %d urltemp_trusted %d urlhost %s source %s\n", urltemp_allow , urltemp_trusted ,urlhost, source);
		
								//if ( (strstr(content,"BLOCK") && (urltemp_allow==1) && (strstr(content, urlhost)==0) && (strcmp(source, content_source)!=0)) || (strstr(content, urlhost)==0)  || (strcmp(source, content_source)!=0) || (urltemp_trusted==1))
								//if((strstr(content, urlhost)==0)  || (strcmp(source, content_source)!=0))
								if((content_source == NULL) || (source == NULL) || (strstr(content, urlhost)==0)  || (strcmp(source, content_source)!=0))
								
								{
									
									
									fd = open("/var/url.log",O_WRONLY | O_CREAT |O_TRUNC );
		
									if(fd < 0)
									{
										//printf("fd url.log write open error\n");
										return -1;
									}
									flock(fd, LOCK_EX);
									write(fd ,content , strlen(content));
										
									flock(fd, LOCK_UN);
									close(fd);
									fd=-1;
									fprintf(fp, "%s", content);
										
									if(alert_trigger)
										smtp_send=1;
								}
								else
								{
									
									goto out;
								}
							}
									
							else
							{
								
								goto out;
							}				
							break;
						case RTL8651_LOGMODULE_ACL:
						case RTL8651_LOGMODULE_DOS:
							//printf("%s\n", content);
							fprintf(fp, "%s", content);
							break;							
						default:
							break;
					}
				}
				i++;
				break;		/* one time */		
			
			}

		}						


	}

	if (fp)
	{
		fclose(fp);	
		fp = NULL;
	}	
	//else if( fd >0 )
	if (fd > 0)
	{
		close(fd);
		fd=-1;
	}
	
	if ( (alert_trigger==1) && (smtp_send==1) )
	{								
			system("/bin/smtpclient subject_log_imm /var/url.log alert_trigger");	
	}
out:				
	if (fp)
	{
		fclose(fp);
	}	
	//else if (fd>0)
	if (fd > 0)
	{
		close(fd);
	}		

	log_len = 0;
	
	if (circBuff)
		free(circBuff);
							
	return ret;	
}

/****End***/

//Modified by Timo Wu 2006/01/13
extern int initialing;
void log_event(int sig)
{
	int idx=sig-60;
	FILE *f, *f1;
	int exit=FALSE;
	struct circ_buf *buf;
	uint32 index=0;
	int i=-1;
	int head,size,tail;
	int show=0;
	int moduleId=1<<(idx);
	char tempstr[160]={0},tempstr2[160]={0};	
	struct sockaddr_in address;
	struct hostent *host; 
	int sockfd;
	int ret;
	void* circBuff = NULL;

	
	if (upgrading)
		return;	
	if (initialing)
		return;			
		
	f=fopen("/var/mail_content.txt","w");

	if (f == NULL)
	{
		printf("open /var/mail_content.txt FAILED\n");
		return;
	}
	

	fprintf(f,"Mail Alert: ");	
	
	
	switch(idx)
	{
		case 1:
			if(((pRomeCfgParam->logCfgParam[0].module&RTL8651_MAILALERT_ACL)==0) &&
				((pRomeCfgParam->logCfgParam[0].module&RTL8651_REMOTELOG_ACL)==0)) exit=TRUE;
			fprintf(f,"ACL");
			
			email_log_byschedule(RTL8651_LOGMODULE_ACL , 0);
			rtl8651_clearLogFromKernel(RTL8651_LOGMODULE_ACL);
			
			break;
		case 2:
			if(((pRomeCfgParam->logCfgParam[0].module&RTL8651_MAILALERT_DOS)==0) &&
				((pRomeCfgParam->logCfgParam[0].module&RTL8651_REMOTELOG_DOS)==0)) exit=TRUE;
			fprintf(f,"DoS");
			
			email_log_byschedule(RTL8651_LOGMODULE_DOS , 0);
			rtl8651_clearLogFromKernel(RTL8651_LOGMODULE_DOS);
			
						
			break;
		case 3:
			if(((pRomeCfgParam->logCfgParam[0].module&RTL8651_MAILALERT_URL)==0) &&
				((pRomeCfgParam->logCfgParam[0].module&RTL8651_REMOTELOG_URL)==0)) exit=TRUE;
			fprintf(f,"URL Filter");
			
			//Fix smtpclient send mail when disabled keywordenable
			if( (pRomeCfgParam->emailCfgParam.alertimm==1)&& (strcmp(nvram_get("fw_keywordenable"), "0")!=0) )				
				email_log_byschedule(RTL8651_LOGMODULE_URL , 1);
				
			if (strcmp(nvram_get("fw_keywordenable"), "0")!=0) 
				email_log_byschedule(RTL8651_LOGMODULE_URL , 0);
								
			rtl8651_clearLogFromKernel(RTL8651_LOGMODULE_URL);

						
			break;
		case 4:
			if(((pRomeCfgParam->logCfgParam[0].module&RTL8651_MAILALERT_NEWFLOW)==0) &&
				((pRomeCfgParam->logCfgParam[0].module&RTL8651_REMOTELOG_NEWFLOW)==0)) exit=TRUE;		
			fprintf(f,"New Connection");
						
			rtl8651_clearLogFromKernel(RTL8651_LOGMODULE_NEWFLOW);
						
			break;

	}
#if defined(DNI)
	fprintf(f,"\r\n");
	fclose(f);
	return;	
#endif	

#if !defined(DNI)
	if(exit==TRUE)
	{
		fprintf(f,"\r\n");
		fclose(f);
		return;
	}

	if((pRomeCfgParam->logCfgParam[0].module & RTL8651_REMOTELOG_MASK )!=0) 
	{
		sockfd=socket(AF_INET,SOCK_DGRAM,0);
		host=gethostbyname(pRomeCfgParam->mgmtCfgParam[0].logserver);	
		if(host==NULL) {  printf("gethostbyname error\n");  return -1;	} 	
		memset(&address,0,sizeof(address));	address.sin_family=PF_INET;
		address.sin_addr=*((struct in_addr *)host->h_addr); 	
		address.sin_port=htons(514);  //RFC 3164
		ret=connect(sockfd,(struct sockaddr *)&address,sizeof(address));		
		if(ret==-1) {	printf("error\n"); close(sockfd); return -1; }
		sprintf(tempstr,"<%d>",(16+idx)*8+6);		
	}

	if (f == NULL) //Add by Timo Wu
	{
		printf("open /var/mail_content.txt FAILED\n");
		//return;
		//reopen it
		f=fopen("/var/mail_content.txt","a");
		if (f == NULL)
			return;
	}
	
	
	fprintf(f,"\r\n");

	if ( moduleId == RTL8651_LOGMODULE_SYS)
	{
		buf = getCircBufPtrByModuleId(moduleId);
	} else
	{
		circBuff = malloc(sizeof(struct circ_buf)+16000);
		if ( circBuff )
		{
			memset(circBuff, 0, (sizeof(struct circ_buf)+16000));
			if (rtl8651_getLogFromKernel(circBuff, moduleId, (sizeof(struct circ_buf)+16000)) == SUCCESS)
			{
				buf = (struct circ_buf *)circBuff;
			} else
			{
				buf = NULL;
			}
		} else
		{
			buf = NULL;
		}
	}
	
	if (	(buf == -1) ||
		(buf == NULL))
	{
		fclose(f);
		return 0;
	}

	head=buf->head;
	size=buf->size;
	tail=buf->tail;
		
	if(head>tail) tail+=size;

	/*
		determine show message or not according to the "prefix" of each message:
			show message only when this message is not dsid related ('x') or the dsid is same as the dsid(it's "ms") we select now.
	*/
	if((buf->data[head]=='0') || buf->data[head] == 'x')
		show = 1;
	else
		show = 0;
	
	for( i = tail-3; i >=head ; i--)
	{
		idx = i;
		while (idx >= size)
			idx -= size;
		
		if(buf->data[idx] == 0) 
		{
			break;
		}			

		if(buf->data[idx] == 10) 
		{	/* LF: Line Feed, we add new line in html form */
			break;
		}

		if (buf->data[idx] == 13)
		{	/* CR: Carriage Return, we ignore it */ 
			break;
		}	

	}

	if(show == 1)
	{
		char t[2]={0};		
		for(i=idx+1;i<tail;i++)
		{

			t[0]=buf->data[i];
			if(i==idx+1) if(t[0]=='0') continue;
			strcat(tempstr2,t);
		}	
		fprintf(f,"%s",tempstr2);
	}

	if((pRomeCfgParam->logCfgParam[0].module & RTL8651_REMOTELOG_MASK )!=0) 
	{
		strcat(tempstr,tempstr2);	
		write(sockfd,tempstr,strlen(tempstr));
		close(sockfd);
		printf("RemoteLog...\n");					
	}

	fclose(f);	

	if((pRomeCfgParam->logCfgParam[0].module & RTL8651_MAILALERT_MASK )!=0) 
	{
		printf("MailAlert...\n");
		sprintf(tempstr,"/bin/sendmail %s %s %s",pRomeCfgParam->mgmtCfgParam[0].smtpserver,pRomeCfgParam->mgmtCfgParam[0].mailfrom,pRomeCfgParam->mgmtCfgParam[0].rcptto);
		system(tempstr);			
	}

	if (circBuff)
	{
		free(circBuff);
	}
#endif	

}

void pppd_start_dial(int sig)
{
	char idStr[4];
	int identity;
	char tmp[20];
	FILE *f2;
	
	if (upgrading)
		return;		
	
	identity=sig-40;
	sprintf(idStr,"%u",identity);
	fprintf(stderr,"receive signal %d identity %d\n",sig,identity);
	
	if(identity==4) // PPTP
	{	
		char tmp[32];
		rtl8651_setNetMtu("eth0",pRomeCfgParam->pptpCfgParam.mtu);
		sprintf(tmp,"/var/run/pptp.pid");		

		send_signal(tmp,9);
		unlink(tmp);
		unlink("/var/run/pppd0.pid");
		{
			sprintf(tmp,"/bin/pptp %u.%u.%u.%u &"
			,pRomeCfgParam->pptpCfgParam.svAddr[0]
			,pRomeCfgParam->pptpCfgParam.svAddr[1]
			,pRomeCfgParam->pptpCfgParam.svAddr[2]
			,pRomeCfgParam->pptpCfgParam.svAddr[3]);
			system(tmp);
		}

	}
	//added by dvd.chen on 01/16/2006, for bpalogin dial_on_demand
	else if( identity==5 )  //bpalogin
	{
		char tmp[32];
		FILE *fp;

		fp = fopen("/var/run/bpalogin.pid", "r");
		if (fp == NULL) {
			bpa_start();	
		}	
		else {
			fclose(fp);
			sprintf(tmp,"/var/run/bpalogin.pid");
			send_signal(tmp,SIGUSR1);
		}	
	}
	//end of dvd.chen
	else if(identity==6)	/* l2tp */
	{
		char tempStr[32];
		rtl8651_setNetMtu("eth0",pRomeCfgParam->l2tpCfgParam.mtu);
		sprintf(tempStr,"/var/run/l2tpd.pid");		
		send_signal(tempStr,9);
		//do_kill("/var/run/l2tpd.pid");
		unlink(tempStr);
		unlink("/var/run/pppd0.pid");

		sprintf(tempStr,"/bin/l2tpd &");
		system(tempStr);
	}	
	else
	{		
		sprintf(tmp,"/var/run/pppd%u.pid",identity);
		send_signal(tmp,9);
		unlink(tmp);
		{
#ifdef CONFIG_PPP_MPPE_MPPC
			run_pppoe(identity);
#else
			do_exec("/bin/pppd",idStr);
#endif
		}

	}

}


#if defined(CONFIG_RTL865X_INIT_BUTTON)
void call_factory_default(int sig)
{
	if (upgrading)
		return;		
	if (initialing)
		return;			
	printf("%s\n", __FUNCTION__);
	system("ifconfig wlan0 down");	
	sleep(2);
	cfgmgr_factoryDefault(1);
} /* end call_factory_ default */
#endif /* CONFIG_RTL865X_INIT_BUTTON */


uint32 restart_crontb(void)
{
	//urlfilter_tableDriverdel();
	printf("%s\n", __FUNCTION__);
	urlfilter_tableDriverAccess();			
	acl_tableDriverAccess();		
	//remoteMgmt_tableDriverAccess();		
	email_tableDriverAccess();		
	
}
	
#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
#define SIGSUBNETMATCH 90
void clear_http_client_info(void) {
	printf("kktest: Assign default value into http client info.\n");
	copy_httpc_info_to_client(&httpcCfgParamDefault);
}
void ProcessWanLanSubnetMatch(void);
#endif

void ProcessStopWLAN(void) {
        system("/bin/ifconfig wlan0 down");
}

//uint32 wan_pastType = pRomeCfgParam->ifCfgParam[0].connType;
uint32 wan_pastType = 0;  
uint32 g_pastWanType = 0;
void system_Reinit(void)
{
	//sysReinit(wan_pastType);
	sysReinit(g_pastWanType);	
}		

/*   Parameter: wan type before system reinit. 
  *   Need this information to reset "protocol stack-related" configuration. */
void sysReinit(uint32 past_wanType)
{
	int32 ret;
	char	*av[3], *av1[4], argv[2];
	char	pname[] = "/bin/ifconfig";
	char	zero_string[] = "0.0.0.0";

	do_kill("/var/run/checkwan.pid");
	unlink("/var/url.log");	
	/* === Reset CFGMGR === */
	cfgmgr_reinit(FALSE);
	
	/* === Flush arp cache in linux kernel === */
	FILE *fp;
	int sockfd = 0;
	struct arpreq {
		struct sockaddr arp_pa;   /* protocol address */
		struct sockaddr arp_ha;   /* hardware address */
         	int arp_flags;            /* flags */
		struct sockaddr arp_netmask; 
		char arp_dev[16];
	} req;
	struct sockaddr_in *sin;
	struct in_addr ina;
	unsigned char *hw_addr;
	char line[200], ip[100], hwa[100], mask[100], dev[100];
	int num, type, flags;
			
	if ((fp = fopen("/proc/net/arp", "r")) == NULL)
		printf("Open /proc/net/arp error!\n");
	if (fgets(line, sizeof(line), fp) != (char *) NULL) {
		for (; fgets(line, sizeof(line), fp);) {
			num = sscanf(line, "%s 0x%x 0x%x %100s %100s %100s\n", ip, &type, &flags, hwa, mask, dev);
		    	if (num < 4)
				break;
			sockfd = socket(AF_INET, SOCK_DGRAM, 0);
			if (sockfd < 0)
		    		printf("socket() error\n");
			sin = (struct sockaddr_in *) &req.arp_pa;
			memset(&req, 0, sizeof(req));
			sin->sin_family = AF_INET;
			ina.s_addr = inet_addr(ip);
			memcpy(&sin->sin_addr, (char *)&ina, sizeof(struct in_addr));
			strncpy(req.arp_dev, dev, 4);
			req.arp_ha.sa_family = AF_UNSPEC;
			ret = ioctl(sockfd, SIOCDARP, &req);
			if (ret < 0)
				printf("ioctl(arp) not successful, ret: %d\n", ret);
		}
	}

	/* == Remove linux default route == */
	{
		int32 ret;
		int sockfd = 0;
		struct sockaddr_in *dst, *gw, *mask;
		struct rtentry route;

		sockfd = socket(AF_INET, SOCK_DGRAM, 0);
		memset(&route, 0, sizeof(struct rtentry));

		dst = (struct sockaddr_in *)(&(route.rt_dst));
		gw = (struct sockaddr_in *)(&(route.rt_gateway));
		mask = (struct sockaddr_in *)(&(route.rt_genmask));

		/* Make sure we're talking about IP here */
		dst->sin_family = AF_INET;
		gw->sin_family = AF_INET;
		mask->sin_family = AF_INET;

		/* Set up the data for removing the default route */
		dst->sin_addr.s_addr = 0;
		gw->sin_addr.s_addr = 0;
		mask->sin_addr.s_addr = 0;
		route.rt_flags = RTF_UP | RTF_GATEWAY;
		    
		/* Remove the default route */
		ret = ioctl(sockfd, SIOCDELRT, &route);
		if (ret < 0)
			printf("ioctl(route) not successful ret: %d\n", ret);
	}
	// linux kernel setting
	av1[0] = pname;
	av1[1] = "eth0";
	av1[2] = zero_string;
	av1[3] = NULL;
	runProgram(pname, av1);

	av[1] = "eth1";
	runProgram(pname, av1);
	
	av[0] = pname;
	av[1] = "eth0";
	av[2] = "down";
	runProgram(pname,av);

	av[1] = "eth1";
	runProgram(pname,av);

	av[1] = "lo";
	runProgram(pname,av);

	stop_service();
/* wan_stop */
/* kill wan */
	switch(past_wanType) {
		case IFCFGPARAM_CONNTYPE_STATIC:
			break;
		case IFCFGPARAM_CONNTYPE_DHCPC:	
			send_signal("/var/run/udhcpc.pid", SIGUSR2); //send signal to release IP first
			sleep(1);
			do_kill("/var/run/udhcpc.pid");
			eval("killall", "-9", "udhcpc");
			break;
		case IFCFGPARAM_CONNTYPE_TELSTRA:
			//send_signal("/var/run/udhcpc.pid", SIGUSR2); //send signal to release IP first
			//sleep(1);
			//do_kill("/var/run/udhcpc.pid");
			//eval("killall", "bpalogin");  //send signal:TERM to bpalogin task, it will trigger the logout process
			send_signal("/var/run/bpalogin.pid", SIGTERM);  //send signal:TERM to bpalogin task, it will trigger the logout process
			sleep( 3 );
			//eval("killall", "-9", "bpalogin");
			do_kill("/var/run/bpalogin.pid");
			
			//unlink(PPP_LINK_PATH"ppp0");
			unlink("/var/run/link.ppp0");
			unlink("/var/run/bpalogin.pid");

			send_signal("/var/run/udhcpc.pid", SIGUSR2); //send signal to release IP first
			sleep(1);
			do_kill("/var/run/udhcpc.pid");
			
			break;
		case IFCFGPARAM_CONNTYPE_PPPOE:
			{
				int pid = 0;
				FILE *f;
				
				do_kill("/var/run/pppd0.pid");
				eval("killall", "-9", "pppd");
				
				#if 0
				f = fopen("/var/run/pppd0.pid","r");
				if(f != NULL)
				{
					fscanf(f, "%d", &pid);
					kill(pid,SIGKILL);
					fclose(f);			
				}
				#endif
			}
			remove("/var/run/pppd0");
			remove("/var/ppp/chap0");
			remove("/var/ppp/pap0");
			remove("/var/ppp/options0");

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;
		case IFCFGPARAM_CONNTYPE_PPTP:
			do_kill("/var/run/pptp.pid");
			eval("killall", "-9", "pptp");			
			do_kill("/var/run/pppd0.pid");
			eval("killall", "-9", "pppd");			
			remove("/var/run/pptp_redial");
			remove("/var/ppp/chap0");
			remove("/var/ppp/pap0");
			remove("/var/ppp/options0");

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;
		case IFCFGPARAM_CONNTYPE_L2TP:
			do_kill("/var/run/l2tpd.pid");
			eval("killall", "-9", "l2tpd");			
			do_kill("/var/run/pppd0.pid");
			eval("killall", "-9", "pppd");			
			remove("/var/l2tpd.conf");
			remove("/var/l2tpd-pppd.conf");
			remove("/var/ppp/chap0");
			remove("/var/ppp/pap0");
			remove("/var/ppp/options0");

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;
			
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:
			do_kill("/var/run/l2tpd.pid");
			eval("killall", "-9", "l2tpd");			
			do_kill("/var/run/pppd0.pid");
			eval("killall", "-9", "pppd");			
			do_kill("/var/run/udhcpc.pid");
			eval("killall", "-9", "udhcpc");			
			remove("/var/l2tpd.conf");
			remove("/var/l2tpd-pppd.conf");
			remove("/var/ppp/chap0");
			remove("/var/ppp/pap0");
			remove("/var/ppp/options0");

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;
			
			
		default:
			break;
	}

	ret = rtl8651_tblDrvReinit();
	if (ret)
		printf("rtl8651_tblDrvReinit: ret %d\n", ret);

	ret = rtl8651_fwdEngineReinit();
	if (ret)
		printf("rtl8651_fwdEngineReinit: ret %d\n", ret);

	ret = rtl8651_reProbe();
	if (ret)
		printf("rtl8651_reProbe: ret %d\n", ret);

	sysInit();
	
}

void start_CheckWan()
{

	do_kill("/var/run/checkwan.pid");
	sleep(2);
	do_exec("/bin/CheckWan", NULL);
	
	printf("%s Done\n", __FUNCTION__);

}

static char loader_version[20] = {0x0};	
#define LOADER_VER_OFFSET	0x0ff0
#define LOADER_VER_LENGTH	16
#define LOADER_DEFAULT_VERSION	"1.00.06"
uint32 sysInit(void)
{
	FILE *f1;
    	struct sigaction sa;
    	sigset_t mask;
	int i;
	char temp[20];

	printf("System initializing...\n");
	unlink("/var/system.log");
	log_message("System initializing...");
	
	upgrading = 0;
	fflush(0);

	/* ===================================
		0. Init cfgmgr structure
	=================================== */
	if (pRomeCfgParam)
	{
		memset(pRomeCfgParam, 0, sizeof(romeCfgParam_t));
	}
	
	/* read loader version */
 	flashdrv_read((void*)temp,(void*)FLASH_MAP_BOARD_INFO_ADDR+LOADER_VER_OFFSET, LOADER_VER_LENGTH);
 	temp[LOADER_VER_LENGTH] = 0;
 	printf("get loader_version = %s\n", temp);
 	if (strncasecmp(temp, "VER:", 4) != 0) {
 		if (loader_version[0] == '\0') {
 			strcpy(loader_version, LOADER_DEFAULT_VERSION);
 		}	
 	}
	else {
		strcpy(loader_version, temp+4);	
	}
	printf("set loader_version = %s\n", loader_version);
	nvram_set("loader_version", loader_version);	

	/* ===================================
		1. Init cfgmgr modules
	=================================== */

	/* code has removed to websAspInit() in asp_page.c, init cfgmgr before all procedures */
	
	/* ===================================
		2. Init timezone
	=================================== */
	time_init();
	zone_init();
	/* ===================================
		3. Init variables for NAT
	=================================== */
	nat_init();
	/* ===================================
		4. Init signals
	=================================== */
    	sigemptyset(&mask);
    	sigaddset(&mask, 40);
    	sigaddset(&mask, 41);
    	sigaddset(&mask, 42);
    	sigaddset(&mask, 43);

    	sigaddset(&mask, 44); //for pptp
    	sigaddset(&mask, 45); //for l2tp
    	sigaddset(&mask, 46); //for l2tp    	
	#if defined(CONFIG_RTL865X_INIT_BUTTON)
	sigaddset(&mask, 50);
	#endif /* CONFIG_RTL865X_INIT_BUTTON */

	sigaddset(&mask, 61); //for mail alert and remote log:ACL
	sigaddset(&mask, 62); //for mail alert and remote log:DoS
	sigaddset(&mask, 63); //for mail alert and remote log:URL Filter
	sigaddset(&mask, 64); //for mail alert and remote log:NAPT log

#if defined(DNI)	
	sigaddset(&mask, 70); //for stop_wan
	sigaddset(&mask, 71); //for start_wan
	sigaddset(&mask, 72); //for system_reinit
	
	sigaddset(&mask, 80); //ntp ok, restart_crontb	
#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
	sigaddset(&mask, SIGSUBNETMATCH); //Clean http client info.
#endif
#endif	
	sigaddset(&mask, SIGSTOPWLAN); 
	sigaddset(&mask, WLAN_REINIT); 	

	sa.sa_mask = mask;
	sa.sa_flags = 0;
	
	/* kernel will send signal to this pid */
#if 0	
	/* move to top */	
	re865xIoctl("eth0",ADD_SIGNAL_RECEIVE_PROCESS,getpid(),0,0);
#endif	
    	SIGNAL(40, pppd_start_dial);	
    	SIGNAL(41, pppd_start_dial);	
    	SIGNAL(42, pppd_start_dial);	
    	SIGNAL(43, pppd_start_dial);
    	SIGNAL(44, pppd_start_dial);
    	SIGNAL(45, pppd_start_dial); 
    	SIGNAL(46, pppd_start_dial); 
    	

	SIGNAL(61, log_event);   
	SIGNAL(62, log_event);   
	SIGNAL(63, log_event);   
	SIGNAL(64, log_event);   	

	#if defined(CONFIG_RTL865X_INIT_BUTTON)
	SIGNAL(50, call_factory_default);
	#endif /* CONFIG_RTL865X_INIT_BUTTON */

#if defined(DNI)
	SIGNAL(70, stop_wan);   
	SIGNAL(71, start_wan);   
 	SIGNAL(72, system_Reinit);  
 	
 	SIGNAL(80, restart_crontb);  	 
#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
	SIGNAL(SIGSUBNETMATCH, ProcessWanLanSubnetMatch);
#endif
#endif
	SIGNAL(SIGSTOPWLAN, ProcessStopWLAN);
	SIGNAL(WLAN_REINIT, Process_wlan_reinit);	

	/* ===================================
		5. Init variables for VLAN
	=================================== */
	vlan_init();

	/* call cfgmgr to read xxxCfgParam structures from nv-ram
	 * wan interface's init is flat in this sysInit()
	 */
	
	/* ===================================
		6. Init variables for Interface
	=================================== */
	if (cfgmgr_read(CFGMGR_TABID_IF,(void*)pRomeCfgParam->ifCfgParam, sizeof(pRomeCfgParam->ifCfgParam))!=0)
	{
		printf("sysInit: cfgmgr read ifCfgParam fail\n");
		/* take proper actions */
		return 1;
	}
	memcpy((void*)&ramWanCfgParam, &(pRomeCfgParam->ifCfgParam[0]),sizeof(ifCfgParam_t));
	memcpy((void*)&ramLanCfgParam, &(pRomeCfgParam->ifCfgParam[1]),sizeof(ifCfgParam_t));
	

	i=0;
	memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
	memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
	memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
	memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);
	memcpy(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,&i,4);			
	
	

	//KEVIN:05DEC27:BlankState+++
#if defined(DNI)
	SmtWzdCfgParam_init();
#if 0
	{
		int	curWZS= atoi(nvram_get("SmtWzdDone"));
		if( curWZS == 0 ) {
			printf("%s:This is blank state, change wan connect type to dhcp\n",
				__FUNCTION__);
				ramWanCfgParam.connType = IFCFGPARAM_CONNTYPE_DHCPC;
				ramWanCfgParam.ipAddr[0]= 0;
				ramWanCfgParam.ipAddr[1]= 0;
				ramWanCfgParam.ipAddr[2]= 0;
				ramWanCfgParam.ipAddr[3]= 0;
				pRomeCfgParam->ifCfgParam[0].connType = IFCFGPARAM_CONNTYPE_DHCPC;
				pRomeCfgParam->ifCfgParam[0].ipAddr[0]= 0;
				pRomeCfgParam->ifCfgParam[0].ipAddr[1]= 0;
				pRomeCfgParam->ifCfgParam[0].ipAddr[2]= 0;
				pRomeCfgParam->ifCfgParam[0].ipAddr[3]= 0;
		}
	}
#endif	 
#endif	
//KEVIN:BlankState---
#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
	cfgmgr_read(CFGMGR_TABID_WAN_LAN_MATCH_DETECTION,
		(void*)&(pRomeCfgParam->wanlan_ip_mat_det),
		sizeof(wanlan_match_det_t));
#endif
	
	/* ===================================
		7. Init variables for DHCP-Client
	=================================== */
	if (cfgmgr_read(CFGMGR_TABID_DHCPC,(void*)&(pRomeCfgParam->dhcpcCfgParam), sizeof(dhcpcCfgParam_t))!=0)
	{
		printf("sysInit: cfgmgr read dhcpcCfgParam fail\n");
		/* take proper actions */
		return 1;
	}
	
	memcpy((void*)&(ramDhcpcCfgParam),(void*)&(pRomeCfgParam->dhcpcCfgParam),sizeof(dhcpcCfgParam_t));
	
	/* ===================================
		8. Init variables for PPPoE
	=================================== */
	if (cfgmgr_read(CFGMGR_TABID_PPPOE,(void*)pRomeCfgParam->pppoeCfgParam, sizeof(pppoeCfgParam_t)*MAX_PPPOE_SESSION)!=0)
	{
		printf("sysInit: cfgmgr read ppoeCfgParam fail\n");
		/* take proper actions */
		return 1;
	}
	
	/* ===================================
		9. Init PPTP/L2TP services
	=================================== */
	pptp_init();// read pptp configuration
	l2tp_init();	
#if defined(DNI)	
	tel_init();// read telstra configuration
	mnu_init();// read mmenu configuration //Yili 2006/1/10
	httpc_init();
#endif	
	pRomeCfgParam->pptpCfgParam.dialState=PPTPCFGPARAM_DIALSTATE_OFF;	
	pRomeCfgParam->pptpCfgParam.manualHangup = 0;
	pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;	
	pRomeCfgParam->l2tpCfgParam.manualHangup = 0;

	// clear dialState when boot
	for(i=0;i<MAX_PPPOE_SESSION;i++) {
		pRomeCfgParam->pppoeCfgParam[i].dialState=PPPOECFGPARAM_DIALSTATE_OFF;	
		pRomeCfgParam->pppoeCfgParam[i].manualHangup = 0;
	}	
	
	
	memcpy((void*)ramPppoeCfgParam,(void*)pRomeCfgParam->pppoeCfgParam,sizeof(pppoeCfgParam_t)*MAX_PPPOE_SESSION);

	/* ===================================
		10. Init WAN/LAN settings and configurations
	=================================== */
	opMode_init();	// Read the operation mode (Gateway/Router/Bridge) which is configured in FLASH.
	

	//wanlan_init(); //NOTICE: rome driver access is okay after this line

	/* ===================================
		11. Init RomeDriver Services
	=================================== */
	email_init(); //must before log_init 2006/1/12 Timo Wu
	
	log_init();	
	userDb_init();
#if defined(DNI)
	schedule_init(); //Add by Timo Wu, must be init before urlfilter_init
	
#endif		
	/* read from flash, these components are wan-independent */
	urlfilter_init(); // read flash and setTableDriver
	urlfilterTrustedUser_init(); // read flash and setTableDriver
	
	dns_init();
	dos_init();
	alg_init();
	dhcps_init();	

	/* read from flash, these components are wan-dependent */
	specialap_init(); //must before acl_tableDriverAccess()
	gaming_init(); //must before acl_tableDriverAccess()
	acl_init();  //must before acl_tableDriverAccess()
	serverp_init();		
	dmz_init();
	udpblock_init();
	upnp_init();	
	ddns_init();
	routing_init();
	stunnel_init();
	rip_init();
	qos_init();
	pbnat_init();
	rateLimit_init();
	ratioQos_init();
	napt_init();
	pseudoVlan_init();
	passthru_init();
	ipMulticast_init();
	domainBlock_init();
	
	wanlan_init(); //NOTICE: rome driver access is okay after this line


	/* ===================================
		12. Init Wireless LAN

		NOTE:
			(tony: wlan must put here, else other init will have problem.)
	=================================== */
	wlan_init();
	
	

	/* ===================================
		13.	Init configurations and related services
			if WAN-side is the STATIC IP Mode
	=================================== */
	if((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC))
	{
		/* for wan cfg other than STATIC, network interface will be created
		 * after wan ip is assigned, so acl rule can only be created by that
		 * time
		 */
		//time_start();		
		acl_tableDriverAccess();
		remoteMgmt_tableDriverAccess();		
		email_tableDriverAccess(); //Must after urlfilter_init 2005/1/12 Timo Wu
		
		serverp_tableDriverAccess(0);
		dmz_tableDriverAccess(0);
		udp_tableDriverAccess(0);
		
		runDNSProxy();	
		time_start();				
		upnp_start();
		syslogd_start();
		//ddns_start(); //must after dns_init();
		check_updateDDNS();
		ripd_start();					
		
		rtl8651a_setWanStatus(0,TRUE);
		rtl8651a_setDosStatus(0, ((pRomeCfgParam->dosCfgParam[0].enable)?(pRomeCfgParam->dosCfgParam[0].enableItem):0));
		rtl8651a_setAlgStatus(0,pRomeCfgParam->algCfgParam[0].algList,pRomeCfgParam->algCfgParam[0].localIp);
	}

	/* ===================================
		14.	Init DHCP Server
	=================================== */
	//if(pRomeCfgParam->dhcpsCfgParam.enable==1) 
	//	dhcps_start();

	/* ===================================
		15.	Init Remote-management functions
	=================================== */
	remoteMgmt_tableDriverAccess();	
	routing_tableDriveradd();	

	//rip_init();
	start_service();	
	/* ===================================
		16.	Init semaphores
	=================================== */
	rtl8651_sem_init(1);	/* default : no counting semaphore */

	/* clear httpc info */
	if ((pRomeCfgParam->httpclientCfgParam.g_bLogin != 0) || (pRomeCfgParam->httpclientCfgParam.client_ip[0] != '\0')) {
		memcpy((char *)&(pRomeCfgParam->httpclientCfgParam), (char *)&httpcCfgParamDefault, sizeof(pRomeCfgParam->httpclientCfgParam));	
		httpc_cfg_save();
	}	
	
	g_pastWanType = GetCurWanConnType();	
	
	start_CheckWan();
	firewall_starting();		
	setLedLight(TEST_LED, LED_OFF);	
	printf("%s Done\n", __FUNCTION__);	
	return 0;
} /* end sysInit */

void stop_service(void)
{

	eval("killall", "-9", "udhcpd");
	eval("killall", "-9", "upnp");
	eval("killall", "-9", "ripd");		
	eval("killall", "-9", "dnrd");	
	eval("killall", "-9", "crond");
	eval("killall", "-9", "syslogd");
	eval("killall", "-9", "ntpclient");
	eval("killall", "-9", "smtpclient");			
	eval("killall" , "-9", "getdeviceinfo");	

	
}	

void start_service(void)
{
	syslogd_start();	
	dhcps_start();
	runDNSProxy();		
	ripd_start();
	upnp_start();
}
	

/*
 * re865x Ioctl (to call kernel functions including rtl8651 table driver APIs
 */
int re865xIoctl(char *name,uint32 arg0, uint32 arg1, uint32 arg2, uint32 arg3)
{
	uint32 args[4];
	struct ifreq ifr;
	int sockfd;

	args[0] = arg0;
	args[1] = arg1;
	args[2] = arg2;
	args[3] = arg3;

	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		DEBUG_P("fatal error socket\n");
		return -3;
	}
	strcpy((char*)&ifr.ifr_name, name);
	((uint32 *)(&ifr.ifr_data))[0] = (uint32)args;
	if (ioctl(sockfd, SIOCDEVPRIVATE, &ifr)<0)
	{
		perror("device ioctl:");
		close(sockfd);
		return -1;
	}
	close(sockfd);
	return 0;
} /* end re865xIoctl */


void set_mib(int idx, char *fmt, char *args)
{
	char	*av[6];
	char	pname[] = "/bin/busybox";
	char    wlan_name[10];
	char	mib_string[50];

	av[0] = pname;
	av[1] = "iwpriv";
	
	sprintf(wlan_name, "wlan%d", idx);
	av[2] = wlan_name;
	av[3] = "set_mib";
	
	sprintf(mib_string, "%s=%s", fmt, args);	
	av[4] = mib_string;
	av[5] = NULL;
	
	/* /bin/busybox iwpriv wlan0 set_mib ssid=NETGEAR */
	printf("@ WLAN -%d- [%s %s %s %s %s]\n", idx, av[0], av[1], av[2], av[3], av[4]);
	runProgram(pname, av);
}	



/*
		run command with argument
 
*/
int runProgram(char *name,char *argv[])
{
	int status;
	int pid;
	char *env[2];	
	pid =vfork();
	if (pid==0)
	{
		pid=vfork();
		if (pid>0) _exit(0); // second parent; grandparent still alive 
		env[0]="PATH=/bin:/sbin";
		env[1]=NULL;
		execve(name,argv,env);
		_exit(0);
	}
	else {
		waitpid(pid,NULL,0);
		//waitpid(pid, &status, 0);

	}	
			
	return 0;

}
int do_exec(char *name, char *identity)
{
	int pid,pid1;
	
	pid =vfork();
	if (pid==0)
	{
		char *av[3];
		char timezone[20];
		char *env[3];
		char tempStr[20]={0};
		FILE *f;
		f=fopen("/etc/TZ","r");
		if(f!=NULL)
		{
			fgets(tempStr,20,f);
			fclose(f);
		}

		pid1=vfork();
		if (pid1>0) _exit(0); // second parent; grandparent still alive 
		
		env[0]="PATH=/bin:/sbin";
		#if 0	/* should not fix TZ environment variable */
		strcpy(timezone,"TZ=std+00:00:00"); 
		#endif
		snprintf(timezone, strlen(tempStr) + 3, "TZ=%s", tempStr);
		env[1]=timezone;
		env[2]=NULL;
		//memcpy(env[1],tempStr,12);
		av[0]=name;
		av[1]=identity;
		//sprintf(tempStr,"%x",(uint32)pRomeCfgParam);
		av[2]=NULL;
		//av[3]=NULL;
		setsid();
		execve(name,av,env);
		_exit(0);
	}
	else
		waitpid(pid,NULL,0);
		
	//st = WEXITSTATUS(stat);
	return 0;
} /* end do_exec */


int run_pppoe(int session)
{
	char tempStr[256];
	sprintf(tempStr,"/bin/pppd  %u pty '/bin/pppoe -i %u -p /var/run/pppoe%u -I eth0 -T 80 -U -m %u %s %s' user %s &",
		session,session,session
		,pRomeCfgParam->pppoeCfgParam[session].mtu-40
		,(pRomeCfgParam->pppoeCfgParam[session].serviceName[0]==0)?"":"-S"
		,pRomeCfgParam->pppoeCfgParam[session].serviceName
		,pRomeCfgParam->pppoeCfgParam[session].username);

	system(tempStr);
	return 0;
} /* end do_exec */

int do_kill(char *filename)
{
	int pid=0;
	FILE *f;
	f=fopen(filename,"r");
	if(f!=NULL)
	{
		fscanf(f,"%d",&pid);

		kill(pid,SIGTERM);
		kill(pid,SIGQUIT);
		sleep(1);
		kill(pid,SIGKILL);
		fclose(f);
		remove(filename);
		return 0;
	}
	return -1;	
}



#define IFREQ_OFFSETOF(x)  offsetof(struct ifreq, x)
int setInterfaceIp(char *name,int ip, int netmask)
{
	struct ifreq ifr;
	unsigned char Str[20];
	struct sockaddr_in sai;
	unsigned char	*v=(char*)&ip;
	int net_fd;

	if ((net_fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		DEBUG_P("fatal error socket\n");
	}
	strcpy((char*)&ifr.ifr_name, name);
	sprintf(Str,"%u.%u.%u.%u",v[0],v[1],v[2],v[3]);
	sai.sin_family = AF_INET;
	sai.sin_addr.s_addr = INADDR_ANY;
	sai.sin_port = 0;
	if(inet_aton(Str, &sai.sin_addr) == 0) 
	{
		DEBUG_P("not dotted\n");
	}
	memcpy((char*)&ifr+IFREQ_OFFSETOF(ifr_addr),(char*)&sai,
		       sizeof(struct sockaddr));
	if (ioctl(net_fd, SIOCSIFADDR, &ifr) < 0) 
		DEBUG_P("error ioctl\n");

	v=(char*)&netmask;
	sprintf(Str,"%u.%u.%u.%u",v[0],v[1],v[2],v[3]);
	if(inet_aton(Str, &sai.sin_addr) == 0) 
	{
		DEBUG_P("not dotted\n");
	}
	memcpy((char*)&ifr+IFREQ_OFFSETOF(ifr_netmask),(char*)&sai,
		       sizeof(struct sockaddr));
	if (ioctl(net_fd, SIOCSIFNETMASK, &ifr) < 0) 
		DEBUG_P("error2 ioctl\n");


	if (ioctl(net_fd, SIOCGIFFLAGS, &ifr) < 0) 
		DEBUG_P("SIOCGIFFLAGS"); 
	ifr.ifr_flags=IFF_UP|IFF_RUNNING|IFF_MULTICAST;
	if (ioctl(net_fd, SIOCSIFFLAGS, &ifr) < 0) 
		DEBUG_P("SIOCSIFFLAGS"); 
	close(net_fd);
	return 0;
}	
int upInterface(char *name)
{
	struct ifreq ifr;
	//struct sockaddr_in sai;
	int net_fd;
	if ((net_fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		DEBUG_P("fatal error socket\n");
	}
	strcpy((char*)&ifr.ifr_name, name);
	if (ioctl(net_fd, SIOCGIFFLAGS, &ifr) < 0) 
		DEBUG_P("SIOCGIFFLAGS"); 
	ifr.ifr_flags=IFF_UP|IFF_RUNNING|IFF_MULTICAST;
	if (ioctl(net_fd, SIOCSIFFLAGS, &ifr) < 0) 
		DEBUG_P("SIOCSIFFLAGS"); 
	close(net_fd);
	return 0;
}	

uint32 board_checkSubnetOverlapping(ipaddr_t ipAddr, ipaddr_t ipMask)
{
	#define WAN_INTERFACE_NUM  0
	
	int i;
	uint8 gipAddr[4], gnetMask[4];

	printf("=> Check subnet (%u.%u.%u.%u/%u.%u.%u.%u) overlapping .... ", NIPQUAD(ipAddr), NIPQUAD(ipMask));

	gipAddr[0] = (uint8)((uint32)ipAddr >> 24);
	gipAddr[1] = (uint8)(((uint32)ipAddr & 0x00ff0000) >> 16);
	gipAddr[2] = (uint8)(((uint32)ipAddr & 0x0000ff00) >> 8);
	gipAddr[3] = (uint8)(((uint32)ipAddr & 0x000000ff));

	gnetMask[0] = (uint8)((uint32)ipMask >> 24);
	gnetMask[1] = (uint8)(((uint32)ipMask & 0x00ff0000) >> 16);
	gnetMask[2] = (uint8)(((uint32)ipMask & 0x0000ff00) >> 8);
	gnetMask[3] = (uint8)((uint32)ipMask & 0x000000ff);

 
	//for ( i = 0 ; i < MAX_IP_INTERFACE ; i ++ )
	for (i = 0; i < 2; i++)
	{
		int arrIdx, j;
		uint8 bmask;
		if ( i == WAN_INTERFACE_NUM )	/* same as WAN */
			continue;
		if ( pRomeCfgParam->ifCfgParam[i].valid )
		{
			for (arrIdx = 0; arrIdx < 4 ; arrIdx ++)
			{
				for (j = 0 ; j < 8 ; j ++)
				{
					uint8 ip[2], msk[2];

					bmask = 1<<j;	/* bitmask in current Array entry */

					ip[0] = pRomeCfgParam->ifCfgParam[i].ipAddr[arrIdx] & bmask;
					msk[0] = pRomeCfgParam->ifCfgParam[i].ipMask[arrIdx] & bmask;
					ip[1] = gipAddr[arrIdx] & bmask;
					msk[1] = gnetMask[arrIdx] & bmask;

					if (msk[0] && msk[1] && (ip[0] != ip[1]))
					{
						goto check_next;	/* Subnet is different ! : legal subnet */
					}
				}
			}
			printf("=> confilct with (%u.%u.%u.%u/%u.%u.%u.%u)  "	, pRomeCfgParam->ifCfgParam[i].ipAddr[0]
																, pRomeCfgParam->ifCfgParam[i].ipAddr[1]
																, pRomeCfgParam->ifCfgParam[i].ipAddr[2]
																, pRomeCfgParam->ifCfgParam[i].ipAddr[3]
																, pRomeCfgParam->ifCfgParam[i].ipMask[0]
																, pRomeCfgParam->ifCfgParam[i].ipMask[1]
																, pRomeCfgParam->ifCfgParam[i].ipMask[2]
																, pRomeCfgParam->ifCfgParam[i].ipMask[3]
																);
			/* subset overlap ! : subnet is illegal ! */
			printf("OverLap! FAIL!\n");
			return 1;	/* overlap found */
		}
check_next:
		continue;
	}
	printf("No Overlap!\n");
	return 0; /* no overlap */
}

void dhcpcDeconfig()
{
	printf("dhcpc client deconfig\n");
	log_message("WAN DisConnected");	
	pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;	
	board_ipDownEventTableDriverAccess();
	setInterfaceIp("eth0",0,0);
}

/*
	DHCP Client RENEW
*/
int dhcpcIPRenew()
{
	int restartDHCP;
	char *lease;
	unsigned int 	ipAddr=0;	

	restartDHCP = FALSE;

#if defined(DNI)
	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC) {
		setLedLight(1/*WAN_LED*/, 0/*LED_GREEN*/);
		//log_message("WAN Connected");	
	}	
	if (getenv("ip"))
	{
		printf("ip  %s\n",getenv("ip"));
		ipAddr=inet_addr(getenv("ip"));
		if (*((uint32 *)&(pRomeCfgParam->ifCfgParam[0].ipAddr)) != ipAddr) {
			printf("dhcpcIPRenew dhcpcIPBound\n");
			dhcpcIPBound();
			return 1;
		}		
	}		
	
#endif	
	/* DNS Server */
	{
		FILE *fp;
		char *dns_environment_str,*dns_token;
		int i, dns_idx;
		ipaddr_t ramDNSAddr[2] = {0};
		ipaddr_t oldDNSAddr[2] = {0};

	     /* check autodns */
	     if (pRomeCfgParam->dnsCfgParam.enable == 0) {	
		fp = fopen("/var/resolv.conf","w+");
		dns_environment_str = getenv("dns");
		dns_token = malloc(MAX_IP_STRING_LEN);
		dns_idx = 0;
		if (dns_environment_str)
		while(*(char*)dns_environment_str)
		{
			i = 0;
			while (*(char*)dns_environment_str )
			{
				dns_token[i] = *(char*)dns_environment_str;
				i ++;
				dns_environment_str ++;
				if (*(char*)dns_environment_str == ' ')
				{
					dns_environment_str ++;
					break;
				}
			}
			dns_token[i]='\0';
			if (dns_idx>=2)
				break;
			ramDNSAddr[dns_idx++] = inet_addr(dns_token);
			fprintf(fp,"nameserver %s\n",dns_token);
		}
		fclose(fp);

		oldDNSAddr[0] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]) << 24) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]) << 16) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]) << 8) +
						(uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

		oldDNSAddr[1] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]) << 24) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]) << 16) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]) << 8) +
						(uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);


		if (((oldDNSAddr[0] == ramDNSAddr[0]) && (oldDNSAddr[1] == ramDNSAddr[1])) ||
			((oldDNSAddr[1] == ramDNSAddr[0]) && (oldDNSAddr[0] == ramDNSAddr[1])))
		{	/* DNS server is not be changed */
		} else
		{	/* DNS server is changed */
			if (ramDNSAddr[0])
				memcpy((void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,(void*)&ramDNSAddr[0],sizeof(int));
			else
				memset((void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr, 0, sizeof(ipaddr_t));
			if (ramDNSAddr[1])
				memcpy((void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,(void*)&ramDNSAddr[1],sizeof(int));
			else
				memset((void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr, 0, sizeof(ipaddr_t));

			if (pRomeCfgParam->dhcpsCfgParam.realDNSenable == 1)
			{
				restartDHCP = TRUE;
			}

			/* restart DNS proxy */
			runDNSProxy();
		}
	      }	
	}
#if defined(DNI)	
	/* lease */	
	lease = getenv("lease");
	printf("lease = %s\n", lease);
	if (lease) {
		pRomeCfgParam->dhcpcCfgParam.lease = atoi(lease);
		pRomeCfgParam->dhcpcCfgParam.lease_expired = pRomeCfgParam->dhcpcCfgParam.lease + GetSysUpTime();
	}	
#endif	
	/* WINS Server */
	if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
	{
		int i, wins_idx;
		char	*wins_environment_str, *wins_token;
		ipaddr_t ramWinsAddr[2] = {0};

		memset(ramWinsAddr, 0, sizeof(ramWinsAddr));

		wins_environment_str = getenv("wins");
		wins_token = malloc(MAX_IP_STRING_LEN);
		wins_idx = 0;
		if (wins_environment_str)
		{
			while(*(char*)wins_environment_str)
			{
				i = 0;
				wins_token[0] = '\0';
				while (*(char*)wins_environment_str)
				{
					wins_token[i] = *(char*)wins_environment_str;
					i ++;
					wins_environment_str ++;
					if (*(char*)wins_environment_str == ' ')
					{
						wins_environment_str ++;
						break;
					}
				}

				wins_token[i] = '\0';
				if (wins_idx >= 2)
					break;
				ramWinsAddr[wins_idx++] = inet_addr(wins_token);
			}
		}
		free(wins_token);
		/* check if wins server is changed or not */
		{
			if (((ramWinsAddr[0] == pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr) &&
				(ramWinsAddr[1] == pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)) ||
				((ramWinsAddr[0] == pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr) &&
				(ramWinsAddr[1] == pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)))
			{	/* wins server is not be changed */
			} else
			{	/* wins server is changed */
				restartDHCP = TRUE;
				pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = ramWinsAddr[0];
				pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = ramWinsAddr[1];
			}
		}
	}
	
	/* domain  */
	if (pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd == 1)
	{
		char	*domain_environment_str;
		char domain[128];
		int minstr;

		memset(domain, 0, sizeof(domain));
		domain_environment_str = getenv("domain");
		if (domain_environment_str)
		{
			strncpy(domain, domain_environment_str, sizeof(domain));
		}
		minstr = (sizeof(pRomeCfgParam->dhcpsCfgParam.domain) > sizeof(domain))?(sizeof(domain)):(sizeof(pRomeCfgParam->dhcpsCfgParam.domain));

		if (strncmp(pRomeCfgParam->dhcpsCfgParam.domain, domain, minstr))
		{	/* domain is changed */
			memset(pRomeCfgParam->dhcpsCfgParam.domain, 0 , sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
			strncpy(pRomeCfgParam->dhcpsCfgParam.domain, domain, sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
			if (pRomeCfgParam->dhcpsCfgParam.lan_domain[0] == '\0')
				restartDHCP = TRUE;			
		}
	}

	if (restartDHCP == TRUE)
	{
		dhcps_start();
	}

	return 0;
}

#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
int Poped_Msg_Subnet_match;
void Set_Flag_WAN_LAN_MATCH_DET(int flag) {
	char FlagStr[6] = {0,0,0,0,0,0};
	sprintf(FlagStr,"%i",flag);
	if( nvram_set("WL_ip_match",FlagStr) ) {
		Poped_Msg_Subnet_match=1;
		cfgmgr_write(CFGMGR_TABID_WAN_LAN_MATCH_DETECTION, 
			(void *)&(pRomeCfgParam->wanlan_ip_mat_det),
			sizeof(pRomeCfgParam->wanlan_ip_mat_det));
		cfgmgr_task();
	}
}

uint GetCurWanConnType(void);
void Reset_LAN(void)
{
	unsigned long Lan_ip;
	uint32	PhyCtl;
	//int cur_connType;

	//Retrive Current WAN mode.
	//cur_connType = GetCurWanConnType();	

	//Cut Physical link.
	//re865xIoctl("eth1", DNI_IOCTL_TRUN_OFF_LAN, &PhyCtl,0,0);		
	
	//Select one of IP address for LAN.
	{
		ifCfgParam_t *pifCfgParam = &(pRomeCfgParam->ifCfgParam[1]);
		int32 result;
		switch(pRomeCfgParam->ifCfgParam[1].ipAddr[0]) {
			case 10:
				pifCfgParam->ipAddr[0] = 172;
				pifCfgParam->ipAddr[1] = 16;
				pifCfgParam->ipAddr[2] = 0;
				pifCfgParam->ipAddr[3] = 1;				
				break;
			case 172:
				pifCfgParam->ipAddr[0] = 192;
				pifCfgParam->ipAddr[1] = 168;
				pifCfgParam->ipAddr[2] = 1;
				pifCfgParam->ipAddr[3] = 1;				
				break;
			case 192:
				pifCfgParam->ipAddr[0] = 10;
				pifCfgParam->ipAddr[1] = 0;
				pifCfgParam->ipAddr[2] = 0;
				pifCfgParam->ipAddr[3] = 1;				
				break;
			default:
				pifCfgParam->ipAddr[0] = 192;
				pifCfgParam->ipAddr[1] = 168;
				pifCfgParam->ipAddr[2] = 1;
				pifCfgParam->ipAddr[3] = 1;				
				break;
		}
		pifCfgParam->ipMask[0] = 255;
		pifCfgParam->ipMask[1] = 255;
		pifCfgParam->ipMask[2] = 255;
		pifCfgParam->ipMask[3] = 0;						
		/* reset dhcp server pool begin 2 and end 254 */
		pRomeCfgParam->dhcpsCfgParam.startIp = 2;
		pRomeCfgParam->dhcpsCfgParam.endIp = 254;			
		result = cfgmgr_write(CFGMGR_TABID_IF,(void*)pRomeCfgParam->ifCfgParam,sizeof(ifCfgParam_t)*MAX_IP_INTERFACE);
		cfgmgr_write(CFGMGR_TABID_DHCPS,(void*)&(pRomeCfgParam->dhcpsCfgParam), sizeof(pRomeCfgParam->dhcpsCfgParam));
		adjust_related_LAN_IP();		
		cfgmgr_task();
	}
	
	
}

//int clr_http_client(void);
void ProcessWanLanSubnetMatch(void) {
	int cur_connType, i;

	//Retrive Current WAN mode.
	cur_connType = GetCurWanConnType();	


	printf("Detected WAN-LAN subnet match!!\n");

	//Default to http client info.
	{
		memcpy((void*)&(pRomeCfgParam->httpclientCfgParam),
			httpcCfgParamDefault,
			sizeof(http_client_ifno_t));
		httpc_cfg_save();
	}

	Reset_LAN();
	Set_Flag_WAN_LAN_MATCH_DET(1);

	//Power Down phy, then turn on whne call f#httpc_init
	for(i=1;i<5;i++) {
		rtl8651_setEthernetPortPowerDown(i,1);
	}
	sleep(3);

	//Re-initial system.
	sysReinit(cur_connType);
	//kill(1,SIGQUIT);

}

#endif

int dhcpcIPBound()
{
	FILE *fp;
	int i,dns_idx, wins_idx;
	char	*dns_environment_str,*dns_token,*router_string, *wins_environment_str, *wins_token, *domain_environment_str;
	int 	ipAddr=0,netMask=0,gwAddr=0;
	int ramDNSAddr[2] = {0};
	ipaddr_t ramWinsAddr[2] = {0};
	char *args[6];
	int restartDHCP;
	char *lease;

#if defined(DNI)
	/* if is telstra then need wait bpalogin ok */
	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC) {
		setLedLight(1/*WAN_LED*/, 0/*LED_GREEN*/);
		log_message("WAN Connected");
	}	
#endif	
	/* get ip and subnet first: to check the correctness of then */
	if (getenv("ip"))
	{
		printf("ip  %s\n",getenv("ip"));
		ipAddr=inet_addr(getenv("ip"));
	}
	if (getenv("subnet"))
	{
		printf("subnet %s\n",getenv("subnet"));
		netMask=inet_addr(getenv("subnet"));
	}
	/*************************************************************************************************/
	/******************************** Check the correctness of IP and Subnet ********************************/
	if (board_checkSubnetOverlapping(ipAddr, netMask) > 0)
		goto errout;
 	/*************************************************************************************************/

	/* Check OK: init variables and call ip-down */
	restartDHCP = FALSE;

	board_ipDownEventTableDriverAccess();
	
#if 0	
#if defined(DNI)
	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC) {
		setLedLight(1/*WAN_LED*/, 0/*LED_GREEN*/);
		log_message("WAN Connected");	
	}	
#endif		
#endif

	/* IP and Subnet is legal: set Interface IP */
	setInterfaceIp("eth0",ipAddr, netMask);

	/* get and set default gateway's information */
	if (getenv("router"))
	{
		printf("router %s\n",getenv("router"));
		gwAddr=inet_addr(getenv("router"));
	}
	args[0]="default";
	args[1]="gw";
	router_string=malloc(MAX_IP_STRING_LEN);
	sprintf(router_string,"%u.%u.%u.%u",(gwAddr>>24)&0xff,
					(gwAddr>>16)&0xff,
					(gwAddr>>8)&0xff,
					(gwAddr)&0xff);
	args[2]=router_string;
	args[3]=NULL;
	INET_setroute(RTACTION_ADD, 0, args);
	free(router_string);

	/* save them to gateway's setting */
	memcpy((void*)&pRomeCfgParam->ifCfgParam[0].ipAddr,(void*)&ipAddr,sizeof(ipAddr));
	memcpy((void*)&pRomeCfgParam->ifCfgParam[0].gwAddr,(void*)&gwAddr,sizeof(gwAddr));
	memcpy((void*)&pRomeCfgParam->ifCfgParam[0].ipMask,(void*)&netMask,sizeof(netMask));

      if (pRomeCfgParam->dnsCfgParam.enable == 0) {
	/* get DNS informations */
	fp = fopen("/var/resolv.conf","w+");
	dns_environment_str=getenv("dns");
	dns_token=malloc(MAX_IP_STRING_LEN);
	dns_idx=0;
	if (dns_environment_str)
	while(*(char*)dns_environment_str)
	{
		i=0;
		while (*(char*)dns_environment_str )
		{
			dns_token[i]=*(char*)dns_environment_str;
			i++;
			dns_environment_str++;
			if (*(char*)dns_environment_str==' ')
			{
				dns_environment_str++;
				break;
			}
		}
		
		dns_token[i]='\0';
		if (dns_idx>=2)
			break;
		ramDNSAddr[dns_idx++]=inet_addr(dns_token);
		fprintf(fp,"nameserver %s\n",dns_token);
	}
	free(dns_token);
	fprintf(fp,"\n");
	fclose(fp);

	{
		ipaddr_t oldDNSAddr[2] = {0};
		
		oldDNSAddr[0] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]) << 24) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]) << 16) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]) << 8) +
						(uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

		oldDNSAddr[1] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]) << 24) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]) << 16) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]) << 8) +
						(uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);


		if (((oldDNSAddr[0] == ramDNSAddr[0]) && (oldDNSAddr[1] == ramDNSAddr[1])) ||
			((oldDNSAddr[1] == ramDNSAddr[0]) && (oldDNSAddr[0] == ramDNSAddr[1])))
		{	/* DNS server is not be changed */
		} else
		{	/* DNS server is changed */
			if (ramDNSAddr[0])
				memcpy((void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,(void*)&ramDNSAddr[0],sizeof(int));
			else
				memset((void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr, 0, sizeof(ipaddr_t));
			if (ramDNSAddr[1])
				memcpy((void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,(void*)&ramDNSAddr[1],sizeof(int));
			else
				memset((void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr, 0, sizeof(ipaddr_t));

			if (pRomeCfgParam->dhcpsCfgParam.realDNSenable == 1)
			{
				restartDHCP = TRUE;
			}

			/* restart DNS proxy */
			runDNSProxy();
		}
	      	
	}
      }		/* if (pRomeCfgParam->dnsCfgParam.enable) */
#if defined(DNI)	
	/* lease */	
	lease = getenv("lease");
	printf("lease = %s\n", lease);
	if (lease) {
		pRomeCfgParam->dhcpcCfgParam.lease = atoi(lease);
		pRomeCfgParam->dhcpcCfgParam.lease_expired = pRomeCfgParam->dhcpcCfgParam.lease + GetSysUpTime();
	}	
#endif
	
#if 0	
	printf("domain = %s\n", getenv("domain"));
	printf("pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd = %d\n", pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd);	
#endif

	/* domain */
	if (pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd == 1)
	{
		domain_environment_str = getenv("domain");
		if (domain_environment_str)
		{
			memset(pRomeCfgParam->dhcpsCfgParam.domain, 0 , sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
			strncpy(pRomeCfgParam->dhcpsCfgParam.domain, domain_environment_str, sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
			if (pRomeCfgParam->dhcpsCfgParam.lan_domain[0] == '\0') {
				restartDHCP = TRUE;
			}	
		}
	}

	/* wins server */
	if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
	{
		memset(ramWinsAddr, 0, sizeof(ramWinsAddr));

		wins_environment_str = getenv("wins");
		wins_token = malloc(MAX_IP_STRING_LEN);
		wins_idx = 0;
		if (wins_environment_str)
		{
			while(*(char*)wins_environment_str)
			{
				i = 0;
				wins_token[0] = '\0';
				while (*(char*)wins_environment_str)
				{
					wins_token[i] = *(char*)wins_environment_str;
					i ++;
					wins_environment_str ++;
					if (*(char*)wins_environment_str == ' ')
					{
						wins_environment_str ++;
						break;
					}
				}

				wins_token[i] = '\0';
				if (wins_idx >= 2)
					break;
				ramWinsAddr[wins_idx++] = inet_addr(wins_token);
			}
		}
		free(wins_token);
		pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = ramWinsAddr[0];
		pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = ramWinsAddr[1];
		restartDHCP = TRUE;
	}

	if (restartDHCP == TRUE)
	{
		dhcps_start();
	}
	
	board_ipUpEventTableDriverAccess();

	return 0;

errout:
#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
		kill(1,SIGSUBNETMATCH);
#else
	udhcpc_renew();	
#endif
	return 0;
} /* end dhcpIpBound */

/* member to Port number*/
uint32 memberToPortNum(uint32 portmask)
{
	uint32  i;
	for (i=0;i<10;i++)
	{
		if (portmask==1)
			return i;
		portmask = portmask >>1;
	}
	return 0;
}




/* 
 * set add route for linux kernel function
 */
static int INET_resolve(char *name, struct sockaddr *sa)
{
	struct sockaddr_in *s_in = (struct sockaddr_in *)sa;

	s_in->sin_family = AF_INET;
	s_in->sin_port = 0;

	/* Default is special, meaning 0.0.0.0. */
	if (strcmp(name, "default")==0) {
		s_in->sin_addr.s_addr = INADDR_ANY;
		return 1;
	}
	/* Look to see if it's a dotted quad. */
	if (inet_aton(name, &s_in->sin_addr)) {
		return 0;
	}
	/* guess not.. */
	return -1;
}

#define HAVE_NEW_ADDRT	1
int INET_setroute(int action, int options, char **args)
{
	struct rtentry rt;
	char target[64], gateway[64] = "NONE", netmask[64] = "default";
	int xflag, isnet;
	int skfd;

	xflag = 0;

	if (strcmp(*args, "-net")==0) {
		xflag = 1;
		args++;
	} else if (strcmp(*args, "-host")==0) {
		xflag = 2;
		args++;
	}
	strncpy(target, *args++, (sizeof target));
	//fprintf(stderr,"target %s\n",target);
	/* Clean out the RTREQ structure. */
	memset((char *) &rt, 0, sizeof(struct rtentry));


	if ((isnet = INET_resolve(target, &rt.rt_dst)) < 0) {
		printf("can't resolve %s", target);
		return -1;   /* XXX change to E_something */
	}

	switch (xflag) {
		case 1:
			isnet = 1;
			break;

		case 2:
			isnet = 0;
			break;

		default:
			break;
	}

	/* Fill in the other fields. */
	rt.rt_flags = (RTF_UP | RTF_HOST);
	if (isnet)
		rt.rt_flags &= ~RTF_HOST;

	while (*args) {
		if (strcmp(*args, "metric")==0) {
			int metric;

			args++;
			metric = atoi(*args);
#if HAVE_NEW_ADDRT
			rt.rt_metric = metric + 1;
#else
			ENOSUPP("inet_setroute", "NEW_ADDRT (metric)");  /* XXX Fixme */
#endif
			args++;
			continue;
		}

		if (strcmp(*args, "netmask")==0) {
			struct sockaddr mask;

			args++;
			strncpy(netmask, *args, (sizeof netmask));
			if ((isnet = INET_resolve(netmask, &mask)) < 0) {
				error_msg(_("can't resolve netmask %s"), netmask);
				return E_LOOKUP;
			}
			rt.rt_genmask = full_mask(mask);
			args++;
			continue;
		}

		if (strcmp(*args, "gw")==0 || strcmp(*args, "gateway")==0) {
			args++;
			strncpy(gateway, *args, (sizeof gateway));
			if ((isnet = INET_resolve(gateway, &rt.rt_gateway)) < 0) {
				error_msg(_("can't resolve gw %s"), gateway);
				return E_LOOKUP;
			}
			if (isnet) {
				error_msg(
					_("%s: cannot use a NETWORK as gateway!"),
					gateway);
				return E_OPTERR;
			}
			rt.rt_flags |= RTF_GATEWAY;
			args++;
			continue;
		}

		if (strcmp(*args, "mss")==0) {
			args++;
			rt.rt_flags |= RTF_MSS;
			rt.rt_mss = atoi(*args);
			args++;
			if (rt.rt_mss < 64 || rt.rt_mss > 32768) {
				error_msg(_("Invalid MSS."));
				return E_OPTERR;
			}
			continue;
		}

		if (strcmp(*args, "window")==0) {
			args++;
			rt.rt_flags |= RTF_WINDOW;
			rt.rt_window = atoi(*args);
			args++;
			if (rt.rt_window < 128) {
				error_msg(_("Invalid window."));
				return E_OPTERR;
			}
			continue;
		}

		if (strcmp(*args, "irtt")==0) {
			args++;
			args++;
#if HAVE_RTF_IRTT
			rt.rt_flags |= RTF_IRTT;
			rt.rt_irtt = atoi(*(args - 1));
			rt.rt_irtt *= (HZ / 100);       /* FIXME */
#if 0                           /* FIXME: do we need to check anything of this? */
			if (rt.rt_irtt < 1 || rt.rt_irtt > (120 * HZ)) {
				error_msg(_("Invalid initial rtt."));
				return E_OPTERR;
			}
#endif
#else
			ENOSUPP("inet_setroute", "RTF_IRTT"); /* XXX Fixme */
#endif
			continue;
		}

		if (strcmp(*args, "reject")==0) {
			args++;
#if HAVE_RTF_REJECT
			rt.rt_flags |= RTF_REJECT;
#else
			ENOSUPP("inet_setroute", "RTF_REJECT"); /* XXX Fixme */
#endif
			continue;
		}
		if (strcmp(*args, "mod")==0) {
			args++;
			rt.rt_flags |= RTF_MODIFIED;
			continue;
		}
		if (strcmp(*args, "dyn")==0) {
			args++;
			rt.rt_flags |= RTF_DYNAMIC;
			continue;
		}
		if (strcmp(*args, "reinstate")==0) {
			args++;
			rt.rt_flags |= RTF_REINSTATE;
			continue;
		}
		if (strcmp(*args, "device")==0 || strcmp(*args, "dev")==0) {
			args++;
			rt.rt_dev = *args++;
			continue;
		}
		/* nothing matches */
		if (!rt.rt_dev) {
			rt.rt_dev = *args++;
		} else {
		}
	}

#if HAVE_RTF_REJECT
	if ((rt.rt_flags & RTF_REJECT) && !rt.rt_dev)
		rt.rt_dev = "lo";
#endif

	/* sanity checks.. */
	if (mask_in_addr(rt)) {
		unsigned long mask = mask_in_addr(rt);
		mask = ~ntohl(mask);
		if ((rt.rt_flags & RTF_HOST) && mask != 0xffffffff) {
			error_msg(
				_("netmask %.8x doesn't make sense with host route"),
				(unsigned int)mask);
			return E_OPTERR;
		}
		if (mask & (mask + 1)) {
			error_msg(_("bogus netmask %s"), netmask);
			return E_OPTERR;
		}
		mask = ((struct sockaddr_in *) &rt.rt_dst)->sin_addr.s_addr;
		if (mask & ~mask_in_addr(rt)) {
			error_msg(_("netmask doesn't match route address"));
			return E_OPTERR;
		}
	}
	/* Fill out netmask if still unset */
	if ((action == RTACTION_ADD) && rt.rt_flags & RTF_HOST)
		mask_in_addr(rt) = 0xffffffff;

	/* Create a socket to the INET kernel. */
	if ((skfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror("socket");
		return E_SOCK;
	}
	/* Tell the kernel to accept this route. */
	if (action == RTACTION_DEL) {
		if (ioctl(skfd, SIOCDELRT, &rt) < 0) {
			perror("SIOCDELRT");
			close(skfd);
			return E_SOCK;
		}
	} else {
		if (ioctl(skfd, SIOCADDRT, &rt) < 0) {
			perror("SIOCADDRT");
			close(skfd);
			return E_SOCK;
		}
	}

	/* Close the socket. */
	(void) close(skfd);
	return SUCCESS;
}




void board_ipUp_dhcp(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		int32  ret;
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);
		memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);

		if (*myIp == *myGw) {	/* This is a special application. Both wan ip and default gateway ip is the same. */
			ret = rtl8651_addIpIntf("eth0", (ipaddr_t)*myIp, 0);
			if (ret)
			{
				printf("rtl8651_addIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);				
			}
		}
		else {
			ret = rtl8651_addIpIntf("eth0",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask);
			if (ret)
			{
				printf("rtl8651_addIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);
			}
		}

		/* set default gateway ip */
		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",(ipaddr_t)*myGw);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
			fprintf(fp,"rtl8651_addRoute(default): ret %d\n",ret);
		}
	
		/* how to determine who is napt? who is nat? */
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_addNaptMapping: ret %d\n",ret);
		}	

		if(nvram_match("wan_proto", "telstra")) {
			sleep(2);
			if (pRomeCfgParam->telCfgParam.auto_connect) {		
				if (pRomeCfgParam->telCfgParam.demand)
					AddDemandRoute(5, 1);
				else {
					pRomeCfgParam->telCfgParam.demand = 1;						
					bpa_start();
				}	
			}
		}
		
#if 0		
		/////added by dvd.chen for bpalogin
		if(nvram_match("wan_proto", "telstra"))
		//if(1)  //for test
		{
			int i=0;
			FILE *fp;
			if( !(fp=fopen("/var/run/bpalogin.pid", "r")) )
			{
				char sig[5];

				//added by dvd.chen on 08/31/2004
				//to reset g_hearbeat_is_listening to 0
				sprintf(sig, "-%d", SIGUSR2);
    				eval("killall",sig,"CheckWan");  //signal CheckWan task that now is NOT listening lan interface
    				//end of dvd.chen
#if 0
				/* Delete all default routes */
		        	while (route_del(wan_ifname, 0, NULL, NULL, NULL) == 0 || i++ < 10);
		
				/* Set default route to gateway if specified */
		        	route_add(wan_ifname, 0, "0.0.0.0", nvram_safe_get("wan0_gateway"), "0.0.0.0");

		        	/* save dns to resolv.conf */
				//dns_to_resolv();  
				add_ns(wan_ifname);	//dvd.chen
#endif			
				printf("calling hb_start\n");
				//start_heartbeat(BOOT);
				//start_heartbeat();
				{
					int pid;
					char *argv[] = {
						"hb_start",
						NULL
					};
					_eval( argv, NULL, 0, &pid );
					return;
				}

			}
			else
			{
				fclose(fp);
#if 0
				wan_up(wan_ifname);
#endif
			}

		}
#if 0
		else
		{
			wan_up(wan_ifname);
		}
#endif
		/////end of dvd.chen
#endif		

}

int ppp_mtu = 1492;

void board_ipUp_pppoe(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		int32  ret;
		uint16 mySessionId;
		ether_addr_t myMac;
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);
		memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);
		memcpy((void*)&myMac,pRomeCfgParam->pppoeCfgParam[0].svrMac,6);

		mySessionId = (uint16)pRomeCfgParam->pppoeCfgParam[0].sessionId;
		pRomeCfgParam->pppoeCfgParam[0].manualHangup=0; /* clear manual hangup flag */
		
		rtl8651_flushDemandRoute(0);
		ret=rtl8651_setPppoeSessionProperty((uint32)0,(uint16)mySessionId,(ether_addr_t*)&myMac,memberToPortNum(pRomeCfgParam->vlanCfgParam[0].memberPort));
		if (ret)
		{
			printf("rtl8651_setPppoeSessionProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_setPppoeSessionProperty: ret %d\n",ret);
		}

		ret=rtl8651_addIpIntf("eth0",(ipaddr_t)*myIp,(ipaddr_t)0xffffffff);
		if (ret)
		{
			printf("rtl8651_addIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);
		}

		ret=rtl8651_bindPppoeSession((ipaddr_t)*myIp,0); /* single pppoe always uses pppObjId=0 */
		if (ret)
		{
			printf("rtl8651_bindPppoeSession: ret %d\n",ret);
			fprintf(fp,"rtl8651_bindPppoeSession: ret %d\n",ret);
		}

		/* how to determine who is napt? who is nat? */
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_addNaptMapping: ret %d\n",ret);
		}

		/* set time out option */
		if (pRomeCfgParam->pppoeCfgParam[0].silentTimeout>0)
		{
			uint32 sec = pRomeCfgParam->pppoeCfgParam[0].silentTimeout;
			ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,TRUE,sec);
			if (ret)
			{
				printf("rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
				fprintf(fp,"rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
			}
		}
		
		/* sync what i have got back to romeCfgParam
		 * for single pppoe, the assigned ip/ipMask/gw/dns is saved in ifCfgParam[0].ipAddr/ipMask/gwAddr/dnsAddr
		 */
		pRomeCfgParam->pppoeCfgParam[0].dialState = PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS;

		//rtl8651_setPppoeMtu(0,pRomeCfgParam->pppoeCfgParam[0].mtu);
		/* if self mtu < peer+mtu then select peer_mru */		
		if ((ppp_mtu > 0) && (pRomeCfgParam->pppoeCfgParam[0].mtu > ppp_mtu)) {
			pRomeCfgParam->pppoeCfgParam[0].mtu = ppp_mtu;
		}	
		rtl8651_setNetMtu("eth0", pRomeCfgParam->pppoeCfgParam[0].mtu);


}


void board_ipUp_pptp(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		char *argv[8];
		uint32 def_gw_ipAddr = 0;
		unsigned char  macStr[17];
		int32  ret;

		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[0]) << 24;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[1]) << 16;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[2]) << 8;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[3]);

		pRomeCfgParam->pptpCfgParam.dialState=PPTPCFGPARAM_DIALSTATE_DIALED_SUCCESS;		
		pRomeCfgParam->pptpCfgParam.manualHangup=0; /* clear manual hangup flag */
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);
		memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);		

		/* ===================================== */
		if (def_gw_ipAddr != 0) {
			argv[0]="default";
			
			sprintf(macStr, "%u.%u.%u.%u",
				pRomeCfgParam->pptpCfgParam.gwAddr[0],
				pRomeCfgParam->pptpCfgParam.gwAddr[1],
				pRomeCfgParam->pptpCfgParam.gwAddr[2],
				pRomeCfgParam->pptpCfgParam.gwAddr[3]);
			argv[1]="gw";
			argv[2]=(char*)&macStr;
			argv[3]=NULL;
			INET_setroute(RTACTION_DEL, 0, argv);
		}
		/* ===================================== */



		rtl8651_flushDemandRoute(4); //for pptp
		
		ret=rtl8651_addIpIntf("eth0",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask);
		//fprintf(fp,"rtl8651_addIpIntf: ip=%x mask=%x\n",myIp,myIpMask);
		if (ret)
		{
			printf("rtl8651_addIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);
		}

		ret = rtl8651_setPptpProperty(1, 0, 0, *(uint32*)(&(pRomeCfgParam->pptpCfgParam.svAddr)), *(uint32*)(&(pRomeCfgParam->pptpCfgParam.gwAddr)));
		if (ret)
		{
			printf("rtl8651_setPptpProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_setPptpProperty: ret %d\n",ret);
		}
		
		ret=rtl8651_bindSession(*myIp, 1); // use myIp to separate sessions.
		if (ret)
		{
			printf("rtl8651_bindSession: ret %d\n",ret);
			fprintf(fp,"rtl8651_bindSession: ret %d\n",ret);
		}
	
		// ret=rtl8651_addNaptMapping((ipaddr_t)myIp);
				
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
			fprintf(fp,"rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
		}
		
		/* set time out option */
		if (pRomeCfgParam->pptpCfgParam.silentTimeout>0)
		{		
			ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,TRUE,pRomeCfgParam->pptpCfgParam.silentTimeout);
			if (ret)
			{
				printf("rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
				fprintf(fp,"rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
			}
		}
		
		/* if self mtu < peer+mtu then select peer_mru */		
		if ((ppp_mtu > 0) && (pRomeCfgParam->pptpCfgParam.mtu > ppp_mtu)) {
			pRomeCfgParam->pptpCfgParam.mtu = ppp_mtu;
		}	
		rtl8651_setNetMtu("eth0", pRomeCfgParam->pptpCfgParam.mtu);

		
}

void board_ipUp_l2tp(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		char *argv[8];
		uint32 def_gw_ipAddr = 0;
		unsigned char  macStr[17];
		int32  ret;

		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[0]) << 24;
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[1]) << 16;
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[2]) << 8;
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[3]);

		pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_SUCCESS;
		
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);
		memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);

	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP) {
		/* ===================================== */
		if (def_gw_ipAddr != 0) {
			argv[0]="default";
			
			sprintf(macStr, "%u.%u.%u.%u",
				pRomeCfgParam->l2tpCfgParam.gwAddr[0],
				pRomeCfgParam->l2tpCfgParam.gwAddr[1],
				pRomeCfgParam->l2tpCfgParam.gwAddr[2],
				pRomeCfgParam->l2tpCfgParam.gwAddr[3]);
			argv[1]="gw";
			argv[2]=(char*)&macStr;
			argv[3]=NULL;
			INET_setroute(RTACTION_DEL, 0, argv);
			
			set_dynamic_l2tp_sv(RTACTION_ADD);
			
		}
		/* ===================================== */
	}
		rtl8651_flushDemandRoute(6); //for l2tp

		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
			//fprintf(fp,"rtl8651_addRoute: ret %d\n",ret);
		}		
		
		ret=rtl8651_addIpIntf("eth0",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask);
		if (ret)
		{
			printf("rtl8651_addIpIntf:ip=%u.%u.%u.%u:mask=%u.%u.%u.%u: ret %d\n",NIPQUAD(myIp),NIPQUAD(myIpMask),ret);
			fprintf(fp,"rtl8651_addIpIntf:ip=%u.%u.%u.%u:mask=%u.%u.%u.%u: ret %d\n",NIPQUAD(myIp),NIPQUAD(myIpMask),ret);
		}
		
		ret = rtl8651_setL2tpProperty(1, 0, 0, *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.svAddr)), *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.gwAddr)));
		if (ret)
		{
			printf("rtl8651_setL2tpProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_setL2tpProperty: ret %d\n",ret);
		}
		
		ret=rtl8651_bindSession(*myIp, 1); // use myIp to separate sessions.
		if (ret)
		{
			printf("rtl8651_bindSession: ret %d\n",ret);
			fprintf(fp,"rtl8651_bindSession: ret %d\n",ret);
		}
	
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
			fprintf(fp,"rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
		}

		/* set time out option */
		if (pRomeCfgParam->l2tpCfgParam.silentTimeout>0)
		{		
			ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,TRUE,pRomeCfgParam->l2tpCfgParam.silentTimeout);
			if (ret)
			{
				printf("rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
				fprintf(fp,"rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
			}
		}	
		/* if self mtu < peer+mtu then select peer_mru */		
		if ((ppp_mtu > 0) && (pRomeCfgParam->l2tpCfgParam.mtu > ppp_mtu)) {
			pRomeCfgParam->l2tpCfgParam.mtu = ppp_mtu;
		}	
		rtl8651_setNetMtu("eth0", pRomeCfgParam->l2tpCfgParam.mtu);
}

int set_dynamic_l2tp_sv(int action)
{
	char svaddr[20], gw[20];
	char *argv[8];
	unsigned long ipaddr, ipmask, sv_addr;
		
	argv[0]="-net";
	argv[1]="0.0.0.0";
	argv[2]="netmask";
	argv[3]="255.255.255.255";
	argv[4]="gw";		
	argv[5]="0.0.0.0";
	argv[6]="eth0";
	argv[7]=NULL;


	ipaddr = *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr));
	ipmask = *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask));
	sv_addr = *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.svAddr));		
	if ((ipaddr & ipmask) == (sv_addr & ipmask))
		return -1;
	
	if (((*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.gwAddr)))== 0) ||
	    ((*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.svAddr)))== 0) )
	 	return -1;    
	sprintf(svaddr, "%u.%u.%u.%u",
		pRomeCfgParam->l2tpCfgParam.svAddr[0],
		pRomeCfgParam->l2tpCfgParam.svAddr[1],
		pRomeCfgParam->l2tpCfgParam.svAddr[2],
		pRomeCfgParam->l2tpCfgParam.svAddr[3]);
	
	sprintf(gw, "%u.%u.%u.%u",
		pRomeCfgParam->l2tpCfgParam.gwAddr[0],
		pRomeCfgParam->l2tpCfgParam.gwAddr[1],
		pRomeCfgParam->l2tpCfgParam.gwAddr[2],
		pRomeCfgParam->l2tpCfgParam.gwAddr[3]);
	argv[1]=svaddr;
	argv[5]=gw;
	if (action == RTACTION_ADD) {
		INET_setroute(RTACTION_ADD, 0, argv);
	}	
	else {
		INET_setroute(RTACTION_DEL, 0, argv);
	}		
	return 0;
}
	

int get_dynamic_l2tp(void)
{
	struct hostent *hp;
	struct in_addr in;
	struct sockaddr_in local_addr;

	if (inet_aton(pRomeCfgParam->l2tpCfgParam.servername, &in) != 0) {
		memcpy(pRomeCfgParam->l2tpCfgParam.svAddr, (void*)&in.s_addr, 4);		
	}	
	else if (!(hp = gethostbyname(pRomeCfgParam->l2tpCfgParam.servername))) {
		fprintf(stderr, "Can't resolve host. %s\n", pRomeCfgParam->l2tpCfgParam.servername);
		//memcpy(pRomeCfgParam->l2tpCfgParam.svAddr, (void*)myGw, 4);						
	}
	else {
		memcpy(&local_addr.sin_addr.s_addr, hp->h_addr, 4);
		in.s_addr = local_addr.sin_addr.s_addr;
		printf("Domain Name: %s ", pRomeCfgParam->l2tpCfgParam.servername);						
		printf("IP address : %s\n", inet_ntoa(in));
		memcpy(pRomeCfgParam->l2tpCfgParam.svAddr, (void*)&local_addr.sin_addr.s_addr, 4);						
	}
	
		
	printf("pRomeCfgParam->l2tpCfgParam.svAddr=%u.%u.%u.%u\n" 
		,pRomeCfgParam->l2tpCfgParam.svAddr[0]
		,pRomeCfgParam->l2tpCfgParam.svAddr[1]
		,pRomeCfgParam->l2tpCfgParam.svAddr[2]
		,pRomeCfgParam->l2tpCfgParam.svAddr[3]);
		
	return 0;	
}	

int32 board_ipUp_dhcpL2tp_init(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		int8 strBuffer[128];			
		uint32 netmask=0;	
		int ret;			
		#if 0
				pRomeCfgParam->ifCfgParam[0].gwAddr[0]=192;
				pRomeCfgParam->ifCfgParam[0].gwAddr[1]=168;
				pRomeCfgParam->ifCfgParam[0].gwAddr[2]=154;
				pRomeCfgParam->ifCfgParam[0].gwAddr[3]=240;
				pRomeCfgParam->ifCfgParam[0].ipMask[0]=255;
				pRomeCfgParam->ifCfgParam[0].ipMask[1]=255;
				pRomeCfgParam->ifCfgParam[0].ipMask[2]=255;
				pRomeCfgParam->ifCfgParam[0].ipMask[3]=0;
		#endif

				if(memcmp(pRomeCfgParam->ifCfgParam[0].ipMask,&netmask,4)==0)
				{
					printf("the DHCP server may be BOOTP Server!\n");
					return -1;
				}
		
				memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
				memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
				memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);				
				memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);
				
				set_dynamic_l2tp_sv(RTACTION_DEL);
				
				memcpy(pRomeCfgParam->l2tpCfgParam.ipAddr, (void*)myIp, 4);
				memcpy(pRomeCfgParam->l2tpCfgParam.ipMask, (void*)myIpMask, 4);
				memcpy(pRomeCfgParam->l2tpCfgParam.svAddr, (void*)myGw, 4);
				
					memcpy(pRomeCfgParam->l2tpCfgParam.gwAddr, (void*)myGw, 4);
				

				netmask|=(pRomeCfgParam->l2tpCfgParam.ipMask[0])<<24;
				netmask|=(pRomeCfgParam->l2tpCfgParam.ipMask[1])<<16;
				netmask|=(pRomeCfgParam->l2tpCfgParam.ipMask[2])<<8;
				netmask|=pRomeCfgParam->l2tpCfgParam.ipMask[3];

				ret=rtl8651_addNetworkIntf("eth0");	
				if(ret)
				{
					printf("rtl8651_addNetworkIntf: ret %d\n",ret);
//					fprintf(fp,"rtl8651_addNetworkIntf: ret %d\n",ret);				
				}

				ret=rtl8651_specifyNetworkIntfLinkLayerType("eth0",LL_L2TP, pRomeCfgParam->vlanCfgParam[0].vid);
				if (ret)
				{
					printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);
					fprintf(fp,"rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);
				}		
		
				//addIpInterface				
				re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)),0);

				/* linux if up */
				upInterface("eth0");

				ret=rtl8651_addExtNetworkInterface((int8*)"eth0");	
				if(ret)					
				{
					printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);
					fprintf(fp,"rtl8651_addExtNetworkInterface: ret %d\n",ret);				
				}

				ret=rtl8651_addSession(RTL8651_L2TP, 1, "eth0",  pRomeCfgParam->vlanCfgParam[0].vid); 
				if (ret)
				{
					printf("rtl8651_addSession: ret %d\n",ret);
					fprintf(fp,"rtl8651_addSession: ret %d\n",ret);
				}				
				
				ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0", (ipaddr_t)0);
				if (ret)
				{
					printf("rtl8651_addRoute: ret %d\n",ret);
					fprintf(fp,"rtl8651_addRoute: ret %d\n",ret);
				}				

				sprintf(strBuffer,"/sbin/ifconfig eth0 %d.%d.%d.%d netmask %d.%d.%d.%d",
					pRomeCfgParam->ifCfgParam[0].ipAddr[0],
					pRomeCfgParam->ifCfgParam[0].ipAddr[1],
					pRomeCfgParam->ifCfgParam[0].ipAddr[2],
					pRomeCfgParam->ifCfgParam[0].ipAddr[3],			
					pRomeCfgParam->ifCfgParam[0].ipMask[0],
					pRomeCfgParam->ifCfgParam[0].ipMask[1],
					pRomeCfgParam->ifCfgParam[0].ipMask[2],
					pRomeCfgParam->ifCfgParam[0].ipMask[3]
				);
				system(strBuffer);
#if 0				
				{
					char *argv[8];
					uint32 def_gw_ipAddr = 0;
					unsigned char  macStr[17];
					int32  ret;

					def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[0]) << 24;
					def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[1]) << 16;
					def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[2]) << 8;
					def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[3]);

					/* ===================================== */
					if (def_gw_ipAddr != 0) {
						argv[0]="default";
			
						sprintf(macStr, "%u.%u.%u.%u",
							pRomeCfgParam->l2tpCfgParam.gwAddr[0],
							pRomeCfgParam->l2tpCfgParam.gwAddr[1],
							pRomeCfgParam->l2tpCfgParam.gwAddr[2],
							pRomeCfgParam->l2tpCfgParam.gwAddr[3]);
						argv[1]="gw";
						argv[2]=(char*)&macStr;
						argv[3]=NULL;
						INET_setroute(RTACTION_ADD, 0, argv);
					}					
				}		
#endif
				printf("DHCP Finish! IP:%u.%u.%u.%u Server IP:%u.%u.%u.%u\n",NIPQUAD(*myIp),NIPQUAD(*myGw));
				fprintf(fp, "DHCP Finish! IP:%u.%u.%u.%u Server IP:%u.%u.%u.%u\n",NIPQUAD(*myIp),NIPQUAD(*myGw));
				//pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;
				//get_dynamic_l2tp();
				return 0;				
}

void board_ipUp_dhcpL2tp(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		int32  ret;
		if (pRomeCfgParam->l2tpCfgParam.dialState==L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER)
			{
				fprintf(fp, "DHCP OK......\n");
				ret=board_ipUp_dhcpL2tp_init(fp,myIp,myIpMask,myGw,myDns);
				if(ret) //dhcp client not get IP info.
				{
					udhcpc_start();
					return;
				}
				else
				{					
					//pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;				
					//l2tp_start(0);
				}
			}
			else 
			{
				fprintf(fp, "L2TP OK......\n");
				board_ipUp_l2tp(fp,myIp,myIpMask,myGw,myDns);
			}	
}

/*
 * Routine Name: board_ipUpEventTableDriverAccess
 * Description: when a wan interface got new ipAddr/ipMask/gwAddr/dnsAddr
 *              call this function to access rtl865x table driver APIs to
 *              configure rtl865x
 *              scenarios: dhcp client ip up event, pppoe ip up event
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 board_ipUpEventTableDriverAccess(void)
{
	FILE   *fp;
	char   tempStr[30];
	int32  ret;
	uint32 pppObjId=0;
	ipaddr_t myIp = 0;
	ipaddr_t myIpMask = 0;
	ipaddr_t myGw = 0;
	ipaddr_t myDns = 0;

	rtl8651_sem_wait(SEMAPHORE_IPEVENT);
	
	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
	case IFCFGPARAM_CONNTYPE_DHCPC:
		setLedLight(1/*WAN_LED*/, 0/*LED_GREEN*/);	
		sprintf(tempStr,"/var/dhcpup.txt");
		break;
#if defined(DNI)	
	case IFCFGPARAM_CONNTYPE_TELSTRA:
		sprintf(tempStr,"/var/telstraup.txt");
		break;
#endif
	case IFCFGPARAM_CONNTYPE_PPPOE:
		setLedLight(1/*WAN_LED*/, 0/*LED_GREEN*/);	
		sprintf(tempStr,"/var/pppoeup.txt");
		break;		
	case IFCFGPARAM_CONNTYPE_PPTP:
		setLedLight(1/*WAN_LED*/, 0/*LED_GREEN*/);	
		sprintf(tempStr,"/var/pptpup.txt");
		break;
	case IFCFGPARAM_CONNTYPE_L2TP:
		setLedLight(1/*WAN_LED*/, 0/*LED_GREEN*/);	
		sprintf(tempStr,"/var/l2tpup.txt");
		break;
	case IFCFGPARAM_CONNTYPE_DHCPL2TP:
		sprintf(tempStr, "/var/dhcpl2tpup.txt");
		break;		
	default:
		sprintf(tempStr,"/var/unkownup.txt");
	}

	//fp = fopen(tempStr,"r");
	//if(fp==NULL)
	//fp=fopen(tempStr,"w");
	//fclose(fp);
	//fp = fopen(tempStr,"a");
		fp=fopen(tempStr,"w");
        if (fp) 
	fprintf(fp,"board_ipUpEventTableDriverAccess ...\n");	

	switch (pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_DHCPC:
		case IFCFGPARAM_CONNTYPE_TELSTRA:
			if (fp) 	
			fprintf(fp,"connType: dhcpc\n");
			break;

		case IFCFGPARAM_CONNTYPE_PPPOE:

		       if (fp) {
			fprintf(fp,"connType: pppoe\n");
			fprintf(fp,"servermac:%x:%x:%x:%x:%x:%x\n",
				pRomeCfgParam->pppoeCfgParam[0].svrMac[0],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[1],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[2],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[3],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[4],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[5]);
		       }	
			break;

		case IFCFGPARAM_CONNTYPE_PPTP:		 	
			if (fp)
			fprintf(fp,"connType: pptp\n");
			break;
		case IFCFGPARAM_CONNTYPE_L2TP:		 	
			if (fp)
			fprintf(fp,"connType: l2tp\n");
			break;		
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:
			if (fp)
			fprintf(fp, "connType: DHCP + L2TP\n");
			break;
			
		default:
			break;
	}

	LogDebugInfo(fp);

	
	switch (pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_DHCPC:
#if defined(DNI)	
		case IFCFGPARAM_CONNTYPE_TELSTRA:
#endif
			//cprintf("%s:: calling board_ipUp_dhcp\n", __FUNCTION__);
			board_ipUp_dhcp(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;		
		case IFCFGPARAM_CONNTYPE_PPPOE:
			board_ipUp_pppoe(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;					
		case IFCFGPARAM_CONNTYPE_PPTP:
			board_ipUp_pptp(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;
		case IFCFGPARAM_CONNTYPE_L2TP:
			board_ipUp_l2tp(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;	
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:
			board_ipUp_dhcpL2tp(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;							
		default:
		/* don't know what to do now */
			printf("board_ipUpEventTableDriverAccess: unknown ifCfgParam[0].connType(%u)\n",pRomeCfgParam->ifCfgParam[0].connType);
			break;
	}/* switch(pRomeCfgParam->ifCfgParam[0].connType) */



	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_STATIC:
			/* do nothing */
			break;
		case IFCFGPARAM_CONNTYPE_DHCPC: /* fall through */
#if defined(DNI)	
		case IFCFGPARAM_CONNTYPE_TELSTRA: /* fall through */
#endif
		case IFCFGPARAM_CONNTYPE_PPTP:  /* fall through */
		case IFCFGPARAM_CONNTYPE_PPPOE: /* fall through */
		case IFCFGPARAM_CONNTYPE_L2TP:  /* fall through */		
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:		
		  if ((pRomeCfgParam->ifCfgParam[0].connType != IFCFGPARAM_CONNTYPE_DHCPL2TP) 
		      || (pRomeCfgParam->l2tpCfgParam.dialState == L2TPCFGPARAM_DIALSTATE_DIALED_SUCCESS)) {	
		  	rtl8651a_setAlgStatus(0,pRomeCfgParam->algCfgParam[0].algList,pRomeCfgParam->algCfgParam[0].localIp);
			serverp_tableDriverAccess(0);
			dmz_tableDriverAccess(0);
			udp_tableDriverAccess(0);
			rtl8651a_setWanStatus(0,TRUE);
			rtl8651a_setDosStatus(0,((pRomeCfgParam->dosCfgParam[0].enable)?(pRomeCfgParam->dosCfgParam[0].enableItem):0));			
		  	pbnat_ipup( 0, myIp ); /* Protocol-Based NAT */
		  } 
		  break;

		default:
			break;
	}
	
	if ((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP) 
	   && (pRomeCfgParam->l2tpCfgParam.dialState == L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER)) {	
		runDNSProxy();				   	
		get_dynamic_l2tp();	
		//pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;				
		pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_RESTART;				
		//l2tp_start(0);		
		goto exit_ipup;
	}
		
	acl_tableDriverAccess();
	remoteMgmt_tableDriverAccess();	
	email_tableDriverAccess(); //Must after urlfilter_init 2005/1/12 Timo Wu
	routing_tableDriverdel();
	routing_tableDriveradd();	
	

	/*
		chenyl (2004/11/24)
		For multiple pppoe case, because ALL services have "restart" mechanism(kill old one and fork new deamon),
		so we don't need to check wan type anymore.
	*/
	{
		runDNSProxy();		
		time_start();			
		upnp_start();
		syslogd_start();
		//ddns_start();
		check_updateDDNS();		
		//rip_init();
		ripd_start();
	}
	
exit_ipup:	
	if (fp)
		fclose(fp);
	
	rtl8651_sem_post(SEMAPHORE_IPEVENT);

	return 0;
} /* end board_ipUpEventTableDriverAccess */

/*
 * Routine Name: board_ipDownEventTableDriverAccess
 * Description: when a wan interface got new ipAddr/ipMask/gwAddr/dnsAddr
 *              call this function to access rtl865x table driver APIs to
 *              configure rtl865x
 *              scenarios: dhcp client ip up event, pppoe ip up event
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 board_ipDownEventTableDriverAccess(void)
{
	FILE   *fp;
	char   tempStr[30];
	int32  i,ret;
	uint32 pppObjId;
	ipaddr_t myIp;
	ipaddr_t myIpMask;
//	romeCfgParam_t * pRomeCfgParam;
	pppoeCfg_t	pppoeCfgPtr;

	rtl8651_sem_wait(SEMAPHORE_IPEVENT);


	setLedLight(1/*WAN_LED*/, 1/*LED_AMBER*/);

	pppObjId = (uint32)pRomeCfgParam->pppoeCfgParam[0].whichPppObjId;
			
	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_DHCPC:
			sprintf(tempStr,"/var/dhcpdown.txt");
			break;
#if defined(DNI)	
		case IFCFGPARAM_CONNTYPE_TELSTRA:
			sprintf(tempStr,"/var/telstradown.txt");
			break;
#endif
		case IFCFGPARAM_CONNTYPE_PPPOE:
			sprintf(tempStr,"/var/pppoedown.txt");
			break;
		case IFCFGPARAM_CONNTYPE_PPTP:
			sprintf(tempStr,"/var/pptpdown.txt");
			break;
		case IFCFGPARAM_CONNTYPE_L2TP:		
			sprintf(tempStr,"/var/l2tpdown.txt");
			break;			
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:		
			sprintf(tempStr,"/var/dhcpl2tpdown.txt");			
			break;			
		default:
			sprintf(tempStr,"/var/unkowndown.txt");
			break;
	}

	//fp = fopen(tempStr,"r");
	//if(fp==NULL)
	//	fp=fopen(tempStr,"w");
	//fclose(fp);
	//fp = fopen(tempStr,"a");
		fp=fopen(tempStr,"w");
        if (fp) 
	fprintf(fp,"board_ipDownEventTableDriverAccess ...\n");

	//fp = stderr;

	if ((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC) ||
	    (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_TELSTRA))
	{
		/* dhcp client renew case */
		rtl8651a_setWanStatus(0,FALSE);		
		LogDebugInfo(fp);
		
		memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);

		ret=rtl8651_delNaptMapping(myIp);
		if (ret)
		{
			printf("rtl8651_delNaptMapping: ret %d\n",ret);
			if (fp)
			fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
		}

		//rtl8651_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask);
		ret=rtl8651_delRoute((ipaddr_t)0,(ipaddr_t)0);
		if (ret)
		{
			printf("rtl8651_delRoute(default): ret %d\n",ret);
			if (fp)
			fprintf(fp,"rtl8651_delRoute(default): ret %d\n",ret);
		}

		ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);
		if (ret)
		{
			printf("rtl8651_delIpIntf: ret %d\n",ret);
			if (fp)
			fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
		}
		
		i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,&i,4);		
			
	}	
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE)
	{

		/* single pppoe hangup case */
		rtl8651a_setWanStatus(0,FALSE);		
		pRomeCfgParam->pppoeCfgParam[0].dialState = PPPOECFGPARAM_DIALSTATE_OFF;

		LogDebugInfo(fp);
	
		memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);

		ret=rtl8651_delNaptMapping(myIp);
		if (ret)
		{
			printf("rtl8651_delNaptMapping: ret %d\n",ret);
			if (fp)
			fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
		}

		//ret=rtl8651_resetPppoeSessionProperty((uint32)pppObjId);
		ret=rtl8651_resetPppoeSessionProperty((uint32)0);
		if (ret)
		{
			printf("rtl8651_resetPppoeSessionProperty: ret %d\n",ret);
			if (fp)
			fprintf(fp,"rtl8651_resetPppoeSessionProperty: ret %d\n",ret);
		}

		ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);
		if (ret)
		{
			printf("rtl8651_delIpIntf: ret %d\n",ret);
			if (fp)
			fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
		}

		i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,&i,4);		

		/* have to delete the pppdx.pid file, wan_start will check it */		
		//unlink("/var/run/pppd0.pid");		
		
		ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,FALSE,0);
		if(ret)
		{
			if (fp)
			fprintf(fp,"disable auto hang up failed.\n");
		}
		
		/* check autoReconnect to see if a pppd_start() is needed */
		//if (   (pRomeCfgParam->pppoeCfgParam[0].manualHangup==0)
		//    && (pRomeCfgParam->pppoeCfgParam[0].autoReconnect==1)
		//   )
		if (   (pRomeCfgParam->pppoeCfgParam[0].manualHangup==0)
		    && (pRomeCfgParam->pppoeCfgParam[0].auto_connect==1)
		   )		
		{			
			if (fp)	
			fprintf(fp,"do pppd_start() due to autoreconnect\n");
			pppd_start(0);
		}
		else
			unlink("/var/run/pppd0.pid");
			
	}
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPTP)
	{
		/* single pppoe hangup case */
		rtl8651a_setWanStatus(0,FALSE);		
		pRomeCfgParam->pptpCfgParam.dialState = PPTPCFGPARAM_DIALSTATE_DISCONNECTING;

		LogDebugInfo(fp);
		
		memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);

		ret=rtl8651_resetPptpProperty(1);
		if (ret)
		{
			printf("rtl8651_resetPptpProperty: ret %d\n",ret);
			if (fp)
			fprintf(fp,"rtl8651_resetPptpProperty: ret %d\n",ret);
		}

		system("/sbin/ifconfig ppp0 down");

		i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);
		
		/* have to delete the pppdx.pid file, asp_pppoe will check it */		
		//unlink("/var/run/pppd0.pid");
		
		//fprintf(fp,"pppoeManualHangupFlag[0]:%u\n",pppoeManualHangupFlag[0]);
		ret=rtl8651_delNaptMapping(myIp);		
		if (ret)
		{
			printf("rtl8651_delNaptMapping: ret %d\n",ret);
			if (fp)
			fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
		}

	
		ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);		
		if (ret)
		{
			printf("rtl8651_delIpIntf: ret %d\n",ret);
			if (fp)
			fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
		}
		
		ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,FALSE,0);
		if(ret)
		{
			if (fp)
			fprintf(fp,"disable auto hang up failed.\n");
		}	
		
		/* check autoReconnect to see if a pppd_start() is needed */
		//if (   (pRomeCfgParam->pptpCfgParam.manualHangup==0)
		//    && (pRomeCfgParam->pptpCfgParam.autoReconnect==1)
		//   )
		if (   (pRomeCfgParam->pptpCfgParam.manualHangup==0)
		    && (pRomeCfgParam->pptpCfgParam.auto_connect==1)
		   )		
		{			
			if (fp)	
			fprintf(fp,"do pppd_start() due to autoreconnect\n");
			pptp_start(0);			
		}
		else 
			unlink("/var/run/pppd0.pid");		
	}	
	/////////////////////
	/* end if pRomeCfgParam->ifCfgParam[0].connType */
	else if ((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_L2TP)
		   || (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP))
	{	
		if ((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP)&&
			(pRomeCfgParam->l2tpCfgParam.dialState==L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER))
			{
				fprintf(fp,"DHCP IP-Down\n");
				//fclose(fp);
				//pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;
#if 1				
				{		
					ipaddr_t myGw=0,myDns=0;

					ret=rtl8651_delRoute((ipaddr_t)0,(ipaddr_t)0);
					if(ret)
					{
						printf("rtl8651_delRoute: ret %d\n",ret);
						fprintf(fp,"rtl8651_delRoute: ret %d\n",ret);		
					}

					ret=rtl8651_delExtNetworkInterface((int8*)"eth0");
					if (ret)
					{
						printf("rtl8651_delExtNetworkInterface: ret %d\n",ret);
						fprintf(fp,"rtl8651_delExtNetworkInterface: ret %d\n",ret);
					}
			
					ret=rtl8651_delSession(1); 
					if (ret)
					{
						printf("rtl8651_delSession: ret %d\n",ret);
						fprintf(fp,"rtl8651_delSession: ret %d\n",ret);
					}

					ret=rtl8651_delIpIntf("eth0",*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)));
					if (ret)
					{
						printf("rtl8651_delIpIntf: ret %d\n",ret);
						fprintf(fp,"rtl8651_delIpIntf: %x %x ret %d\n",*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)),ret);
					}

					memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
					memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		
					ret=rtl8651_delIpIntf("eth0", myIp, myIpMask);
					if (ret)
					{
						printf("rtl8651_delIpIntf: ret %d\n",ret);
						fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);			
					}

					ret=rtl8651_removeNetworkIntfLinkLayerType("eth0");
					if (ret)
					{
						printf("rtl8651_removeNetworkIntfLinkLayerType: ret %d\n",ret);
						fprintf(fp,"rtl8651_removeNetworkIntfLinkLayerType: ret %d\n",ret);
					}

					ret=rtl8651_delNetworkIntf("eth0");	
					if(ret)
					{
						printf("rtl8651_delNetworkIntf: ret %d\n",ret);
						fprintf(fp,"rtl8651_delNetworkIntf: ret %d\n",ret);				
					}		
		
					pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;
					setInterfaceIp("eth0",0,0);
				}				
#else
				{
					/* dhcp client renew case */
					rtl8651a_setWanStatus(0,FALSE);		
					LogDebugInfo(fp);
					
					memcpy((void*)&myIp,pRomeCfgParam->l2tpCfgParam.ipAddr,4);
					memcpy((void*)&myIpMask,pRomeCfgParam->l2tpCfgParam.ipMask,4);
									
					if (myIp == 0) {
						memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
						memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
					}
		
					ret=rtl8651_delNaptMapping(myIp);
					if (ret)
					{
						printf("rtl8651_delNaptMapping: ret %d\n",ret);
						if (fp)
							fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
					}

					//rtl8651_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask);
					ret=rtl8651_delRoute((ipaddr_t)0,(ipaddr_t)0);
					if (ret)
					{
						printf("rtl8651_delRoute(default): ret %d\n",ret);
						if (fp)
							fprintf(fp,"rtl8651_delRoute(default): ret %d\n",ret);
					}

					ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);
					if (ret)
					{
						printf("rtl8651_delIpIntf: ret %d\n",ret);
						if (fp)
							fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
					}
		
					int i=0;
					memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
					memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
					memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
					memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);
					memcpy(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,&i,4);		
				}				
#endif				
				pRomeCfgParam->l2tpCfgParam.manualHangup = 0;
				rtl8651_sem_post(SEMAPHORE_IPEVENT);
				fclose(fp);				
				return 0;
			}
	
			fprintf(fp,"L2TP IP-Down\n");
	
		//pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;
		pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;		
		rtl8651a_setWanStatus(0,FALSE);
		//pRomeCfgParam->l2tpCfgParam.dialState = L2TPCFGPARAM_DIALSTATE_OFF;
		LogDebugInfo(fp);
		
		memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);

		ret=rtl8651_resetL2tpProperty(1);
		if (ret)
		{
			printf("rtl8651_resetL2tpProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_resetL2tpProperty: ret %d\n",ret);
		}

		/* have to delete the pppdx.pid file, asp_pppoe will check it */		
		
		//fprintf(fp,"pppoeManualHangupFlag[0]:%u\n",pppoeManualHangupFlag[0]);

		ret=rtl8651_delNaptMapping(myIp);
		if (ret)
		{
			printf("rtl8651_delNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
		}
	
		/* DHCP+L2TP -> if l2tp down then no needed down dhcp */
		//if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP)
		if (0)
		{		
			ipaddr_t myGw=0,myDns=0;

			ret=rtl8651_delRoute((ipaddr_t)0,(ipaddr_t)0);
			if(ret)
			{
				printf("rtl8651_delRoute: ret %d\n",ret);
				fprintf(fp,"rtl8651_delRoute: ret %d\n",ret);		
			}

			ret=rtl8651_delExtNetworkInterface((int8*)"eth0");
			if (ret)
			{
				printf("rtl8651_delExtNetworkInterface: ret %d\n",ret);
				fprintf(fp,"rtl8651_delExtNetworkInterface: ret %d\n",ret);
			}
			
			ret=rtl8651_delSession(1); 
			if (ret)
			{
				printf("rtl8651_delSession: ret %d\n",ret);
				fprintf(fp,"rtl8651_delSession: ret %d\n",ret);
			}

			ret=rtl8651_delIpIntf("eth0",*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)));
			if (ret)
			{
				printf("rtl8651_delIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_delIpIntf: %x %x ret %d\n",*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)),ret);
			}
		
			ret=rtl8651_delIpIntf("eth0", myIp, myIpMask);
			if (ret)
			{
				printf("rtl8651_delIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);			
			}

			ret=rtl8651_removeNetworkIntfLinkLayerType("eth0");
			if (ret)
			{
				printf("rtl8651_removeNetworkIntfLinkLayerType: ret %d\n",ret);
				fprintf(fp,"rtl8651_removeNetworkIntfLinkLayerType: ret %d\n",ret);
			}

			ret=rtl8651_delNetworkIntf("eth0");	
			if(ret)
			{
				printf("rtl8651_delNetworkIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_delNetworkIntf: ret %d\n",ret);				
			}		
		

			//pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;
			//setInterfaceIp("eth0",0,0);
			pRomeCfgParam->l2tpCfgParam.dialState=	L2TPCFGPARAM_DIALSTATE_OFF;
			//setInterfaceIp("eth0",0,0);
			
		}
		else
		{		

			ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);
			if (ret)
			{
				printf("rtl8651_delIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
			}
		}	
	
		system("/sbin/ifconfig ppp0 down");

		i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);

		unlink("/var/run/pppd0.pid");
		//unlink("/var/run/l2tpd.pid");
		
		//disable idle timeout
		ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,FALSE,0);
		if(ret)
		{
			fprintf(fp,"disable auto hang up failed.\n");
		}	
		
		/* check autoReconnect to see if a pppd_start() is needed */
		if (   (pRomeCfgParam->l2tpCfgParam.manualHangup==0)
		    && (pRomeCfgParam->l2tpCfgParam.auto_connect==1)
		   )			
		{			
			if (fp )
				fprintf(fp,"do l2tp_start() due to autoreconnect\n");
			l2tp_start(0);
		}
		else 
			unlink("/var/run/pppd0.pid");			
		pRomeCfgParam->l2tpCfgParam.manualHangup = 0;	
exit_l2tp_down:			
	}

	/*
	 *   Protocol-Based NAT
	 */
	{
		switch(pRomeCfgParam->ifCfgParam[0].connType)
		{
			case IFCFGPARAM_CONNTYPE_STATIC:
				/* do nothing */
				break;
			case IFCFGPARAM_CONNTYPE_DHCPC: /* fall through */
			case IFCFGPARAM_CONNTYPE_TELSTRA: /* fall through */			
			case IFCFGPARAM_CONNTYPE_PPTP:  /* fall through */
			case IFCFGPARAM_CONNTYPE_PPPOE: /* fall through */
			case IFCFGPARAM_CONNTYPE_L2TP:  /* fall through */			
			case IFCFGPARAM_CONNTYPE_DHCPL2TP: /* fall through */
				pbnat_ipdown( 0, myIp );
				break;
			default:
				break;
		}
	
	} /* end of pbnat */

	/* domain setting: its used only for DHCP related wan-type */
	if ((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC) ||
	    (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_TELSTRA) ||
	    (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP) )
	{
		if (pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd == 1)
		{
			memset(pRomeCfgParam->dhcpsCfgParam.domain, 0, sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
		}
	}


	/* wins server setting */
	{
		if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
		{
			pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = 0;
			pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = 0;
		}
	}

	if (fp)
	fclose(fp);

	{
		/* stop services */
		/* removed by lucas, stop service is no needed */
		/* upnp_stop(); */
	}

	rtl8651_sem_post(SEMAPHORE_IPEVENT);

	return 0;
} /* end board_ipDownEventTableDriverAccess(void) */


void AddDemandRoute(int pppObjId,int defaultSession)
{
	rtl8651_tblDrvDemandRoute_t tmpRt;
	int32  i;
	uint32 ip_start,ip_end;
	uint16 port_start,port_end;
	
	rtl8651_flushDemandRoute(pppObjId);
	
	if (defaultSession){
		tmpRt.type=TRIGGER_DSTIP;
		tmpRt.ip_start=0;
		tmpRt.ip_end=0xffffffff;
		rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
		return;
	}

	if (pRomeCfgParam->pppoeCfgParam[pppObjId].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED){
		ipaddr_t stub1,stub2;
		uint32 srcSubnet;
		memcpy(&stub1,pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpAddr,4);
		memcpy(&stub2,pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpMask,4);
		srcSubnet = (ipaddr_t)(stub1 & stub2);/* get subnet value */
		tmpRt.type=STATIC_POLICY_ROUTE|TRIGGER_SRCIP;
		tmpRt.ip_start=srcSubnet+1;
		tmpRt.ip_end=srcSubnet+(~stub2);
		rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
	}
	
	for (i=0;i<4;i++){
		if (pRomeCfgParam->pppoeCfgParam[pppObjId].destnetType[i] == PPPOECFGPARAM_DESTNETTYPE_IP){
			parse_ipRange(pRomeCfgParam->pppoeCfgParam[pppObjId].destnet[i],&ip_start,&ip_end);
			tmpRt.type=TRIGGER_DSTIP;
			tmpRt.ip_start=ip_start;
			tmpRt.ip_end=ip_end;
			rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
		} else if (pRomeCfgParam->pppoeCfgParam[pppObjId].destnetType[i] == PPPOECFGPARAM_DESTNETTYPE_TCPPORT){
			parse_portRange(pRomeCfgParam->pppoeCfgParam[pppObjId].destnet[i], &port_start ,&port_end);
					tmpRt.type=TRIGGER_DSTTCPPORT;
					tmpRt.trigger.dport.start=port_start;
					tmpRt.trigger.dport.end=port_end;
					rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
		} else if (pRomeCfgParam->pppoeCfgParam[pppObjId].destnetType[i] ==	PPPOECFGPARAM_DESTNETTYPE_UDPPORT){
			parse_portRange( pRomeCfgParam->pppoeCfgParam[pppObjId].destnet[i], &port_start ,&port_end);
			tmpRt.type=TRIGGER_DSTUDPPORT;
			tmpRt.trigger.dport.start=port_start;
			tmpRt.trigger.dport.end=port_end;
			rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
		}
	}

}

/*
 * start pppd on specified pppObjId (0,1,...,MAX_PPPOE_SESSION-1)
 */
void pppd_start(uint32 identity)
{
	FILE * f1, * f2;
	//romeCfgParam_t * pRomeCfgParam;
	char    idStr[4];
	char    papStr[20];
	char    pppOptionStr[20];
	char    chapStr[20];
	uint8   tmp[160];

	sprintf(tmp,"/var/run/pppd%d.pid",identity);
	send_signal(tmp,9);
	unlink(tmp);
	
	if (upgrading)
		return;

	if (pRomeCfgParam->pppoeCfgParam[identity].enable==0)
	{
		printf("pppoe session #%u disabled ... \n", identity);
		return;
	}

	f1 = fopen("/etc/ppp.options","r");
	if (!f1)
	{
		printf("pppd_start: fopen /etc/ppp.options failed\n");
		return;
	}

	//if(pRomeCfgParam->pppoeCfgParam[identity].authType ==PPPPARAM_AUTHTYPE_PAP)
	if (1)
	{			
		sprintf(papStr,"/var/ppp/pap%u",identity);
		f2 = fopen(papStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",papStr);
			return;
		}
		
		sprintf(tmp,"%s * %s" ,pRomeCfgParam->pppoeCfgParam[identity].username,pRomeCfgParam->pppoeCfgParam[identity].password);
		fputs(tmp,f2);
		fclose(f2);

		//sprintf(chapStr,"/var/ppp/chap%u",identity);
		//unlink(chapStr);
	}

	//if(pRomeCfgParam->pppoeCfgParam[identity].authType==PPPPARAM_AUTHTYPE_CHAP)
	if (1)
	{
		sprintf(chapStr,"/var/ppp/chap%u",identity);
		f2 = fopen(chapStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",chapStr);
			return;
		}
		sprintf(tmp,"\"%s\" * \"%s\" \"*\"\n" ,pRomeCfgParam->pppoeCfgParam[identity].username,pRomeCfgParam->pppoeCfgParam[identity].password);
		fputs(tmp,f2);
		fclose(f2);

		//sprintf(papStr,"/var/ppp/pap%u",identity);
		//unlink(papStr);
		
	}	

		
	sprintf(pppOptionStr,"/var/ppp/options%u",identity);
	f2 = fopen(pppOptionStr,"w+");
	while (!feof(f1))
	{
		fgets(tmp,160,f1);

		if (!memcmp(tmp,"mtu",3))
			sprintf(tmp,"mtu %d\n",pRomeCfgParam->pppoeCfgParam[identity].mtu);
			
		if (!memcmp(tmp,"mru",3))
			sprintf(tmp,"mru %d\n",pRomeCfgParam->pppoeCfgParam[identity].mtu);
		
		if (!memcmp(tmp,"user",4))
			sprintf(tmp,"user %s\n",pRomeCfgParam->pppoeCfgParam[identity].username);
			
		/* generate usepeerdns option for pppd's reference */
		if(!memcmp(tmp,"usepeerdns",10))
		{
			if (pRomeCfgParam->dnsCfgParam.enable == 0)
			{
				;				
			}
			else
			{
				sprintf(tmp,"\n");		
			}
		}

		/* generate service-name option for pppd's reference */
		if(!memcmp(tmp,"service_name",12))
		{
			if (pRomeCfgParam->pppoeCfgParam[identity].serviceName[0])
			{
				sprintf(tmp,"service_name \"%s\"\n",pRomeCfgParam->pppoeCfgParam[identity].serviceName);		
			}
			else
			{
				sprintf(tmp,"\n");		
			}
		}		


		/* generate ac-name option for pppd's reference */
		if(!memcmp(tmp,"ac_name",7))
		{
			if (pRomeCfgParam->pppoeCfgParam[identity].acName[0])
			{
				sprintf(tmp,"ac_name \"%s\"\n",pRomeCfgParam->pppoeCfgParam[identity].acName);		
			}
			else
			{
				sprintf(tmp,"\n");		
			}
		}


	/* generate nodefaultroute option for pppd's reference */
		if((!memcmp(tmp,"defaultroute",12))||(!memcmp(tmp,"nodefaultroute",14)))
		{			
			if ((pRomeCfgParam->pppoeCfgParam[identity].defaultSession!=1)&&(pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE))
				sprintf(tmp,"nodefaultroute\n");
			else
				sprintf(tmp,"defaultroute\n");
		}
		
		fputs(tmp,f2);
	}		
		
	fclose(f1);


	/* put requested ip in the option file
	 * option format: <local IP address>:<remote IP address>
	 */
	if (   pRomeCfgParam->pppoeCfgParam[identity].internetassign == 0)
	{
		fprintf(f2,"%u.%u.%u.%u:0.0.0.0\n",
			pRomeCfgParam->pppoeCfgParam[identity].localHostIp[0],
			pRomeCfgParam->pppoeCfgParam[identity].localHostIp[1],
			pRomeCfgParam->pppoeCfgParam[identity].localHostIp[2],
			pRomeCfgParam->pppoeCfgParam[identity].localHostIp[3]);
	}
	
	/* generate idle option (auto disconnect) for pppd's reference */
//	fprintf(f2,"idle %u\n",pRomeCfgParam->pppoeCfgParam[identity].silentTimeout);

	fclose(f2);

	sprintf(idStr,"%u",identity);
	if ((pRomeCfgParam->pppoeCfgParam[identity].demand==1) && (pRomeCfgParam->pppoeCfgParam[identity].manualStart == 0))
	{   
		pRomeCfgParam->pppoeCfgParam[identity].manualStart = 0;		
		pRomeCfgParam->pppoeCfgParam[identity].dialState=PPPOECFGPARAM_DIALSTATE_DIALED_WAITING;

		AddDemandRoute(identity,1);
		return ;
	}
	
	pRomeCfgParam->pppoeCfgParam[identity].manualStart = 0;
	pRomeCfgParam->pppoeCfgParam[identity].dialState=PPPOECFGPARAM_DIALSTATE_DIALED_TRYING;
	if (pRomeCfgParam->pppoeCfgParam[identity].auto_connect)
		pRomeCfgParam->pppoeCfgParam[identity].demand = 1;		

	{
#ifdef CONFIG_PPP_MPPE_MPPC	
	run_pppoe(identity);
#else
	do_exec("/bin/pppd",idStr);
#endif
	}

} /* end pppd_start */


/*
 * called by asp_setpppoe() only now. the table driver cannot call this
 * function directly, so cannot install this function as a callback in
 * rtl8651_setPppoeSessionHangUp().
 * note: pppd_stop can only be called by user thru asp engine, so there
 *       manual hangup must be true !!
 */
int32 pppd_stop(uint32 pppObjId)
{
	uint8 tempStr[20];
	pppoeCfg_t	pppoeCfgPtr;
	
	/* set flag to record the Mannual hangup event */	
	//pRomeCfgParam->pppoeCfgParam[pppObjId].manualHangup = 1;
	sprintf(tempStr,"/var/run/pppd%u.pid",pppObjId);
	pRomeCfgParam->pppoeCfgParam[pppObjId].dialState=PPPOECFGPARAM_DIALSTATE_OFF;	
	
	pppoeCfgPtr.defaultSession=pRomeCfgParam->pppoeCfgParam[pppObjId].defaultSession;	
	pppoeCfgPtr.sessionId=pRomeCfgParam->pppoeCfgParam[pppObjId].sessionId;
	memcpy((char*)&pppoeCfgPtr.ipAddr,(char*)&pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr,4);
	memcpy((char*)&pppoeCfgPtr.ipMask,(char*)&pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask,4);
	memcpy(&(pppoeCfgPtr.lanType),&(pRomeCfgParam->pppoeCfgParam[pppObjId].lanType),4);

	/*   Case 'PPPOEDOWN_CFG' in 're_core.c' does not take 'unnumbered PPPoE' into account. 
	  *   The current code seems to do the corresponding action (ex. delNaptMapping....)
	  *   in 'asp_setPppoe()'.
	  */
	re865xIoctl("eth0",PPPOEDOWN_CFG,(uint32)&pppoeCfgPtr,pppObjId,0);
	
	//do_kill(tempStr);
	send_signal(tempStr,1); //Hang Up

	return 0;
} /* end pppd_stop */



/*
 * start pptp 
 */
void pptp_start(uint32 identity)
{
	FILE * f1, * f2;
	//romeCfgParam_t * pRomeCfgParam;
	char    idStr[4];
	char    papStr[20];
	char    pppOptionStr[20];
	char    chapStr[20];
	uint8   tmp[160];


	//send_signal("/var/run/pptp.pid", 9);
	//send_signal("/var/run/pppd0.pid", 15);
	do_kill("/var/run/pptp.pid");
	do_kill("/var/run/pppd0.pid");	
	unlink("/var/run/pptp.pid");
	unlink("/var/run/pppd0.pid");
	
	if (upgrading)
		return;	
	
	f1 = fopen("/etc/pptp.options","r");
	if (!f1)
	{
		printf("pppd_start: fopen /etc/pptp.options failed\n");
		return;
	}

	//if(pRomeCfgParam->pptpCfgParam.authType==PPPPARAM_AUTHTYPE_PAP)	
	if (1)
	{		
		sprintf(papStr,"/var/ppp/pap%u",identity);
		f2 = fopen(papStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",papStr);
			return;
		}
		
		sprintf(tmp,"%s * %s\n" ,pRomeCfgParam->pptpCfgParam.username,pRomeCfgParam->pptpCfgParam.password);
		fputs(tmp,f2);
		fclose(f2);

		//sprintf(chapStr,"/var/ppp/chap%u",identity);
		//unlink(chapStr);
		
	}
	
	//if(pRomeCfgParam->pptpCfgParam.authType==PPPPARAM_AUTHTYPE_CHAP)	
	if (1)
	{
		sprintf(chapStr,"/var/ppp/chap%u",identity);
		f2 = fopen(chapStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",chapStr);
			return;
		}
		sprintf(tmp,"NTDOMAIN %s %s\n" ,pRomeCfgParam->pptpCfgParam.username,pRomeCfgParam->pptpCfgParam.password);
		fputs(tmp,f2);
		sprintf(tmp,"%s NTDOMAIN %s\n" ,pRomeCfgParam->pptpCfgParam.username,pRomeCfgParam->pptpCfgParam.password);
		fputs(tmp,f2);			
		fclose(f2);

		//sprintf(papStr,"/var/ppp/pap%u",identity);
		//unlink(papStr);
		
	}
			
	sprintf(pppOptionStr,"/var/ppp/options%u",identity);
	f2 = fopen(pppOptionStr,"w+");
	while (!feof(f1))
	{
		fgets(tmp,160,f1);
		fputs(tmp,f2);
	}			
	fclose(f1);
	
	//sprintf(tmp,"mtu %d mru %d\n",pRomeCfgParam->pptpCfgParam.mtu,pRomeCfgParam->pptpCfgParam.mtu);
	//fputs(tmp,f2);
	sprintf(tmp,"mtu %d\n",pRomeCfgParam->pptpCfgParam.mtu);
	fputs(tmp,f2);		
	sprintf(tmp,"mru %d\n",pRomeCfgParam->pptpCfgParam.mtu);
	fputs(tmp,f2);		
	sprintf(tmp,"name %s\n",pRomeCfgParam->pptpCfgParam.username);	
	fputs(tmp,f2);
	
	if (pRomeCfgParam->dnsCfgParam.enable == 0) {
		sprintf(tmp, "usepeerdns\n");
		fputs(tmp,f2);
	}	
	
	fputs("remotename NTDOMAIN\n",f2);
	
	/* generate idle option (auto disconnect) for pppd's reference */
	//fprintf(f2,"idle %u\n",pRomeCfgParam->pptpCfgParam.silentTimeout);

	fprintf(f2,"defaultroute\n");
		
	fclose(f2);

	rtl8651_setNetMtu("eth0",pRomeCfgParam->pptpCfgParam.mtu);

	if ((pRomeCfgParam->pptpCfgParam.demand==1) && (pRomeCfgParam->pptpCfgParam.manualStart==0))
	{
		pRomeCfgParam->pptpCfgParam.manualStart = 0;		
		pRomeCfgParam->pptpCfgParam.dialState=PPPOECFGPARAM_DIALSTATE_DIALED_WAITING;
		printf("Add Demand Route\n");
		AddDemandRoute(4,1); // 4: used for signal 44.		
	}
	else
	{
		pRomeCfgParam->pptpCfgParam.manualStart = 0;		
		pRomeCfgParam->pptpCfgParam.dialState=PPPOECFGPARAM_DIALSTATE_DIALED_TRYING;
		if (pRomeCfgParam->pptpCfgParam.auto_connect)
			pRomeCfgParam->pptpCfgParam.demand = 1;


		/* set auto redial options */
		f1 = fopen("/var/run/pptp_redial", "w");
		if (f1)
		{
			fprintf(f1, "%d", pRomeCfgParam->pptpCfgParam.autoReconnect?1:0);
			fclose(f1);
		}
	

		//sprintf(tempStr,"/bin/pptp %u.%u.%u.%u file /var/ppp/options0 &"
		{
			sprintf(tmp,"/bin/pptp %u.%u.%u.%u &"
			,pRomeCfgParam->pptpCfgParam.svAddr[0]
			,pRomeCfgParam->pptpCfgParam.svAddr[1]
			,pRomeCfgParam->pptpCfgParam.svAddr[2]
			,pRomeCfgParam->pptpCfgParam.svAddr[3]);
			system(tmp);
		}

		
	}
} /* end pptp_start */

void l2tp_start(uint32 identity)
{
	FILE * f1, * f2;
	//romeCfgParam_t * pRomeCfgParam;
	char    idStr[4];
	char    papStr[20];
	char    pppOptionStr[20];
	char    chapStr[20];
	char	tmp[160];


	if((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_DHCPL2TP)&&
		(pRomeCfgParam->l2tpCfgParam.dialState==L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER))
	{
		udhcpc_start();	
		return;
	}

	do_kill("/var/run/l2tpd.pid");
	do_kill("/var/run/pppd0.pid");	
	//sprintf(tmp,"/var/run/l2tpd.pid");
	//send_signal(tmp,9);
	//unlink(tmp);
	unlink("/var/run/pppd0.pid");
	unlink("/var/run/pptp.pid");
	
	{	
		int i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,&i,4);			
	}

	f1 = fopen("/etc/l2tp.options","r");
	if (!f1)
	{
		printf("pppd_start: fopen /etc/l2tp.options failed\n");
		return;
	}

	//if(pRomeCfgParam->l2tpCfgParam.authType==PPPPARAM_AUTHTYPE_PAP)	
	if (1)
	{			
		sprintf(papStr,"/var/ppp/pap%u",identity);
		f2 = fopen(papStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",papStr);
			return;
		}
		
		sprintf(tmp,"%s * %s\n" ,pRomeCfgParam->l2tpCfgParam.username,pRomeCfgParam->l2tpCfgParam.password);
		fputs(tmp,f2);
		fclose(f2);
		sprintf(chapStr,"/var/ppp/chap%u",identity);
		//unlink(chapStr);
	}	

	//if(pRomeCfgParam->l2tpCfgParam.authType==PPPPARAM_AUTHTYPE_CHAP)
	if (1)
	{				
		sprintf(chapStr,"/var/ppp/chap%u",identity);
		f2 = fopen(chapStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",chapStr);
			return;
		}
		sprintf(tmp,"NTDOMAIN %s %s\n" ,pRomeCfgParam->l2tpCfgParam.username,pRomeCfgParam->l2tpCfgParam.password);
		fputs(tmp,f2);
		sprintf(tmp,"%s NTDOMAIN %s\n" ,pRomeCfgParam->l2tpCfgParam.username,pRomeCfgParam->l2tpCfgParam.password);
		fputs(tmp,f2);	
		fclose(f2);
		sprintf(papStr,"/var/ppp/pap%u",identity);
		//unlink(papStr);
	}			
	sprintf(pppOptionStr,"/var/ppp/options%u",identity);
	f2 = fopen(pppOptionStr,"w+");
	while (!feof(f1))
	{
		fgets(tmp,160,f1);
		fputs(tmp,f2);
	}			
	fclose(f1);
	
	if (pRomeCfgParam->dnsCfgParam.enable == 0) {
		sprintf(tmp, "usepeerdns\n");
		fputs(tmp,f2);
	}	
	
	sprintf(tmp,"mtu %d mru %d\n",pRomeCfgParam->l2tpCfgParam.mtu,pRomeCfgParam->l2tpCfgParam.mtu);
	fputs(tmp,f2);	
	sprintf(tmp,"name %s\n",pRomeCfgParam->l2tpCfgParam.username);	
	fputs(tmp,f2);
	
	fputs("remotename NTDOMAIN\n",f2);
	
	/* generate idle option (auto disconnect) for pppd's reference */
	fprintf(f2,"idle %u\n",pRomeCfgParam->l2tpCfgParam.silentTimeout);

	fprintf(f2,"defaultroute\n");
		
	fclose(f2);

	// L2TP configuration file
	f2 = fopen("/var/l2tpd.conf","w+");
	fprintf(f2,"[lac test]\n");
	fprintf(f2,"lns=%u.%u.%u.%u\n",pRomeCfgParam->l2tpCfgParam.svAddr[0],pRomeCfgParam->l2tpCfgParam.svAddr[1],pRomeCfgParam->l2tpCfgParam.svAddr[2],pRomeCfgParam->l2tpCfgParam.svAddr[3]);
	fprintf(f2,"pppoptfile = /etc/config/l2tpd-pppd.conf\n");
	fprintf(f2,"length bit = yes\n");
	fprintf(f2,"redial = yes\n");
	fprintf(f2,"redial timeout = 15\n");
	fprintf(f2,"max redials = 5\n");
	//fprintf(f2,"redial = no\n");
//	fprintf(f2,"redial timeout = 15\n");
	fprintf(f2,"autodial = yes\n");
	fclose(f2);

	// L2TP PPPD conifguration file
	f2 = fopen("/var/l2tpd-pppd.conf","w+");
	fprintf(f2,"user %s\n",pRomeCfgParam->l2tpCfgParam.username);
	fprintf(f2,"asyncmap 0\n");
	fprintf(f2,"noauth\n");
	fprintf(f2,"defaultroute\n");
	if (pRomeCfgParam->dnsCfgParam.enable == 0) {
		sprintf(tmp, "usepeerdns\n");
		fputs(tmp,f2);
	}	
	fprintf(f2,"mru %d\nmtu %d\n",pRomeCfgParam->l2tpCfgParam.mtu,pRomeCfgParam->l2tpCfgParam.mtu);
	fclose(f2);	

	rtl8651_setNetMtu("eth0",pRomeCfgParam->l2tpCfgParam.mtu);
	
	if ((pRomeCfgParam->l2tpCfgParam.demand==1) && (pRomeCfgParam->l2tpCfgParam.manualStart==0))
	{
		pRomeCfgParam->l2tpCfgParam.manualStart = 0;		
		pRomeCfgParam->l2tpCfgParam.dialState=PPPOECFGPARAM_DIALSTATE_DIALED_WAITING;
		printf("Add Demand Route\n");
		AddDemandRoute(6,1); // 6: used for signal 46.		
	}
	else
	{
		pRomeCfgParam->l2tpCfgParam.manualStart = 0;		
		pRomeCfgParam->l2tpCfgParam.dialState=PPPOECFGPARAM_DIALSTATE_DIALED_TRYING;
		if (pRomeCfgParam->l2tpCfgParam.auto_connect)
			pRomeCfgParam->l2tpCfgParam.demand = 1;	


		sprintf(tmp,"/bin/l2tpd &");		
		system(tmp);
		
	}
} /* end l2tp_start */




void syslogd_start()
{
#if 0	
	send_signal("/var/run/syslogd.pid",9);
	send_signal("/var/run/klogd.pid",9);	
	printf("pRomeCfgParam->logCfgParam[0].module = %d\n", pRomeCfgParam->logCfgParam[0].module);
	if(pRomeCfgParam->logCfgParam[0].module&RTL8651_LOGMODULE_SYS)
	{
		rtl8651a_enableLogging(0,RTL8651_LOGMODULE_SYS,1);
		system("/bin/syslogd &");
#if !defined(DNI)		
		system("/bin/klogd &");
#endif		
	}
#endif
	
}

/* DNS Proxy*/
void runDNSProxy()
{
	char	pname[]="/bin/dnrd";
	ipaddr_t	ipAddr = 0;
	int		boundIP = 0;
	FILE *	f = NULL;
	int		pid = 0;
	char primary[16]={0};	

	// fill server list config file
	f = fopen("/var/run/dnrd.serv", "w");
	if (f == NULL)
	{
		printf("Can NOT set server list of DNRD daemon, exit.\n");
		return;
	}

#if defined(DNI)	
	if (pRomeCfgParam->dnsCfgParam.enable == 1) {

		memcpy((uint32 *)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr), 
			(uint32 *)(pRomeCfgParam->dnsCfgParam.primary), 4);
		memcpy((uint32 *)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr), 
			(uint32 *)(pRomeCfgParam->dnsCfgParam.secondary), 4);	
	}	
#endif		

	/* record primary DNS server */
	memcpy((void*)&ipAddr,(void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,
			sizeof(ipaddr_t));

	if (ipAddr)
	{
		fprintf(f,"%u.%u.%u.%u\n", pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]
								, pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]
								, pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]
								, pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);
	}

	/* record secondary DNS server */
	memcpy((void*)&ipAddr,(void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,
			sizeof(ipAddr));

	if (ipAddr)
	{
		fprintf(f,"%u.%u.%u.%u\n", pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]
								, pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]
								, pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]
								, pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);
	}

	/* close server file */
	fclose(f);

	
	/* create /var/resolv.conf */	
	f=fopen("/var/resolv.conf","w+");		
	/* record secondary DNS server */
	memcpy((void*)&ipAddr,(void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,
			sizeof(ipAddr));
	if (ipAddr) {		
		sprintf(primary,"%d.%d.%d.%d",pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0],
	        	                      pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1],
					      pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2],
			        	      pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3] );
		fprintf(f,"nameserver %s\n",primary);
	}	
	memcpy((void*)&ipAddr,(void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,
			sizeof(ipAddr));
	if (ipAddr) {			
	
		sprintf(primary,"%d.%d.%d.%d",pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0],
	        	      		      pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1],
					      pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2],
					      pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3] );
		fprintf(f,"nameserver %s\n",primary);									  
	}	
	fclose(f);	

	//f = fopen("/var/run/dnrd.pid","r");
	//if (!f)
	//{
	//	goto forkNew;
	//}

	//fscanf(f, "%d", &pid);

	//fclose(f);
	/* remove exist process */
	//kill(pid, 9);
	eval("killall", "-9", "dnrd");
	do_kill("/var/run/dnrd.pid");
	unlink("/var/run/dnrd.pid");

forkNew:
	{
		char tmp[32];
		sprintf(tmp,"%s &", pname);
		system(tmp);
	}
#ifdef DNS_HIJACK	
	dnshijack_add();	
#endif	
	
	return;
}
char *mgmtUserName()
{

	return (char*)&pRomeCfgParam->mgmtCfgParam[0].name;
}
char *mgmtPassword()
{
	return (char*)&pRomeCfgParam->mgmtCfgParam[0].password;
}


int  rtl865x_mmap(int base,int length) // for flash , register mapping
{
	int sg_fd;
	int new_base;
	if ((sg_fd = open("/dev/mem", O_RDWR)) < 0) 
	       printf("open fail\n");
    	new_base = mmap((void*)0x0, length, PROT_READ | PROT_WRITE | PROT_EXEC, MAP_SHARED, sg_fd, base);
	close(sg_fd);
	if (new_base==MAP_FAILED)
	{
		fprintf(stderr,"MAP FAIL\n");
		return 0;	
	}
	return new_base;
}

int  rtl865x_kmmap(int base,int length) //for kmalloc mapping
{
	int sg_fd;
	int new_base;
	if ((sg_fd = open("/dev/node1", O_RDWR)) < 0) 
	       printf("open fail\n");
    	new_base = mmap((void*)0x0, length, PROT_READ | PROT_WRITE | PROT_EXEC, MAP_SHARED, sg_fd, base);
	close(sg_fd);
	if (new_base==MAP_FAILED)
	{
		fprintf(stderr,"MAP FAIL\n");
		return 0;	
	}
	return new_base;
}

/* end board.c */

#if defined(DNI)
char str[200];
//#define DPRINTF printf
#define DPRINTF
int factory_default = 0;
#define MAX_DHCPC	MAX_RESERVED_FIXED//ATTACHED_DEVICES

extern int filter_client_cur_index;

char *
nvram_get_current_fw_client(char *name)
{
	char *ptr;
	int i;
	
	i = filter_client_cur_index;			/* current */
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	if (strcmp(name, "port") == 0) {	
		if (i < MAX_ACL)
			sprintf(str, "%d-%d", pRomeCfgParam->aclCfgParam[0][i].port,
				      pRomeCfgParam->aclCfgParam[0][i].port_e);
		else
			strcpy(str, "");	/* for add */
	
		return str;
	}
	else if (strcmp(name, "ip") == 0) {
		if (i < MAX_ACL) {	
			strcpy(str, (char *)(inet_string((uint32)&(pRomeCfgParam->aclCfgParam[0][i].ip))));		
		}	
		else
			strcpy(str, "");		/* for add */	
		return (str);
	}	
	else if (strcmp(name, "ip_s") == 0) {
		if (i < MAX_ACL)		
			strcpy(str, (char *)(inet_string((uint32)&(pRomeCfgParam->aclCfgParam[0][i].ip))));		
		else
			strcpy(str, "0.0.0.0");		/* for add */	
		return (str);
	}
	else if (strcmp(name, "ip_e") == 0) {
		if (i < MAX_ACL)		
			strcpy(str, (char *)(inet_string((uint32)&(pRomeCfgParam->aclCfgParam[0][i].ip_end))));		
		else
			strcpy(str, "255.255.255.255");		/* for add */	
		return (str);
	}				
	else if (strcmp(name, "proto") == 0) {	
		if (i < MAX_ACL)
			return ((pRomeCfgParam->aclCfgParam[0][i].type == 0) ? 
			  "tcp" : ((pRomeCfgParam->aclCfgParam[0][i].type == 1) ? "udp" : "both"));	
		else
			return ("both");	/* for add */
	}
	else if (strcmp(name, "service") == 0) {	
		if (i < MAX_ACL)
			strcpy(str, pRomeCfgParam->aclCfgParam[0][i].desc);	
		else
			strcpy(str, "");
		return (str);
	}	
	else
		return ("");	
		
}


extern int forward_port_cur_index;
char *
nvram_get_current_forward(char *name)
{
	char *ptr;
	int i;
	
	i = forward_port_cur_index;			/* current */
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	if (strcmp(name, "port") == 0) {	
		if (i < MAX_SERVER_PORT)
			sprintf(str, "%d-%d", pRomeCfgParam->serverpCfgParam[0][i].wanPortStart,
				      pRomeCfgParam->serverpCfgParam[0][i].wanPortFinish);
		else
	      
			strcpy(str, "");
	
		return str;
	}
	else if (strcmp(name, "proto") == 0) {	
		if (i >= MAX_SERVER_PORT)
			//return ("tcp");
			return ("both");
		return ((pRomeCfgParam->serverpCfgParam[0][i].protocol == 0) ? 
			"tcp" : ((pRomeCfgParam->serverpCfgParam[0][i].protocol == 1) ? "udp" : "both"));	
	}
	else if (strcmp(name, "ip") == 0) {
		if (i < MAX_SERVER_PORT)		
			strcpy(str, (char *)(inet_string((uint32)&(pRomeCfgParam->serverpCfgParam[0][i].ip))));		
		else
			strcpy(str, "");		/* for add */	
		return (str);
	}
	else if (strcmp(name, "enable") == 0) {
		if (i < MAX_SERVER_PORT)		
			strcpy(str, (pRomeCfgParam->serverpCfgParam[0][i].enable ? "on" : "off"));
		else
			strcpy(str, "off");		/* for add */	
		return (str);
	}		
	else if (strcmp(name, "service") == 0) {
		if (i < MAX_SERVER_PORT)
			strcpy(str, pRomeCfgParam->serverpCfgParam[0][i].desc);		
		else
			strcpy(str, "");
		return (str);	
	}
	else
		return ("");	
		
}

extern int static_route_cur_index;
char *
nvram_get_current_static_route(char *name)
{
	char *ptr;
	int i;
	
	i = static_route_cur_index;			/* current */
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	if (strcmp(name, "desc") == 0) {	
		if (i < MAX_ROUTING)
			//sprintf(str, "Static Route"); 
			strcpy(str, pRomeCfgParam->routingCfgParam[i].desc);
		else
			strcpy(str, "");	/* for add */
	
		return str;
	}
	else if (strcmp(name, "ipaddr") == 0) {	
		if (i < MAX_ROUTING)
			strcpy(str, (char *)(inet_string((uint32)&(pRomeCfgParam->routingCfgParam[i].route)))); 
		else
			strcpy(str, "");	
		return str;
	}
	else if (strcmp(name, "netmask") == 0) {	
		if (i < MAX_ROUTING)
			strcpy(str, (char *)(inet_string((uint32)&(pRomeCfgParam->routingCfgParam[i].mask)))); 
		else
			strcpy(str, "");	
		return str;
		
	}
	else if (strcmp(name, "gateway") == 0) {	
		if (i < MAX_ROUTING)
			strcpy(str, (char *)(inet_string((uint32)&(pRomeCfgParam->routingCfgParam[i].gateway)))); 
		else
			strcpy(str, "");	
		return str;
		
	}	
	else if (strcmp(name, "enable") == 0) {
		if (i < MAX_ROUTING)		
			strcpy(str, (pRomeCfgParam->routingCfgParam[i].valid ? "on" : "off"));
		else
			strcpy(str, "on");		/* for add */	
		return (str);
	}
	else if (strcmp(name, "interface") == 0) {
		if (i < MAX_ROUTING)		
			strcpy(str, ((pRomeCfgParam->routingCfgParam[i].interface == ROUTING_INTERFACE_LAN) ? "1" : "0"));
		else
			strcpy(str, "0");		/* for add */	
		return (str);
	}
	else if (strcmp(name, "private") == 0) {
		if (i < MAX_ROUTING)		
			strcpy(str, ((pRomeCfgParam->routingCfgParam[i].rip_private == 1) ? "1" : "0"));
		else
			strcpy(str, "0");		/* for add */	
		return (str);
	}	
	else if (strcmp(name, "metric") == 0) {
		if (i < MAX_ROUTING)		
			sprintf(str, "%d", pRomeCfgParam->routingCfgParam[i].metric);
		else
			strcpy(str, "");		/* for add */	
		return (str);
	}				
	else
		return ("");	
		
}

extern int trigger_port_cur_index;
char *
nvram_get_current_trigger(char *name)
{
	char *ptr;
	int i;
	
	i = trigger_port_cur_index;			/* current */
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	if (strcmp(name, "o_port") == 0) {	
		if (i < MAX_SPECIAL_AP)
			sprintf(str, "%d-%d", pRomeCfgParam->specialapCfgParam[0][i].outStart,
				      pRomeCfgParam->specialapCfgParam[0][i].outFinish);
		else
			strcpy(str, "");				      
		return str;
	}
	if (strcmp(name, "i_port") == 0) {	
		if (i < MAX_SPECIAL_AP)
			sprintf(str, "%s", pRomeCfgParam->specialapCfgParam[0][i].inRange);
		else
			strcpy(str, "");			      
	
		return str;
	}	
	else if (strcmp(name, "i_proto") == 0) {	
		if (i >= MAX_SPECIAL_AP)
			return ("tcp");
		return ((pRomeCfgParam->specialapCfgParam[0][i].inType == 0) ? 
		         "tcp" : ((pRomeCfgParam->specialapCfgParam[0][i].inType == 1) ? "udp" : "both"));	
	}
	else if (strcmp(name, "o_proto") == 0) {	 //pamela20060104
		if (i >= MAX_SPECIAL_AP)
			return ("tcp");
		return ((pRomeCfgParam->specialapCfgParam[0][i].outType == 0) ? 
		         "tcp" : ((pRomeCfgParam->specialapCfgParam[0][i].outType == 1) ? "udp" : "both"));	
	}
	else if (strcmp(name, "enable") == 0) {	
		if (i >= MAX_SPECIAL_AP)
			return ("off");
		return ((pRomeCfgParam->specialapCfgParam[0][i].enable) ? "on" : "off");	
	}
	else if (strcmp(name, "service") == 0) {	
		if (i >= MAX_SPECIAL_AP)
			return ("");
		else
			return (pRomeCfgParam->specialapCfgParam[0][i].name);	
	}		
	else if (strcmp(name, "ip") == 0) { //pamela20060104
		if (i < MAX_SERVER_PORT)		
			strcpy(str, (char *)(inet_string((uint32)&(pRomeCfgParam->specialapCfgParam[0][i].ip))));		
		else
			strcpy(str, "");		/* for add */	
		return (str);
	}
	else
		return ("");	
		
}

extern int qos_cur_index;
char *
nvram_get_current_qos(char *name)
{
	char *ptr;
	int i;
	
	i = qos_cur_index;			/* current */
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	if (strcmp(name, "port") == 0) {	
		if (i < MAX_QOS)
			sprintf(str, "%d-%d", pRomeCfgParam->qosCfgParam[i].un.policy_based.portNumber,
				      pRomeCfgParam->qosCfgParam[i].un.policy_based.portNumber1);
		else
	      
			strcpy(str, "");
	
		return str;
	}
	else if (strcmp(name, "proto") == 0) {	
		if (i >= MAX_QOS)
			return ("both");
		return ((pRomeCfgParam->qosCfgParam[i].un.policy_based.protocol == 0) ? 
			"tcp" : ((pRomeCfgParam->qosCfgParam[i].un.policy_based.protocol == 1) ? "udp" : "both"));	
	}

	else if (strcmp(name, "enable") == 0) {
		if (i < MAX_QOS)		
			strcpy(str, (pRomeCfgParam->qosCfgParam[i].un.policy_based.enable ? "on" : "off"));
		else
			strcpy(str, "off");		/* for add */	
		return (str);
	}
	else if (strcmp(name, "priority") == 0) {
		if (i < MAX_QOS)		
			strcpy(str, (pRomeCfgParam->qosCfgParam[i].un.policy_based.isHigh ? "on" : "off"));
		else
			strcpy(str, "on");		/* for add */	
		return (str);
	}			
	else if (strcmp(name, "service") == 0) {
		if (i < MAX_QOS)
			strcpy(str, pRomeCfgParam->qosCfgParam[i].un.policy_based.desc);		
		else
			strcpy(str, "");
		return (str);	
	}
	else
		return ("");	
		
}


extern int dhcpc_res_cur_index;
char *
nvram_get_current_dhcpc_res(char *name)
{
	char *ptr;
	int i;
	
	i = dhcpc_res_cur_index;			/* current */
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	if (strcmp(name, "desc") == 0) {	
		if (i < MAX_DHCPC)
			sprintf(str, pRomeCfgParam->dhcpsCfgParam.manu_desc[i]); 
		else
			strcpy(str, "");
	
		return str;
	}
	else if (strcmp(name, "ipaddr") == 0) {	
		if (i < MAX_DHCPC)
			strcpy(str, (char *)(inet_string((uint32)&(pRomeCfgParam->dhcpsCfgParam.manualIp[i])))); 
		else
			strcpy(str, "");	
		return str;
	}
	else if (strcmp(name, "macaddr") == 0) {	
		if (i < MAX_DHCPC)
			ether_etoa(pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i], str);
		else
			strcpy(str, "");	
		return str;
	}
	else
		return ("");	
		
}



int pppoe_dial_status(int id)
{
	return (pRomeCfgParam->pppoeCfgParam[0].dialState);

}

int pptp_dial_status(int id)
{

	return (pRomeCfgParam->pptpCfgParam.dialState);	
}

int l2tp_dial_status(int id)
{

	return (pRomeCfgParam->l2tpCfgParam.dialState);	
}

void adjust_related_LAN_IP(void)
{
	struct in_addr ipaddr, netmask, tmp_ipaddr;
	int dsid = 0, i;
	int forward=0, triggerport=0, dmz=0, routing=0, acl=0, trusted=0, reserved=0;
	
	ipaddr.s_addr = *((unsigned int *)&(pRomeCfgParam->ifCfgParam[1].ipAddr));
	netmask.s_addr = *((unsigned int *)&(pRomeCfgParam->ifCfgParam[1].ipMask));		
	
	ipaddr.s_addr &= netmask.s_addr;
	
	for (i=0;i<MAX_SERVER_PORT;i++)
	{	
		
		//if (pRomeCfgParam->serverpCfgParam[dsid][i].enable == 0)
		//	continue;
		if (*((unsigned int *)&(pRomeCfgParam->serverpCfgParam[dsid][i].ip)) == 0)
			continue;		
		tmp_ipaddr.s_addr = *((unsigned int *)&(pRomeCfgParam->serverpCfgParam[dsid][i].ip));
	
		tmp_ipaddr.s_addr &= ~netmask.s_addr;
		tmp_ipaddr.s_addr |= ipaddr.s_addr;
		
		*((unsigned int *)&(pRomeCfgParam->serverpCfgParam[dsid][i].ip)) = tmp_ipaddr.s_addr;		
		forward = 1;
	}	
	
	for(i=0;i<MAX_SPECIAL_AP;i++)
	{		
		if(*((uint32 *)&(pRomeCfgParam->specialapCfgParam[dsid][i].ip)) == 0)
			continue;
			
		tmp_ipaddr.s_addr = *((uint32 *)&(pRomeCfgParam->specialapCfgParam[dsid][i].ip));
	
		tmp_ipaddr.s_addr &= ~netmask.s_addr;
		tmp_ipaddr.s_addr |= ipaddr.s_addr;
		
		*((uint32 *)&(pRomeCfgParam->specialapCfgParam[dsid][i].ip)) = tmp_ipaddr.s_addr;		
		triggerport = 1;		
	} //end special_application	
	
	if (pRomeCfgParam->dmzCfgParam[dsid].dmzIp != 0) {
		tmp_ipaddr.s_addr = pRomeCfgParam->dmzCfgParam[dsid].dmzIp;
		tmp_ipaddr.s_addr &= ~netmask.s_addr;
		tmp_ipaddr.s_addr |= ipaddr.s_addr;
		pRomeCfgParam->dmzCfgParam[dsid].dmzIp = tmp_ipaddr.s_addr;
		dmz = 1;
	}	
	
	for(i=0;i<MAX_ROUTING;i++)
	{
		if ((pRomeCfgParam->routingCfgParam[i].gateway == 0) || 
			(pRomeCfgParam->routingCfgParam[i].interface != ROUTING_INTERFACE_LAN))
			continue; 	
		tmp_ipaddr.s_addr = pRomeCfgParam->routingCfgParam[i].gateway;
		tmp_ipaddr.s_addr &= ~netmask.s_addr;
		tmp_ipaddr.s_addr |= ipaddr.s_addr;
		pRomeCfgParam->routingCfgParam[i].gateway = tmp_ipaddr.s_addr;			
		routing = 1;
	}	
	
	for (i=0; i<MAX_ACL; i++){	
		
		if (*((unsigned int *)&(pRomeCfgParam->aclCfgParam[dsid][i].ip)) != 0) {
			tmp_ipaddr.s_addr = *((unsigned int *)&(pRomeCfgParam->aclCfgParam[dsid][i].ip));
	
			tmp_ipaddr.s_addr &= ~netmask.s_addr;
			tmp_ipaddr.s_addr |= ipaddr.s_addr;
		
			*((unsigned int *)&(pRomeCfgParam->aclCfgParam[dsid][i].ip)) = tmp_ipaddr.s_addr;		
			acl = 1;					
		}
		if (*((unsigned int *)&(pRomeCfgParam->aclCfgParam[dsid][i].ip_end)) != 0) {
			tmp_ipaddr.s_addr = *((unsigned int *)&(pRomeCfgParam->aclCfgParam[dsid][i].ip_end));
	
			tmp_ipaddr.s_addr &= ~netmask.s_addr;
			tmp_ipaddr.s_addr |= ipaddr.s_addr;
		
			*((unsigned int *)&(pRomeCfgParam->aclCfgParam[dsid][i].ip_end)) = tmp_ipaddr.s_addr;		
			acl = 1;					
		}		
	}
	
	for(i=0;i<URL_FILTER_MAX_TRUSTED_USERS;i++)
	{
		if(pRomeCfgParam->urlfilterTrustedUserCfgParam[i].trustedIP ==0 )
			continue;
		tmp_ipaddr.s_addr = pRomeCfgParam->urlfilterTrustedUserCfgParam[i].trustedIP;
		tmp_ipaddr.s_addr &= ~netmask.s_addr;
		tmp_ipaddr.s_addr |= ipaddr.s_addr;
		pRomeCfgParam->urlfilterTrustedUserCfgParam[i].trustedIP = tmp_ipaddr.s_addr;			
		trusted = 1;			
				
	}
	
	for(i=0; i<MAX_RESERVED_FIXED; i++) {
		if (pRomeCfgParam->dhcpsCfgParam.manualIp[i] == 0)
			continue;
		tmp_ipaddr.s_addr = pRomeCfgParam->dhcpsCfgParam.manualIp[i];
		tmp_ipaddr.s_addr &= ~netmask.s_addr;
		tmp_ipaddr.s_addr |= ipaddr.s_addr;
		pRomeCfgParam->dhcpsCfgParam.manualIp[i] = tmp_ipaddr.s_addr;			
		reserved = 1;			
				
	}
			
	if (forward)
		forwardport_cfg_save();	
	if (triggerport) 
		porttrig_cfg_save();
	if (dmz)
		dmz_cfg_save();	
	if (routing)
		routing_cfg_save();
		
	if (acl) {		
		cfgmgr_write(CFGMGR_TABID_ACL,(void*)pRomeCfgParam->aclCfgParam,sizeof(struct aclCfgParam_s)*MAX_ACL*MAX_PPPOE_SESSION);
	}	
	
	if (trusted)
		trusted_cfg_save();	
		
	if (reserved)
		cfgmgr_write(CFGMGR_TABID_DHCPS,(void*)&(pRomeCfgParam->dhcpsCfgParam), sizeof(pRomeCfgParam->dhcpsCfgParam));
	
}	

//Yili 2006/1/10
#if defined(DNI)
int mnu_login_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_MNU,(void*)&(pRomeCfgParam->mnuCfgParam),sizeof(pRomeCfgParam->mnuCfgParam));
	cfgmgr_task();

	return 1;
}


int httpc_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_HTTPC_INFO,(void*)&(pRomeCfgParam->httpclientCfgParam), sizeof(pRomeCfgParam->httpclientCfgParam));
	cfgmgr_task();
	
	return 1;
}

#endif
//end

int wan_cfg_save(int pastType)
{
	char *ptr;

	ptr = nvram_get_wan_proto("wan_proto");
	if (strcmp(ptr, "dhcp") == 0)		
		cfgmgr_write(CFGMGR_TABID_DHCPC,(void*)&(pRomeCfgParam->dhcpcCfgParam),sizeof(pRomeCfgParam->dhcpcCfgParam));
	else if (strcmp(ptr, "pppoe") == 0)		
		cfgmgr_write(CFGMGR_TABID_PPPOE,(void*)pRomeCfgParam->pppoeCfgParam,sizeof(struct pppoeCfgParam_s)*MAX_PPPOE_SESSION);
	else if (strcmp(ptr, "pptp") == 0)	
		cfgmgr_write(CFGMGR_TABID_PPTP,(void*)&pRomeCfgParam->pptpCfgParam, sizeof(pRomeCfgParam->pptpCfgParam));
	else if (strcmp(ptr, "telstra") == 0)	
		cfgmgr_write(CFGMGR_TABID_TEL,(void*)&pRomeCfgParam->telCfgParam, sizeof(pRomeCfgParam->telCfgParam));
	else if (strcmp(ptr, "l2tp") == 0)	
		cfgmgr_write(CFGMGR_TABID_L2TP,(void*)&(pRomeCfgParam->l2tpCfgParam),sizeof(pRomeCfgParam->l2tpCfgParam));
		
	cfgmgr_write(CFGMGR_TABID_IF,(void*)pRomeCfgParam->ifCfgParam, sizeof(pRomeCfgParam->ifCfgParam));
	cfgmgr_write(CFGMGR_TABID_DNS,(void*)&(pRomeCfgParam->dnsCfgParam), sizeof(pRomeCfgParam->dnsCfgParam));
	cfgmgr_write(CFGMGR_TABID_DHCPS,(void*)&(pRomeCfgParam->dhcpsCfgParam), sizeof(pRomeCfgParam->dhcpsCfgParam));

	cfgmgr_task();
	return 1;
}

int dhcps_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_DHCPS,(void*)&(pRomeCfgParam->dhcpsCfgParam), sizeof(pRomeCfgParam->dhcpsCfgParam));
	cfgmgr_task();	
	
	return 1;
}	
	

int dhcpc_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_DHCPC,(void*)&(pRomeCfgParam->dhcpcCfgParam),sizeof(pRomeCfgParam->dhcpcCfgParam));
	cfgmgr_task();

	return 1;
}

int lan_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_IF,(void*)pRomeCfgParam->ifCfgParam, sizeof(pRomeCfgParam->ifCfgParam));
	cfgmgr_write(CFGMGR_TABID_DHCPS,(void*)&(pRomeCfgParam->dhcpsCfgParam), sizeof(pRomeCfgParam->dhcpsCfgParam));
	cfgmgr_write(CFGMGR_TABID_RIP,(void*)&(pRomeCfgParam->ripCfgParam), sizeof(pRomeCfgParam->ripCfgParam));
	cfgmgr_task();			
	
	return 1;
}	
int wlan_cfg_save(void)
{
	//cfgmgr_write(CFGMGR_TABID_WLAN,(void*)pRomeCfgParam->wlanCfgParam, sizeof(pRomeCfgParam->wlanCfgParam));
	cfgmgr_write(CFGMGR_TABID_WLAN,(void*)pRomeCfgParam->wlanCfgParam,sizeof(wlanCfgParam_t)*MAX_WLAN_CARDS);
	cfgmgr_task();			
	
	return 1;
}	

int wan_security_cfg_save(void)
{
	/* for mtu */
	cfgmgr_write(CFGMGR_TABID_IF,(void*)pRomeCfgParam->ifCfgParam, sizeof(pRomeCfgParam->ifCfgParam));
	cfgmgr_write(CFGMGR_TABID_PPPOE,(void*)pRomeCfgParam->pppoeCfgParam,sizeof(struct pppoeCfgParam_s)*MAX_PPPOE_SESSION);
	cfgmgr_write(CFGMGR_TABID_PPTP,(void*)&pRomeCfgParam->pptpCfgParam, sizeof(pRomeCfgParam->pptpCfgParam));	
	cfgmgr_write(CFGMGR_TABID_TEL,(void*)&pRomeCfgParam->telCfgParam, sizeof(pRomeCfgParam->telCfgParam));
	cfgmgr_write(CFGMGR_TABID_L2TP,(void*)&(pRomeCfgParam->l2tpCfgParam),sizeof(pRomeCfgParam->l2tpCfgParam));
	
	cfgmgr_task();	
	return 1;
}

int alg_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_ALG,(void*)pRomeCfgParam->algCfgParam,sizeof(algCfgParam_t)*MAX_PPPOE_SESSION);
	
	cfgmgr_task();	
	return 1;
}

int dos_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_DOS,(void*)&pRomeCfgParam->dosCfgParam, sizeof(pRomeCfgParam->dosCfgParam));	
	cfgmgr_task();	
	return 1;
}	

int mgmt_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_MGMT,(void*)pRomeCfgParam->mgmtCfgParam,sizeof(mgmtCfgParam_t)*MAX_MGMT_USER);
	
	cfgmgr_task();	

	return 1;	
	
}

int email_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_EMAIL,(void*)&(pRomeCfgParam->emailCfgParam), sizeof(emailCfgParam_t));
	cfgmgr_task();	

	return 1;	
	
}

int dmz_cfg_save(void)
{
	
	cfgmgr_write(CFGMGR_TABID_DMZ,(void*)pRomeCfgParam->dmzCfgParam, sizeof(struct dmzCfgParam_s)*MAX_PPPOE_SESSION);
	
	cfgmgr_task();	
		
	return 1;
		
}

int forwardport_cfg_save(void)
{
	/* save to cfgmgr */
	cfgmgr_write(CFGMGR_TABID_SERVERP,(void*)pRomeCfgParam->serverpCfgParam,sizeof(struct serverpCfgParam_s)*MAX_SERVER_PORT*MAX_PPPOE_SESSION);
	cfgmgr_task();
	return 1;	
}	

int fw_blocksitet_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_URLFILTER,(void*)pRomeCfgParam->urlfilterCfgParam,sizeof(urlfilterCfgParam_t)*MAX_URL_FILTER*MAX_PPPOE_SESSION);
	cfgmgr_write(CFGMGR_TABID_SCHEDULE,(void*)&(pRomeCfgParam->scheduleCfgParam), sizeof(struct scheduleCfgParam_s));
	cfgmgr_write(CFGMGR_TABID_URLFILTERTRUSTEDUSER,(void*)pRomeCfgParam->urlfilterTrustedUserCfgParam,sizeof(urlfilterTrustedUserCfgParam_t)*URL_FILTER_MAX_TRUSTED_USERS);


	cfgmgr_task();
	
	return 1;	

	
}	

int schedule_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_SCHEDULE,(void*)&(pRomeCfgParam->scheduleCfgParam), sizeof(struct scheduleCfgParam_s));

	cfgmgr_task();
	return 1;	
}

int trusted_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_URLFILTERTRUSTEDUSER,(void*)pRomeCfgParam->urlfilterTrustedUserCfgParam,sizeof(urlfilterTrustedUserCfgParam_t)*URL_FILTER_MAX_TRUSTED_USERS);

	cfgmgr_task();
	return 1;	
}

int fw_filter_client_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_ACL,(void*)pRomeCfgParam->aclCfgParam,sizeof(struct aclCfgParam_s)*MAX_ACL*MAX_PPPOE_SESSION);
	cfgmgr_write(CFGMGR_TABID_SCHEDULE,(void*)&(pRomeCfgParam->scheduleCfgParam), sizeof(struct scheduleCfgParam_s));
	cfgmgr_task();

	return 1;	

}

int fw_schedule_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_ACL,(void*)pRomeCfgParam->aclCfgParam,sizeof(struct aclCfgParam_s)*MAX_ACL*MAX_PPPOE_SESSION);
	cfgmgr_write(CFGMGR_TABID_SCHEDULE,(void*)&(pRomeCfgParam->scheduleCfgParam), sizeof(struct scheduleCfgParam_s));
	cfgmgr_task();
	
	return 1;	
}	

int ddns_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_DDNS,(void*)&(pRomeCfgParam->ddnsCfgParam), sizeof(pRomeCfgParam->ddnsCfgParam));
	cfgmgr_task();

	return 1;	
}	


int upnp_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_UPNP,(void*)&(pRomeCfgParam->upnpCfgParam), sizeof(pRomeCfgParam->upnpCfgParam));
	cfgmgr_task();
	
	return 1;
}

int porttrig_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_SPECIALAP,(void*)pRomeCfgParam->specialapCfgParam,sizeof(struct specialapCfgParam_s)*MAX_PPPOE_SESSION*MAX_SPECIAL_AP);
	cfgmgr_task();
	
	return 1;
	
}

int routing_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_ROUTING,(void*)pRomeCfgParam->routingCfgParam,sizeof(struct routingCfgParam_s)*MAX_ROUTING);
	cfgmgr_task();
	
	return 1;
}

int qos_cfg_save(void)
{
	cfgmgr_write(CFGMGR_TABID_QOS,(void*)&(pRomeCfgParam->qosCfgParam), sizeof(struct qosCfgParam_s)*MAX_QOS);
	cfgmgr_task();
	
	return 1;
}

//KEVIN:05DEC27:BlankState+++
uint GetCurWanConnType(void) 
{
	return (pRomeCfgParam->ifCfgParam[0].connType);
}

/************************************************************
 *	
 *	Write WAN Configuration into Flash
 *	
 ************************************************************/
int WanConfigSaveToFlash(uint32 connType)
{
	int result;

	switch(connType)
	{
	case IFCFGPARAM_CONNTYPE_DHCPC:	
		cfgmgr_write(CFGMGR_TABID_DHCPC,(void*)&(pRomeCfgParam->dhcpcCfgParam),sizeof(pRomeCfgParam->dhcpcCfgParam));
		break;
	case IFCFGPARAM_CONNTYPE_PPTP:
		cfgmgr_write(CFGMGR_TABID_PPTP,(void*)&(pRomeCfgParam->pptpCfgParam),sizeof(pRomeCfgParam->pptpCfgParam));
		break;
	case IFCFGPARAM_CONNTYPE_PPPOE:		
		cfgmgr_write(CFGMGR_TABID_PPPOE,(void*)pRomeCfgParam->pppoeCfgParam ,sizeof(pppoeCfgParam_t)*MAX_PPPOE_SESSION);
		break;
	case IFCFGPARAM_CONNTYPE_TELSTRA:		
		cfgmgr_write(CFGMGR_TABID_DHCPC,(void*)&(pRomeCfgParam->dhcpcCfgParam),sizeof(pRomeCfgParam->dhcpcCfgParam));
		cfgmgr_write(CFGMGR_TABID_TEL,(void*)&pRomeCfgParam->telCfgParam, sizeof(pRomeCfgParam->telCfgParam));
		break;
	case IFCFGPARAM_CONNTYPE_L2TP:
		cfgmgr_write(CFGMGR_TABID_L2TP,(void*)&(pRomeCfgParam->l2tpCfgParam),sizeof(pRomeCfgParam->l2tpCfgParam));
		break;		
	case IFCFGPARAM_CONNTYPE_DHCPL2TP:
		cfgmgr_write(CFGMGR_TABID_L2TP,(void*)&(pRomeCfgParam->l2tpCfgParam),sizeof(pRomeCfgParam->l2tpCfgParam));
		break;		
		
		
	}	
	result = cfgmgr_write(CFGMGR_TABID_IF,(void*)pRomeCfgParam->ifCfgParam,sizeof(ifCfgParam_t)*MAX_IP_INTERFACE);
	result = cfgmgr_write(CFGMGR_TABID_DHCPS,(void*)&(pRomeCfgParam->dhcpsCfgParam),sizeof(dhcpsCfgParam_t));
	cfgmgr_write(CFGMGR_TABID_DNS,(void*)&(pRomeCfgParam->dnsCfgParam), sizeof(pRomeCfgParam->dnsCfgParam));
	
	//DEBUG_P("write result %d\n", result);
	cfgmgr_write(CFGMGR_TABID_MGMT,(void*)pRomeCfgParam->mgmtCfgParam,sizeof(mgmtCfgParam_t)*MAX_MGMT_USER); //KEVIN:06JAN25:Add
	cfgmgr_write(CFGMGR_TABID_BLANK_STATE,(void*)&(pRomeCfgParam->BlankStateCfgParam), sizeof(pRomeCfgParam->BlankStateCfgParam));
	
	cfgmgr_task();
	
	return 1;
	

}
//KEVIN:BlankState---

int nvram_commit(void)
{
	cfgmgr_write(CFGMGR_TABID_IF,(void*)pRomeCfgParam->ifCfgParam, sizeof(pRomeCfgParam->ifCfgParam));
	cfgmgr_write(CFGMGR_TABID_PPPOE,(void*)pRomeCfgParam->pppoeCfgParam,sizeof(struct pppoeCfgParam_s)*MAX_PPPOE_SESSION);
	cfgmgr_write(CFGMGR_TABID_PPTP,(void*)&pRomeCfgParam->pptpCfgParam, sizeof(pRomeCfgParam->pptpCfgParam));
	cfgmgr_write(CFGMGR_TABID_TEL,(void*)&pRomeCfgParam->telCfgParam, sizeof(pRomeCfgParam->telCfgParam));
	cfgmgr_write(CFGMGR_TABID_L2TP,(void*)&(pRomeCfgParam->l2tpCfgParam),sizeof(pRomeCfgParam->l2tpCfgParam));
	
//Yili 2006/1/10
#if defined(DNI)
	cfgmgr_write(CFGMGR_TABID_MNU,(void*)&pRomeCfgParam->mnuCfgParam, sizeof(pRomeCfgParam->mnuCfgParam));
#endif
//end
	cfgmgr_write(CFGMGR_TABID_DNS,(void*)&(pRomeCfgParam->dnsCfgParam), sizeof(pRomeCfgParam->dnsCfgParam));
	cfgmgr_write(CFGMGR_TABID_DHCPS,(void*)&(pRomeCfgParam->dhcpsCfgParam), sizeof(pRomeCfgParam->dhcpsCfgParam));
	cfgmgr_write(CFGMGR_TABID_DHCPC,(void*)&(pRomeCfgParam->dhcpcCfgParam),sizeof(pRomeCfgParam->dhcpcCfgParam));
	cfgmgr_write(CFGMGR_TABID_RIP,(void*)&(pRomeCfgParam->ripCfgParam), sizeof(pRomeCfgParam->ripCfgParam));
	cfgmgr_write(CFGMGR_TABID_DOS,(void*)&pRomeCfgParam->dosCfgParam, sizeof(pRomeCfgParam->dosCfgParam));	
	cfgmgr_write(CFGMGR_TABID_MGMT,(void*)pRomeCfgParam->mgmtCfgParam,sizeof(mgmtCfgParam_t)*MAX_MGMT_USER);
	cfgmgr_write(CFGMGR_TABID_EMAIL,(void*)&(pRomeCfgParam->emailCfgParam), sizeof(emailCfgParam_t));
	cfgmgr_write(CFGMGR_TABID_DMZ,(void*)pRomeCfgParam->dmzCfgParam, sizeof(struct dmzCfgParam_s)*MAX_PPPOE_SESSION);
	cfgmgr_write(CFGMGR_TABID_SERVERP,(void*)pRomeCfgParam->serverpCfgParam,sizeof(struct serverpCfgParam_s)*MAX_SERVER_PORT*MAX_PPPOE_SESSION);
	cfgmgr_write(CFGMGR_TABID_URLFILTER,(void*)pRomeCfgParam->urlfilterCfgParam,sizeof(urlfilterCfgParam_t)*MAX_URL_FILTER*MAX_PPPOE_SESSION);
	cfgmgr_write(CFGMGR_TABID_URLFILTERTRUSTEDUSER,(void*)pRomeCfgParam->urlfilterTrustedUserCfgParam,sizeof(urlfilterTrustedUserCfgParam_t)*URL_FILTER_MAX_TRUSTED_USERS);
	cfgmgr_write(CFGMGR_TABID_SCHEDULE,(void*)&(pRomeCfgParam->scheduleCfgParam), sizeof(struct scheduleCfgParam_s));
	cfgmgr_write(CFGMGR_TABID_ACL,(void*)pRomeCfgParam->aclCfgParam,sizeof(struct aclCfgParam_s)*MAX_ACL*MAX_PPPOE_SESSION);
	cfgmgr_write(CFGMGR_TABID_DDNS,(void*)&(pRomeCfgParam->ddnsCfgParam), sizeof(pRomeCfgParam->ddnsCfgParam));
	cfgmgr_write(CFGMGR_TABID_UPNP,(void*)&(pRomeCfgParam->upnpCfgParam), sizeof(pRomeCfgParam->upnpCfgParam));
	cfgmgr_write(CFGMGR_TABID_SPECIALAP,(void*)pRomeCfgParam->specialapCfgParam,sizeof(struct specialapCfgParam_s)*MAX_PPPOE_SESSION*MAX_SPECIAL_AP);
	cfgmgr_write(CFGMGR_TABID_ROUTING,(void*)pRomeCfgParam->routingCfgParam,sizeof(struct routingCfgParam_s)*MAX_ROUTING);
	cfgmgr_write(CFGMGR_TABID_BLANK_STATE,(void*)&(pRomeCfgParam->BlankStateCfgParam),sizeof(pRomeCfgParam->BlankStateCfgParam));
	//cfgmgr_write(CFGMGR_TABID_HTTPC_INFO,(void*)&(pRomeCfgParam->httpclientCfgParam), sizeof(pRomeCfgParam->httpclientCfgParam));
	cfgmgr_write(CFGMGR_TABID_WLAN,(void*)pRomeCfgParam->wlanCfgParam,sizeof(wlanCfgParam_t)*MAX_WLAN_CARDS);
	cfgmgr_write(CFGMGR_TABID_QOS,(void*)&(pRomeCfgParam->qosCfgParam), sizeof(struct qosCfgParam_s)*MAX_QOS);

	
	cfgmgr_task();	
	return 1;	
}	

#endif		/* #if defined(DNI) */

//ch### >>
////////////////////////////////////////////////////////
//int32 POT_factoryDefault(uint16 POT_Resolution,uint16 POT_RepackThreshold);  // Ĥ@ϥ, N bdinfo block   POT infomation M
//int32 POT_oneSecPass(void); // C榹 function @
//int32 POT_ReadPowerOnTime(void);  // Ū^@LXPOT_oneSecPass.
 
//ҦǦ^ȥu  SUCCESS:0 , FAILED: -1
 
#define POT_OFFSET 0x1000
#define POT_LENGTH 0x1000
int32 POT_oneSecPass(void)
{
 int pot,offset;
 uint16 value=0xffff;
 pot=POT_ReadPowerOnTime();

 
 if(pot==FAILED) return -1;

 //rtlglue_printf( "POT = %d\r\n",pot);

 if(pot<4320)
 {
    offset=(pot>>4)<<1;
    pot=(pot&0xf)+1; 
    value>>=pot; 
    flashdrv_write((void*)FLASH_MAP_BOARD_INFO_ADDR+POT_OFFSET+offset+4,(void*)&value,2); 
 }

 return SUCCESS; 
}

int32 POT_GetResolution(void)
{
 uint16 ptr[POT_LENGTH];
 //ptr=(uint16 *)malloc(POT_LENGTH);
 //if(ptr==NULL) return FAILED; // out of memory
 
 if(flashdrv_read((void*)ptr,(void*)FLASH_MAP_BOARD_INFO_ADDR+POT_OFFSET,POT_LENGTH)!=SUCCESS) return FAILED;

 return (int32)ptr[0]; 
}

#if 1
// onClick="reRestore();
int32 POT_GetRepackThreshold(void)
{
 uint16 ptr[POT_LENGTH];
 //ptr=(uint16 *)malloc(POT_LENGTH);
 //if(ptr==NULL) return FAILED; // out of memory
 
 if(flashdrv_read((void*)ptr,(void*)FLASH_MAP_BOARD_INFO_ADDR+POT_OFFSET,POT_LENGTH)!=SUCCESS) return FAILED;

 //rtlglue_printf( "POT_GetRepackThreshold=%d \r\n", POT_GetRepackThreshold );
 
 //pRomeCfgParam->potCfgParam.Threshold = (int32)ptr[1];
 
 return (int32)ptr[1]; 
}
#endif

 
int32 POT_ReadPowerOnTime(void)
{
 int32 pot=0;
 uint16 ptr[POT_LENGTH];
 int i,j;
 //ptr=(uint16 *)malloc(POT_LENGTH);
 //if(ptr==NULL) return FAILED; // out of memory
 
 if(flashdrv_read((void*)ptr,(void*)FLASH_MAP_BOARD_INFO_ADDR+POT_OFFSET,POT_LENGTH)!=SUCCESS) return FAILED;
 
 /*
 for(i=0;i<128;i++)
 {
     rtlglue_printf( "%04x ", ptr[i] );
	 if((i+1)%16==0)rtlglue_printf( "\r\n");
 }

 rtlglue_printf( "\r\n");
 rtlglue_printf( "----------------------------------------------------------\r\n");
 */


 for(i=0;i<POT_LENGTH/2;i++)
 {
  for(j=15;j>=0;j--)
  {
   if((ptr[i+2]&(1<<j))!=0) goto finished;
   pot++;
  } 
 }
finished: 
 return pot;
}

 
int32 POT_factoryDefault(uint16 POT_Resolution,uint16 POT_RepackThreshold)
{
 bdinfo_t bdinfo;
 uint32 ChipSeq;
 uint32 BlockSeq; 
 if(bdinfo_read(&bdinfo)!=SUCCESS) return FAILED;
  
 if ( searchBlockSeq( ((uint32)FLASH_MAP_BOARD_INFO_ADDR) , &ChipSeq, &BlockSeq ) != SUCCESS )
 {
  rtlglue_printf( "searchBlockSeq(0x%08x) failed.\n", ((uint32)FLASH_MAP_BOARD_INFO_ADDR) );
  return FAILED;
 }
 if ( flashdrv_eraseBlock(ChipSeq,BlockSeq) != SUCCESS)
 {
  rtlglue_printf( "eraseBlock(0x%08x) failed.\n", ((uint32)FLASH_MAP_BOARD_INFO_ADDR) ); 
  return FAILED;
 }
 
 if(flashdrv_write((void*)FLASH_MAP_BOARD_INFO_ADDR,(void*)&bdinfo,sizeof(bdinfo))!=SUCCESS)
 {
  rtlglue_printf( "flashdrv_write(0x%08x) failed.\n", ((uint32)FLASH_MAP_BOARD_INFO_ADDR) ); 
  return FAILED;
 }

 
 flashdrv_write((void*)FLASH_MAP_BOARD_INFO_ADDR+POT_OFFSET+0,(void*)(&POT_Resolution),2); 
 flashdrv_write((void*)FLASH_MAP_BOARD_INFO_ADDR+POT_OFFSET+2,(void*)(&POT_RepackThreshold),2); 

 return SUCCESS;
}
//ch### <<

