



#include <stdio.h>
#include <sys/shm.h>
#include <netinet/in.h>
#include "ej_nvram.h"
#include <board.h>

static int geted = 0;

static char str[250];

romeCfgParam_t * pRomeCfgParam;


static int match( const char* pattern, const char* string );
static int match_one( const char* pattern, int patternlen, const char* string );


int nvram_handler_match( const char* pattern, const char* string )
{
    return (match(pattern,string));
}

/* Simple shell-style filename matcher.  Only does ? * and **, and multiple
** patterns separated by |.  Returns 1 or 0.
*/
int
match( const char* pattern, const char* string )
    {
    const char* or;

    for (;;)
	{
	or = strchr( pattern, '|' );
	if ( or == (char*) 0 )
	    return match_one( pattern, strlen( pattern ), string );
	if ( match_one( pattern, or - pattern, string ) )
	    return 1;
	pattern = or + 1;
	}
    }


static int
match_one( const char* pattern, int patternlen, const char* string )
    {
    const char* p;

    for ( p = pattern; p - pattern < patternlen; ++p, ++string )
	{
	if ( *p == '?' && *string != '\0' )
	    continue;
	if ( *p == '*' )
	    {
	    int i, pl;
	    ++p;
	    if ( *p == '*' )
		{
		/* Double-wildcard matches anything. */
		++p;
		i = strlen( string );
		}
	    else
		/* Single-wildcard matches anything but slash. */
		i = strcspn( string, "/" );
	    pl = patternlen - ( p - pattern );
	    for ( ; i >= 0; --i )
		if ( match_one( p, pl, &(string[i]) ) )
		    return 1;
	    return 0;
	    }
	if ( *p != *string )
	    return 0;
	}
    //if ( *string == '\0' || *string == '?' )
    if ( *string == '\0' )
	return 1;
    return 0;
}

int nvram_commit(void)
{
	return 1;	
}	

char* nvram_get(char *name)
{
	char *c=NULL;
	struct ej_nvram_handler *handler;	

    	int shmid=0;

	if (geted == 0)	{
    		shmid=shmget(SHM_PROMECFGPARAM,sizeof(romeCfgParam_t),0666|IPC_CREAT);
    		pRomeCfgParam=shmat(shmid,(void*)0,0);    	
    		geted = 1;
    	}	

        /* request semaphore */
    	//status = NU_Obtain_Semaphore(&nvram_get_semaphore, NU_SUSPEND);	
	
	/* Call handler */
	for (handler = &nvram_handlers[0]; handler->pattern; handler++) {
		//if (strncmp(handler->pattern, name, strlen(handler->pattern)) == 0) {
	    if (nvram_handler_match(handler->pattern, name)) {
			if (handler->get)
			  c = (char *)handler->get(name);
			break;
		}	

	}
    	//status = NU_Release_Semaphore(&nvram_get_semaphore);
	//if (shmdt(pRomeCfgParam) == -1) 
	//	perror("shmdt");   	
	    	
	return c;
}

int nvram_set(char *name, char *value)
{
	char *c=NULL;
	struct ej_nvram_handler *handler;
	
    	int shmid=0;	
	
        /* request semaphore */
    	//status = NU_Obtain_Semaphore(&nvram_get_semaphore, NU_SUSPEND);	
    	
	if (geted == 0) {
    		shmid=shmget(SHM_PROMECFGPARAM,sizeof(romeCfgParam_t),0666|IPC_CREAT);
    		pRomeCfgParam=shmat(shmid,(void*)0,0);    	
    		geted = 1;
    	}    	
	
	/* Call handler */
	for (handler = &nvram_handlers[0]; handler->pattern; handler++) {
		//if (strncmp(handler->pattern, name, strlen(handler->pattern)) == 0) {
	
	    if (nvram_handler_match(handler->pattern, name)) {
			if (handler->set)
			  c = (char *)handler->set(name, value);
			break;
		}	

	}
    	//status = NU_Release_Semaphore(&nvram_get_semaphore);
	//if (shmdt(pRomeCfgParam) == -1) 
	//	perror("shmdt");   	
    	
	return c;
}



int nvram_match(char *name, char *match)
{
	char *c;
	int ret = 0;
	
	c = nvram_get(name);
	if (c != NULL) {
		if (strcmp(c, match) == 0)
		  ret = 1;
	}
	return ret;
}

int nvram_invmatch(char *name, char *invmatch)
{
	char *c;
	int ret = 1;
	
	c = nvram_get(name);
	if (c != NULL) {
		if (strcmp(c, invmatch) == 0)
		  ret = 0;
	}
	return ret;
}


extern struct ej_nvram_handler nvram_handlers[];
struct ej_nvram_handler *pNvramHandle=nvram_handlers;


/* argv[0] -> skip nvram item */
char*
nvram_show(int restart, int agrc, char **argv)
{
	char *pstrValue;
	static char nvram_value[100];	
	int i = 0;
	
	if (restart)
		pNvramHandle=nvram_handlers;
	
	if ( pNvramHandle->pattern ) {
		
		pstrValue = nvram_get( pNvramHandle->pattern );
		i = 0;
		while (argv[i] != 0) {
			if (strstr(pNvramHandle->pattern, argv[i])) {
				strcpy(nvram_value, "");
				goto exit_show;
			}	
			i++;
		}
		sprintf(nvram_value, "%s=%s", pNvramHandle->pattern, (pstrValue ? pstrValue : ""));
exit_show:
		pNvramHandle++;
		return (nvram_value);
	}
	return NULL;	

}

char *none_backup_nvram1[] = 
{
	NULL,
};	

int
nvram_get_all(int restart, int agrc, char **argv)
{
	int ret = 0;
	char *value;
	
	value = nvram_show(1, 0, none_backup_nvram1);
	while (value) {
		if (*value)
			printf("%s\n", value);			
		value = nvram_show(0, 0, none_backup_nvram1);
	}	

	return ret;
}

//#define DPRINTF		printf
#define DPRINTF				

#if 0		/* moved to shutils.c */
#define ETHER_ADDR_LEN		6
/*
 * Convert Ethernet address string representation to binary data
 * @param	a	string in xx:xx:xx:xx:xx:xx notation
 * @param	e	binary data
 * @return	TRUE if conversion was successful and FALSE otherwise
 */
int
ether_atoe(const char *a, unsigned char *e)
{
	char *c = (char *) a;
	int i = 0;

	memset(e, 0, ETHER_ADDR_LEN);
	for (;;) {
		e[i++] = (unsigned char) strtoul(c, &c, 16);
		if (!*c++ || i == ETHER_ADDR_LEN)
			break;
	}
	return (i == ETHER_ADDR_LEN);
}


/*
 * Convert Ethernet address binary data to string representation
 * @param	e	binary data
 * @param	a	string in xx:xx:xx:xx:xx:xx notation
 * @return	a
 */
char *
ether_etoa(const unsigned char *e, char *a)
{
	char *c = a;
	int i;

	for (i = 0; i < ETHER_ADDR_LEN; i++) {
		if (i)
			*c++ = ':';
		c += sprintf(c, "%02X", e[i] & 0xff);
	}
	return a;
}	
#endif

/************************************************************
 *	
 *	Status 
 *	
 ************************************************************/
char *inet_string(uint32 dst)
{
	struct in_addr	in;
	memcpy((char*)&in,(char*)dst,sizeof(in));
	return (inet_ntoa(in));
}


char *
nvram_get_wan0_hwaddr(char *name)
{
	ether_etoa(pRomeCfgParam->ifCfgParam[0].hwaddr, str);
	return (str);	
	
	
} 

int
nvram_set_wan0_hwaddr(char *name, char *value)
{


	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	ether_atoe(value, pRomeCfgParam->ifCfgParam[0].hwaddr);
	ether_atoe(value, pRomeCfgParam->ifCfgParam[2].hwaddr);		/* for static */

	return 1;
} 

char *
nvram_get_wan_hwaddr(char *name)
{
	unsigned char *c=NULL;
	int ret = 0;
	

	DPRINTF("nvram_get(\"%s\")\n", name);

	return (nvram_get_wan0_hwaddr("wan0_hwaddr"));
		
} 

int
nvram_set_wan_hwaddr(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	unsigned char hwaddr[6];

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	nvram_set_wan0_hwaddr("wan0_hwaddr", value);

	return 1;
} 

char *
nvram_get_lan_hwaddr(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	
	ether_etoa(pRomeCfgParam->ifCfgParam[1].hwaddr, str);
	return (str);	

} 

int
nvram_set_lan_hwaddr(char *name, char *value)
{
	int ret = 0;
	

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	ether_atoe(value, pRomeCfgParam->ifCfgParam[1].hwaddr);
	
	return 1;
} 

char *
nvram_get_lan_ipaddr(char *name)
{
	char *c;
	int ret = 0;
	
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[1].ipAddr)));				

}

int
nvram_set_lan_ipaddr(char *name, char *value)
{
	int ret = 0;

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->ifCfgParam[1].ipAddr)); 
	
	return 1;
}


char *
nvram_get_lan_netmask(char *name)
{
	char *c;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[1].ipMask)));	

}

int
nvram_set_lan_netmask(char *name, char *value)
{
	char *c;
	int ret = 0;

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->ifCfgParam[1].ipMask));
	return 1;

}
char *
nvram_get_rip_dir(char *name)
{
	char *c;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	sprintf(str, "%d", pRomeCfgParam->ripCfgParam.rip_dir);
	c = str;
	return (c);	
}

int
nvram_set_rip_dir(char *name, char *value)
{
	char *c;
	int ret = 0;

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	pRomeCfgParam->ripCfgParam.rip_dir = atoi(value);	
	return 1;

}

char *
nvram_get_rip_ver(char *name)
{
	char *c;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	sprintf(str, "%d", pRomeCfgParam->ripCfgParam.rip_ver);
	c = str;
	return (c);	

}

int
nvram_set_rip_ver(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	pRomeCfgParam->ripCfgParam.rip_ver = atoi(value);	
	return 1;

}

char *
nvram_get_dhcp_start(char *name)
{
	char *c;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	sprintf(str, "%d.%d.%d.%d", pRomeCfgParam->ifCfgParam[1].ipAddr[0], 
					pRomeCfgParam->ifCfgParam[1].ipAddr[1],
					pRomeCfgParam->ifCfgParam[1].ipAddr[2],
					pRomeCfgParam->dhcpsCfgParam.startIp);

	c=str;
	return (c);

}

int
nvram_set_dhcp_start(char *name, char *value)
{
	char *ptr;
	int i = 0;

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	ptr = strtok(value, ".");	
	while (ptr) {
		i++;		
		if (i == 4) break;
		ptr= strtok(NULL, ".");
	}	
	
	if (ptr && i == 4)
		pRomeCfgParam->dhcpsCfgParam.startIp = atoi(ptr);	
		
	return 1;		
}		
		

char *
nvram_get_dhcp_end(char *name)
{
	char *c;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	sprintf(str, "%d.%d.%d.%d", pRomeCfgParam->ifCfgParam[1].ipAddr[0], 
					pRomeCfgParam->ifCfgParam[1].ipAddr[1],
					pRomeCfgParam->ifCfgParam[1].ipAddr[2],
					pRomeCfgParam->dhcpsCfgParam.endIp);

	c=str;
	return (c);

}

int
nvram_set_dhcp_end(char *name, char *value)
{
	char *ptr;
	int i = 0;

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	ptr = strtok(value, ".");	
	while (ptr) {
		i++;		
		if (i == 4) break;
		ptr= strtok(NULL, ".");
	}	
	
	if (ptr && i == 4)
		pRomeCfgParam->dhcpsCfgParam.endIp = atoi(ptr);	
		
	return 1;		
}	

char *
nvram_get_lan_proto(char *name)
{
	char *c;
	int ret = 0;

	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return ((pRomeCfgParam->dhcpsCfgParam.enable) ? "dhcp" : "static");

}

int
nvram_set_lan_proto(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	if (strcmp(value, "dhcp") == 0)
		pRomeCfgParam->dhcpsCfgParam.enable = 1;
	else
		pRomeCfgParam->dhcpsCfgParam.enable = 0;					
	return 1;
}

char *
nvram_get_wan_proto(char *name)
{
	char *c;
	int ret = 0;

	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	switch (pRomeCfgParam->ifCfgParam[0].connType) {
		case IFCFGPARAM_CONNTYPE_STATIC:	
			DPRINTF("static\n");
			return ("static");
		case IFCFGPARAM_CONNTYPE_PPPOE:
			DPRINTF("pppoe\n");
			return ("pppoe");
		case IFCFGPARAM_CONNTYPE_DHCPC:
			DPRINTF("dhcp\n");
			return ("dhcp");
		case IFCFGPARAM_CONNTYPE_PPTP:
			DPRINTF("pptp\n");
			return ("pptp");
		case IFCFGPARAM_CONNTYPE_L2TP:
			DPRINTF("l2tp\n");
			return ("l2tp");
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:
			DPRINTF("dhcpl2tp\n");
			return ("dhcpl2tp");
			//return ("l2tp");							
//Yili/2006/1/6
#if defined(DNI)		
		case IFCFGPARAM_CONNTYPE_TELSTRA:			
			DPRINTF("telstra\n");			
			return ("telstra");			
#endif
		default:
			DPRINTF("default dhcp\n");
			return ("dhcp");
	}						
}

int
nvram_set_wan_proto(char *name, char *value)
{
	char *c;
	int ret = 0;

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	if (strcmp(value, "static") == 0)
		pRomeCfgParam->ifCfgParam[0].connType = IFCFGPARAM_CONNTYPE_STATIC;
	else if (strcmp(value, "dhcp") == 0)	
		pRomeCfgParam->ifCfgParam[0].connType = IFCFGPARAM_CONNTYPE_DHCPC;			
	else if (strcmp(value, "pppoe") == 0)	
		pRomeCfgParam->ifCfgParam[0].connType = IFCFGPARAM_CONNTYPE_PPPOE;			
	else if (strcmp(value, "pptp") == 0)	
		pRomeCfgParam->ifCfgParam[0].connType = IFCFGPARAM_CONNTYPE_PPTP;	
	else if (strcmp(value, "dhcpl2tp") == 0)	
		pRomeCfgParam->ifCfgParam[0].connType = IFCFGPARAM_CONNTYPE_DHCPL2TP;	
	//else if (strcmp(value, "l2tp") == 0)	
	//	pRomeCfgParam->ifCfgParam[0].connType = IFCFGPARAM_CONNTYPE_DHCPL2TP;	
	else if (strcmp(value, "l2tp") == 0)	
		pRomeCfgParam->ifCfgParam[0].connType = IFCFGPARAM_CONNTYPE_L2TP;	
		
//Yili 2006/1/6
#if defined(DNI)	
	else if (strcmp(value, "telstra") == 0)			
		pRomeCfgParam->ifCfgParam[0].connType = IFCFGPARAM_CONNTYPE_TELSTRA;			
#endif
		
	return 1;
}

char *
nvram_get_wan_domain(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	return (pRomeCfgParam->dhcpsCfgParam.domain);
	
} 

int 
nvram_set_wan_domain(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	strncpy(pRomeCfgParam->dhcpsCfgParam.domain, value, sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
	
	return 1;
	
} 

//Yili 2006/1/6
#if defined(DNI)
char *nvram_get_lan_domain(char *name)
{	
	char *c=NULL;	
	int ret = 0;		
	DPRINTF("nvram_get(\"%s\")\n", name);	
	return (pRomeCfgParam->dhcpsCfgParam.lan_domain);	
}

int nvram_set_lan_domain(char *name, char *value)
{	
	char *c=NULL;	
	int ret = 0;		
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	strncpy(pRomeCfgParam->dhcpsCfgParam.lan_domain, value, sizeof(pRomeCfgParam->dhcpsCfgParam.lan_domain));	
	return 1;	
} 
#endif
//Yili end

char *
nvram_get_wan_ipaddr(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[2].ipAddr)));		
} 

int
nvram_set_wan_ipaddr(char *name, char *value)
{
	char *c;
	int ret = 0;

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->ifCfgParam[2].ipAddr));
	return 1;

}

char *
nvram_get_wan_netmask(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[2].ipMask)));	
} 

int
nvram_set_wan_netmask(char *name, char *value)
{
	char *c;
	int ret = 0;

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->ifCfgParam[2].ipMask));
	return 1;

}

char *
nvram_get_wan_gateway(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[2].gwAddr)));
}

int
nvram_set_wan_gateway(char *name, char *value)
{
	char *c;
	int ret = 0;

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->ifCfgParam[2].gwAddr));
	return 1;

} 

char *
nvram_get_wan0_ipaddr(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);	

	//return nvram_get_wan_ipaddr(name);
	//return (inet_string((uint32)&(ramWanCfgParam.ipAddr)));		
	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[0].ipAddr)));		
	
}

char *
nvram_get_wan0_netmask(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	

	//return nvram_get_wan_netmask(name);	
	//return (inet_string((uint32)&(ramWanCfgParam.ipMask)));	
	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[0].ipMask)));	
	
}

char *
nvram_get_wan0_gateway(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	//return nvram_get_wan_gateway(name);		
	//return (inet_string((uint32)&(ramWanCfgParam.gwAddr)));	
	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[0].gwAddr)));
	
}

char *
nvram_get_wan_dns1(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	return (inet_string((uint32)&(pRomeCfgParam->dnsCfgParam.primary)));		
}

char *
nvram_get_wan_dns2(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	return (inet_string((uint32)&(pRomeCfgParam->dnsCfgParam.secondary)));		
}

char *
nvram_get_wan0_dns1(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr)));		
}

char *
nvram_get_wan0_dns2(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (inet_string((uint32)&(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr)));		
	
}

int nvram_set_wan0_dns1(char* name)
{
}

int nvram_set_wan0_dns2(char* name)
{
}

char *
nvram_get_wan_autodns(char *name)
{	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	//return ((pRomeCfgParam->dnsCfgParam.enable) ? "1" : "0");
	return ((pRomeCfgParam->dnsCfgParam.enable) ? "0" : "1");
	
}

int 
nvram_set_wan_dns1(char* name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->dnsCfgParam.primary));
	return 1;	
}

int 
nvram_set_wan_dns2(char* name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->dnsCfgParam.secondary));
	return 1;	
}

int
nvram_set_wan_autodns(char* name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	if (atoi(value) == 1)
		pRomeCfgParam->dnsCfgParam.enable = 0;
	else
		pRomeCfgParam->dnsCfgParam.enable = 1;		
	return 1;
}

char *
nvram_get_wan_pppoe_username(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	//return (pRomeCfgParam->pppoeCfgParam[0].username);
	strncpy(str, pRomeCfgParam->pppoeCfgParam[0].username, sizeof(pRomeCfgParam->pppoeCfgParam[0].username));		
	return (str);
	
}

int
nvram_set_wan_pppoe_username(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	strncpy(pRomeCfgParam->pppoeCfgParam[0].username, value, sizeof(pRomeCfgParam->pppoeCfgParam[0].username));

	return (1);
	
} 

char *
nvram_get_wan_pppoe_passwd(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	//return (pRomeCfgParam->pppoeCfgParam[0].password);	
	strncpy(str, pRomeCfgParam->pppoeCfgParam[0].password, sizeof(pRomeCfgParam->pppoeCfgParam[0].password));		
	return (str);

	
}

int
nvram_set_wan_pppoe_passwd(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	strncpy(pRomeCfgParam->pppoeCfgParam[0].password, value, sizeof(pRomeCfgParam->pppoeCfgParam[0].password));
	return 1;
}

char *
nvram_get_wan_pppoe_service(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	//return (pRomeCfgParam->pppoeCfgParam[0].serviceName);
	strncpy(str, pRomeCfgParam->pppoeCfgParam[0].serviceName, sizeof(pRomeCfgParam->pppoeCfgParam[0].serviceName));		
	return (str);	
}

int
nvram_set_wan_pppoe_service(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	strncpy(pRomeCfgParam->pppoeCfgParam[0].serviceName, value, sizeof(pRomeCfgParam->pppoeCfgParam[0].serviceName));
	return 1;
}

char *
nvram_get_wan_pppoe_demand(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return ((pRomeCfgParam->pppoeCfgParam[0].demand == 1) ? "1" : "0");
	
}

int
nvram_set_wan_pppoe_demand(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	if (atoi(value) == 1)
	 	pRomeCfgParam->pppoeCfgParam[0].demand = 1;
	else
	 	pRomeCfgParam->pppoeCfgParam[0].demand = 0;
	 	
	return 1; 		
	
}

char *
nvram_get_wan_pppoe_mtu(char *name)
{
	char *c;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	sprintf(str, "%d", pRomeCfgParam->pppoeCfgParam[0].mtu);
	c = str;
	return (c);	
}

int
nvram_set_wan_pppoe_mtu(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	pRomeCfgParam->pppoeCfgParam[0].mtu = atoi(value);
	
	return 1; 		
	
}

char *
nvram_get_wan_pppoe_idletime(char *name)
{
	int ret = 0;
	char *c;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	sprintf(str, "%d", pRomeCfgParam->pppoeCfgParam[0].silentTimeout/60);
	c = str;
	return (c);		
}	
	

int
nvram_set_wan_pppoe_idletime(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	/* value is minutes */
	/* silentTimeout is seconds */
	
	pRomeCfgParam->pppoeCfgParam[0].silentTimeout = atoi(value)*60;	
	if (pRomeCfgParam->pppoeCfgParam[0].silentTimeout != 0)
		nvram_set_wan_pppoe_demand("wan_pppoe_demand", "1");
	else
		nvram_set_wan_pppoe_demand("wan_pppoe_demand", "0");		

	return 1;	
}


char *
nvram_get_wan_pppoe_dynamicassign(char *name)
{	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->pppoeCfgParam[0].internetassign ? "1" : "0");		
}	
	

int
nvram_set_wan_pppoe_dynamicassign(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	pRomeCfgParam->pppoeCfgParam[0].internetassign = atoi(value);
	
	return 1;	
}

char *
nvram_get_wan_pppoe_fixedipAddr(char *name)
{	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (inet_string((uint32)&(pRomeCfgParam->pppoeCfgParam[0].localHostIp)));		
}	
	

int
nvram_set_wan_pppoe_fixedipAddr(char *name, char *value)
{	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->pppoeCfgParam[0].localHostIp));		

	return 1;	
}


char *
nvram_get_wan_pptp_username(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	//return (pRomeCfgParam->pptpCfgParam.username);	
	strncpy(str, pRomeCfgParam->pptpCfgParam.username, sizeof(pRomeCfgParam->pptpCfgParam.username));		
	return (str);	
	
	
}

int
nvram_set_wan_pptp_username(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	strncpy(pRomeCfgParam->pptpCfgParam.username, value, sizeof(pRomeCfgParam->pptpCfgParam.username));
	return 1;
	
}

char *
nvram_get_wan_pptp_passwd(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	//return (pRomeCfgParam->pptpCfgParam.password);	
	strncpy(str, pRomeCfgParam->pptpCfgParam.password, sizeof(pRomeCfgParam->pptpCfgParam.password));		
	return (str);	
	

}

int
nvram_set_wan_pptp_passwd(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	strncpy(pRomeCfgParam->pptpCfgParam.password, value, sizeof(pRomeCfgParam->pptpCfgParam.password));
	return 1;
}

char *
nvram_get_wan_pptp_idle_disconnect(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	return ((pRomeCfgParam->pptpCfgParam.demand) ? "1" : "0");
	//return ((pRomeCfgParam->pptpCfgParam.silentTimeout != 0) ? "1" : "0");		
	
}

int
nvram_set_wan_pptp_idle_disconnect(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	if (atoi(value) == 1)
		pRomeCfgParam->pptpCfgParam.demand = 1;
	else
		pRomeCfgParam->pptpCfgParam.demand = 0;				
	return 1;	
}

char *
nvram_get_wan_pptp_idle_interval(char *name)
{
	int ret = 0;
	char *c;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->pptpCfgParam.silentTimeout/60);
	c = str;
	return (c);	
}

int
nvram_set_wan_pptp_idle_interval(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	/* value is minutes */
	/* silentTimeout is seconds */
	pRomeCfgParam->pptpCfgParam.silentTimeout = atoi(value)*60;
	if (pRomeCfgParam->pptpCfgParam.silentTimeout != 0)
		;//pRomeCfgParam->pptpCfgParam.demand = 1;
	else
		;//pRomeCfgParam->pptpCfgParam.demand = 0;		
	return 1;
}

char *
nvram_get_wan_pptp_id(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (pRomeCfgParam->pptpCfgParam.pptpid);
	
}

int
nvram_set_wan_pptp_id(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	strncpy(pRomeCfgParam->pptpCfgParam.pptpid, value, sizeof(pRomeCfgParam->pptpCfgParam.pptpid));
	return 1;	
}



char *
nvram_get_wan_pptp_ipaddr(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (inet_string((uint32)&(pRomeCfgParam->pptpCfgParam.ipAddr)));		
	
}

int
nvram_set_wan_pptp_ipaddr(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->pptpCfgParam.ipAddr));
	return 1;
	
}

char *
nvram_get_wan_pptp_netmask(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (inet_string((uint32)&(pRomeCfgParam->pptpCfgParam.ipMask)));
	
}

int
nvram_set_wan_pptp_netmask(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->pptpCfgParam.ipMask));
	return 1;
	
}

char *
nvram_get_wan_pptp_server_ipaddr(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	return (inet_string((uint32)&(pRomeCfgParam->pptpCfgParam.svAddr)));
	
	
}

int
nvram_set_wan_pptp_server_ipaddr(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->pptpCfgParam.svAddr));
	return 1;
	
}

char *
nvram_get_wan_l2tp_username(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	//return (pRomeCfgParam->l2tpCfgParam.username);	
	strncpy(str, pRomeCfgParam->l2tpCfgParam.username, sizeof(pRomeCfgParam->l2tpCfgParam.username));		
	return (str);	
	
	
}

int
nvram_set_wan_l2tp_username(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	strncpy(pRomeCfgParam->l2tpCfgParam.username, value, sizeof(pRomeCfgParam->l2tpCfgParam.username));
	return 1;
	
}

char *
nvram_get_wan_l2tp_passwd(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	//return (pRomeCfgParam->pptpCfgParam.password);	
	strncpy(str, pRomeCfgParam->l2tpCfgParam.password, sizeof(pRomeCfgParam->l2tpCfgParam.password));		
	return (str);	
	

}

int
nvram_set_wan_l2tp_passwd(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	strncpy(pRomeCfgParam->l2tpCfgParam.password, value, sizeof(pRomeCfgParam->l2tpCfgParam.password));
	return 1;
}

char *
nvram_get_wan_l2tp_idle_disconnect(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	return ((pRomeCfgParam->l2tpCfgParam.demand) ? "1" : "0");
	//return ((pRomeCfgParam->l2tpCfgParam.silentTimeout != 0) ? "1" : "0");		
	
}

int
nvram_set_wan_l2tp_idle_disconnect(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	if (atoi(value) == 1)
		pRomeCfgParam->l2tpCfgParam.demand = 1;
	else
		pRomeCfgParam->l2tpCfgParam.demand = 0;				
	return 1;	
}

char *
nvram_get_wan_l2tp_idle_interval(char *name)
{
	int ret = 0;
	char *c;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->l2tpCfgParam.silentTimeout/60);
	c = str;
	return (c);	
}

int
nvram_set_wan_l2tp_idle_interval(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	/* value is minutes */
	/* silentTimeout is seconds */
	pRomeCfgParam->l2tpCfgParam.silentTimeout = atoi(value)*60;
	if (pRomeCfgParam->l2tpCfgParam.silentTimeout != 0)
		;//pRomeCfgParam->pptpCfgParam.demand = 1;
	else
		;//pRomeCfgParam->pptpCfgParam.demand = 0;		
	return 1;
}
char *
nvram_get_wan_l2tp_servername(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	strncpy(str, pRomeCfgParam->l2tpCfgParam.servername, sizeof(pRomeCfgParam->l2tpCfgParam.servername));		
	return (str);	
	
	
}

int
nvram_set_wan_l2tp_servername(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	strncpy(pRomeCfgParam->l2tpCfgParam.servername, value, sizeof(pRomeCfgParam->l2tpCfgParam.servername));
	return 1;
	
}

char *
nvram_get_wan_l2tp_id(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (pRomeCfgParam->l2tpCfgParam.l2tpid);
	
}

int
nvram_set_wan_l2tp_id(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	strncpy(pRomeCfgParam->l2tpCfgParam.l2tpid, value, sizeof(pRomeCfgParam->l2tpCfgParam.l2tpid));
	return 1;	
}



char *
nvram_get_wan_l2tp_ipaddr(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (inet_string((uint32)&(pRomeCfgParam->l2tpCfgParam.ipAddr)));		
	
}

int
nvram_set_wan_l2tp_ipaddr(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->l2tpCfgParam.ipAddr));
	return 1;
	
}

char *
nvram_get_wan_l2tp_netmask(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (inet_string((uint32)&(pRomeCfgParam->l2tpCfgParam.ipMask)));
	
}

int
nvram_set_wan_l2tp_netmask(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->l2tpCfgParam.ipMask));
	return 1;
	
}

char *
nvram_get_wan_l2tp_server_ipaddr(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	return (inet_string((uint32)&(pRomeCfgParam->l2tpCfgParam.svAddr)));
	
	
}

int
nvram_set_wan_l2tp_server_ipaddr(char *name, char *value)
{
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->l2tpCfgParam.svAddr));
	return 1;
	
}

char *
nvram_get_fw_pppoe_type(char *name)
{
	char *ptr;
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	ptr = nvram_get_wan_proto("wan_proto");
	
	if (strcmp(ptr, "pppoe") == 0)
		return ("0");
	else if (strcmp(ptr, "pptp") == 0)
		return ("2");
//Yili 2006/1/9
#if defined(DNI)
	else if (strcmp(ptr, "telstra") == 0)
		return ("3");
	else if (strcmp(ptr, "l2tp") == 0)
		return ("4");	
	else if (strcmp(ptr, "dhcpl2tp") == 0)
		return ("5");			
#endif
//end
	else		
		return ("0");
}

//Yili 2006/1/10
#if defined(DNI)
char *
nvram_get_logo_enable(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
		
	return (pRomeCfgParam->mnuCfgParam.enable ? "1" : "0");
	
}

int
nvram_set_logo_enable(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	pRomeCfgParam->mnuCfgParam.enable = atoi(value);

	return (1);
	
} 

char *
nvram_get_ver_check_enable(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
		
	return (pRomeCfgParam->mnuCfgParam.check_enable ? "1" : "0");
	
}

int
nvram_set_ver_check_enable(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	if((pRomeCfgParam->mnuCfgParam.check_enable = atoi(value)) == 0)
		pRomeCfgParam->mnuCfgParam.runtest_enable = 1;
	else
		pRomeCfgParam->mnuCfgParam.runtest_enable = 0;

	return (1);
	
} 

char *
nvram_get_runtest(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	if (pRomeCfgParam->mnuCfgParam.runtest_enable == 1)
		return "yes";
	else
		return "no";
}

#endif
//end

char *
nvram_get_wan_tel_username(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	strncpy(str, pRomeCfgParam->telCfgParam.username, sizeof(pRomeCfgParam->telCfgParam.username));		
	return (str);
	
}

int
nvram_set_wan_tel_username(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	strncpy(pRomeCfgParam->telCfgParam.username, value, sizeof(pRomeCfgParam->telCfgParam.username));

	return (1);
	
} 

char *
nvram_get_wan_tel_password(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);

	strncpy(str, pRomeCfgParam->telCfgParam.password, sizeof(pRomeCfgParam->telCfgParam.password));		
	return (str);

	
}

int
nvram_set_wan_tel_password(char *name, char *value)
{	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	strncpy(pRomeCfgParam->telCfgParam.password, value, sizeof(pRomeCfgParam->telCfgParam.password));
	return 1;
}

char *
nvram_get_wan_tel_service(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);

	strncpy(str, pRomeCfgParam->telCfgParam.serviceName, sizeof(pRomeCfgParam->telCfgParam.serviceName));		
	return (str);	
}

int
nvram_set_wan_tel_service(char *name, char *value)
{	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	strncpy(pRomeCfgParam->telCfgParam.serviceName, value, sizeof(pRomeCfgParam->telCfgParam.serviceName));
	return 1;
}

char *
nvram_get_wan_tel_idle_interval(char *name)
{
	int ret = 0;
	char *c;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->telCfgParam.silentTimeout/60);
	c = str;
	return (c);	
}

int
nvram_set_wan_tel_idle_interval(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	/* value is minutes */
	/* silentTimeout is seconds */
	pRomeCfgParam->telCfgParam.silentTimeout = atoi(value)*60;
	if (pRomeCfgParam->telCfgParam.silentTimeout != 0)
		;//pRomeCfgParam->telCfgParam.demand = 1;
	else
		;//pRomeCfgParam->telCfgParam.demand = 0;		
	return 1;
}

char *
nvram_get_wan_tel_demand(char *name)
{
	int ret = 0;
	char *c;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->telCfgParam.demand ? "1" : "0");

}

int
nvram_set_wan_tel_demand(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	pRomeCfgParam->telCfgParam.demand = atoi(value);	
	return 1;
}

char *
nvram_get_wan_tel_manualHangup(char *name)
{
	int ret = 0;
	char *c;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->telCfgParam.manualHangup ? "1" : "0");
	

}

int
nvram_set_wan_tel_manualHangup(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	pRomeCfgParam->telCfgParam.manualHangup = atoi(value);	
	return 1;
}

char *
nvram_get_http_passwd(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	//return (pRomeCfgParam->mgmtCfgParam[0].password);
	strncpy(str, pRomeCfgParam->mgmtCfgParam[0].password, sizeof(pRomeCfgParam->mgmtCfgParam[0].password));		
	return (str);	
	
		
	
}

int
nvram_set_http_passwd(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	strncpy(pRomeCfgParam->mgmtCfgParam[0].password, value, sizeof(pRomeCfgParam->mgmtCfgParam[0].password));			
	return 1;	
	
}

char *
nvram_get_http_remoteenable(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	return ((pRomeCfgParam->mgmtCfgParam[0].valid) ? "1" : "0");	
	
}

int
nvram_set_http_remoteenable(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	if (atoi(value) == 1)
		pRomeCfgParam->mgmtCfgParam[0].valid = 1;
	else		
		pRomeCfgParam->mgmtCfgParam[0].valid = 0;			
	return 1;	
	
}

char *
nvram_get_http_wanport(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort);
	c = str;
	return (c);		
}

int
nvram_set_http_wanport(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort = atoi(value);	

	return 1;	
	
}

char *
nvram_get_remote_config_ip(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (inet_string((uint32)&(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp)));
	
}

int
nvram_set_remote_config_ip(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp));
	return 1;	
	
}

char *
nvram_get_remote_config_ip_start(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (inet_string((uint32)&(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp)));
	
}

int
nvram_set_remote_config_ip_start(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp));
	return 1;	
	
}

char *
nvram_get_remote_config_ip_end(char *name)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (inet_string((uint32)&(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtMask)));
	
}

int
nvram_set_remote_config_ip_end(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtMask));
	return 1;	
	
}

char *
nvram_get_client_filter_ip(char *name)
{
	char *c=NULL;
	int ret = 0;
	char* ptr;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	ptr = name+strlen("filter_client");
	ret =atoi(ptr);
	
	return (inet_string((uint32)&(pRomeCfgParam->aclCfgParam[0][ret].ip)));
	
}

int
nvram_set_client_filter_ip(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	//(void) inet_aton(value, (struct in_addr *)&(RomeCfgParam->aclCfgParam[0][i].ip));
	return 1;	
	
}

char *
nvram_get_client_filter_s_ip(char *name)
{
	char *c=NULL;
	int ret = 0;
	char* ptr;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	ptr = name+strlen("filter_client");
	ret =atoi(ptr);
	return (inet_string((uint32)&(pRomeCfgParam->aclCfgParam[0][ret].ip)));
	
}

int
nvram_set_client_filter_s_ip(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	//(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp));
	return 1;	
	
}

char *
nvram_get_client_filter_e_ip(char *name)
{
	char *c=NULL;
	int ret = 0;
	char* ptr;
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	ptr = name+strlen("filter_client");
	ret =atoi(ptr);
	return (inet_string((uint32)&(pRomeCfgParam->aclCfgParam[0][ret].ip_end)));
	
	
}

int
nvram_set_client_filter_e_ip(char *name, char *value)
{
	char *c=NULL;
	int ret = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	//(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp));
	return 1;	
	
}

char *
nvram_get_wan_ping(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);	
	return ((pRomeCfgParam->mgmtCfgParam[0].remoteIcmpEnable) ? "1" : "0");		
}


int 
nvram_set_wan_ping(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	if (atoi(value) == 1)
		pRomeCfgParam->mgmtCfgParam[0].remoteIcmpEnable = 1;
	else		
		pRomeCfgParam->mgmtCfgParam[0].remoteIcmpEnable = 0;			
	return 1;	
}

char *
nvram_get_sip_alg(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);	
	return ((pRomeCfgParam->algCfgParam[0].sip) ? "1" : "0");		
}


int 
nvram_set_sip_alg(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	if (atoi(value) == 1)
		pRomeCfgParam->algCfgParam[0].sip = 1;
	else		
		pRomeCfgParam->algCfgParam[0].sip = 0;			
	return 1;	
}

char *
nvram_get_wan_mtu(char *name)
{
	char *c;
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	c = nvram_get_wan_proto("wan_proto");
	if (!strcmp(c, "static")) 
		sprintf(str, "%d",  pRomeCfgParam->ifCfgParam[2].mtu);	
	else if (!strcmp(c, "dhcp") || !strcmp(c, "telstra"))
		sprintf(str, "%d",  pRomeCfgParam->ifCfgParam[0].mtu);
	else if (!strcmp(c, "pppoe"))
		sprintf(str, "%d", pRomeCfgParam->pppoeCfgParam[0].mtu);
	else if (!strcmp(c, "pptp"))	
		sprintf(str, "%d", pRomeCfgParam->pptpCfgParam.mtu);
	else if (!strcmp(c, "l2tp"))	
		sprintf(str, "%d", pRomeCfgParam->l2tpCfgParam.mtu);			
	else if (!strcmp(c, "dhcpl2tp"))	
		sprintf(str, "%d", pRomeCfgParam->l2tpCfgParam.mtu);			
		
	else
		sprintf(str, "%d", 1500);
	return (str);	

	
}



int 
nvram_set_wan_mtu(char *name, char *value)
{
	char *c; 
	
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);

	c = nvram_get_wan_proto("wan_proto");
	if (!strcmp(c, "static"))
		pRomeCfgParam->ifCfgParam[2].mtu = atoi(value);	
	else if (!strcmp(c, "dhcp") || !strcmp(c, "telstra"))
		pRomeCfgParam->ifCfgParam[0].mtu = atoi(value);
	else if (!strcmp(c, "pppoe"))		
		pRomeCfgParam->pppoeCfgParam[0].mtu = atoi(value);
	else if (!strcmp(c, "pptp"))	
		pRomeCfgParam->pptpCfgParam.mtu = atoi(value);	
	else if (!strcmp(c, "l2tp"))	
		pRomeCfgParam->l2tpCfgParam.mtu = atoi(value);			
	else if (!strcmp(c, "dhcpl2tp"))	
		pRomeCfgParam->l2tpCfgParam.mtu = atoi(value);			
		
	return 1;	
}


char *
nvram_get_vs_count(char *name)
{
	int i, vs_count = 0;
	char *ptr;
	char tmp[20];
	
	for (i = 0; i < MAX_SERVER_PORT; i++) {
		sprintf(tmp, "forward_port%d", i);
		ptr = nvram_get_forward_port(tmp);
		if (*ptr != '\0') 
			vs_count++;
	}
	sprintf(str, "%d", vs_count);
	return (str);
}

char *
nvram_get_qos_count(char *name)
{
	int i, qos_count = 0;
	char *ptr;
	char tmp[20];
	
	DPRINTF("nvram_get(\"%s\")\n", name);		
	for (i = 0; i < MAX_QOS; i++) {
		sprintf(tmp, "qos_port%d", i);
		ptr = nvram_get_qos_port(tmp);
		if (*ptr != '\0') 
			qos_count++;
	}
	sprintf(str, "%d", qos_count);
	return (str);
}


/* d-d>ip:d-d,proto,on/off,desc */
char *
nvram_get_forward_port(char *name)
{
	char *ptr;
	int ret;

	DPRINTF("nvram_get(\"%s\")\n", name);	
	ptr = name+strlen("forward_port");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_SERVER_PORT)
		return ("");
			
	if (*((unsigned long *)&(pRomeCfgParam->serverpCfgParam[0][ret].ip))) {
		sprintf(str, "%d-%d>%s:%d-%d,%s,%s,%s",
			pRomeCfgParam->serverpCfgParam[0][ret].wanPortStart,
			pRomeCfgParam->serverpCfgParam[0][ret].wanPortFinish,
			(inet_string((uint32)&(pRomeCfgParam->serverpCfgParam[0][ret].ip))),
			pRomeCfgParam->serverpCfgParam[0][ret].portStart,
			pRomeCfgParam->serverpCfgParam[0][ret].wanPortFinish/*portStart*/,
			((pRomeCfgParam->serverpCfgParam[0][ret].protocol == 0) ? 
				"tcp" : ((pRomeCfgParam->serverpCfgParam[0][ret].protocol == 1) ? "udp" : "both")),			
			(pRomeCfgParam->serverpCfgParam[0][ret].enable ? "on" : "off"),		
			(pRomeCfgParam->serverpCfgParam[0][ret].desc)
			);		
		return (str);	
	}
	else
		return ("");
}	

int
nvram_set_forward_port(char *name, char *value)
{
	char *ptr;
	int ret, i;
	char *tmp;
	char *wan_port0, *wan_port1, *lan_ipaddr, *lan_port0, *lan_port1, *proto, *enable, *desc;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	ptr = name+strlen("forward_port");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_SERVER_PORT)
		return 0;
		
	if (*value == 0) {
		for (i = ret; i < (MAX_SERVER_PORT-1); i++) {
			memcpy((char *)&(pRomeCfgParam->serverpCfgParam[0][i]), 
				(char *)&(pRomeCfgParam->serverpCfgParam[0][i+1]),
					 sizeof(serverpCfgParam_t));
		}
		/* clear finial entry */
		memset((char *)&(pRomeCfgParam->serverpCfgParam[0][i]), 0x0, sizeof(serverpCfgParam_t));	
		return 1;
	}	
			
	tmp = value;	
	//strcpy(tmp, ptr);
	/* Check for LAN IP address specification */
	lan_ipaddr = tmp;
	wan_port0 = strsep(&lan_ipaddr, ">");
	if (!lan_ipaddr)
		return 0;

	/* Check for LAN destination port specification */
	lan_port0 = lan_ipaddr;
	lan_ipaddr = strsep(&lan_port0, ":");
	if (!lan_port0)
		return 0;

	/* Check for protocol specification */
	proto = lan_port0;
	lan_port0 = strsep(&proto, ":,");
	if (!proto)
		return 0;

	/* Check for enable specification */
	enable = proto;
	proto = strsep(&enable, ":,");
	if (!enable)
		return 0;

	/* Check for description specification (optional) */
	desc = enable;
	enable = strsep(&desc, ":,");

	/* Check for WAN destination port range (optional) */
	wan_port1 = wan_port0;
	wan_port0 = strsep(&wan_port1, "-");
	if (!wan_port1)
		wan_port1 = wan_port0;

	/* Check for LAN destination port range (optional) */
	lan_port1 = lan_port0;
	lan_port0 = strsep(&lan_port1, "-");
	if (!lan_port1)
		lan_port1 = lan_port0;
		
	(void) inet_aton(lan_ipaddr, (struct in_addr *)&(pRomeCfgParam->serverpCfgParam[0][ret].ip));
	if (strcmp(enable, "on") == 0)
		pRomeCfgParam->serverpCfgParam[0][ret].enable = 1;
	else
		pRomeCfgParam->serverpCfgParam[0][ret].enable = 0;				
	pRomeCfgParam->serverpCfgParam[0][ret].wanPortStart = atoi(lan_port0);
	pRomeCfgParam->serverpCfgParam[0][ret].wanPortFinish = atoi(lan_port1);
	pRomeCfgParam->serverpCfgParam[0][ret].portStart = atoi(lan_port0);
	
	if (strcmp(proto, "both") == 0) 
		pRomeCfgParam->serverpCfgParam[0][ret].protocol = 2;			
	else if(strcmp(proto, "udp") == 0) 	
		pRomeCfgParam->serverpCfgParam[0][ret].protocol = SERVERPCFGPARAM_PROTOCOL_UDP;			
	else 	
		pRomeCfgParam->serverpCfgParam[0][ret].protocol = SERVERPCFGPARAM_PROTOCOL_TCP;	
		
	if (desc)
		strncpy(pRomeCfgParam->serverpCfgParam[0][ret].desc, desc, sizeof(pRomeCfgParam->serverpCfgParam[0][ret].desc));	
	return 1;	
		
}	

char *
nvram_get_sr_count(char *name)
{
	int i, static_route_count = 0;
	char *ptr;
	char tmp[20];
	
	for (i = 0; i < MAX_ROUTING; i++) {
		sprintf(tmp, "static_route%d", i);
		ptr = nvram_get_static_route(tmp);
		if (*ptr != '\0') 
			static_route_count++;
	}
	sprintf(str, "%d", static_route_count);
	return (str);
}

/* ipaddr,netmask,gateway,0/1,on/off,rip_private,desc */
char *
nvram_get_static_route(char *name)
{
	char *ptr, ipaddr[20], netmask[20];
	int ret;

	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	ptr = name+strlen("static_route");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_ROUTING)
		return ("");
			
	if (*((unsigned long *)&(pRomeCfgParam->routingCfgParam[ret].gateway))) {
		strcpy(ipaddr, (char *)(inet_string((uint32)&(pRomeCfgParam->routingCfgParam[ret].route))));		
		strcpy(netmask, (char *)(inet_string((uint32)&(pRomeCfgParam->routingCfgParam[ret].mask))));		
		
		sprintf(str, "%s,%s,%s,%d,%s,%s,%d,%s",
			ipaddr,
			netmask,
			(inet_string((uint32)&(pRomeCfgParam->routingCfgParam[ret].gateway))),
			pRomeCfgParam->routingCfgParam[ret].metric,
			((pRomeCfgParam->routingCfgParam[ret].interface == ROUTING_INTERFACE_LAN) ? "1" : "0"),
			(pRomeCfgParam->routingCfgParam[ret].valid ? "on" : "off"),		
			//"Static Route"
			pRomeCfgParam->routingCfgParam[ret].rip_private,	
			(pRomeCfgParam->routingCfgParam[ret].desc)
			);		
	DPRINTF("%s\n", str);	
		return (str);	
	}
	else
		return ("");
}	

int
nvram_set_static_route(char *name, char *value)
{
	char *ptr;
	int ret, i;
	char *ipaddr, *netmask, *gateway, *pri, *enable, *desc,*metric, *rip_private;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	ptr = name+strlen("static_route");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_ROUTING)
		return 0;
		
	if (*value == 0) {
		/* clear static route entry */
		for (i = ret; i < (MAX_ROUTING-1); i++) {
			memcpy((char *)&(pRomeCfgParam->routingCfgParam[i]), 
				(char *)&(pRomeCfgParam->routingCfgParam[i+1]),
					 sizeof(routingCfgParam_t));
		}
		/* clear finial entry */
		memset((char *)&(pRomeCfgParam->routingCfgParam[i]), 0x0, sizeof(routingCfgParam_t));	
		return 1;
	}	
			
		

	/* Check for dip address specification */
	netmask = value;
	ipaddr = strsep(&netmask, ",");
	if (!ipaddr)
		return 0;
		
	gateway = netmask;
	netmask = strsep(&gateway, ",");
	if (!netmask)
		return 0;

	metric = gateway;
	gateway = strsep(&metric, ",");
	if (!gateway)
		return 0;		

	pri = metric;
	metric = strsep(&pri, ",");
	if (!gateway)
		return 0;		

	/* Check for pri specification */
	enable = pri;
	pri = strsep(&enable, ",");
	if (!pri)
		return 0;

	/* Check for enable specification */
	rip_private = enable;
	enable = strsep(&rip_private, ",");
	if (!enable)
		return 0;

	/* Check for rip_private specification */
	desc = rip_private;
	rip_private = strsep(&desc, ",");
	if (!rip_private)
		return 0;
		
	if (!desc)
		return 0;		
		

	(void) inet_aton(ipaddr, (struct in_addr *)&(pRomeCfgParam->routingCfgParam[ret].route));
	(void) inet_aton(netmask, (struct in_addr *)&(pRomeCfgParam->routingCfgParam[ret].mask));
	(void) inet_aton(gateway, (struct in_addr *)&(pRomeCfgParam->routingCfgParam[ret].gateway));
	
	pRomeCfgParam->routingCfgParam[ret].metric=atoi(metric);
	
	if (strcmp(enable, "on") == 0)
		pRomeCfgParam->routingCfgParam[ret].valid = 1;
	else
		pRomeCfgParam->routingCfgParam[ret].valid = 0;

	if (strcmp(pri, "1") == 0) {
		pRomeCfgParam->routingCfgParam[ret].interface = ROUTING_INTERFACE_LAN;
	}	
	else
		pRomeCfgParam->routingCfgParam[ret].interface = ROUTING_INTERFACE_WAN;						

	if (desc)
		strncpy(pRomeCfgParam->routingCfgParam[ret].desc, desc, sizeof(pRomeCfgParam->routingCfgParam[ret].desc));	
	
	pRomeCfgParam->routingCfgParam[ret].rip_private = (rip_private ? atoi(rip_private) : 0);	
		

	return 1;	
		
}	

char *
nvram_get_trigger_count(char *name)
{
	int i, trigger_count = 0;
	char *ptr;
	char tmp[20];
	
	for (i = 0; i < MAX_SPECIAL_AP; i++) {
		sprintf(tmp, "trigger_port%d", i);
		ptr = nvram_get_trigger_port(tmp);
		if (*ptr != '\0') 
			trigger_count++;
	}
	sprintf(str, "%d", trigger_count);
	return (str);
}
//pamela added 20060106
int
nvram_set_trigger_enable(char *name, char *value)
{
	char *ptr, *tmp;
	int i, ret;
	
	ret = atoi(nvram_get_trigger_count("trigger_count"));
	if (ret <= 0 || ret > MAX_SPECIAL_AP)
		return 0;
	
	tmp = value;	
	for (i=0 ; i< ret ;i++){
		if (tmp[i] ==  '1')
			pRomeCfgParam->specialapCfgParam[0][i].enable = 1;	
		else
			pRomeCfgParam->specialapCfgParam[0][i].enable = 0;			
	}
	return 1;
}	

/* d-d,wan_proto>ip:d-d,proto,on/off,used,desc */

/* outbound, inbound */
char *
nvram_get_trigger_port(char *name)
{
	char *ptr;
	int ret;
	char ipaddr[20];

	DPRINTF("nvram_get(\"%s\")\n", name);	
	ptr = name+strlen("trigger_port");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_SPECIAL_AP)
		return ("");
		
	strcpy(ipaddr, (inet_string((uint32)&(pRomeCfgParam->specialapCfgParam[0][ret].ip))));

	if (pRomeCfgParam->specialapCfgParam[0][ret].outStart != 0) {
		//sprintf(str, "%d-%d>%s:%d-%d*,%s,%s,%s,%s",
		sprintf(str, "%d-%d,%s>%s:%s,%s,%s,%s,%s",		
			pRomeCfgParam->specialapCfgParam[0][ret].outStart,	/* out wan port */
			pRomeCfgParam->specialapCfgParam[0][ret].outFinish,
			(pRomeCfgParam->specialapCfgParam[0][ret].outType ? 
				((pRomeCfgParam->specialapCfgParam[0][ret].outType==1) ? "udp" : "both") : "tcp"),			
		
			//(inet_string((uint32)&(pRomeCfgParam->specialapCfgParam[0][ret].ip))),
			//"ANY",
			ipaddr,
			//pRomeCfgParam->specialapCfgParam[0][ret].outStart,	/* in wan port */
			//pRomeCfgParam->specialapCfgParam[0][ret].outFinish,
			pRomeCfgParam->specialapCfgParam[0][ret].inRange,
			
			(pRomeCfgParam->specialapCfgParam[0][ret].inType ? 
				((pRomeCfgParam->specialapCfgParam[0][ret].inType==1) ? "udp" : "both") : "tcp"),			
			(pRomeCfgParam->specialapCfgParam[0][ret].enable ? "on" : "off"),		
			"on",			/* used */			
			(pRomeCfgParam->specialapCfgParam[0][ret].name)			
			//"Trigger Service",	/* desc */
			);
		//printf("%s = %s\n", name, str);				
		return (str);	
	}
	else
		return ("");
}	

int
nvram_set_trigger_port(char *name, char *value)
{
	char *ptr;
	int ret, i, tmp1,tmp2;
	char *tmp;
	char *wan_port0, *wan_port1, *wan_proto, *lan_ipaddr, *lan_port0, *lan_port1, *proto, *enable, *used, *desc;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	ptr = name+strlen("trigger_port");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_SPECIAL_AP)
		return 0;
		
	if (*value == 0) { //pamela20060109
		tmp1 = pRomeCfgParam->specialapCfgParam[0][0].g_enable;
		tmp2 = pRomeCfgParam->specialapCfgParam[0][0].g_triggertime;

		for (i = ret; i < (MAX_SPECIAL_AP-1); i++) {
			memcpy((char *)&(pRomeCfgParam->specialapCfgParam[0][i]), 
				(char *)&(pRomeCfgParam->specialapCfgParam[0][i+1]),
					 sizeof(specialapCfgParam_t));
		}
		/* clear finial entry */ //pamela20060109
		memset((char *)&(pRomeCfgParam->specialapCfgParam[0][i]), 0x0, sizeof(specialapCfgParam_t));	
		pRomeCfgParam->specialapCfgParam[0][0].g_enable = tmp1;
		pRomeCfgParam->specialapCfgParam[0][0].g_triggertime = tmp2;
		return 1;
	}	
			
		
	tmp = value;	
	//strcpy(tmp, ptr);
	/* Check for WAN PORT address specification */
		
	wan_proto = tmp;
	wan_port0 = strsep(&wan_proto, ",");
	if (!wan_proto)
		return 0;
		
	lan_ipaddr = wan_proto;
	wan_proto = strsep(&lan_ipaddr, ">");
	if (!lan_ipaddr)
		return 0;	

	/* Check for LAN destination port specification */
	lan_port0 = lan_ipaddr;
	lan_ipaddr = strsep(&lan_port0, ":");
	if (!lan_port0)
		return 0;

	/* Check for protocol specification */
	proto = lan_port0;
	lan_port0 = strsep(&proto, ":,");
	if (!proto)
		return 0;

	/* Check for enable specification */
	enable = proto;
	proto = strsep(&enable, ":,");
	if (!enable)
		return 0;

	/* Check for used specification (optional) */
	used = enable;
	enable = strsep(&used, ":,");
	if (!used)
		return 0;
	
	/* Check for description specification (optional) */
	desc = used;
	used = strsep(&desc, ":,");
	if (!desc)
		return 0;
		
	/* Check for WAN destination port range (optional) */
	wan_port1 = wan_port0;
	wan_port0 = strsep(&wan_port1, "-");
	if (!wan_port1)
		wan_port1 = wan_port0;

	/* Check for LAN destination port range (optional) */
	lan_port1 = lan_port0;
	lan_port0 = strsep(&lan_port1, "-");
	if (!lan_port1)
		lan_port1 = lan_port0;
		
	//(void) inet_aton(lan_ipaddr, (struct in_addr *)&(pRomeCfgParam->specialapCfgParam[0][ret].ip));
	if (strcmp(enable, "on") == 0)
		pRomeCfgParam->specialapCfgParam[0][ret].enable = 1;
	else
		pRomeCfgParam->specialapCfgParam[0][ret].enable = 0;				
	pRomeCfgParam->specialapCfgParam[0][ret].outStart = atoi(wan_port0);
	pRomeCfgParam->specialapCfgParam[0][ret].outFinish = atoi(wan_port1);
	
	sprintf(pRomeCfgParam->specialapCfgParam[0][ret].inRange, "%s-%s", lan_port0, lan_port1);
	
/*	
	SPECIALACPCFGPARAM_PROTOCOL_TCP = 0,
	SPECIALACPCFGPARAM_PROTOCOL_UDP,
	SPECIALACPCFGPARAM_PROTOCOL_BOTH	
*/	
	/* outbound */
	if (strcmp(wan_proto, "tcp") == 0)
		pRomeCfgParam->specialapCfgParam[0][ret].outType = 0;	
	else if (strcmp(wan_proto, "udp") == 0)
		pRomeCfgParam->specialapCfgParam[0][ret].outType = 1;		
	else	
	     pRomeCfgParam->specialapCfgParam[0][ret].outType = 2;
	     
	/* inbound */     
	if (strcmp(proto, "tcp") == 0)
		pRomeCfgParam->specialapCfgParam[0][ret].inType = 0;	
	else if (strcmp(proto, "udp") == 0)
		pRomeCfgParam->specialapCfgParam[0][ret].inType = 1;		
	else	
	     pRomeCfgParam->specialapCfgParam[0][ret].inType = 2;	     			
	
	if (desc)	     
		strncpy(pRomeCfgParam->specialapCfgParam[0][ret].name, desc, sizeof(pRomeCfgParam->specialapCfgParam[0][ret].name));    

	if (lan_ipaddr)		
		(void) inet_aton(lan_ipaddr, (struct in_addr *)&(pRomeCfgParam->specialapCfgParam[0][ret].ip));
		

	return 1;	
		
}	

char *
nvram_get_fw_keywordenable(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	//Add by Timo Wu
	if(pRomeCfgParam->scheduleCfgParam.filterstatus == BLOCK_ALWAYS)
		return ("2");	/* Always */
	//else if((pRomeCfgParam->urlfilterCfgParam[0][0].enable == 1) &&(pRomeCfgParam->scheduleCfgParam.filterstatus == BLOCK_PERSCHEDULE))
	else if(pRomeCfgParam->scheduleCfgParam.filterstatus == BLOCK_PERSCHEDULE)	
		return ("1"); //Per Schedule
	else
		return ("0"); //Never
}


int
nvram_set_fw_keywordenable(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	int i, ret;

	//Add by Timo Wu
        //printf("fw_keywordenable value %d\n", atoi(value));
    	ret = atoi(nvram_get_fw_blockrulenumber("fw_blockrulenumber"));
	//printf("fw_blockrulenumber is %d\n", ret);
	  	
	if (atoi(value) ==0 )
	{
		//printf("Never\n");
		for(i =0; i <ret; i++)
			pRomeCfgParam->urlfilterCfgParam[0][i].enable = 0;
		pRomeCfgParam->scheduleCfgParam.filterstatus = BLOCK_NEVER;
		pRomeCfgParam->scheduleCfgParam.isfilter = 1;

		
	}
	else if(atoi(value) == 1) //Per Schedule
	{
		//printf("Per Schedule\n");
		for(i =0; i <ret; i++)
			pRomeCfgParam->urlfilterCfgParam[0][i].enable = 1;
		pRomeCfgParam->scheduleCfgParam.filterstatus = BLOCK_PERSCHEDULE;
		pRomeCfgParam->scheduleCfgParam.isfilter = 1;

		
	}
	else //Always
	{
		//printf("Always\n");
		for(i =0; i <ret; i++)
			pRomeCfgParam->urlfilterCfgParam[0][i].enable = 1;
		pRomeCfgParam->scheduleCfgParam.filterstatus = BLOCK_ALWAYS;
		pRomeCfgParam->scheduleCfgParam.isfilter = 1;
		
	}
		
	return 1;									

}

/*** Add by Timo Wu******/
char *
nvram_get_fw_blockrulenumber(char *name)
{
	int i, count = 0;
	char *ptr, nvram_name[20];
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	for (i = 0; i < MAX_URL_FILTER; i++) {
		sprintf(nvram_name, "fw_block_keyword_domain%d", i);
		ptr = nvram_get_fw_block_keyword_domain(nvram_name);
		if (*ptr)
			count++;
		else
		    break;
	}		     	
	sprintf(str, "%d", count);
	return(str);
}
/*****End*****/


char *
nvram_get_fw_trustipenable(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);

	return (pRomeCfgParam->urlfilterTrustedUserCfgParam[0].enable ? "1" : "0");
}

int
nvram_set_fw_trustipenable(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	if (atoi(value) == 1)	
		pRomeCfgParam->urlfilterTrustedUserCfgParam[0].enable = 1;
	else
		pRomeCfgParam->urlfilterTrustedUserCfgParam[0].enable = 0;
		
	return 1;									
}

char *
nvram_get_fw_trustip(char *name)
{
	
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (inet_string((uint32)&(pRomeCfgParam->urlfilterTrustedUserCfgParam[0].trustedIP)));				

}

int
nvram_set_fw_trustip(char *name, char *value)
{
		
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	
	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->urlfilterTrustedUserCfgParam[0].trustedIP));
	return 1;									

}


char *
nvram_get_fw_block_keyword_domain(char *name)
{
	char *ptr;
	int ret;

	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	ptr = name+strlen("fw_block_keyword_domain");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_URL_FILTER)
		return ("");
	
	if (strcmp(pRomeCfgParam->urlfilterCfgParam[0][ret].string, "") != 0) {
		//return (pRomeCfgParam->urlfilterCfgParam[0][ret].string);	
		strncpy(str, pRomeCfgParam->urlfilterCfgParam[0][ret].string, sizeof(pRomeCfgParam->urlfilterCfgParam[0][ret].string));		
		return str;
	}					
	else
		return("");	
	
}

int
nvram_set_fw_block_keyword_domain(char *name, char *value)
{
	char *ptr;
	int ret;
	char *tmp;
	char *wan_port0, *wan_port1, *lan_ipaddr, *lan_port0, *lan_port1, *proto, *enable, *desc;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	ptr = name+strlen("fw_block_keyword_domain");
	ret =atoi(ptr);

	if (ret < 0 || ret >= MAX_URL_FILTER)
		return 0;
	
	pRomeCfgParam->urlfilterCfgParam[0][ret].enable = 1;		
	strncpy(pRomeCfgParam->urlfilterCfgParam[0][ret].string, value, sizeof(pRomeCfgParam->urlfilterCfgParam[0][ret].string));	
	pRomeCfgParam->urlfilterCfgParam[0][ret].ip_start = 0;
	pRomeCfgParam->urlfilterCfgParam[0][ret].ip_end = 0xffffffff;	
	
	
	return 1;
}

int
nvram_set_add_block_keyword_domain(char *name, char *value)
{
	char *ptr;
	char nv_name[50];
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	for (i = 0; i < MAX_URL_FILTER; i++) {
		sprintf(nv_name, "fw_block_keyword_domain%d", i);	

		ptr = nvram_get_fw_block_keyword_domain(nv_name);
		if (*ptr == '\0') {
		//pRomeCfgParam->urlfilterCfgParam[0][i].enable = 1;
			strncpy(pRomeCfgParam->urlfilterCfgParam[0][i].string, value, sizeof(pRomeCfgParam->urlfilterCfgParam[0][i].string));	
			pRomeCfgParam->urlfilterCfgParam[0][i].ip_start = 0;
			pRomeCfgParam->urlfilterCfgParam[0][i].ip_end = 0xffffffff;	
			
			break;
		}
		else {
			if (strcmp(ptr, value) == 0)	/* have same keyword */
				break;
		}		 	
	}		
	return 1;
}	

int
nvram_set_del_block_keyword_domain(char *name, char *value)
{
	char *ptr;
	char nv_name[50];
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	for (i = 0; i < MAX_URL_FILTER; i++) {
		sprintf(nv_name, "fw_block_keyword_domain%d", i);		     
		ptr = nvram_get_fw_block_keyword_domain(nv_name);
		if (strcmp(value, ptr) == 0) {
			//Add by Timo Wu	
			memset((char *)&(pRomeCfgParam->urlfilterCfgParam[0][i]), 0x0, sizeof(urlfilterCfgParam_t));
			break;
		}
	}		
	return 1;
}	

int
nvram_set_clr_block_keyword_domain(char *name, char *value)
{
	char *ptr;
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	for (i = 0; i < MAX_URL_FILTER; i++) {
		//Add by Timo Wu
		memset((char *)&(pRomeCfgParam->urlfilterCfgParam[0][i]), 0x0, sizeof(urlfilterCfgParam_t));
	}
	return 1;
}

char *
nvram_get_fw_packenable(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);	
	//Add by Timo Wu
	if(pRomeCfgParam->scheduleCfgParam.aclstatus == BLOCK_ALWAYS)
		return ("2");	/* Always */
	else if (pRomeCfgParam->scheduleCfgParam.aclstatus == BLOCK_PERSCHEDULE)
	
		return ("1");	/* Per Schedule */
	else
		return ("0");	/* Never */
	
	/* 0 -> never
	   1 -> schedule
	   2 -> always */	
}

int
nvram_set_fw_packenable(char *name, char *value)
{
	char *ptr;
	int i, ret;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	//Add by Timo Wu

	ret = atoi(nvram_get_fw_packrulenumber("fw_packrulenumber"));
	
	if (atoi(value) ==0 )
	{
		//printf("acl Never\n");		
		for (i=0 ; i< ret ;i++)
			pRomeCfgParam->aclCfgParam[0][i].enable = 0;
		pRomeCfgParam->scheduleCfgParam.aclstatus = BLOCK_NEVER;
		pRomeCfgParam->scheduleCfgParam.isacl = 1;

		
	}
	else if(atoi(value) == 1) //Per Schedule
	{
		//printf("Per Schedule\n");
		for (i=0 ; i< ret ;i++)
		{
			pRomeCfgParam->aclCfgParam[0][i].enable = 1;
			pRomeCfgParam->aclCfgParam[0][i].start_hour = pRomeCfgParam->scheduleCfgParam.start_hour;
	    		pRomeCfgParam->aclCfgParam[0][i].end_hour = pRomeCfgParam->scheduleCfgParam.end_hour;
	    		pRomeCfgParam->aclCfgParam[0][i].start_minute = pRomeCfgParam->scheduleCfgParam.start_minute;
	    		pRomeCfgParam->aclCfgParam[0][i].end_minute = pRomeCfgParam->scheduleCfgParam.end_minute;
		}
		pRomeCfgParam->scheduleCfgParam.aclstatus = BLOCK_PERSCHEDULE;
		pRomeCfgParam->scheduleCfgParam.isacl = 1;

		
	}
	else //Always
	{
		//printf("acl Always\n");
		for (i=0 ; i< ret ;i++)
		{
			pRomeCfgParam->aclCfgParam[0][i].enable = 1;
			pRomeCfgParam->aclCfgParam[0][i].start_hour = 0;
	                pRomeCfgParam->aclCfgParam[0][i].end_hour = 23;	    
	                pRomeCfgParam->aclCfgParam[0][i].start_minute = 0;
	                pRomeCfgParam->aclCfgParam[0][i].end_minute = 59;
		}
		pRomeCfgParam->scheduleCfgParam.aclstatus = BLOCK_ALWAYS;
		pRomeCfgParam->scheduleCfgParam.isacl = 1;
		
	}		
	
	return 1;
}	

char *
nvram_get_fw_packrulenumber(char *name)
{
	int i, count = 0;
	char *ptr, nvram_name[20];
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	for (i = 0; i < MAX_ACL; i++) {
		sprintf(nvram_name, "filter_client%d", i);
		ptr = nvram_get_filter_client(nvram_name);
		if (*ptr) 
			count++;
		else
		    break;
	}		     	
	sprintf(str, "%d", count);
	return(str);
}

int
nvram_set_fw_packrulenumber(char *name, char *value)
{
	char *ptr;
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	return 1;
}	


/* "%s-%s:%d-%d,%s,%d-%d,%d-%d,%s,%s" */
/* %s-%s:%d-%d,%s,%d,%d,%d,%d,%d,%d,%d:%d-%d,%s,%s */
char *
nvram_get_filter_client(char *name)
{
	char *ptr;
	int ret;
	int sun=0, mon=0, tue=0, wed=0, thu=0, fri=0 ,sat=0, day=0;//Add by Timo Wu for print out days
	int i;
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	ptr = name+strlen("filter_client");
	ret =atoi(ptr);
	
	if (ret < 0)
		return ("");
	if (ret >= MAX_ACL) {
		
		sprintf(str, "%s-%s:%d-%d,%s,%d,%d,%d,%d,%d,%d,%d:%d-%d,%s,%s",
			"",
			"",
			0,
			0,
			"tcp",
			0,0,0,0,0,0,0,
			0,
			0,
			"off",
			""
			);		
		return (str);	
	}	
	
	//Get block days, Add by Timo	
	day = pRomeCfgParam->scheduleCfgParam.day;
	
	for (i = 0; i < 7; i++) {
		if (((day & (1 << i)) != 0) && (i == 0))
			sun = 1;
		else if (((day & (1 << i)) != 0) && (i == 1))
			mon = 1;
		else if (((day & (1 << i)) != 0) && (i == 2))
			tue = 1;
		else if (((day & (1 << i)) != 0) && (i == 3))
			wed = 1;
		else if (((day & (1 << i)) != 0) && (i == 4))
			thu = 1;
		else if (((day & (1 << i)) != 0) && (i == 5))
			fri = 1;
		else if (((day & (1 << i)) != 0) && (i == 6))
			sat = 1;
	}					

	if (*((unsigned long *)&(pRomeCfgParam->aclCfgParam[0][ret].ip)) || *((unsigned long *)&(pRomeCfgParam->aclCfgParam[0][ret].ip_end))) {
		char startip[20], endip[20];
		
	        strcpy(startip, (char *)(inet_string((uint32)&(pRomeCfgParam->aclCfgParam[0][ret].ip))));	
	        strcpy(endip, (char *)(inet_string((uint32)&(pRomeCfgParam->aclCfgParam[0][ret].ip_end))));
		
		sprintf(str, "%s-%s:%d-%d,%s,%d,%d,%d,%d,%d,%d,%d:%d-%d,%s,%s",
			startip,
			endip,
			pRomeCfgParam->aclCfgParam[0][ret].port,
			pRomeCfgParam->aclCfgParam[0][ret].port_e,
			((pRomeCfgParam->aclCfgParam[0][ret].type) ? 
				((pRomeCfgParam->aclCfgParam[0][ret].type == 1) ? "udp" : "both") : "tcp"),
			sun,mon,tue,wed,thu,fri,sat,
			0,
			0,
			((pRomeCfgParam->aclCfgParam[0][ret].enable) ? "on" : "off"),
			//"Blcok Service"
			(pRomeCfgParam->aclCfgParam[0][ret].desc)
			);		
		return (str);	
	}
	else {
		return ("");
	}	
}	

int
nvram_set_filter_client(char *name, char *value)
{
	char *ptr;
	int i, ret;
	char *lan_ipaddr0, *lan_ipaddr1, *lan_port0, *lan_port1, *proto;
	char *day_start, *day_end, *sec_start, *sec_end;
	char *enable, *desc;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	ptr = name+strlen("filter_client");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_ACL)
		return 0;

	if (*value == 0) {
		for (i = ret; i < (MAX_ACL-1); i++) {
			memcpy((char *)&(pRomeCfgParam->aclCfgParam[0][i]), 
				(char *)&(pRomeCfgParam->aclCfgParam[0][i+1]),
					 sizeof(aclCfgParam_t));
		}
		/* clear finial entry */
		
		memset((char *)&(pRomeCfgParam->aclCfgParam[0][i]), 0x0, sizeof(aclCfgParam_t));	
		return 1;
	}
		
	/* Check for port specification */
	lan_port0 = value;
	lan_ipaddr0 = strsep(&lan_port0, ":");
	if (!lan_port0)
		return 0;

	/* Check for protocol specification */
	proto = lan_port0;
	lan_port0 = strsep(&proto, ",");
	if (!proto)
		return 0;

	/* Check for day specification */
	day_start = proto;
	proto = strsep(&day_start, ",");
	if (!day_start)
		return 0;

	/* Check for time specification */
	sec_start = day_start;
	day_start = strsep(&sec_start, ":");
	if (!sec_start)
		return 0;

	/* Check for enable specification */
	enable = sec_start;
	sec_start = strsep(&enable, ",");
	if (!enable)
		return 0;

	/* Check for description specification (optional) */
	desc = enable;
	enable = strsep(&desc, ",");

	/* Check for address range (optional) */
	lan_ipaddr1 = lan_ipaddr0; 
	lan_ipaddr0 = strsep(&lan_ipaddr1, "-");
	if (!lan_ipaddr1)
		lan_ipaddr1 = lan_ipaddr0;

	/* Check for port range (optional) */
	lan_port1 = lan_port0;
	lan_port0 = strsep(&lan_port1, "-");
	if (!lan_port1)
		lan_port1 = lan_port0;

	/* Check for day range (optional) */
	day_end = day_start;
	day_start = strsep(&day_end, "-");
	if (!day_end)
		day_end = day_start;

	/* Check for time range (optional) */
	sec_end = sec_start;
	sec_start = strsep(&sec_end, "-");
	if (!sec_end)
		sec_end = sec_start;

	/* Parse address range */
	if (*lan_ipaddr0 == '*') {
		/* Match any IP address */
		
	} else {
		/* Match a range of IP addresses */
		(void) inet_aton(lan_ipaddr0, (struct in_addr *)&(pRomeCfgParam->aclCfgParam[0][ret].ip));
		//(void) inet_aton(lan_ipaddr1, (struct in_addr *)&(pRomeCfgParam->aclCfgParam[0][ret].ip));				
		
		/* Match a range of IP addresses */
		(void) inet_aton(lan_ipaddr1, (struct in_addr *)&(pRomeCfgParam->aclCfgParam[0][ret].ip_end));
		//(void) inet_aton(lan_ipaddr1, (struct in_addr *)&(pRomeCfgParam->aclCfgParam[0][ret].ip));				
		
	}

	/* Parse destination port range */
        pRomeCfgParam->aclCfgParam[0][ret].port = atoi(lan_port0);
        pRomeCfgParam->aclCfgParam[0][ret].port_e = atoi(lan_port1);  
        //pRomeCfgParam->aclCfgParam[0][ret].port = atoi(lan_port1);        
        /* need implementation port range later */

	/* Parse protocol */
	if (!strncasecmp(proto, "tcp", 3))
		pRomeCfgParam->aclCfgParam[0][ret].type = 0; /* TCP */
	else if (!strncasecmp(proto, "udp", 3))
		pRomeCfgParam->aclCfgParam[0][ret].type = 1; /* UDP */		
	else if (!strncasecmp(proto, "both", 4))
	{
		pRomeCfgParam->aclCfgParam[0][ret].type = 2; /* BOTH */		
	}
	else
		return 0;

	/* Parse day range */
	{
	#if defined(DNI) //Add By Timo Wu
	//printf("pRomeCfgParam->scheduleCfgParam.day is %d\n",pRomeCfgParam->scheduleCfgParam.day);
	for( i=0; i <MAX_ACL ; i++)
	{
		pRomeCfgParam->aclCfgParam[0][ret].day = pRomeCfgParam->scheduleCfgParam.day;
		if(pRomeCfgParam->scheduleCfgParam.aclstatus == BLOCK_ALWAYS)
			pRomeCfgParam->aclCfgParam[0][ret].day = 127;	//Block whole week, not set to scheduleCfgParam
	}
	#endif

	}

	/* Parse time range */
	#if 0
	pRomeCfgParam->aclCfgParam[0][ret].start_hour = atoi(sec_start);
	pRomeCfgParam->aclCfgParam[0][ret].end_hour = atoi(sec_end);	
	#endif

	/* Parse enable */
	#if 0	
	if (!strncasecmp(enable, "off", 3))
		pRomeCfgParam->aclCfgParam[0][ret].enable = 0;
	else
		pRomeCfgParam->aclCfgParam[0][ret].enable = 1;
	#endif	
	
	/* Parse description */ // Note that it is used for block mode now
	if (desc) {
		strncpy(pRomeCfgParam->aclCfgParam[0][ret].desc, desc, sizeof(pRomeCfgParam->aclCfgParam[0][ret].desc));
	}
	
	/* client filter */
	pRomeCfgParam->aclCfgParam[0][ret].direction = ACLCFGPARAM_DIRECTION_INGRESS_SRC;

	return 1;	
		
}	


char *
nvram_get_fw_inidays(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	return ("0");	
}

char *
nvram_get_fw_blockdays(char *name)
{
	int i, day;
	char tmp[20];
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	strcpy(tmp, "0,0,0,0,0,0,0");
	
	//Add by Timo Wu
	day = pRomeCfgParam->scheduleCfgParam.day;
	for (i = 0; i < 7; i++) {
		if ((day & (1 << i)) != 0)
			tmp[i * 2] = '1';
	}
	strcpy(str, tmp);
	return (str);		
	
}

/* value fommat : x,x,x,x,x,x,x */
int
nvram_set_fw_blockdays(char *name, char *value)
{
	char *ptr;
	int i = 0;
	unsigned char day = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	ptr = strtok(value, ",:");	
	while (ptr && (i < 7)) {
		if (*ptr == '1') 
			day |= (1 << i);			
		i++;
		ptr= strtok(NULL, ",:");
	}
	//pRomeCfgParam->aclCfgParam[0][0].day = day;
	//Add by Timo Wu
	pRomeCfgParam->scheduleCfgParam.day = day;

	for( i=0 ;i< MAX_ACL; i++)
	{
	  pRomeCfgParam->aclCfgParam[0][i].day = day;		
	}
	
	return 1;
}	


char *
nvram_get_fw_blockallday(char *name)
{
	if(pRomeCfgParam->scheduleCfgParam.allday==1) //Add by Timo
	{
		return ("1");
	}
	else if ((strcmp(nvram_get_fw_starthour("fw_starthour"),"0")==0)&&
	(strcmp(nvram_get_fw_endhour("fw_endhour"),"23")==0)&&
	(strcmp(nvram_get_fw_startmin("fw_startmin"),"0")==0)&&
	(strcmp(nvram_get_fw_endmin("fw_endmin"),"59")==0))
	{
		return ("1");
	}
	else
	{
		return ("0");	
	}
}


int
nvram_set_fw_blockallday(char *name, char *value)
{
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	int i;
	
	//pRomeCfgParam->aclCfgParam[0][0].allday = atoi(value);
	//Add by Timo
	pRomeCfgParam->aclCfgParam[0][0].allday = atoi(value);

	pRomeCfgParam->scheduleCfgParam.allday = atoi(value);
	
	if(strcmp(value,"1")==0)
	{

	for(i = 0; i < MAX_ACL ; i++)
	{		
	  pRomeCfgParam->aclCfgParam[0][i].start_hour=0;
	  pRomeCfgParam->aclCfgParam[0][i].end_hour=23;
	  pRomeCfgParam->aclCfgParam[0][i].start_minute=0;
	  pRomeCfgParam->aclCfgParam[0][i].end_minute=59;
        }
	  
	  pRomeCfgParam->scheduleCfgParam.start_hour=0;
	  pRomeCfgParam->scheduleCfgParam.end_hour=23;
	  pRomeCfgParam->scheduleCfgParam.start_minute=0;
	  pRomeCfgParam->scheduleCfgParam.end_minute=59;
	
	}
	
	return 1;
}	


char *
nvram_get_fw_everyday(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	if (strcmp(nvram_get_fw_blockdays("fw_blockdays"), "1,1,1,1,1,1,1") == 0)
		return ("1");	
	return ("0");
}

int
nvram_set_fw_everyday(char *name, char *value)
{
	char *ptr;
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	//pRomeCfgParam->aclCfgParam[0][0].day = 0x7f;	/* all days */
        for (i=0; i <MAX_ACL ; i++)
        {	
		pRomeCfgParam->aclCfgParam[0][i].day = 0x7f;	/* all days */
	}
	// Add by Timo Wu
	pRomeCfgParam->scheduleCfgParam.day = 0x7f;
	return 1;
}


char *
nvram_get_fw_starthour(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	//Add by Timo Wu	
	sprintf(str, "%d", pRomeCfgParam->scheduleCfgParam.start_hour);	
	return (str);
}

int
nvram_set_fw_starthour(char *name, char *value)
{
	char *ptr;
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	//pRomeCfgParam->aclCfgParam[0][0].start_hour = atoi(value);
	for ( i =0 ; i < MAX_ACL; i++)
	{	
	  pRomeCfgParam->aclCfgParam[0][i].start_hour = atoi(value);
	}
	//Add by Timo Wu
	pRomeCfgParam->scheduleCfgParam.start_hour = atoi(value);
	return 1;
}

char *
nvram_get_fw_endhour(char *name)
{
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	//Add by Timo Wu
	sprintf(str, "%d", pRomeCfgParam->scheduleCfgParam.end_hour);
	return (str);
}

int
nvram_set_fw_endhour(char *name, char *value)
{
	char *ptr;
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	//pRomeCfgParam->aclCfgParam[0][0].end_hour = atoi(value);
	//Add by Timo Wu
	pRomeCfgParam->scheduleCfgParam.end_hour = atoi(value);

        for( i =0; i < MAX_ACL ; i++)
        {
	  pRomeCfgParam->aclCfgParam[0][i].end_hour = atoi(value);
        }
	return 1;
}

char *
nvram_get_fw_startmin(char *name)
{
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	//sprintf(str, "%d", pRomeCfgParam->aclCfgParam[0][0].start_minute);	
	//Add by Timo Wu
	sprintf(str, "%d", pRomeCfgParam->scheduleCfgParam.start_minute);	
	return (str);
}

int
nvram_set_fw_startmin(char *name, char *value)
{
	char *ptr;
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	//pRomeCfgParam->aclCfgParam[0][0].start_minute = atoi(value);
	//Add by Timo Wu
	for(i=0; i<MAX_ACL; i++)
	{	
	  pRomeCfgParam->aclCfgParam[0][i].start_minute = atoi(value);
	}
	pRomeCfgParam->scheduleCfgParam.start_minute = atoi(value);
	return 1;
}

char *
nvram_get_fw_endmin(char *name)
{
	
	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	//sprintf(str, "%d", pRomeCfgParam->aclCfgParam[0][0].end_minute);	
	//Add by Timo Wu
	sprintf(str, "%d", pRomeCfgParam->scheduleCfgParam.end_minute);	
	return (str);
}

int
nvram_set_fw_endmin(char *name, char *value)
{
	char *ptr;
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	//pRomeCfgParam->aclCfgParam[0][0].end_minute = atoi(value);
	//Add by Timo Wu
	for (i=0; i<MAX_ACL; i++)
	{	
	   pRomeCfgParam->aclCfgParam[0][i].end_minute = atoi(value);
 	}
	pRomeCfgParam->scheduleCfgParam.end_minute = atoi(value);	
	return 1;
}


#define MAX_DHCPC	MAX_RESERVED_FIXED //ATTACHED _DEVICES
char *
nvram_get_dhcpc_res_count(char *name)
{
	int i, dhcpc_res_count = 0;
	char *ptr;
	char tmp[20];

	for (i = 0; i < MAX_DHCPC; i++) {
		sprintf(tmp, "dhcpc_res%d", i);
		ptr = nvram_get_dhcpc_reservation(tmp);
		if (*ptr != '\0') 
			dhcpc_res_count++;
	}
	sprintf(str, "%d", dhcpc_res_count);
	return (str);
}

char *
nvram_get_ddns_enable(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	return ((pRomeCfgParam->ddnsCfgParam.enable) ? "1" : "0");
}	

int
nvram_set_ddns_enable(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	pRomeCfgParam->ddnsCfgParam.enable = atoi(value);
	strcpy(pRomeCfgParam->ddnsCfgParam.service, "dyndns");
		
	return 1;

}

char *
nvram_get_ddns_hostname(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	return (pRomeCfgParam->ddnsCfgParam.hostname);
}	

int
nvram_set_ddns_hostname(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	strncpy(pRomeCfgParam->ddnsCfgParam.hostname, value, sizeof(pRomeCfgParam->ddnsCfgParam.hostname));
	return 1;

}

char *
nvram_get_ddns_login(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	return (pRomeCfgParam->ddnsCfgParam.username);
}	

int
nvram_set_ddns_login(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	strncpy(pRomeCfgParam->ddnsCfgParam.username, value, sizeof(pRomeCfgParam->ddnsCfgParam.username));
	return 1;

}

char *
nvram_get_ddns_passwd(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	return (pRomeCfgParam->ddnsCfgParam.password);
}	

int
nvram_set_ddns_passwd(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	strncpy(pRomeCfgParam->ddnsCfgParam.password, value, sizeof(pRomeCfgParam->ddnsCfgParam.password));
	
	return 1;
}

char *
nvram_get_ddns_wildcard(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);

	if (pRomeCfgParam->ddnsCfgParam.wildcard == 1)
		return ("1");
	else
		return ("0");	
}

int
nvram_set_ddns_wildcard(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->ddnsCfgParam.wildcard = atoi(value);	
	
	return 1;
}

char *
nvram_get_ddns_status(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	
	sprintf(str, "%d", pRomeCfgParam->ddnsCfgParam.ddns_status);
	return (str);

}

int
nvram_set_ddns_status(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->ddnsCfgParam.ddns_status = atoi(value);	
	
	return 1;
}



char *
nvram_get_upnp_enable(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return ((pRomeCfgParam->upnpCfgParam.enable) ? "1" : "0");

}

int
nvram_set_upnp_enable(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->upnpCfgParam.enable = atoi(value);
	
	return 1;
}

char *
nvram_get_upnp_advertime(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	
	sprintf(str, "%d", pRomeCfgParam->upnpCfgParam.advertime);
	
	return(str);

}

int
nvram_set_upnp_advertime(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->upnpCfgParam.advertime = atoi(value);
	return 1;
}

char *
nvram_get_upnp_timetolive(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->upnpCfgParam.timetolive);
	return(str);	

}

int
nvram_set_upnp_timetolive(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->upnpCfgParam.timetolive = atoi(value);
	return 1;	

}

char *
nvram_get_fw_porttrigenable(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return ((pRomeCfgParam->specialapCfgParam[0][0].g_enable) ? "1" : "0");
	

}

int
nvram_set_fw_porttrigenable(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->specialapCfgParam[0][0].g_enable = atoi(value);
	
	return 1;
}

char *
nvram_get_fw_triggertime(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	
	sprintf(str, "%d", pRomeCfgParam->specialapCfgParam[0][0].g_triggertime);
	return (str);
}

int
nvram_set_fw_triggertime(char *name, char *value)
{
	int i, ret;
	
	ret = atoi(nvram_get_trigger_count("trigger_count"));
	if (ret == 0)
		pRomeCfgParam->specialapCfgParam[0][0].g_triggertime = atoi(value);
	else{	
		for (i=0 ; i< ret ;i++){
			pRomeCfgParam->specialapCfgParam[0][i].g_triggertime = atoi(value);
		}
	}

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	return 1;
}

char *
nvram_get_fw_disable(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	if(pRomeCfgParam->dosCfgParam[0].enable) 
		return "0";
	else
		return "1";	
	//return ((pRomeCfgParam->dosCfgParam[0].enable) ? "0" : "1");
}

int
nvram_set_fw_disable(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	if (!strcmp(value, "on") || !strcmp(value, "1"))
		pRomeCfgParam->dosCfgParam[0].enable = 0;
	else
		pRomeCfgParam->dosCfgParam[0].enable = 1;
	return 1;
}

char *
nvram_get_emailenable(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return ((pRomeCfgParam->emailCfgParam.enable) ? "1" : "0");	
	
}

int
nvram_set_emailenable(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	if (atoi(value) == 1)
		pRomeCfgParam->emailCfgParam.enable = 1;	
	else
		pRomeCfgParam->emailCfgParam.enable = 0;		
	return 1;
}

char *
nvram_get_fw_remoteenable(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return ((pRomeCfgParam->mgmtCfgParam[0].valid) ? "1" : "0");	
	
}

int
nvram_set_fw_remoteenable(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	if (atoi(value) == 1)
		pRomeCfgParam->mgmtCfgParam[0].valid = 1;	
	else
		pRomeCfgParam->mgmtCfgParam[0].valid = 0;		
	return 1;
}
	


char *
nvram_get_logsubject(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return ("Event Log");
	//return ("");

}

int
nvram_set_logsubject(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	return 1;
}	

char *
nvram_get_alertsubject(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return ("Event Log");
	//return ("");

}

int
nvram_set_alertsubject(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	return 1;
}

char *
nvram_get_mailserver(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return(pRomeCfgParam->emailCfgParam.smtpserver);	

}

int
nvram_set_mailserver(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	strncpy(pRomeCfgParam->emailCfgParam.smtpserver, value, sizeof(pRomeCfgParam->emailCfgParam.smtpserver));
	return 1;
}

char *
nvram_get_tomail(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->emailCfgParam.rcptto);

}

int
nvram_set_tomail(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	strncpy(pRomeCfgParam->emailCfgParam.rcptto, value, sizeof(pRomeCfgParam->emailCfgParam.rcptto));
	return 1;
}

char *
nvram_get_frommail(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->emailCfgParam.mailfrom);
}

int
nvram_set_frommail(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	strncpy(pRomeCfgParam->emailCfgParam.mailfrom, value, sizeof(pRomeCfgParam->emailCfgParam.mailfrom));
	return 1;
}

char *
nvram_get_alertimm(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->emailCfgParam.alertimm ? "1" : "0");	

}

int
nvram_set_alertimm(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->emailCfgParam.alertimm = atoi(value);

	return 1;
}

char *
nvram_get_alerttype(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	switch(pRomeCfgParam->emailCfgParam.alerttype)
	{
		case 0: return "0";
		case 1: return "1";
		case 2: return "2";
		case 3: return "3";
		case 4: return "4";
		default: return "4"; //4 -> None
	}
	
/*	
		0 -> When Log is Full
		1 -> Hourly
		2 -> Daily
		3 -> Weekly
		4 -> None	
*/
}

int
nvram_set_alerttype(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->emailCfgParam.alerttype = atoi(value);
	
	return 1;
}

char *
nvram_get_alertday(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	switch(pRomeCfgParam->emailCfgParam.alertday)
	{
		case 0: return "0";
		case 1: return "1";
		case 2: return "2"; 
		case 3: return "3";
		case 4: return "4";
		case 5: return "5";
		case 6: return "6";
		default: return "1"; //1 -> Monday
	}

/*
		0 -> Sunday
		1 -> Monday
		2 -> Tuesday
		3 -> Wednesday
		4 -> Thursday
		5 -> Friday
		6 -> Saturday	
*/		

}

int
nvram_set_alertday(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->emailCfgParam.alertday = atoi(value);

	return 1;
}

char *
nvram_get_alerthour(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	switch(pRomeCfgParam->emailCfgParam.alerthour)
	{
		case 1: return "1";
		case 2: return "2";
		case 3: return "3";
		case 4: return "4";
		case 5: return "5";
		case 6: return "6";
		case 7: return "7";
		case 8: return "8";
		case 9: return "9";
		case 10: return "10";
		case 11: return "11";
		case 12: return "12";
		default: return "1"; //1 -> 1:00
	}
/*
		1 -> 1:00
		12-> 12:00	
*/		

}

int
nvram_set_alerthour(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->emailCfgParam.alerthour = atoi(value);

	return 1;
}



char *
nvram_get_alertampm(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->emailCfgParam.alertampm ? "1" : "0");	

/*	
(0->AM 1->PM)	
*/
}

int
nvram_set_alertampm(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
		
	pRomeCfgParam->emailCfgParam.alertampm = atoi(value);
	return 1;
}


char *
nvram_get_email_sameaddr(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return ("0");
	
}

int
nvram_set_email_sameaddr(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	return 1;
}

char *
nvram_get_email_diffaddr(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return ("1");
	
}

int
nvram_set_email_diffaddr(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	return 1;
}

char *
nvram_get_email_serverauth(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->emailCfgParam.serverauth ? "1" : "0");	
	
}

int
nvram_set_email_serverauth(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->emailCfgParam.serverauth = atoi(value);
	return 1;
}

char *
nvram_get_email_authname(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return(pRomeCfgParam->emailCfgParam.smtp_name);	
	
}

int
nvram_set_email_authname(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	strncpy(pRomeCfgParam->emailCfgParam.smtp_name, value, sizeof(pRomeCfgParam->emailCfgParam.smtp_name));	
	return 1;
}

char *
nvram_get_email_authpasswd(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);

	return(pRomeCfgParam->emailCfgParam.smtp_password);	

}

int
nvram_set_email_authpasswd(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	strncpy(pRomeCfgParam->emailCfgParam.smtp_password, value, sizeof(pRomeCfgParam->emailCfgParam.smtp_password));	
	return 1;
}


char *
nvram_get_dmz_enable(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->dmzCfgParam[0].enable ? "1" : "0");	
}
	
int 
nvram_set_dmz_enable(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	//if (strcmp(value, "on") == 0)
	if (!strcmp(value, "on") || !strcmp(value, "1"))	
		pRomeCfgParam->dmzCfgParam[0].enable = 1;
	else
		pRomeCfgParam->dmzCfgParam[0].enable = 0;
	return 1;			
		
}

char *
nvram_get_dmz_ipaddr(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	return (inet_string((uint32)&(pRomeCfgParam->dmzCfgParam[0].dmzIp)));		


}

int 
nvram_set_dmz_ipaddr(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	(void) inet_aton(value, (struct in_addr *)&(pRomeCfgParam->dmzCfgParam[0].dmzIp));
	return 1;	
}	

char *
nvram_get_wan_mac_mode(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	sprintf(str, "%d", pRomeCfgParam->dhcpcCfgParam.cmacValid);
	return(str);	

}

int 
nvram_set_wan_mac_mode(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	pRomeCfgParam->dhcpcCfgParam.cmacValid = atoi(value);
	return 1;	
}


/* return AABBCCDDEEFF */
char *
nvram_get_wan_spoofmac(char *name)
{
	char *c=str;
	int i;

	DPRINTF("nvram_get(\"%s\")\n", name);
	
	for (i = 0; i < 6; i++) {
		c += sprintf(c, "%02X", (pRomeCfgParam->ifCfgParam[0].hwaddr[i] & 0xff));
	}

	
	return(str);	

}

/* value = AABBCCDDEEFF */
int 
nvram_set_wan_spoofmac(char *name, char *value)
{
	char *c=str;
	int i;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	if (strstr(value, ":") == 0) {
		for (i = 0; i < 6; i++) {
			*c++ = value[i*2];
			*c++ = value[i*2+1];			
			if (i < 5)
		   	*c++ = ':';
		} 	
		*c = 0;
		c = str;
	}	
	else {
		c = value;
	}	
	ether_atoe(c, pRomeCfgParam->dhcpcCfgParam.cloneMac);
	return 1;	
}	

char *
nvram_get_wizard_wan_spoofmac_detected(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	sprintf(str, "%d", pRomeCfgParam->dhcpcCfgParam.spoofmac_detected);
	return(str);	

}

int 
nvram_set_wizard_wan_spoofmac_detected(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	pRomeCfgParam->dhcpcCfgParam.spoofmac_detected = atoi(value);
	return 1;	
}

/* ipaddr,macaddr(xx:xx:xx:xx:xx:xx),desc */
char *
nvram_get_dhcpc_reservation(char *name)
{
	char *ptr, ipaddr[20], macaddr[20];
	int ret;

	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	ptr = name+strlen("dhcpc_res");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_DHCPC)
		return ("");
			
	if (*((unsigned long *)&(pRomeCfgParam->dhcpsCfgParam.manualIp[ret]))) {
		strcpy(ipaddr, (char *)(inet_string((uint32)&(pRomeCfgParam->dhcpsCfgParam.manualIp[ret]))));		
		ether_etoa(pRomeCfgParam->dhcpsCfgParam.hardwareAddr[ret], macaddr);
		
		sprintf(str, "%s,%s,%s",
			ipaddr,
			macaddr,
			//"Dhcpc Reservation"		/* name */
			pRomeCfgParam->dhcpsCfgParam.manu_desc[ret]			
			);		
		return (str);	
	}
	else
		return ("");
}	

int
nvram_set_dhcpc_reservation(char *name, char *value)
{
	char *ptr;
	int ret, i;
	char *ipaddr, *mac, *desc;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	ptr = name+strlen("dhcpc_res");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_DHCPC)
		return 0;
		
	if (*value == 0) {
		/* clear dhcpc res */
		for (i = ret; i < (MAX_DHCPC-1); i++) {
			pRomeCfgParam->dhcpsCfgParam.manualIp[i] = pRomeCfgParam->dhcpsCfgParam.manualIp[i+1];			
			memcpy(pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i], 
			       pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i+1], 6);
		}	       
		
		/* clear finial entry */
		pRomeCfgParam->dhcpsCfgParam.manualIp[i] = 0;			
		memset(pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i], 0x0, 6); 
		return 1;
	}	
			
	/* Check for ipaddr address specification */
	mac = value;
	ipaddr = strsep(&mac, ",");
	if (!ipaddr)
		return 0;
		
	desc = mac;
	mac = strsep(&desc, ",");
	if (!mac)
		return 0;
		
	(void) inet_aton(ipaddr, (struct in_addr *)&(pRomeCfgParam->dhcpsCfgParam.manualIp[ret]));
	ether_atoe(mac, pRomeCfgParam->dhcpsCfgParam.hardwareAddr[ret]); 
	//printf("mac = %02x:%02x:%02x:%02x:%02x:%02x\n", 
	//	pRomeCfgParam->dhcpsCfgParam.hardwareAddr[ret][0],
	//	pRomeCfgParam->dhcpsCfgParam.hardwareAddr[ret][1],
	//	pRomeCfgParam->dhcpsCfgParam.hardwareAddr[ret][2],
	//	pRomeCfgParam->dhcpsCfgParam.hardwareAddr[ret][3],
	//	pRomeCfgParam->dhcpsCfgParam.hardwareAddr[ret][4],
	//	pRomeCfgParam->dhcpsCfgParam.hardwareAddr[ret][5]);	
		
	strncpy(pRomeCfgParam->dhcpsCfgParam.manu_desc[ret], desc, sizeof(pRomeCfgParam->dhcpsCfgParam.manu_desc[ret]));	
	
	return 1;	
		
}	

//#define OS_VERSION	"V0.1.2_01_09 NA"
//#define OS_VERSION	"V0.1.2_01.10"
//#define OS_VERSION	"V0.1.3_01.16"
//#define OS_VERSION	"V0.1.3_01.17"
//#define OS_VERSION	"V0.1.3_01.24"
//#define OS_VERSION	"V0.1.3_01.27"
//#define OS_VERSION	"V0.1.3_02.06"
//#define OS_VERSION	"V0.1.3_02.10"
//#define OS_VERSION	"V0.1.4_02.13"
//#define OS_VERSION	"V0.1.4_02.15"
//#define OS_VERSION	"V0.1.4_02.16"
//#define OS_VERSION	"V0.1.5_02.18"
//#define OS_VERSION	"V0.1.5_02.20"
//#define OS_VERSION	"V0.1.5_03.01"
//#define OS_VERSION	"V0.0.1_03.21"
//#define OS_VERSION	"V0.0.2_03.24"
//#define OS_VERSION	"V0.0.3_03.28"
//#define OS_VERSION	"V0.0.4_04.19"
//#define OS_VERSION	"V0.0.5_04.25"
//#define OS_VERSION	"V0.0.6_04.27"
//#define OS_VERSION	"V0.0.6_05.02"
//#define OS_VERSION	"V0.0.6_05.04"
//#define OS_VERSION	"V0.1.0_06.05"
//#define OS_VERSION	"V0.1.1_08.25"
//#define OS_VERSION	"V1.0.0_09.11"
#define OS_VERSION	"V1.0.1_10.18"

#define HW_VERSION	"KWGR614H1"
#define LOADER_VERSION	"1.00.03"

char*
nvram_get_model(char *name)
{
	sprintf(str, "%s", _PRODUCT_NAME);	
	return (str);

}

#ifdef EXTENSION_KO
        #define EXTENSION       "KO"    /* KO */
#elif defined(EXTENSION_GR)
        #define EXTENSION       "GR"    /* GR */
#elif defined(EXTENSION_WW)
        #define EXTENSION       "WW"    /* WW */
#else
        #define EXTENSION       "NA"    /* NA */
#endif

char*
nvram_get_os_version(char *name)
{
	//sprintf(str, "%s_%s", OS_VERSION, __DATE__);
	sprintf(str, "%s%s", OS_VERSION, EXTENSION);	
	return (str);
	//return (OS_VERSION);
}

char*
nvram_get_hw_version(char *name)
{
	return (HW_VERSION);
}

//char *
//nvram_get_loader_version(char *name)
//{
//	return (LOADER_VERSION);
//}
char*
nvram_get_loader_version(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	return (pRomeCfgParam->loaderParam.version);
}

int
nvram_set_loader_version(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	strncpy(pRomeCfgParam->loaderParam.version, value, sizeof(pRomeCfgParam->loaderParam.version));

	return 1;
	
} 	

char *
nvram_get_show_Product(char *name)
{
	return ("2");
}	

char *
nvram_get_time_zone(char *name)
{

#if 1
	bzero(str,200);
	sprintf(str,"%d",pRomeCfgParam->emailCfgParam.time_zone);
	return str;
#else
	switch(pRomeCfgParam->emailCfgParam.time_zone)
	{
		case 0: return "0";
		case 1: return "1";
		case 2: return "2";
		case 3: return "3";
		case 4: return "4";
		case 5: return "5";
		case 6: return "6";
		case 7: return "7";
		case 8: return "8";
		case 9: return "9";
		case 10: return "10";
		case 11: return "11";
		case 12: return "12";
		case 13: return "13";
		case 14: return "14";
		case 15: return "15";
		case 16: return "16";
		case 17: return "17";
		case 18: return "18";
		case 19: return "19";
		case 20: return "20";
		case 21: return "21";
		case 22: return "22";
		case 23: return "23";
		case 24: return "24";
		default: return "20"; /* Taipei */
	}
#endif
}

int
nvram_set_time_zone(char *name, char *value)
{
	pRomeCfgParam->emailCfgParam.time_zone = atoi(value);
	return 1;
}

char *
nvram_get_daylight(char *name)
{
	return (pRomeCfgParam->emailCfgParam.daylight ? "1" : "0");	
}

int
nvram_set_daylight(char *name, char *value)
{

	pRomeCfgParam->emailCfgParam.daylight = atoi(value);

	return 1;
}

char *
nvram_get_sys_clock(char *name)
{
	return ("1");
}	

char *
nvram_get_available_localtime(char *name)
{
	return ("1");
}	

char *
nvram_get_blankstate(char *name)
{
	return ("1");		/* 0 -> done */
				/* 1 -> doing */
}

int
nvram_set_blankstate(char *name, char *value)
{
	return 1;
}

char *
nvram_get_wireless_supported(char *name)
{
	return ("1");
}


char *
nvram_get_wan_hostname(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	return (pRomeCfgParam->dhcpcCfgParam.hostname);

	
	
} 

int
nvram_set_wan_hostname(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);
	strncpy(pRomeCfgParam->dhcpcCfgParam.hostname, value, sizeof(pRomeCfgParam->dhcpcCfgParam.hostname));

	return 1;
	
} 

//KEVIN:06DEC05:BlankState+++

int
nvram_set_Smartwizard_Done(char *name, char *value)
{
	int	retval=-1;
	int 	iVal= atoi(value);
	
	switch(iVal)  {
		case 0:
			pRomeCfgParam->BlankStateCfgParam.SmtWzdDone = 0;
			retval = 1;
			break;
		case 1:
			pRomeCfgParam->BlankStateCfgParam.SmtWzdDone = 1;
		retval=1;
			break;
		default:
			break;
	}
	
	return retval;
	
}

char *
nvram_get_Smartwizard_Done(char *name)
{
	sprintf(str,"%d",pRomeCfgParam->BlankStateCfgParam.SmtWzdDone);
	return str;
}	

int
nvram_set_Smartwizard_Step(char *name, char *value)
{
	int	retval=-1;
	int 	iVal= atoi(value);

	if(iVal >= 0 && iVal < 255) {
		pRomeCfgParam->BlankStateCfgParam.SmtWzdState= iVal;
		retval = 1;
	}
	return retval;

}
	
char *
nvram_get_Smartwizard_Step(char *name)
{
	sprintf(str,"%d",pRomeCfgParam->BlankStateCfgParam.SmtWzdState);
	return str;
}	

int
nvram_set_BDetWanType(char *name, char *value)
{
	int	retval=-1;
	int 	iVal= atoi(value);

	if(iVal >= 0 && iVal < 255) {
		pRomeCfgParam->BlankStateCfgParam.Buf_DetectedWanType= iVal;
		retval = 1;
	}
	return retval;

}

char *
nvram_get_BDetWanType(char *name)
{
	sprintf(str,"%d",pRomeCfgParam->BlankStateCfgParam.Buf_DetectedWanType);
	return str;
}	

int
nvram_set_BTestWanConn(char *name, char *value)
{
	int	retval=-1;
	int 	iVal= atoi(value);

	if(iVal >= 0 && iVal < 255) {
		pRomeCfgParam->BlankStateCfgParam.Buf_SuccWanConn= iVal;
		retval = 1;
	}
	return retval;

}

char *
nvram_get_BTestWanConn(char *name)
{
	sprintf(str,"%d",pRomeCfgParam->BlankStateCfgParam.Buf_SuccWanConn);
	return str;
}	
//KEVIN:BlankState---

//pamela20051228 set auto connect
char *
nvram_get_auto_connect(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	//return (pRomeCfgParam->pppoeCfgParam[0].autoReconnect ? "1" : "0");	
	//return (pRomeCfgParam->pppoeCfgParam[0].auto_connect ? "1" : "0");	
	if ((pRomeCfgParam->pppoeCfgParam[0].auto_connect) || 
	    (pRomeCfgParam->pptpCfgParam.auto_connect) ||
	    (pRomeCfgParam->l2tpCfgParam.auto_connect) ||	    
	    (pRomeCfgParam->telCfgParam.auto_connect)) 
	    	return ("1");
	else
		return ("0");    		
}
	

int 
nvram_set_auto_connect(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	//if (strcmp(value, "on") == 0){
	if (!strcmp(value, "on") || !strcmp(value, "1")) {	
		//pRomeCfgParam->pptpCfgParam.autoReconnect = 1;
		//pRomeCfgParam->pppoeCfgParam[0].autoReconnect = 1;
		pRomeCfgParam->pptpCfgParam.auto_connect = 1;
		pRomeCfgParam->pppoeCfgParam[0].auto_connect = 1;
		pRomeCfgParam->telCfgParam.auto_connect = 1;	
		pRomeCfgParam->l2tpCfgParam.auto_connect = 1;				
		pRomeCfgParam->pptpCfgParam.demand = 1;	
		pRomeCfgParam->pppoeCfgParam[0].demand = 1;
		pRomeCfgParam->telCfgParam.demand = 1;	
		pRomeCfgParam->l2tpCfgParam.demand = 1;							
	}
	else{
		//pRomeCfgParam->pptpCfgParam.autoReconnect = 0;
		//pRomeCfgParam->pppoeCfgParam[0].autoReconnect = 0;
		pRomeCfgParam->pptpCfgParam.auto_connect = 0;
		pRomeCfgParam->pppoeCfgParam[0].auto_connect = 0;
		pRomeCfgParam->telCfgParam.auto_connect = 0;	
		pRomeCfgParam->l2tpCfgParam.auto_connect = 0;				
		pRomeCfgParam->pptpCfgParam.demand = 0;	
		pRomeCfgParam->pppoeCfgParam[0].demand = 0;
		pRomeCfgParam->telCfgParam.demand = 0;	
		pRomeCfgParam->l2tpCfgParam.demand = 0;								
	}
	return 1;		
		
}


char *
nvram_get_newfirm(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	return (pRomeCfgParam->mgmtCfgParam[0].newfirm ? "1" : "0");	
}


	

int 
nvram_set_newfirm(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->mgmtCfgParam[0].newfirm = atoi(value);	

	return 1;		
		
}

char *
nvram_get_dhcpc_lease_obtained(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	sprintf(str, "%d", pRomeCfgParam->dhcpcCfgParam.lease);
	return (str);

}


	

int 
nvram_set_dhcpc_lease_obtained(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->dhcpcCfgParam.lease = atoi(value);	

	return 1;		
		
}

char *
nvram_get_dhcpc_lease_expired(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	sprintf(str, "%d", pRomeCfgParam->dhcpcCfgParam.lease_expired);
	return (str);

}	

int 
nvram_set_dhcpc_lease_expired(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->dhcpcCfgParam.lease_expired = atoi(value);	

	return 1;		
		
}
char *
nvram_get_wl_ssid(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	strncpy(str, pRomeCfgParam->wlanCfgParam[0].ssid, sizeof(pRomeCfgParam->wlanCfgParam[0].ssid));		
	return (str);
}
int
nvram_set_wl_ssid(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	strncpy(pRomeCfgParam->wlanCfgParam[0].ssid, value, sizeof(pRomeCfgParam->wlanCfgParam[0].ssid));
	pRomeCfgParam->wlanCfgParam[0].ssid[32] = 0;
	return 1;
	
} 

char *
nvram_get_wl_domain(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].tmpDomain);
	return str;
}
int 
nvram_set_wl_domain(char *name, char *value)
{
	uint8 iWlanRegion = atoi(value);
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].tmpDomain= iWlanRegion;
	switch(iWlanRegion) {
		case 11: //USA
			pRomeCfgParam->wlanCfgParam[0].regDomain = 0;
			break;
		case 4: //Canada
			pRomeCfgParam->wlanCfgParam[0].regDomain = 1;
			break;
		case 8: //Japan
			pRomeCfgParam->wlanCfgParam[0].regDomain = 5;
			break;
		case 7: //Israel
			pRomeCfgParam->wlanCfgParam[0].regDomain = 6;
			break;
		default:
			pRomeCfgParam->wlanCfgParam[0].regDomain = 2;
			break;
		}
	return 1;	
}

char *
nvram_get_wl_channel(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].channel);
	return str;
}
int 
nvram_set_wl_channel(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].channel= atoi(value);
	return 1;	
}

char *
nvram_get_wl_datarate_mode(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].dataRateMode);
	return str;
}

int 
nvram_set_wl_datarate_mode(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].dataRateMode= atoi(value);
	return 1;	
}


char *
nvram_get_wl_security_type(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
#if 0
	if (pRomeCfgParam->wlanCfgParam[0].cryptType == '2')
		return ("2");
	else if (pRomeCfgParam->wlanCfgParam[0].cryptType == '1')
		return ("1");
	else
		return ("0");	
#else
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].cryptType);
	return str;
#endif
}

int
nvram_set_wl_security_type(char *name, char *value)
{

	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].cryptType = atoi(value);	
	return 1;
}
char *
nvram_get_wl_auth_type(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].authType);
	return str;
}
int 
nvram_set_wl_auth_type(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].authType= atoi(value);
	return 1;	
}

char *
nvram_get_wl_passphrase(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	strncpy(str, pRomeCfgParam->wlanCfgParam[0].passphrase, sizeof(pRomeCfgParam->wlanCfgParam[0].passphrase));		
	return (str);
}
int
nvram_set_wl_passphrase(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	strncpy(pRomeCfgParam->wlanCfgParam[0].passphrase, value, sizeof(pRomeCfgParam->wlanCfgParam[0].passphrase));
	return 1;	
} 

char *
nvram_get_wl_key_no(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].keyNo);
	return str;
}
int 
nvram_set_wl_key_no(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].keyNo= atoi(value);
	return 1;	
}
char *
nvram_get_wl_key1(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	strncpy(str, pRomeCfgParam->wlanCfgParam[0].key1, sizeof(pRomeCfgParam->wlanCfgParam[0].key1));		
	return (str);
}
int
nvram_set_wl_key1(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	strncpy(pRomeCfgParam->wlanCfgParam[0].key1, value, sizeof(pRomeCfgParam->wlanCfgParam[0].key1));
	return 1;	
} 
char *
nvram_get_wl_key2(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	strncpy(str, pRomeCfgParam->wlanCfgParam[0].key2, sizeof(pRomeCfgParam->wlanCfgParam[0].key2));		
	return (str);
}
int
nvram_set_wl_key2(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	strncpy(pRomeCfgParam->wlanCfgParam[0].key2, value, sizeof(pRomeCfgParam->wlanCfgParam[0].key2));
	return 1;	
} 
char *
nvram_get_wl_key3(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	strncpy(str, pRomeCfgParam->wlanCfgParam[0].key3, sizeof(pRomeCfgParam->wlanCfgParam[0].key3));		
	return (str);
}
int
nvram_set_wl_key3(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	strncpy(pRomeCfgParam->wlanCfgParam[0].key3, value, sizeof(pRomeCfgParam->wlanCfgParam[0].key3));
	return 1;	
} 
char *
nvram_get_wl_key4(char *name)
{

	DPRINTF("nvram_get(\"%s\")\n", name);
	strncpy(str, pRomeCfgParam->wlanCfgParam[0].key4, sizeof(pRomeCfgParam->wlanCfgParam[0].key4));		
	return (str);
}
int
nvram_set_wl_key4(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	strncpy(pRomeCfgParam->wlanCfgParam[0].key4, value, sizeof(pRomeCfgParam->wlanCfgParam[0].key4));
	return 1;	
} 
char *
nvram_get_wl_wepenc(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].cryptSubType[0]);
	return str;
}
int 
nvram_set_wl_wepenc(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].cryptSubType[0]= atoi(value);
	return 1;	
}

char *
nvram_get_wl_enable_ap(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].enable);
	return str;
}
int 
nvram_set_wl_enable_ap(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].enable= atoi(value);
	return 1;	
}

char *
nvram_get_wl_ssid_bc(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].broadcastSSID);
	return str;
}
int 
nvram_set_wl_ssid_bc(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].broadcastSSID= atoi(value);
	return 1;	
}

char *
nvram_get_wl_frag(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].frag);
	return str;
}
int 
nvram_set_wl_frag(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].frag= atoi(value);
	return 1;	
}

char *
nvram_get_wl_rts(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].rts);
	return str;
}
int 
nvram_set_wl_rts(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].rts= atoi(value);
	return 1;	
}
char *
nvram_get_wl_TxRange(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].range);
	return str;
}
int 
nvram_set_wl_TxRange(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].range= atoi(value);
	return 1;	
}
char *
nvram_get_wl_preamble(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].preambleType);
	return str;
}
int 
nvram_set_wl_preamble(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].preambleType= atoi(value);
	return 1;	
}

char *
nvram_get_wlan_acl(char *name)
{
	char *ptr;
	int ret;

	DPRINTF("nvram_get(\"%s\")\n", name);	
	
	ptr = name+strlen("wlan_acl");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_WLAN_AC)
		return ("");

	if ((pRomeCfgParam->wlanCfgParam[0].acMacList[ret][3] == 0x0) && (pRomeCfgParam->wlanCfgParam[0].acMacList[ret][4] == 0x0) && (pRomeCfgParam->wlanCfgParam[0].acMacList[ret][5] == 0x0))
		return ("");
	else {
		/*printf("%d %s _mac = %02x:%02x:%02x:%02x:%02x:%02x\n", __LINE__, __FUNCTION__, \
			pRomeCfgParam->wlanCfgParam[0].acMacList[ret][0], \
			pRomeCfgParam->wlanCfgParam[0].acMacList[ret][1], \
			pRomeCfgParam->wlanCfgParam[0].acMacList[ret][2], \
			pRomeCfgParam->wlanCfgParam[0].acMacList[ret][3], \ 
			pRomeCfgParam->wlanCfgParam[0].acMacList[ret][4], \
			pRomeCfgParam->wlanCfgParam[0].acMacList[ret][5]);*/	
		
		sprintf(str, "%02x%02x%02x%02x%02x%02x,%s",
				/*macaddr*/pRomeCfgParam->wlanCfgParam[0].acMacList[ret][0], \
				pRomeCfgParam->wlanCfgParam[0].acMacList[ret][1], \
				pRomeCfgParam->wlanCfgParam[0].acMacList[ret][2], \
				pRomeCfgParam->wlanCfgParam[0].acMacList[ret][3], \ 
				pRomeCfgParam->wlanCfgParam[0].acMacList[ret][4], \
				pRomeCfgParam->wlanCfgParam[0].acMacList[ret][5], \
				pRomeCfgParam->wlanCfgParam[0].acComment[ret]);	
	}

	return (str);	
	
}	

int
nvram_set_wlan_acl(char *name, char *value)
{
	char *ptr;
	int ret, i, j=0;
	char *mac, *desc;
	char tmp[10];
	unsigned char _mac[6];
	int val = 0;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	ptr = name+strlen("wlan_acl");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_WLAN_AC)
		return 0;
		
	if (*value == 0) {
		/* clear wlan_acl  */
		for (i = ret; i < (MAX_WLAN_AC-1); i++) {
			memcpy(pRomeCfgParam->wlanCfgParam[0].acMacList[i], pRomeCfgParam->wlanCfgParam[0].acMacList[i+1], 6);
		}	       
		
		/* clear final entry */
		memset(pRomeCfgParam->wlanCfgParam[0].acMacList[i], 0x0, 6); 
			return 1;
	}	
	
	desc = value;
	mac = strsep(&desc, ",");
	
	if (!mac)
		return 0;
	
	for ( i = 0; i < 12; i++) {
		sprintf(tmp, "%c%c", mac[i], mac[i+1]);
		val = strtol(tmp, NULL, 16);
		_mac[j++] = val;
		i++;
	}	

	memcpy(pRomeCfgParam->wlanCfgParam[0].acMacList[ret], _mac, 6);
	/*printf("%d %s = %02x:%02x:%02x:%02x:%02x:%02x\n", __LINE__, __FUNCTION__, \
		pRomeCfgParam->wlanCfgParam[0].acMacList[ret][0], \
		pRomeCfgParam->wlanCfgParam[0].acMacList[ret][1], \
		pRomeCfgParam->wlanCfgParam[0].acMacList[ret][2], \
		pRomeCfgParam->wlanCfgParam[0].acMacList[ret][3], \ 
		pRomeCfgParam->wlanCfgParam[0].acMacList[ret][4], \
		pRomeCfgParam->wlanCfgParam[0].acMacList[ret][5]);*/	
		
	memcpy(pRomeCfgParam->wlanCfgParam[0].acComment[ret], desc, sizeof(pRomeCfgParam->wlanCfgParam[0].acComment[ret]));	
	
	return 1;	
		
}	

char *
nvram_get_wlan_count(char *name)
{
	int i, wlan_acl_count = 0;
	char *ptr;
	char tmp[20];

	DPRINTF("nvram_get(\"%s\")\n", name);	
#if 0
	for (i = 0; i < MAX_WLAN_AC; i++) {
		sprintf(tmp, "wlan_acl%d", i);
		ptr = nvram_get_wlan_acl(tmp);
		
		if (*ptr != '\0')  {
			wlan_acl_count++;
			printf("%d %s %d\n", __LINE__, __FUNCTION__, wlan_acl_count); 
		}
	}
	printf("%d %s %d\n", __LINE__, __FUNCTION__, wlan_acl_count); 
#endif
	wlan_acl_count = pRomeCfgParam->wlanCfgParam[0].wlan_acl_count;
	//printf("%d %s %d\n", __LINE__, __FUNCTION__, wlan_acl_count); 

	sprintf(str, "%d", wlan_acl_count);
	
	return (str);
}

int
nvram_set_wlan_count(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	

	pRomeCfgParam->wlanCfgParam[0].wlan_acl_count = atoi(value);				
	
	return 1;
}

char *
nvram_get_wl_ac_enable(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	sprintf(str, "%d", pRomeCfgParam->wlanCfgParam[0].acEnable);
	return str;
}
int 
nvram_set_wl_ac_enable(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	pRomeCfgParam->wlanCfgParam[0].acEnable= atoi(value);
	return 1;	
}


/* d-d,proto,on/off,priority(0/1),desc */
char *
nvram_get_qos_port(char *name)
{
	char *ptr;
	int ret;

	DPRINTF("nvram_get(\"%s\")\n", name);	
	ptr = name+strlen("qos_port");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_QOS)
		return ("");
		
	if (pRomeCfgParam->qosCfgParam[ret].un.policy_based.portNumber != 0) {			
		sprintf(str, "%d-%d,%s,%s,%d,%s",
			pRomeCfgParam->qosCfgParam[ret].un.policy_based.portNumber,
			pRomeCfgParam->qosCfgParam[ret].un.policy_based.portNumber1,
			((pRomeCfgParam->qosCfgParam[ret].un.policy_based.protocol == 0) ? 
				"tcp" : ((pRomeCfgParam->qosCfgParam[ret].un.policy_based.protocol == 1) ? "udp" : "both")),			
			(pRomeCfgParam->qosCfgParam[ret].un.policy_based.enable ? "on" : "off"),		
			pRomeCfgParam->qosCfgParam[ret].un.policy_based.isHigh,			
			pRomeCfgParam->qosCfgParam[ret].un.policy_based.desc
			);		
		return (str);	
	}
	else
		return ("");
}	

/* d-d,proto,on/off,priority(0/1),desc */
int
nvram_set_qos_port(char *name, char *value)
{
	char *ptr;
	int ret, i;
	char *tmp;
	char *port0, *port1, *proto, *enable, *priority, *desc;
	
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	ptr = name+strlen("qos_port");
	ret =atoi(ptr);
	
	if (ret < 0 || ret >= MAX_QOS)
		return 0;
		
	if (*value == 0) {
		for (i = ret; i < (MAX_QOS-1); i++) {
			memcpy((char *)&(pRomeCfgParam->qosCfgParam[i]), 
				(char *)&(pRomeCfgParam->qosCfgParam[i+1]),
					 sizeof(qosCfgParam_t));
		}
		/* clear finial entry */
		memset((char *)&(pRomeCfgParam->qosCfgParam[i]), 0x0, sizeof(qosCfgParam_t));	
		return 1;
	}	
			
		
	tmp = value;	
	//strcpy(tmp, ptr);
	/* Check for LAN IP address specification */
	proto = tmp;
	port0 = strsep(&proto, ":,");
	if (!proto)
		return 0;

	/* Check for enable specification */
	enable = proto;
	proto = strsep(&enable, ":,");
	if (!enable)
		return 0;

	/* Check for priority specification (optional) */
	priority = enable;
	enable = strsep(&priority, ":,");
	if (!priority)
		return 0;
	
	/* Check for description specification (optional) */
	desc = priority;
	priority = strsep(&desc, ":,");	

	/* Check for port range (optional) */
	port1 = port0;
	port0 = strsep(&port1, "-");
	if (!port1)
		port1 = port0;

	if (strcmp(enable, "on") == 0) {
		pRomeCfgParam->qosCfgParam[ret].un.policy_based.enable = 1;
	}	
	else {
		pRomeCfgParam->qosCfgParam[ret].un.policy_based.enable = 0;
	}
	
	pRomeCfgParam->qosCfgParam[ret].un.policy_based.isHigh = atoi(priority);		
						
	pRomeCfgParam->qosCfgParam[ret].un.policy_based.portNumber = atoi(port0);
	pRomeCfgParam->qosCfgParam[ret].un.policy_based.portNumber1 = atoi(port1);
		
	if (strcmp(proto, "both") == 0) 
		pRomeCfgParam->qosCfgParam[ret].un.policy_based.protocol = 2;			
	else if(strcmp(proto, "udp") == 0) 	
		pRomeCfgParam->qosCfgParam[ret].un.policy_based.protocol = 1;	/* udp */		
	else 	
		pRomeCfgParam->qosCfgParam[ret].un.policy_based.protocol = 0;	/* tcp */
		
	if (desc)
		strncpy(pRomeCfgParam->qosCfgParam[ret].un.policy_based.desc, desc, sizeof(pRomeCfgParam->qosCfgParam[ret].un.policy_based.desc));	
	return 1;	
		
}	


#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
int 
nvram_set_flag_WL_ip_match(char *name, char *value)
{
	DPRINTF("nvram_set(\"%s\", \"%s\")\n", name, value);	
	
	pRomeCfgParam->wanlan_ip_mat_det.LAN_WAN_FLAG= (uint32)atoi(value);	

	return 1;		
		
}

char *
nvram_get_flag_WL_ip_match(char *name)
{
	DPRINTF("nvram_get(\"%s\")\n", name);
	memset(str,0x0,sizeof(str));
	sprintf(str, "%d", pRomeCfgParam->wanlan_ip_mat_det.LAN_WAN_FLAG);
	return (str);

}

#endif	

char *
nvram_get_router_info(char *name)
{
	int SecurityType, WepKeyLen, AuthticationType ;
	char *SecurityTypeStr[] = { "NONE", "WEP", "WPA-PSK", "WPA2-PSK", "WPA-PSK-Mixed", NULL};
	char *AuthticationTypeStr[] = {"Open", "Shared", "Auto", NULL};
	char *WepKeyLenStr[] = {"", "64", "128",NULL};
	DPRINTF("nvram_get(\"%s\")\n", name);
	
	SecurityType = (int)pRomeCfgParam->wlanCfgParam[0].cryptType;
	AuthticationType = (int)pRomeCfgParam->wlanCfgParam[0].authType;
	WepKeyLen = (int)pRomeCfgParam->wlanCfgParam[0].cryptSubType[0];
	
	memset(str,0x0,sizeof(str));
	switch(SecurityType) {
		case 0:
			sprintf(str,"WLAN-Security:SecurityMode=NONE;");
			break;
		case 1:
			sprintf(str,"WLAN-Security:SecurityMode=%s;WEPAuthType=%s;WEPStrength=%s;WEPKey1=%s;WEPKey2=%s;WEPKey3=%s;WEPKey4=%s;ActiveKeyIndex=%d;",
					SecurityTypeStr[SecurityType],
					AuthticationTypeStr[AuthticationType],
					WepKeyLenStr[WepKeyLen],
					pRomeCfgParam->wlanCfgParam[0].key1,
					pRomeCfgParam->wlanCfgParam[0].key2,
					pRomeCfgParam->wlanCfgParam[0].key3,
					pRomeCfgParam->wlanCfgParam[0].key4,
					pRomeCfgParam->wlanCfgParam[0].keyNo);
			break;
		default:
			sprintf(str,"WLAN-Security:SecurityMode=%s;WPAPassPhrase=%s;",
					SecurityTypeStr[SecurityType],
					pRomeCfgParam->wlanCfgParam[0].passphrase);
			break;
	}
	return (str);

}

struct ej_nvram_handler nvram_handlers[] = {
	{ "model", nvram_get_model, NULL},
	{ "os_version", nvram_get_os_version, NULL},
	{ "hw_version", nvram_get_hw_version, NULL},	
	{ "loader_version", nvram_get_loader_version, nvram_set_loader_version},
	
//Yili 2006/1/10
#if defined(DNI)
	{ "logo_enable", nvram_get_logo_enable, nvram_set_logo_enable },
	{ "ver_check_enable", nvram_get_ver_check_enable, nvram_set_ver_check_enable },
	{ "runtest", nvram_get_runtest, NULL },
#endif
//end
	
	{ "lan_ipaddr", nvram_get_lan_ipaddr, nvram_set_lan_ipaddr },
	{ "lan_netmask", nvram_get_lan_netmask, nvram_set_lan_netmask },
	{ "lan_hwaddr", nvram_get_lan_hwaddr, nvram_set_lan_hwaddr },
	//{ "default_lan_ipaddr", nvram_get_lan_ipaddr, nvram_set_lan_ipaddr },
	//{ "default_lan_netmask", nvram_get_lan_netmask, nvram_set_lan_netmask },
	//{ "default_lan_ipaddr_br", nvram_get_lan_ipaddr, nvram_set_lan_ipaddr },
	//{ "default_lan_netmask_br", nvram_get_lan_netmask, nvram_set_lan_netmask },
	//{ "wan_ifname", nvram_get_wan_ifname, NULL },	
	{ "lan_proto", nvram_get_lan_proto, nvram_set_lan_proto },
	{ "dhcp_start", nvram_get_dhcp_start, nvram_set_dhcp_start },
	{ "dhcp_end", nvram_get_dhcp_end, nvram_set_dhcp_end },

	{ "rip_dir", nvram_get_rip_dir, nvram_set_rip_dir }, //pamela20051227
	{ "rip_ver", nvram_get_rip_ver, nvram_set_rip_ver }, //pamela20051227
	
	//{ "dhcp_lease", nvram_get_dhcp_lease, nvram_set_dhcp_lease },
	{ "wan_proto", nvram_get_wan_proto, nvram_set_wan_proto },
	{ "wan_hostname", nvram_get_wan_hostname, nvram_set_wan_hostname },
	{ "wan_domain",	nvram_get_wan_domain, nvram_set_wan_domain },
//Yili 2006/1/6
#if defined(DNI)	
	{ "lan_domain",	nvram_get_lan_domain, nvram_set_lan_domain },
#endif
	{ "wan_ipaddr", nvram_get_wan_ipaddr, nvram_set_wan_ipaddr },
	{ "wan_netmask", nvram_get_wan_netmask, nvram_set_wan_netmask },
	{ "wan_gateway", nvram_get_wan_gateway, nvram_set_wan_gateway },	
	{ "wan0_ipaddr", nvram_get_wan0_ipaddr, NULL },
	{ "wan0_netmask", nvram_get_wan0_netmask, NULL },
	{ "wan0_gateway", nvram_get_wan0_gateway, NULL },		
	{ "wan_pppoe_username", nvram_get_wan_pppoe_username, nvram_set_wan_pppoe_username },
	{ "wan_pppoe_passwd", nvram_get_wan_pppoe_passwd, nvram_set_wan_pppoe_passwd },
	{ "wan_pppoe_service", nvram_get_wan_pppoe_service, nvram_set_wan_pppoe_service },
	{ "wan_pppoe_mtu", nvram_get_wan_pppoe_mtu, nvram_set_wan_pppoe_mtu },
	{ "wan_pppoe_demand", nvram_get_wan_pppoe_demand, nvram_set_wan_pppoe_demand },
	{ "wan_pppoe_idletime", nvram_get_wan_pppoe_idletime, nvram_set_wan_pppoe_idletime },					
	{ "wan_pppoe_dynamicassign", nvram_get_wan_pppoe_dynamicassign, nvram_set_wan_pppoe_dynamicassign },					
	{ "wan_pppoe_fixedipAddr", nvram_get_wan_pppoe_fixedipAddr, nvram_set_wan_pppoe_fixedipAddr },								

	{ "wan_pptp_username", nvram_get_wan_pptp_username, nvram_set_wan_pptp_username },
	{ "wan_pptp_password", nvram_get_wan_pptp_passwd, nvram_set_wan_pptp_passwd },
	{ "wan_pptp_idle_disconnect", nvram_get_wan_pptp_idle_disconnect, nvram_set_wan_pptp_idle_disconnect },
	{ "wan_pptp_idle_interval", nvram_get_wan_pptp_idle_interval, nvram_set_wan_pptp_idle_interval },
	{ "wan_pptp_conn_id", nvram_get_wan_pptp_id, nvram_set_wan_pptp_id },
	{ "wan_pptp_ipaddr", nvram_get_wan_pptp_ipaddr, nvram_set_wan_pptp_ipaddr },
	{ "wan_pptp_netmask", nvram_get_wan_pptp_netmask, nvram_set_wan_pptp_netmask },
	{ "wan_pptp_server_ipaddr", nvram_get_wan_pptp_server_ipaddr, nvram_set_wan_pptp_server_ipaddr },
	
	{ "wan_l2tp_username", nvram_get_wan_l2tp_username, nvram_set_wan_l2tp_username },
	{ "wan_l2tp_password", nvram_get_wan_l2tp_passwd, nvram_set_wan_l2tp_passwd },
	{ "wan_l2tp_idle_disconnect", nvram_get_wan_l2tp_idle_disconnect, nvram_set_wan_l2tp_idle_disconnect },
	{ "wan_l2tp_idle_interval", nvram_get_wan_l2tp_idle_interval, nvram_set_wan_l2tp_idle_interval },
	{ "wan_l2tp_conn_id", nvram_get_wan_l2tp_id, nvram_set_wan_l2tp_id },
	{ "wan_l2tp_ipaddr", nvram_get_wan_l2tp_ipaddr, nvram_set_wan_l2tp_ipaddr },
	{ "wan_l2tp_netmask", nvram_get_wan_l2tp_netmask, nvram_set_wan_l2tp_netmask },
	{ "wan_l2tp_server_ipaddr", nvram_get_wan_l2tp_server_ipaddr, nvram_set_wan_l2tp_server_ipaddr },
	{ "wan_l2tp_servername", nvram_get_wan_l2tp_servername, nvram_set_wan_l2tp_servername }, 
	
	
	{ "wan_tel_username", nvram_get_wan_tel_username, nvram_set_wan_tel_username },
	{ "wan_tel_password", nvram_get_wan_tel_password, nvram_set_wan_tel_password },
	{ "wan_tel_service", nvram_get_wan_tel_service, nvram_set_wan_tel_service },
	{ "wan_tel_idle_interval", nvram_get_wan_tel_idle_interval, nvram_set_wan_tel_idle_interval },
	{ "wan_tel_demand", nvram_get_wan_tel_demand, nvram_set_wan_tel_demand },
	{ "wan_tel_manualHangup", nvram_get_wan_tel_manualHangup, nvram_set_wan_tel_manualHangup },
	
	

	{ "wan0_hwaddr", nvram_get_wan0_hwaddr, nvram_set_wan0_hwaddr },
	{ "wan_hwaddr", nvram_get_wan_hwaddr, nvram_set_wan_hwaddr },

	{ "wan0_dns1", nvram_get_wan0_dns1, nvram_set_wan0_dns1 },
	{ "wan0_dns2", nvram_get_wan0_dns2, nvram_set_wan0_dns2 },	
	{ "wan_dns1", nvram_get_wan_dns1, nvram_set_wan_dns1 },
	{ "wan_dns2", nvram_get_wan_dns2, nvram_set_wan_dns2 },		
	{ "wan_autodns", nvram_get_wan_autodns, nvram_set_wan_autodns },
	
	{ "http_remoteenable", nvram_get_http_remoteenable, nvram_set_http_remoteenable },
	{ "http_wanport", nvram_get_http_wanport, nvram_set_http_wanport },	
	{ "remote_config_ip", nvram_get_remote_config_ip, nvram_set_remote_config_ip },	
	{ "remote_config_ip_start", nvram_get_remote_config_ip_start, nvram_set_remote_config_ip_start },	
	{ "remote_config_ip_end", nvram_get_remote_config_ip_end, nvram_set_remote_config_ip_end },	
	
	{ "wan_ping", nvram_get_wan_ping, nvram_set_wan_ping },	
	{ "sip_alg", nvram_get_sip_alg, nvram_set_sip_alg },		
	{ "fw_wan_mtu", nvram_get_wan_mtu, nvram_set_wan_mtu },	
	
	{ "vs_count", nvram_get_vs_count, NULL },
	/* d-d>ip:d-d,proto,on/off,desc */	
	{ "forward_port0", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port1", nvram_get_forward_port, nvram_set_forward_port },	
	{ "forward_port2", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port3", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port4", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port5", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port6", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port7", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port8", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port9", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port10", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port11", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port12", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port13", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port14", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port15", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port16", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port17", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port18", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port19", nvram_get_forward_port, nvram_set_forward_port },	
	{ "forward_port20", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port21", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port22", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port23", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port24", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port25", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port26", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port27", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port28", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port29", nvram_get_forward_port, nvram_set_forward_port },	
	{ "forward_port30", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port31", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port32", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port33", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port34", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port35", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port36", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port37", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port38", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port39", nvram_get_forward_port, nvram_set_forward_port },	
	{ "forward_port40", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port41", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port42", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port43", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port44", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port45", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port46", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port47", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port48", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port49", nvram_get_forward_port, nvram_set_forward_port },	
	{ "forward_port50", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port51", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port52", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port53", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port54", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port55", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port56", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port57", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port58", nvram_get_forward_port, nvram_set_forward_port },
	{ "forward_port59", nvram_get_forward_port, nvram_set_forward_port },	
	
	
	
	{ "fw_keywordenable", nvram_get_fw_keywordenable, nvram_set_fw_keywordenable },		
	{ "fw_trustipenable", nvram_get_fw_trustipenable, nvram_set_fw_trustipenable },		
	{ "fw_trustip", nvram_get_fw_trustip, nvram_set_fw_trustip },		
	
	{ "add_block_keyword_domain", NULL, nvram_set_add_block_keyword_domain	},
	{ "del_block_keyword_domain", NULL, nvram_set_del_block_keyword_domain	},
	{ "clr_block_keyword_domain", NULL, nvram_set_clr_block_keyword_domain	},	
		
	{ "fw_block_keyword_domain0", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain1", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain2", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain3", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain4", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain5", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain6", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain7", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain8", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain9", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain10", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain11", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain12", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain13", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain14", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain15", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain16", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain17", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain18", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain19", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain20", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain21", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain22", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain23", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain24", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain25", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain26", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain27", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain28", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain29", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain30", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain31", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain32", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain33", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain34", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain35", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain36", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain37", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain38", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	
	{ "fw_block_keyword_domain39", nvram_get_fw_block_keyword_domain, nvram_set_fw_block_keyword_domain },	

	{ "fw_blockrulenumber", nvram_get_fw_blockrulenumber, NULL }, //Add by Timo Wu
	
	{ "fw_packenable", nvram_get_fw_packenable, nvram_set_fw_packenable },
	{ "fw_packrulenumber", nvram_get_fw_packrulenumber, nvram_set_fw_packrulenumber },
	/* %s-%s:%d-%d,%s,%d,%d,%d,%d,%d,%d,%d:%d-%d,%s,%s */	
	{ "filter_client0", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client1", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client2", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client3", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client4", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client5", nvram_get_filter_client, nvram_set_filter_client },						
	{ "filter_client6", nvram_get_filter_client, nvram_set_filter_client },						
	{ "filter_client7", nvram_get_filter_client, nvram_set_filter_client },						
	{ "filter_client8", nvram_get_filter_client, nvram_set_filter_client },						
	{ "filter_client9", nvram_get_filter_client, nvram_set_filter_client },						
	{ "filter_client10", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client11", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client12", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client13", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client14", nvram_get_filter_client, nvram_set_filter_client },	
	{ "filter_client15", nvram_get_filter_client, nvram_set_filter_client },						
	{ "filter_client16", nvram_get_filter_client, nvram_set_filter_client },						
	{ "filter_client17", nvram_get_filter_client, nvram_set_filter_client },						
	{ "filter_client18", nvram_get_filter_client, nvram_set_filter_client },						
	{ "filter_client19", nvram_get_filter_client, nvram_set_filter_client },						

	{ "client_filter_ip", nvram_get_client_filter_ip, nvram_set_client_filter_ip },	
	{ "client_filter_s_ip", nvram_get_client_filter_s_ip, nvram_set_client_filter_s_ip },	
	{ "client_filter_e_ip", nvram_get_client_filter_e_ip, nvram_set_client_filter_e_ip },	


	{ "fw_inidays", nvram_get_fw_inidays, NULL },	
	{ "fw_everyday", nvram_get_fw_everyday, nvram_set_fw_everyday },	
	{ "fw_blockdays", nvram_get_fw_blockdays, nvram_set_fw_blockdays },
	{ "fw_blockallday", nvram_get_fw_blockallday, nvram_set_fw_blockallday },
	{ "fw_starthour", nvram_get_fw_starthour, nvram_set_fw_starthour },						
	{ "fw_endhour", nvram_get_fw_endhour, nvram_set_fw_endhour },						
	{ "fw_startmin", nvram_get_fw_startmin, nvram_set_fw_startmin },						
	{ "fw_endmin", nvram_get_fw_endmin, nvram_set_fw_endmin },	
	
	{ "time_zone", nvram_get_time_zone, nvram_set_time_zone },
	{ "daylight", nvram_get_daylight, nvram_set_daylight },
	//{ "SysClock", nvram_get_sys_clock, NULL },
	{ "available_localtime", nvram_get_available_localtime, NULL },	
	{ "blankstate", nvram_get_blankstate, nvram_set_blankstate },	

	{ "emailenable", nvram_get_emailenable, nvram_set_emailenable },
	{ "logsubject", nvram_get_logsubject, nvram_set_logsubject },
	{ "alertsubject", nvram_get_alertsubject, nvram_set_alertsubject },
	{ "mailserver", nvram_get_mailserver, nvram_set_mailserver },	
	{ "tomail", nvram_get_tomail, nvram_set_tomail },
	{ "alertimm", nvram_get_alertimm, nvram_set_alertimm },	
	{ "alerttype", nvram_get_alerttype, nvram_set_alerttype },
	{ "alertday", nvram_get_alertday, nvram_set_alertday },	
	{ "alerthour", nvram_get_alerthour, nvram_set_alerthour },
	{ "alertampm", nvram_get_alertampm, nvram_set_alertampm },	
	
	
	{ "frommail", nvram_get_frommail, nvram_set_frommail },
	{ "email_authname", nvram_get_email_authname, nvram_set_email_authname },	
	{ "email_authpasswd", nvram_get_email_authpasswd, nvram_set_email_authpasswd },
	{ "email_serverauth", nvram_get_email_serverauth, nvram_set_email_serverauth },	
	//{ "email_sameaddr", nvram_get_email_sameaddr, nvram_set_email_sameaddr },
	//{ "email_diffaddr", nvram_get_email_diffaddr, nvram_set_email_diffaddr },								
							

	{ "ddns_enable", nvram_get_ddns_enable, nvram_set_ddns_enable },	
	{ "ddns_hostname", nvram_get_ddns_hostname, nvram_set_ddns_hostname },		
	{ "ddns_login", nvram_get_ddns_login, nvram_set_ddns_login },	
	{ "ddns_passwd", nvram_get_ddns_passwd, nvram_set_ddns_passwd },	
	{ "ddns_wildcard", nvram_get_ddns_wildcard, nvram_set_ddns_wildcard },	
	
	{ "upnp_enable", nvram_get_upnp_enable, nvram_set_upnp_enable },	
	{ "upnp_advertime", nvram_get_upnp_advertime, nvram_set_upnp_advertime },	
	{ "upnp_timetolive", nvram_get_upnp_timetolive, nvram_set_upnp_timetolive },	
	
	{ "fw_porttrigenable", nvram_get_fw_porttrigenable, nvram_set_fw_porttrigenable },	
	{ "fw_triggertime", nvram_get_fw_triggertime, nvram_set_fw_triggertime },	
	{ "trigger_count", nvram_get_trigger_count, NULL },		

	/* d-d>ip:d-d,proto,on/off,desc,used */
	{ "trigger_port0", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port1", nvram_get_trigger_port, nvram_set_trigger_port },	
	{ "trigger_port2", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port3", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port4", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port5", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port6", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port7", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port8", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port9", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port10", nvram_get_trigger_port, nvram_set_trigger_port },	
	{ "trigger_port11", nvram_get_trigger_port, nvram_set_trigger_port },	
	{ "trigger_port12", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port13", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port14", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port15", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port16", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port17", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port18", nvram_get_trigger_port, nvram_set_trigger_port },
	{ "trigger_port19", nvram_get_trigger_port, nvram_set_trigger_port },
	
	{ "triggerporten", NULL, nvram_set_trigger_enable }, //pamela20060106

	//{ "restore_defaults", nvram_get_restore_defaults, nvram_set_restore_defaults },	
	
	{ "static_route0", nvram_get_static_route, nvram_set_static_route },	
	{ "static_route1", nvram_get_static_route, nvram_set_static_route },	
	{ "static_route2", nvram_get_static_route, nvram_set_static_route },	
	{ "static_route3", nvram_get_static_route, nvram_set_static_route },	
	{ "static_route4", nvram_get_static_route, nvram_set_static_route },	
	{ "static_route5", nvram_get_static_route, nvram_set_static_route },	
	{ "static_route6", nvram_get_static_route, nvram_set_static_route },	
	{ "static_route7", nvram_get_static_route, nvram_set_static_route },	
	{ "static_route8", nvram_get_static_route, nvram_set_static_route },	
	{ "static_route9", nvram_get_static_route, nvram_set_static_route },	
	{ "sr_count", nvram_get_sr_count, NULL }, //pamela
	

	{ "http_passwd", nvram_get_http_passwd, nvram_set_http_passwd },	

	{ "fw_disable", nvram_get_fw_disable, nvram_set_fw_disable },

	{ "dmz_enable", nvram_get_dmz_enable, nvram_set_dmz_enable },
	{ "dmz_ipaddr", nvram_get_dmz_ipaddr, nvram_set_dmz_ipaddr },
	

	{ "dhcpc_res_count", nvram_get_dhcpc_res_count, NULL },		
	
	/* ipaddr,mac,desc */
	{ "dhcpc_res0", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res1", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },	
	//ATTACHED_DEVICES 
	{ "dhcpc_res2", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res3", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },	
	{ "dhcpc_res4", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res5", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },	
	{ "dhcpc_res6", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res7", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res8", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },	
	{ "dhcpc_res9", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res10", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res11", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },	
	{ "dhcpc_res12", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res13", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res14", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res15", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res16", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res17", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },	
	{ "dhcpc_res18", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res19", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res20", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res21", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res22", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res23", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },	
	{ "dhcpc_res24", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res25", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },	
	{ "dhcpc_res26", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res27", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	{ "dhcpc_res28", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },	
	{ "dhcpc_res29", nvram_get_dhcpc_reservation, nvram_set_dhcpc_reservation },
	//ATTACHED_DEVICES 

	{ "wireless", nvram_get_wireless_supported, NULL },
	{ "fw_pppoetype", nvram_get_fw_pppoe_type, NULL },		
	{ "show_Product", nvram_get_show_Product, NULL },	
	
	{ "wan_mac_mode", nvram_get_wan_mac_mode, nvram_set_wan_mac_mode },
	{ "wan_spoofmac", nvram_get_wan_spoofmac, nvram_set_wan_spoofmac },	
	{ "wizard_wan_spoofmac_detected", nvram_get_wizard_wan_spoofmac_detected, nvram_set_wizard_wan_spoofmac_detected },	
	{ "auto_connect", nvram_get_auto_connect, nvram_set_auto_connect },	//pamela20051228
	
	{ "fw_remoteenable", nvram_get_fw_remoteenable, nvram_set_fw_remoteenable },		
	
	{ "SmtWzdDone", nvram_get_Smartwizard_Done, nvram_set_Smartwizard_Done },	//KEVIN:ADD:06DEC05:BlankState
	{ "SmtWzdStep", nvram_get_Smartwizard_Step, nvram_set_Smartwizard_Step },	//KEVIN:ADD:06DEC05:BlankState

	{ "SmtBDetWanType", nvram_get_BDetWanType, nvram_set_BDetWanType },	//KEVIN:ADD:06Mar01:BlankState
	{ "SmtBTestWanConn", nvram_get_BTestWanConn, nvram_set_BTestWanConn },	//KEVIN:ADD:06Mar01:BlankState
	
	//{ "ddns_status", nvram_get_ddns_status, nvram_set_ddns_status },	
	
	{ "newfirm", nvram_get_newfirm, nvram_set_newfirm },	
	
	{ "dhcpc_lease_obtained", nvram_get_dhcpc_lease_obtained, nvram_set_dhcpc_lease_obtained },	
	
	{ "dhcpc_lease_expired", nvram_get_dhcpc_lease_expired, nvram_set_dhcpc_lease_expired },	

	//kwgr614
	{ "ssid", nvram_get_wl_ssid, nvram_set_wl_ssid },	
	{ "reg_domain", nvram_get_wl_domain, nvram_set_wl_domain },	
	{ "channel", nvram_get_wl_channel, nvram_set_wl_channel },	
	{ "datarate_mode", nvram_get_wl_datarate_mode, nvram_set_wl_datarate_mode },	

	{ "sec_type", nvram_get_wl_security_type, nvram_set_wl_security_type },	
	{ "auth_type", nvram_get_wl_auth_type, nvram_set_wl_auth_type },	
	{ "passphrase", nvram_get_wl_passphrase, nvram_set_wl_passphrase },	
	{ "wep_key_no", nvram_get_wl_key_no, nvram_set_wl_key_no },	
	{ "key1", nvram_get_wl_key1, nvram_set_wl_key1 },	
	{ "key2", nvram_get_wl_key2, nvram_set_wl_key2 },	
	{ "key3", nvram_get_wl_key3, nvram_set_wl_key3 },	
	{ "key4", nvram_get_wl_key4, nvram_set_wl_key4 },	
	{ "wepenc", nvram_get_wl_wepenc, nvram_set_wl_wepenc },	
	
	{ "enable_ap", nvram_get_wl_enable_ap, nvram_set_wl_enable_ap },	
	{ "ssid_bc", nvram_get_wl_ssid_bc, nvram_set_wl_ssid_bc },	
	{ "frag", nvram_get_wl_frag, nvram_set_wl_frag },	
	{ "rts", nvram_get_wl_rts, nvram_set_wl_rts },	
	{ "TxRange", nvram_get_wl_TxRange, nvram_set_wl_TxRange},	
	
	{ "wlan_acl0", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl1", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl2", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl3", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl4", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl5", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl6", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl7", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl8", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl9", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl10", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl11", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl12", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl13", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl14", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl15", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl16", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl17", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl18", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl19", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl20", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl21", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl22", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl23", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl24", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl25", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl26", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl27", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl28", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl29", nvram_get_wlan_acl, nvram_set_wlan_acl },	
	{ "wlan_acl30", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl31", nvram_get_wlan_acl, nvram_set_wlan_acl },
	{ "wlan_acl_count", nvram_get_wlan_count, nvram_set_wlan_count },	
	
	{ "preamble", nvram_get_wl_preamble, nvram_set_wl_preamble },

	{ "acEnable", nvram_get_wl_ac_enable, nvram_set_wl_ac_enable },	
	
	/* d-d,proto,on/off,priority(1/0),desc */	
	{ "qos_port0", nvram_get_qos_port, nvram_set_qos_port },
	{ "qos_port1", nvram_get_qos_port, nvram_set_qos_port },	
	{ "qos_port2", nvram_get_qos_port, nvram_set_qos_port },
	{ "qos_port3", nvram_get_qos_port, nvram_set_qos_port },
	{ "qos_port4", nvram_get_qos_port, nvram_set_qos_port },
	{ "qos_port5", nvram_get_qos_port, nvram_set_qos_port },
	{ "qos_port6", nvram_get_qos_port, nvram_set_qos_port },
	{ "qos_port7", nvram_get_qos_port, nvram_set_qos_port },
	{ "qos_port8", nvram_get_qos_port, nvram_set_qos_port },
	{ "qos_port9", nvram_get_qos_port, nvram_set_qos_port },

	{ "qos_count", nvram_get_qos_count, NULL },	

#ifdef CONFIG_WAN_LAN_MATCH_DETECTION
	{ "WL_ip_match", nvram_get_flag_WL_ip_match, nvram_set_flag_WL_ip_match},
#endif	
	{ "router_info", nvram_get_router_info, NULL},
	
	{ NULL, NULL, NULL },	
	
};


